var RTCMultiConnection = function(roomid, forceOptions) {
  var that;
  function SocketConnection(connection, connectCallback) {
    function isData2(session) {
      return !session.audio && !session.video && !session.screen && session.data;
    }
    var parameters = "";
    parameters += "?userid=" + connection.userid, parameters += "&sessionid=" + connection.sessionid, parameters += "&msgEvent=" + connection.socketMessageEvent, parameters += "&socketCustomEvent=" + connection.socketCustomEvent, parameters += "&autoCloseEntireSession=" + !!connection.autoCloseEntireSession, true === connection.session.broadcast && (parameters += "&oneToMany=true"), parameters += "&maxParticipantsAllowed=" + connection.maxParticipantsAllowed, connection.enableScalableBroadcast && (parameters += "&enableScalableBroadcast=true", parameters += "&maxRelayLimitPerUser=" + (connection.maxRelayLimitPerUser || 2)), parameters += "&extra=" + JSON.stringify(connection.extra || {}), connection.socketCustomParameters && (parameters += connection.socketCustomParameters);
    try {
      io.sockets = {};
    } catch (e) {
    }
    if (connection.socketURL || (connection.socketURL = "/"), "/" != connection.socketURL.substr(connection.socketURL.length - 1, 1))
      throw '"socketURL" MUST end with a slash.';
    connection.enableLogs && ("/" == connection.socketURL ? console.info("socket.io url is: ", location.origin + "/") : console.info("socket.io url is: ", connection.socketURL));
    try {
      connection.socket = io(connection.socketURL + parameters);
    } catch (e) {
      connection.socket = io.connect(connection.socketURL + parameters, connection.socketOptions);
    }
    var mPeer = connection.multiPeersHandler;
    function updateExtraBackup(remoteUserId, extra) {
      connection.peersBackup[remoteUserId] || (connection.peersBackup[remoteUserId] = { userid: remoteUserId, extra: {} }), connection.peersBackup[remoteUserId].extra = extra;
    }
    connection.socket.on("extra-data-updated", function(remoteUserId, extra) {
      connection.peers[remoteUserId] && (connection.peers[remoteUserId].extra = extra, connection.onExtraDataUpdated({ userid: remoteUserId, extra }), updateExtraBackup(remoteUserId, extra));
    }), connection.socket.on(connection.socketMessageEvent, function onMessageEvent(message) {
      if (message.remoteUserId == connection.userid)
        if (connection.peers[message.sender] && connection.peers[message.sender].extra != message.message.extra && (connection.peers[message.sender].extra = message.extra, connection.onExtraDataUpdated({ userid: message.sender, extra: message.extra }), updateExtraBackup(message.sender, message.extra)), message.message.streamSyncNeeded && connection.peers[message.sender]) {
          var stream2 = connection.streamEvents[message.message.streamid];
          if (!stream2 || !stream2.stream)
            return;
          var action = message.message.action;
          if ("ended" === action || "inactive" === action || "stream-removed" === action)
            return connection.peersBackup[stream2.userid] && (stream2.extra = connection.peersBackup[stream2.userid].extra), void connection.onstreamended(stream2);
          var type = "both" != message.message.type ? message.message.type : null;
          "function" == typeof stream2.stream[action] && stream2.stream[action](type);
        } else if ("dropPeerConnection" !== message.message) {
          if (message.message.allParticipants)
            return -1 === message.message.allParticipants.indexOf(message.sender) && message.message.allParticipants.push(message.sender), void message.message.allParticipants.forEach(function(participant) {
              mPeer[connection.peers[participant] ? "renegotiatePeer" : "createNewPeer"](participant, { localPeerSdpConstraints: { OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo }, remotePeerSdpConstraints: { OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo }, isOneWay: !!connection.session.oneway || "one-way" === connection.direction, isDataOnly: isData2(connection.session) });
            });
          if (message.message.newParticipant) {
            if (message.message.newParticipant == connection.userid)
              return;
            if (connection.peers[message.message.newParticipant])
              return;
            mPeer.createNewPeer(message.message.newParticipant, message.message.userPreferences || { localPeerSdpConstraints: { OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo }, remotePeerSdpConstraints: { OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo }, isOneWay: !!connection.session.oneway || "one-way" === connection.direction, isDataOnly: isData2(connection.session) });
          } else if (message.message.readyForOffer && (connection.attachStreams.length && (connection.waitingForLocalMedia = false), connection.waitingForLocalMedia))
            setTimeout(function() {
              onMessageEvent(message);
            }, 1);
          else if (message.message.newParticipationRequest && message.sender !== connection.userid) {
            connection.peers[message.sender] && connection.deletePeer(message.sender);
            var userPreferences = { extra: message.extra || {}, localPeerSdpConstraints: message.message.remotePeerSdpConstraints || { OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo }, remotePeerSdpConstraints: message.message.localPeerSdpConstraints || { OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo }, isOneWay: void 0 !== message.message.isOneWay ? message.message.isOneWay : !!connection.session.oneway || "one-way" === connection.direction, isDataOnly: void 0 !== message.message.isDataOnly ? message.message.isDataOnly : isData2(connection.session), dontGetRemoteStream: void 0 !== message.message.isOneWay ? message.message.isOneWay : !!connection.session.oneway || "one-way" === connection.direction, dontAttachLocalStream: !!message.message.dontGetRemoteStream, connectionDescription: message, successCallback: function() {
            } };
            connection.onNewParticipant(message.sender, userPreferences);
          } else {
            if (message.message.changedUUID && connection.peers[message.message.oldUUID] && (connection.peers[message.message.newUUID] = connection.peers[message.message.oldUUID], delete connection.peers[message.message.oldUUID]), message.message.userLeft)
              return mPeer.onUserLeft(message.sender), void (message.message.autoCloseEntireSession && connection.leave());
            mPeer.addNegotiatedMessage(message.message, message.sender);
          }
        } else
          connection.deletePeer(message.sender);
    });
    var alreadyConnected = false;
    connection.socket.resetProps = function() {
      alreadyConnected = false;
    }, connection.socket.on("connect", function() {
      alreadyConnected || (alreadyConnected = true, connection.enableLogs && console.info("socket.io connection is opened."), setTimeout(function() {
        connection.socket.emit("extra-data-updated", connection.extra);
      }, 1e3), connectCallback && connectCallback(connection.socket));
    }), connection.socket.on("disconnect", function(event2) {
      connection.onSocketDisconnect(event2);
    }), connection.socket.on("error", function(event2) {
      connection.onSocketError(event2);
    }), connection.socket.on("user-disconnected", function(remoteUserId) {
      remoteUserId !== connection.userid && (connection.onUserStatusChanged({ userid: remoteUserId, status: "offline", extra: connection.peers[remoteUserId] && connection.peers[remoteUserId].extra || {} }), connection.deletePeer(remoteUserId));
    }), connection.socket.on("user-connected", function(userid) {
      userid !== connection.userid && connection.onUserStatusChanged({ userid, status: "online", extra: connection.peers[userid] && connection.peers[userid].extra || {} });
    }), connection.socket.on("closed-entire-session", function(sessionid, extra) {
      connection.leave(), connection.onEntireSessionClosed({ sessionid, userid: sessionid, extra });
    }), connection.socket.on("userid-already-taken", function(useridAlreadyTaken, yourNewUserId) {
      connection.onUserIdAlreadyTaken(useridAlreadyTaken, yourNewUserId);
    }), connection.socket.on("logs", function(log) {
      connection.enableLogs && console.debug("server-logs", log);
    }), connection.socket.on("number-of-broadcast-viewers-updated", function(data) {
      connection.onNumberOfBroadcastViewersUpdated(data);
    }), connection.socket.on("set-isInitiator-true", function(sessionid) {
      sessionid == connection.sessionid && (connection.isInitiator = true);
    });
  }
  function MultiPeers(connection) {
    var self = this, skipPeers = ["getAllParticipants", "getLength", "selectFirst", "streams", "send", "forEach"];
    function initFileBufferReader() {
      connection.fbr = new FileBufferReader(), connection.fbr.onProgress = function(chunk) {
        connection.onFileProgress(chunk);
      }, connection.fbr.onBegin = function(file) {
        connection.onFileStart(file);
      }, connection.fbr.onEnd = function(file) {
        connection.onFileEnd(file);
      };
    }
    connection.peers = { getLength: function() {
      var numberOfPeers = 0;
      for (var peer in this)
        -1 == skipPeers.indexOf(peer) && numberOfPeers++;
      return numberOfPeers;
    }, selectFirst: function() {
      var firstPeer;
      for (var peer in this)
        -1 == skipPeers.indexOf(peer) && (firstPeer = this[peer]);
      return firstPeer;
    }, getAllParticipants: function(sender) {
      var allPeers = [];
      for (var peer in this)
        -1 == skipPeers.indexOf(peer) && peer != sender && allPeers.push(peer);
      return allPeers;
    }, forEach: function(callback) {
      this.getAllParticipants().forEach(function(participant) {
        callback(connection.peers[participant]);
      });
    }, send: function(data, remoteUserId) {
      var that2 = this;
      if (!isNull(data.size) && !isNull(data.type)) {
        if (connection.enableFileSharing)
          return void self.shareFile(data, remoteUserId);
        "string" != typeof data && (data = JSON.stringify(data));
      }
      if ("text" === data.type || data instanceof ArrayBuffer || data instanceof DataView) {
        if ("text" === data.type && (data = JSON.stringify(data)), remoteUserId) {
          var remoteUser = connection.peers[remoteUserId];
          if (remoteUser)
            return remoteUser.channels.length ? void remoteUser.channels.forEach(function(channel) {
              channel.send(data);
            }) : (connection.peers[remoteUserId].createDataChannel(), connection.renegotiate(remoteUserId), void setTimeout(function() {
              that2.send(data, remoteUserId);
            }, 3e3));
        }
        this.getAllParticipants().forEach(function(participant) {
          if (!that2[participant].channels.length)
            return connection.peers[participant].createDataChannel(), connection.renegotiate(participant), void setTimeout(function() {
              that2[participant].channels.forEach(function(channel) {
                channel.send(data);
              });
            }, 3e3);
          that2[participant].channels.forEach(function(channel) {
            channel.send(data);
          });
        });
      } else
        TextSender.send({ text: data, channel: this, connection, remoteUserId });
    } }, this.uuid = connection.userid, this.getLocalConfig = function(remoteSdp, remoteUserId, userPreferences) {
      return userPreferences || (userPreferences = {}), { streamsToShare: userPreferences.streamsToShare || {}, rtcMultiConnection: connection, connectionDescription: userPreferences.connectionDescription, userid: remoteUserId, localPeerSdpConstraints: userPreferences.localPeerSdpConstraints, remotePeerSdpConstraints: userPreferences.remotePeerSdpConstraints, dontGetRemoteStream: !!userPreferences.dontGetRemoteStream, dontAttachLocalStream: !!userPreferences.dontAttachLocalStream, renegotiatingPeer: !!userPreferences.renegotiatingPeer, peerRef: userPreferences.peerRef, channels: userPreferences.channels || [], onLocalSdp: function(localSdp) {
        self.onNegotiationNeeded(localSdp, remoteUserId);
      }, onLocalCandidate: function(localCandidate) {
        (localCandidate = OnIceCandidateHandler.processCandidates(connection, localCandidate)) && self.onNegotiationNeeded(localCandidate, remoteUserId);
      }, remoteSdp, onDataChannelMessage: function(message) {
        if (!connection.fbr && connection.enableFileSharing && initFileBufferReader(), "string" != typeof message && connection.enableFileSharing) {
          var that2 = this;
          message instanceof ArrayBuffer || message instanceof DataView ? connection.fbr.convertToObject(message, function(object) {
            that2.onDataChannelMessage(object);
          }) : message.readyForNextChunk ? connection.fbr.getNextChunk(message, function(nextChunk, isLastChunk) {
            connection.peers[remoteUserId].channels.forEach(function(channel) {
              channel.send(nextChunk);
            });
          }, remoteUserId) : message.chunkMissing ? connection.fbr.chunkMissing(message) : connection.fbr.addChunk(message, function(promptNextChunk) {
            connection.peers[remoteUserId].peer.channel.send(promptNextChunk);
          });
        } else
          self.onDataChannelMessage(message, remoteUserId);
      }, onDataChannelError: function(error) {
        self.onDataChannelError(error, remoteUserId);
      }, onDataChannelOpened: function(channel) {
        self.onDataChannelOpened(channel, remoteUserId);
      }, onDataChannelClosed: function(event2) {
        self.onDataChannelClosed(event2, remoteUserId);
      }, onRemoteStream: function(stream2) {
        connection.peers[remoteUserId] && connection.peers[remoteUserId].streams.push(stream2), self.onGettingRemoteMedia(stream2, remoteUserId);
      }, onRemoteStreamRemoved: function(stream2) {
        self.onRemovingRemoteMedia(stream2, remoteUserId);
      }, onPeerStateChanged: function(states) {
        self.onPeerStateChanged(states), "new" === states.iceConnectionState && self.onNegotiationStarted(remoteUserId, states), "connected" === states.iceConnectionState && self.onNegotiationCompleted(remoteUserId, states), -1 !== states.iceConnectionState.search(/closed|failed/gi) && (self.onUserLeft(remoteUserId), self.disconnectWith(remoteUserId));
      } };
    }, this.createNewPeer = function(remoteUserId, userPreferences) {
      if (!(connection.maxParticipantsAllowed <= connection.getAllParticipants().length)) {
        if (userPreferences = userPreferences || {}, connection.isInitiator && connection.session.audio && "two-way" === connection.session.audio && !userPreferences.streamsToShare && (userPreferences.isOneWay = false, userPreferences.isDataOnly = false, userPreferences.session = connection.session), !userPreferences.isOneWay && !userPreferences.isDataOnly)
          return userPreferences.isOneWay = true, void this.onNegotiationNeeded({ enableMedia: true, userPreferences }, remoteUserId);
        userPreferences = connection.setUserPreferences(userPreferences, remoteUserId);
        var localConfig = this.getLocalConfig(null, remoteUserId, userPreferences);
        connection.peers[remoteUserId] = new PeerInitiator(localConfig);
      }
    }, this.createAnsweringPeer = function(remoteSdp, remoteUserId, userPreferences) {
      userPreferences = connection.setUserPreferences(userPreferences || {}, remoteUserId);
      var localConfig = this.getLocalConfig(remoteSdp, remoteUserId, userPreferences);
      connection.peers[remoteUserId] = new PeerInitiator(localConfig);
    }, this.renegotiatePeer = function(remoteUserId, userPreferences, remoteSdp) {
      if (connection.peers[remoteUserId]) {
        userPreferences || (userPreferences = {}), userPreferences.renegotiatingPeer = true, userPreferences.peerRef = connection.peers[remoteUserId].peer, userPreferences.channels = connection.peers[remoteUserId].channels;
        var localConfig = this.getLocalConfig(remoteSdp, remoteUserId, userPreferences);
        connection.peers[remoteUserId] = new PeerInitiator(localConfig);
      } else
        connection.enableLogs && console.error("Peer (" + remoteUserId + ") does not exist. Renegotiation skipped.");
    }, this.replaceTrack = function(track, remoteUserId, isVideoTrack, oldTrack) {
      if (!connection.peers[remoteUserId])
        throw "This peer (" + remoteUserId + ") does not exist.";
      var peer = connection.peers[remoteUserId].peer;
      if (peer.getSenders && "function" == typeof peer.getSenders && peer.getSenders().length) {
        let replaceIt = function(rtpSender) {
          var key = "lastAudioTrack";
          isVideoTrack && "video" === rtpSender.track.kind && (key = "lastVideoTrack"), connection.peers[remoteUserId].peer[key] = rtpSender.track, rtpSender.replaceTrack(track);
        };
        var selectedSender = null, pSenders = peer.getSenders().filter(function(rtpSender) {
          return rtpSender.track;
        });
        return oldTrack && (selectedSender = pSenders.find(function(rtpSender) {
          return rtpSender.track.id === oldTrack.id;
        })), void (selectedSender ? replaceIt(selectedSender) : pSenders.forEach(replaceIt));
      }
      console.warn("RTPSender.replaceTrack is NOT supported."), this.renegotiatePeer(remoteUserId);
    }, this.onNegotiationNeeded = function(message, remoteUserId) {
    }, this.addNegotiatedMessage = function(message, remoteUserId) {
      if (message.type && message.sdp)
        return "answer" == message.type && connection.peers[remoteUserId] && connection.peers[remoteUserId].addRemoteSdp(message), "offer" == message.type && (message.renegotiatingPeer ? this.renegotiatePeer(remoteUserId, null, message) : this.createAnsweringPeer(message, remoteUserId)), void (connection.enableLogs && console.log("Remote peer's sdp:", message.sdp));
      if (message.candidate)
        return connection.peers[remoteUserId] && connection.peers[remoteUserId].addRemoteCandidate(message), void (connection.enableLogs && console.log("Remote peer's candidate pairs:", message.candidate));
      if (message.enableMedia) {
        connection.session = message.userPreferences.session || connection.session, connection.session.oneway && connection.attachStreams.length && (connection.attachStreams = []), message.userPreferences.isDataOnly && connection.attachStreams.length && (connection.attachStreams.length = []);
        var streamsToShare = {};
        connection.attachStreams.forEach(function(stream2) {
          streamsToShare[stream2.streamid] = { isAudio: !!stream2.isAudio, isVideo: !!stream2.isVideo, isScreen: !!stream2.isScreen };
        }), message.userPreferences.streamsToShare = streamsToShare, self.onNegotiationNeeded({ readyForOffer: true, userPreferences: message.userPreferences }, remoteUserId);
      }
      message.readyForOffer && connection.onReadyForOffer(remoteUserId, message.userPreferences);
    }, this.onGettingRemoteMedia = function(stream2, remoteUserId) {
    }, this.onRemovingRemoteMedia = function(stream2, remoteUserId) {
    }, this.onGettingLocalMedia = function(localStream) {
    }, this.onLocalMediaError = function(error, constraints) {
      connection.onMediaError(error, constraints);
    }, this.shareFile = function(file, remoteUserId) {
      initFileBufferReader(), connection.fbr.readAsArrayBuffer(file, function(uuid) {
        var arrayOfUsers = connection.getAllParticipants();
        remoteUserId && (arrayOfUsers = [remoteUserId]), arrayOfUsers.forEach(function(participant) {
          connection.fbr.getNextChunk(uuid, function(nextChunk) {
            connection.peers[participant].channels.forEach(function(channel) {
              channel.send(nextChunk);
            });
          }, participant);
        });
      }, { userid: connection.userid, chunkSize: "Firefox" === DetectRTC.browser.name ? 15e3 : connection.chunkSize || 0 });
    };
    var textReceiver = new TextReceiver(connection);
    this.onDataChannelMessage = function(message, remoteUserId) {
      textReceiver.receive(JSON.parse(message), remoteUserId, connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {});
    }, this.onDataChannelClosed = function(event2, remoteUserId) {
      event2.userid = remoteUserId, event2.extra = connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}, connection.onclose(event2);
    }, this.onDataChannelError = function(error, remoteUserId) {
      error.userid = remoteUserId, event.extra = connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}, connection.onerror(error);
    }, this.onDataChannelOpened = function(channel, remoteUserId) {
      connection.peers[remoteUserId].channels.length ? connection.peers[remoteUserId].channels = [channel] : (connection.peers[remoteUserId].channels.push(channel), connection.onopen({ userid: remoteUserId, extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}, channel }));
    }, this.onPeerStateChanged = function(state) {
      connection.onPeerStateChanged(state);
    }, this.onNegotiationStarted = function(remoteUserId, states) {
    }, this.onNegotiationCompleted = function(remoteUserId, states) {
    }, this.getRemoteStreams = function(remoteUserId) {
      return remoteUserId = remoteUserId || connection.peers.getAllParticipants()[0], connection.peers[remoteUserId] ? connection.peers[remoteUserId].streams : [];
    };
  }
  function fireEvent(obj, eventName, args) {
    if ("undefined" != typeof CustomEvent) {
      var event2 = new CustomEvent(eventName, { arguments: args, __exposedProps__: args });
      obj.dispatchEvent(event2);
    }
  }
  function setMuteHandlers(connection, streamEvent) {
    streamEvent.stream && streamEvent.stream && streamEvent.stream.addEventListener && (streamEvent.stream.addEventListener("mute", function(event2) {
      (event2 = connection.streamEvents[streamEvent.streamid]).session = { audio: "audio" === event2.muteType, video: "video" === event2.muteType }, connection.onmute(event2);
    }, false), streamEvent.stream.addEventListener("unmute", function(event2) {
      (event2 = connection.streamEvents[streamEvent.streamid]).session = { audio: "audio" === event2.unmuteType, video: "video" === event2.unmuteType }, connection.onunmute(event2);
    }, false));
  }
  function getRandomString() {
    if (window.crypto && window.crypto.getRandomValues && -1 === navigator.userAgent.indexOf("Safari")) {
      for (var a = window.crypto.getRandomValues(new Uint32Array(3)), token = "", i = 0, l = a.length; i < l; i++)
        token += a[i].toString(36);
      return token;
    }
    return (Math.random() * new Date().getTime()).toString(36).replace(/\./g, "");
  }
  function getRMCMediaElement(stream2, callback, connection) {
    if (connection.autoCreateMediaElement) {
      var isAudioOnly = false;
      getTracks(stream2, "video").length || stream2.isVideo || stream2.isScreen || (isAudioOnly = true), "Firefox" === DetectRTC.browser.name && (connection.session.video || connection.session.screen) && (isAudioOnly = false);
      var mediaElement = document.createElement(isAudioOnly ? "audio" : "video");
      if (mediaElement.srcObject = stream2, mediaElement.setAttribute("autoplay", true), mediaElement.setAttribute("playsinline", true), mediaElement.setAttribute("controls", true), mediaElement.setAttribute("muted", false), mediaElement.setAttribute("volume", 1), "Firefox" === DetectRTC.browser.name) {
        var streamEndedEvent = "ended";
        "oninactive" in mediaElement && (streamEndedEvent = "inactive"), mediaElement.addEventListener(streamEndedEvent, function() {
          if (currentUserMediaRequest.remove(stream2.idInstance), "local" === stream2.type) {
            streamEndedEvent = "ended", "oninactive" in stream2 && (streamEndedEvent = "inactive"), StreamsHandler.onSyncNeeded(stream2.streamid, streamEndedEvent), connection.attachStreams.forEach(function(aStream, idx) {
              stream2.streamid === aStream.streamid && delete connection.attachStreams[idx];
            });
            var newStreamsArray = [];
            connection.attachStreams.forEach(function(aStream) {
              aStream && newStreamsArray.push(aStream);
            }), connection.attachStreams = newStreamsArray;
            var streamEvent = connection.streamEvents[stream2.streamid];
            if (streamEvent)
              return void connection.onstreamended(streamEvent);
            this.parentNode && this.parentNode.removeChild(this);
          }
        }, false);
      }
      var played = mediaElement.play();
      if (void 0 !== played) {
        var cbFired = false;
        setTimeout(function() {
          cbFired || (cbFired = true, callback(mediaElement));
        }, 1e3), played.then(function() {
          cbFired || (cbFired = true, callback(mediaElement));
        }).catch(function(error) {
          cbFired || (cbFired = true, callback(mediaElement));
        });
      } else
        callback(mediaElement);
    } else
      callback({});
  }
  function listenEventHandler(eventName, eventHandler) {
    window.removeEventListener(eventName, eventHandler), window.addEventListener(eventName, eventHandler, false);
  }
  function removeNullEntries(array) {
    var newArray = [];
    return array.forEach(function(item) {
      item && newArray.push(item);
    }), newArray;
  }
  function isData(session) {
    return !session.audio && !session.video && !session.screen && session.data;
  }
  function isNull(obj) {
    return void 0 === obj;
  }
  (that = "undefined" != typeof global ? global : null) && "undefined" == typeof window && "undefined" != typeof global && (global.navigator = { userAgent: "Fake/5.0 (FakeOS) AppleWebKit/123 (KHTML, like Gecko) Fake/12.3.4567.89 Fake/123.45", getUserMedia: function() {
  } }, global.console || (global.console = {}), void 0 === global.console.debug && (global.console.debug = global.console.info = global.console.error = global.console.log = global.console.log || function() {
    console.log(arguments);
  }), "undefined" == typeof document && (that.document = {}, document.createElement = document.captureStream = document.mozCaptureStream = function() {
    var obj = { getContext: function() {
      return obj;
    }, play: function() {
    }, pause: function() {
    }, drawImage: function() {
    }, toDataURL: function() {
      return "";
    } };
    return obj;
  }, document.addEventListener = document.removeEventListener = that.addEventListener = that.removeEventListener = function() {
  }, that.HTMLVideoElement = that.HTMLMediaElement = function() {
  }), "undefined" == typeof io && (that.io = function() {
    return { on: function(eventName, callback) {
      callback = callback || function() {
      }, "connect" === eventName && callback();
    }, emit: function(eventName, data, callback) {
      callback = callback || function() {
      }, "open-room" !== eventName && "join-room" !== eventName || callback(true, data.sessionid, null);
    } };
  }), "undefined" == typeof location && (that.location = { protocol: "file:", href: "", hash: "", origin: "self" }), "undefined" == typeof screen && (that.screen = { width: 0, height: 0 }), "undefined" == typeof URL && (that.URL = { createObjectURL: function() {
    return "";
  }, revokeObjectURL: function() {
    return "";
  } }), that.window = global), function() {
    var browserFakeUserAgent = "Fake/5.0 (FakeOS) AppleWebKit/123 (KHTML, like Gecko) Fake/12.3.4567.89 Fake/123.45";
    if (isNodejs = "object" == typeof process && "object" == typeof process.versions && process.versions.node && !process.browser) {
      var version = process.versions.node.toString().replace("v", "");
      browserFakeUserAgent = "Nodejs/" + version + " (NodeOS) AppleWebKit/" + version + " (KHTML, like Gecko) Nodejs/" + version + " Nodejs/" + version;
    }
    !function(that2) {
      "undefined" == typeof window && ("undefined" == typeof window && "undefined" != typeof global && (global.navigator = { userAgent: browserFakeUserAgent, getUserMedia: function() {
      } }, that2.window = global), "undefined" == typeof location && (that2.location = { protocol: "file:", href: "", hash: "" }), "undefined" == typeof screen && (that2.screen = { width: 0, height: 0 }));
    }("undefined" != typeof global ? global : window);
    var navigator2 = window.navigator;
    void 0 !== navigator2 ? (void 0 !== navigator2.webkitGetUserMedia && (navigator2.getUserMedia = navigator2.webkitGetUserMedia), void 0 !== navigator2.mozGetUserMedia && (navigator2.getUserMedia = navigator2.mozGetUserMedia)) : navigator2 = { getUserMedia: function() {
    }, userAgent: browserFakeUserAgent };
    var isMobileDevice = !!/Android|webOS|iPhone|iPad|iPod|BB10|BlackBerry|IEMobile|Opera Mini|Mobile|mobile/i.test(navigator2.userAgent || ""), isEdge = !(-1 === navigator2.userAgent.indexOf("Edge") || !navigator2.msSaveOrOpenBlob && !navigator2.msSaveBlob), isOpera = !!window.opera || navigator2.userAgent.indexOf(" OPR/") >= 0, isFirefox2 = void 0 !== window.InstallTrigger, isSafari = /^((?!chrome|android).)*safari/i.test(navigator2.userAgent), isChrome = !!window.chrome && !isOpera, isIE = "undefined" != typeof document && !!document.documentMode && !isEdge;
    function retry(isDone, next) {
      var currentTrial = 0, isTimeout = false, id = window.setInterval(function() {
        isDone() && (window.clearInterval(id), next(isTimeout)), currentTrial++ > 50 && (window.clearInterval(id), next(isTimeout = true));
      }, 10);
    }
    var isMobile = { Android: function() {
      return navigator2.userAgent.match(/Android/i);
    }, BlackBerry: function() {
      return navigator2.userAgent.match(/BlackBerry|BB10/i);
    }, iOS: function() {
      return navigator2.userAgent.match(/iPhone|iPad|iPod/i);
    }, Opera: function() {
      return navigator2.userAgent.match(/Opera Mini/i);
    }, Windows: function() {
      return navigator2.userAgent.match(/IEMobile/i);
    }, any: function() {
      return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows();
    }, getOsName: function() {
      var osName2 = "Unknown OS";
      return isMobile.Android() && (osName2 = "Android"), isMobile.BlackBerry() && (osName2 = "BlackBerry"), isMobile.iOS() && (osName2 = "iOS"), isMobile.Opera() && (osName2 = "Opera Mini"), isMobile.Windows() && (osName2 = "Windows"), osName2;
    } };
    var osName = "Unknown OS", osVersion = "Unknown OS Version";
    var ua, match, osInfo = function() {
      for (var cs, nVer = navigator2.appVersion, nAgt = navigator2.userAgent, os = "-", clientStrings = [{ s: "Windows 10", r: /(Windows 10.0|Windows NT 10.0)/ }, { s: "Windows 8.1", r: /(Windows 8.1|Windows NT 6.3)/ }, { s: "Windows 8", r: /(Windows 8|Windows NT 6.2)/ }, { s: "Windows 7", r: /(Windows 7|Windows NT 6.1)/ }, { s: "Windows Vista", r: /Windows NT 6.0/ }, { s: "Windows Server 2003", r: /Windows NT 5.2/ }, { s: "Windows XP", r: /(Windows NT 5.1|Windows XP)/ }, { s: "Windows 2000", r: /(Windows NT 5.0|Windows 2000)/ }, { s: "Windows ME", r: /(Win 9x 4.90|Windows ME)/ }, { s: "Windows 98", r: /(Windows 98|Win98)/ }, { s: "Windows 95", r: /(Windows 95|Win95|Windows_95)/ }, { s: "Windows NT 4.0", r: /(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)/ }, { s: "Windows CE", r: /Windows CE/ }, { s: "Windows 3.11", r: /Win16/ }, { s: "Android", r: /Android/ }, { s: "Open BSD", r: /OpenBSD/ }, { s: "Sun OS", r: /SunOS/ }, { s: "Linux", r: /(Linux|X11)/ }, { s: "iOS", r: /(iPhone|iPad|iPod)/ }, { s: "Mac OS X", r: /Mac OS X/ }, { s: "Mac OS", r: /(MacPPC|MacIntel|Mac_PowerPC|Macintosh)/ }, { s: "QNX", r: /QNX/ }, { s: "UNIX", r: /UNIX/ }, { s: "BeOS", r: /BeOS/ }, { s: "OS/2", r: /OS\/2/ }, { s: "Search Bot", r: /(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver)/ }], i = 0; cs = clientStrings[i]; i++)
        if (cs.r.test(nAgt)) {
          os = cs.s;
          break;
        }
      var osVersion2 = "-";
      switch (/Windows/.test(os) && (/Windows (.*)/.test(os) && (osVersion2 = /Windows (.*)/.exec(os)[1]), os = "Windows"), os) {
        case "Mac OS X":
          /Mac OS X (10[\.\_\d]+)/.test(nAgt) && (osVersion2 = /Mac OS X (10[\.\_\d]+)/.exec(nAgt)[1]);
          break;
        case "Android":
          /Android ([\.\_\d]+)/.test(nAgt) && (osVersion2 = /Android ([\.\_\d]+)/.exec(nAgt)[1]);
          break;
        case "iOS":
          /OS (\d+)_(\d+)_?(\d+)?/.test(nAgt) && (osVersion2 = (osVersion2 = /OS (\d+)_(\d+)_?(\d+)?/.exec(nVer))[1] + "." + osVersion2[2] + "." + (0 | osVersion2[3]));
      }
      return { osName: os, osVersion: osVersion2 };
    }();
    osInfo && osInfo.osName && "-" != osInfo.osName ? (osName = osInfo.osName, osVersion = osInfo.osVersion) : isMobile.any() && "Android" == (osName = isMobile.getOsName()) && (osVersion = !!(match = (ua = (ua || navigator2.userAgent).toLowerCase()).match(/android\s([0-9\.]*)/)) && match[1]);
    var isNodejs = "object" == typeof process && "object" == typeof process.versions && process.versions.node;
    "Unknown OS" === osName && isNodejs && (osName = "Nodejs", osVersion = process.versions.node.toString().replace("v", ""));
    var isCanvasSupportsStreamCapturing = false, isVideoSupportsStreamCapturing = false;
    ["captureStream", "mozCaptureStream", "webkitCaptureStream"].forEach(function(item) {
      "undefined" != typeof document && "function" == typeof document.createElement && (!isCanvasSupportsStreamCapturing && item in document.createElement("canvas") && (isCanvasSupportsStreamCapturing = true), !isVideoSupportsStreamCapturing && item in document.createElement("video") && (isVideoSupportsStreamCapturing = true));
    });
    var regexIpv4Local = /^(192\.168\.|169\.254\.|10\.|172\.(1[6-9]|2\d|3[01]))/, regexIpv4 = /([0-9]{1,3}(\.[0-9]{1,3}){3})/, regexIpv6 = /[a-f0-9]{1,4}(:[a-f0-9]{1,4}){7}/;
    var MediaDevices = [], audioInputDevices = [], audioOutputDevices = [], videoInputDevices = [];
    navigator2.mediaDevices && navigator2.mediaDevices.enumerateDevices && (navigator2.enumerateDevices = function(callback) {
      var enumerateDevices = navigator2.mediaDevices.enumerateDevices();
      enumerateDevices && enumerateDevices.then ? navigator2.mediaDevices.enumerateDevices().then(callback).catch(function() {
        callback([]);
      }) : callback([]);
    });
    var canEnumerate = false;
    (void 0 !== MediaStreamTrack && "getSources" in MediaStreamTrack || navigator2.mediaDevices && navigator2.mediaDevices.enumerateDevices) && (canEnumerate = true);
    var hasMicrophone = false, hasSpeakers = false, hasWebcam = false, isWebsiteHasMicrophonePermissions = false, isWebsiteHasWebcamPermissions = false;
    function checkDeviceSupport(callback) {
      if (canEnumerate)
        if (!navigator2.enumerateDevices && window.MediaStreamTrack && window.MediaStreamTrack.getSources && (navigator2.enumerateDevices = window.MediaStreamTrack.getSources.bind(window.MediaStreamTrack)), !navigator2.enumerateDevices && navigator2.enumerateDevices && (navigator2.enumerateDevices = navigator2.enumerateDevices.bind(navigator2)), navigator2.enumerateDevices) {
          MediaDevices = [], audioInputDevices = [], audioOutputDevices = [], videoInputDevices = [], hasMicrophone = false, hasSpeakers = false, hasWebcam = false, isWebsiteHasMicrophonePermissions = false, isWebsiteHasWebcamPermissions = false;
          var alreadyUsedDevices = {};
          navigator2.enumerateDevices(function(devices) {
            devices.forEach(function(_device) {
              var device = {};
              for (var d in _device)
                try {
                  "function" != typeof _device[d] && (device[d] = _device[d]);
                } catch (e) {
                }
              alreadyUsedDevices[device.deviceId + device.label + device.kind] || ("audio" === device.kind && (device.kind = "audioinput"), "video" === device.kind && (device.kind = "videoinput"), device.deviceId || (device.deviceId = device.id), device.id || (device.id = device.deviceId), device.label ? ("videoinput" !== device.kind || isWebsiteHasWebcamPermissions || (isWebsiteHasWebcamPermissions = true), "audioinput" !== device.kind || isWebsiteHasMicrophonePermissions || (isWebsiteHasMicrophonePermissions = true)) : (device.isCustomLabel = true, "videoinput" === device.kind ? device.label = "Camera " + (videoInputDevices.length + 1) : "audioinput" === device.kind ? device.label = "Microphone " + (audioInputDevices.length + 1) : "audiooutput" === device.kind ? device.label = "Speaker " + (audioOutputDevices.length + 1) : device.label = "Please invoke getUserMedia once.", void 0 !== DetectRTC2 && DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 46 && !/^(https:|chrome-extension:)$/g.test(location.protocol || "") && "undefined" != typeof document && "string" == typeof document.domain && document.domain.search && -1 === document.domain.search(/localhost|127.0./g) && (device.label = "HTTPs is required to get label of this " + device.kind + " device.")), "audioinput" === device.kind && (hasMicrophone = true, -1 === audioInputDevices.indexOf(device) && audioInputDevices.push(device)), "audiooutput" === device.kind && (hasSpeakers = true, -1 === audioOutputDevices.indexOf(device) && audioOutputDevices.push(device)), "videoinput" === device.kind && (hasWebcam = true, -1 === videoInputDevices.indexOf(device) && videoInputDevices.push(device)), MediaDevices.push(device), alreadyUsedDevices[device.deviceId + device.label + device.kind] = device);
            }), void 0 !== DetectRTC2 && (DetectRTC2.MediaDevices = MediaDevices, DetectRTC2.hasMicrophone = hasMicrophone, DetectRTC2.hasSpeakers = hasSpeakers, DetectRTC2.hasWebcam = hasWebcam, DetectRTC2.isWebsiteHasWebcamPermissions = isWebsiteHasWebcamPermissions, DetectRTC2.isWebsiteHasMicrophonePermissions = isWebsiteHasMicrophonePermissions, DetectRTC2.audioInputDevices = audioInputDevices, DetectRTC2.audioOutputDevices = audioOutputDevices, DetectRTC2.videoInputDevices = videoInputDevices), callback && callback();
          });
        } else
          callback && callback();
      else
        callback && callback();
    }
    var DetectRTC2 = window.DetectRTC || {};
    DetectRTC2.browser = function() {
      navigator2.appVersion;
      var nameOffset, verOffset, ix, nAgt = navigator2.userAgent, browserName = navigator2.appName, fullVersion = "" + parseFloat(navigator2.appVersion), majorVersion = parseInt(navigator2.appVersion, 10);
      if (isSafari && !isChrome && -1 !== nAgt.indexOf("CriOS") && (isSafari = false, isChrome = true), isOpera) {
        browserName = "Opera";
        try {
          majorVersion = (fullVersion = navigator2.userAgent.split("OPR/")[1].split(" ")[0]).split(".")[0];
        } catch (e) {
          fullVersion = "0.0.0.0", majorVersion = 0;
        }
      } else
        isIE ? ((verOffset = nAgt.indexOf("rv:")) > 0 ? fullVersion = nAgt.substring(verOffset + 3) : (verOffset = nAgt.indexOf("MSIE"), fullVersion = nAgt.substring(verOffset + 5)), browserName = "IE") : isChrome ? (verOffset = nAgt.indexOf("Chrome"), browserName = "Chrome", fullVersion = nAgt.substring(verOffset + 7)) : isSafari ? (verOffset = nAgt.indexOf("Safari"), browserName = "Safari", fullVersion = nAgt.substring(verOffset + 7), -1 !== (verOffset = nAgt.indexOf("Version")) && (fullVersion = nAgt.substring(verOffset + 8)), -1 !== navigator2.userAgent.indexOf("Version/") && (fullVersion = navigator2.userAgent.split("Version/")[1].split(" ")[0])) : isFirefox2 ? (verOffset = nAgt.indexOf("Firefox"), browserName = "Firefox", fullVersion = nAgt.substring(verOffset + 8)) : (nameOffset = nAgt.lastIndexOf(" ") + 1) < (verOffset = nAgt.lastIndexOf("/")) && (browserName = nAgt.substring(nameOffset, verOffset), fullVersion = nAgt.substring(verOffset + 1), browserName.toLowerCase() === browserName.toUpperCase() && (browserName = navigator2.appName));
      return isEdge && (browserName = "Edge", fullVersion = navigator2.userAgent.split("Edge/")[1]), -1 !== (ix = fullVersion.search(/[; \)]/)) && (fullVersion = fullVersion.substring(0, ix)), majorVersion = parseInt("" + fullVersion, 10), isNaN(majorVersion) && (fullVersion = "" + parseFloat(navigator2.appVersion), majorVersion = parseInt(navigator2.appVersion, 10)), { fullVersion, version: majorVersion, name: browserName, isPrivateBrowsing: false };
    }(), function(callback) {
      var isPrivate;
      try {
        if (window.webkitRequestFileSystem)
          window.webkitRequestFileSystem(window.TEMPORARY, 1, function() {
            isPrivate = false;
          }, function(e) {
            isPrivate = true;
          });
        else if (window.indexedDB && /Firefox/.test(window.navigator.userAgent)) {
          var db;
          try {
            (db = window.indexedDB.open("test")).onerror = function() {
              return true;
            };
          } catch (e) {
            isPrivate = true;
          }
          void 0 === isPrivate && retry(function() {
            return "done" === db.readyState;
          }, function(isTimeout) {
            isTimeout || (isPrivate = !db.result);
          });
        } else if (function(userAgent) {
          var ua2 = userAgent.toLowerCase();
          if (0 === ua2.indexOf("msie") && 0 === ua2.indexOf("trident"))
            return false;
          var match2 = /(?:msie|rv:)\s?([\d\.]+)/.exec(ua2);
          return !!(match2 && parseInt(match2[1], 10) >= 10);
        }(window.navigator.userAgent)) {
          isPrivate = false;
          try {
            window.indexedDB || (isPrivate = true);
          } catch (e) {
            isPrivate = true;
          }
        } else if (window.localStorage && /Safari/.test(window.navigator.userAgent)) {
          try {
            window.localStorage.setItem("test", 1);
          } catch (e) {
            isPrivate = true;
          }
          void 0 === isPrivate && (isPrivate = false, window.localStorage.removeItem("test"));
        }
      } catch (e) {
        isPrivate = false;
      }
      retry(function() {
        return void 0 !== isPrivate;
      }, function(isTimeout) {
        callback(isPrivate);
      });
    }(function(isPrivateBrowsing) {
      DetectRTC2.browser.isPrivateBrowsing = !!isPrivateBrowsing;
    }), DetectRTC2.browser["is" + DetectRTC2.browser.name] = true, DetectRTC2.osName = osName, DetectRTC2.osVersion = osVersion;
    "object" == typeof process && "object" == typeof process.versions && process.versions["node-webkit"];
    var isWebRTCSupported = false;
    ["RTCPeerConnection", "webkitRTCPeerConnection", "mozRTCPeerConnection", "RTCIceGatherer"].forEach(function(item) {
      isWebRTCSupported || item in window && (isWebRTCSupported = true);
    }), DetectRTC2.isWebRTCSupported = isWebRTCSupported, DetectRTC2.isORTCSupported = "undefined" != typeof RTCIceGatherer;
    var isScreenCapturingSupported = false;
    ((DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 35 || DetectRTC2.browser.isFirefox && DetectRTC2.browser.version >= 34 || DetectRTC2.browser.isEdge && DetectRTC2.browser.version >= 17 || "Android" === DetectRTC2.osName && DetectRTC2.browser.isChrome) && (isScreenCapturingSupported = true), /^(https:|chrome-extension:)$/g.test(location.protocol || "")) || ("undefined" != typeof document && "string" == typeof document.domain && document.domain.search && -1 === document.domain.search(/localhost|127.0./g) && (DetectRTC2.browser.isChrome || DetectRTC2.browser.isEdge || DetectRTC2.browser.isOpera) || DetectRTC2.browser.isFirefox) && (isScreenCapturingSupported = false);
    DetectRTC2.isScreenCapturingSupported = isScreenCapturingSupported;
    var webAudio = { isSupported: false, isCreateMediaStreamSourceSupported: false };
    ["AudioContext", "webkitAudioContext", "mozAudioContext", "msAudioContext"].forEach(function(item) {
      webAudio.isSupported || item in window && (webAudio.isSupported = true, window[item] && "createMediaStreamSource" in window[item].prototype && (webAudio.isCreateMediaStreamSourceSupported = true));
    }), DetectRTC2.isAudioContextSupported = webAudio.isSupported, DetectRTC2.isCreateMediaStreamSourceSupported = webAudio.isCreateMediaStreamSourceSupported;
    var isRtpDataChannelsSupported = false;
    DetectRTC2.browser.isChrome && DetectRTC2.browser.version > 31 && (isRtpDataChannelsSupported = true), DetectRTC2.isRtpDataChannelsSupported = isRtpDataChannelsSupported;
    var isSCTPSupportd = false;
    (DetectRTC2.browser.isFirefox && DetectRTC2.browser.version > 28 || DetectRTC2.browser.isChrome && DetectRTC2.browser.version > 25 || DetectRTC2.browser.isOpera && DetectRTC2.browser.version >= 11) && (isSCTPSupportd = true), DetectRTC2.isSctpDataChannelsSupported = isSCTPSupportd, DetectRTC2.isMobileDevice = isMobileDevice;
    var isGetUserMediaSupported = false;
    (navigator2.getUserMedia || navigator2.mediaDevices && navigator2.mediaDevices.getUserMedia) && (isGetUserMediaSupported = true), DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 46 && !/^(https:|chrome-extension:)$/g.test(location.protocol || "") && "undefined" != typeof document && "string" == typeof document.domain && document.domain.search && -1 === document.domain.search(/localhost|127.0./g) && (isGetUserMediaSupported = "Requires HTTPs"), "Nodejs" === DetectRTC2.osName && (isGetUserMediaSupported = false), DetectRTC2.isGetUserMediaSupported = isGetUserMediaSupported;
    var w, h, r, displayResolution = "";
    screen.width && (displayResolution += (screen.width ? screen.width : "") + " x " + (screen.height ? screen.height : ""));
    DetectRTC2.displayResolution = displayResolution, DetectRTC2.displayAspectRatio = (w = screen.width, h = screen.height, r = function gcd(a, b) {
      return 0 == b ? a : gcd(b, a % b);
    }(w, h), w / r / (h / r)).toFixed(2), DetectRTC2.isCanvasSupportsStreamCapturing = isCanvasSupportsStreamCapturing, DetectRTC2.isVideoSupportsStreamCapturing = isVideoSupportsStreamCapturing, "Chrome" == DetectRTC2.browser.name && DetectRTC2.browser.version >= 53 && (DetectRTC2.isCanvasSupportsStreamCapturing || (DetectRTC2.isCanvasSupportsStreamCapturing = "Requires chrome flag: enable-experimental-web-platform-features"), DetectRTC2.isVideoSupportsStreamCapturing || (DetectRTC2.isVideoSupportsStreamCapturing = "Requires chrome flag: enable-experimental-web-platform-features")), DetectRTC2.DetectLocalIPAddress = function(callback, stream2) {
      if (DetectRTC2.isWebRTCSupported) {
        var isPublic = true, isIpv4 = true;
        !function(callback2, stream3) {
          if ("undefined" == typeof document || "function" != typeof document.getElementById)
            return;
          var ipDuplicates = {}, RTCPeerConnection3 = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
          if (!RTCPeerConnection3) {
            var iframe = document.getElementById("iframe");
            if (!iframe)
              return;
            var win = iframe.contentWindow;
            RTCPeerConnection3 = win.RTCPeerConnection || win.mozRTCPeerConnection || win.webkitRTCPeerConnection;
          }
          if (!RTCPeerConnection3)
            return;
          var peerConfig = null;
          "Chrome" === DetectRTC2.browser && DetectRTC2.browser.version < 58 && (peerConfig = { optional: [{ RtpDataChannels: true }] });
          var pc = new RTCPeerConnection3({ iceServers: [{ urls: "stun:stun.l.google.com:19302" }] }, peerConfig);
          stream3 && (pc.addStream ? pc.addStream(stream3) : pc.addTrack && stream3.getTracks()[0] && pc.addTrack(stream3.getTracks()[0], stream3));
          function handleCandidate(candidate) {
            if (candidate) {
              var match2 = regexIpv4.exec(candidate);
              if (match2) {
                var ipAddress = match2[1], isPublic2 = candidate.match(regexIpv4Local), isIpv42 = true;
                void 0 === ipDuplicates[ipAddress] && callback2(ipAddress, isPublic2, isIpv42), ipDuplicates[ipAddress] = true;
              }
            } else
              callback2();
          }
          if (pc.onicecandidate = function(event2) {
            event2.candidate && event2.candidate.candidate ? handleCandidate(event2.candidate.candidate) : handleCandidate();
          }, !stream3)
            try {
              pc.createDataChannel("sctp", {});
            } catch (e) {
            }
          DetectRTC2.isPromisesSupported ? pc.createOffer().then(function(result) {
            pc.setLocalDescription(result).then(afterCreateOffer);
          }) : pc.createOffer(function(result) {
            pc.setLocalDescription(result, afterCreateOffer, function() {
            });
          }, function() {
          });
          function afterCreateOffer() {
            pc.localDescription.sdp.split("\n").forEach(function(line) {
              line && 0 === line.indexOf("a=candidate:") && handleCandidate(line);
            });
          }
        }(function(ip) {
          ip ? ip.match(regexIpv4Local) ? callback("Local: " + ip, isPublic = false, isIpv4) : ip.match(regexIpv6) ? callback("Public: " + ip, isPublic, isIpv4 = false) : callback("Public: " + ip, isPublic, isIpv4) : callback();
        }, stream2);
      }
    }, DetectRTC2.isWebSocketsSupported = "WebSocket" in window && 2 === window.WebSocket.CLOSING, DetectRTC2.isWebSocketsBlocked = !DetectRTC2.isWebSocketsSupported, "Nodejs" === DetectRTC2.osName && (DetectRTC2.isWebSocketsSupported = true, DetectRTC2.isWebSocketsBlocked = false), DetectRTC2.checkWebSocketsSupport = function(callback) {
      callback = callback || function() {
      };
      try {
        var starttime, websocket = new WebSocket("wss://echo.websocket.org:443/");
        websocket.onopen = function() {
          DetectRTC2.isWebSocketsBlocked = false, starttime = new Date().getTime(), websocket.send("ping");
        }, websocket.onmessage = function() {
          DetectRTC2.WebsocketLatency = new Date().getTime() - starttime + "ms", callback(), websocket.close(), websocket = null;
        }, websocket.onerror = function() {
          DetectRTC2.isWebSocketsBlocked = true, callback();
        };
      } catch (e) {
        DetectRTC2.isWebSocketsBlocked = true, callback();
      }
    }, DetectRTC2.load = function(callback) {
      checkDeviceSupport(callback = callback || function() {
      });
    }, DetectRTC2.MediaDevices = void 0 !== MediaDevices ? MediaDevices : [], DetectRTC2.hasMicrophone = hasMicrophone, DetectRTC2.hasSpeakers = hasSpeakers, DetectRTC2.hasWebcam = hasWebcam, DetectRTC2.isWebsiteHasWebcamPermissions = isWebsiteHasWebcamPermissions, DetectRTC2.isWebsiteHasMicrophonePermissions = isWebsiteHasMicrophonePermissions, DetectRTC2.audioInputDevices = audioInputDevices, DetectRTC2.audioOutputDevices = audioOutputDevices, DetectRTC2.videoInputDevices = videoInputDevices;
    var isSetSinkIdSupported = false;
    "undefined" != typeof document && "function" == typeof document.createElement && "setSinkId" in document.createElement("video") && (isSetSinkIdSupported = true), DetectRTC2.isSetSinkIdSupported = isSetSinkIdSupported;
    var isRTPSenderReplaceTracksSupported = false;
    DetectRTC2.browser.isFirefox && "undefined" != typeof mozRTCPeerConnection ? "getSenders" in mozRTCPeerConnection.prototype && (isRTPSenderReplaceTracksSupported = true) : DetectRTC2.browser.isChrome && "undefined" != typeof webkitRTCPeerConnection && "getSenders" in webkitRTCPeerConnection.prototype && (isRTPSenderReplaceTracksSupported = true), DetectRTC2.isRTPSenderReplaceTracksSupported = isRTPSenderReplaceTracksSupported;
    var isRemoteStreamProcessingSupported = false;
    DetectRTC2.browser.isFirefox && DetectRTC2.browser.version > 38 && (isRemoteStreamProcessingSupported = true), DetectRTC2.isRemoteStreamProcessingSupported = isRemoteStreamProcessingSupported;
    var isApplyConstraintsSupported = false;
    void 0 !== MediaStreamTrack && "applyConstraints" in MediaStreamTrack.prototype && (isApplyConstraintsSupported = true), DetectRTC2.isApplyConstraintsSupported = isApplyConstraintsSupported;
    var isMultiMonitorScreenCapturingSupported = false;
    DetectRTC2.browser.isFirefox && DetectRTC2.browser.version >= 43 && (isMultiMonitorScreenCapturingSupported = true), DetectRTC2.isMultiMonitorScreenCapturingSupported = isMultiMonitorScreenCapturingSupported, DetectRTC2.isPromisesSupported = !!("Promise" in window), DetectRTC2.version = "1.3.9", void 0 === DetectRTC2 && (window.DetectRTC = {});
    var MediaStream2 = window.MediaStream;
    void 0 === MediaStream2 && "undefined" != typeof webkitMediaStream && (MediaStream2 = webkitMediaStream), DetectRTC2.MediaStream = void 0 !== MediaStream2 && "function" == typeof MediaStream2 && Object.keys(MediaStream2.prototype), DetectRTC2.MediaStreamTrack = void 0 !== MediaStreamTrack && Object.keys(MediaStreamTrack.prototype);
    var RTCPeerConnection2 = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
    DetectRTC2.RTCPeerConnection = void 0 !== RTCPeerConnection2 && Object.keys(RTCPeerConnection2.prototype), window.DetectRTC = DetectRTC2, "undefined" != typeof module && (module.exports = DetectRTC2), "function" == typeof define && define.amd && define("DetectRTC", [], function() {
      return DetectRTC2;
    });
  }(), "undefined" != typeof cordova && (DetectRTC.isMobileDevice = true, DetectRTC.browser.name = "Chrome"), navigator && navigator.userAgent && -1 !== navigator.userAgent.indexOf("Crosswalk") && (DetectRTC.isMobileDevice = true, DetectRTC.browser.name = "Chrome"), window.addEventListener || (window.addEventListener = function(el, eventName, eventHandler) {
    el.attachEvent && el.attachEvent("on" + eventName, eventHandler);
  }), window.attachEventListener = function(video, type, listener, useCapture) {
    video.addEventListener(type, listener, useCapture);
  };
  var MediaStream = window.MediaStream;
  function isAudioPlusTab(connection, audioPlusTab) {
    return (!connection.session.audio || "two-way" !== connection.session.audio) && ("Firefox" === DetectRTC.browser.name && false !== audioPlusTab || !("Chrome" !== DetectRTC.browser.name || DetectRTC.browser.version < 50) && (true === typeof audioPlusTab || !(void 0 !== audioPlusTab || !connection.session.audio || !connection.session.screen || connection.session.video) && (audioPlusTab = true, true)));
  }
  function getTracks(stream2, kind) {
    return stream2 && stream2.getTracks ? stream2.getTracks().filter(function(t) {
      return t.kind === (kind || "audio");
    }) : [];
  }
  function isUnifiedPlanSupportedDefault() {
    var canAddTransceiver = false;
    try {
      if ("undefined" == typeof RTCRtpTransceiver)
        return false;
      if (!("currentDirection" in RTCRtpTransceiver.prototype))
        return false;
      var tempPc = new RTCPeerConnection();
      try {
        tempPc.addTransceiver("audio"), canAddTransceiver = true;
      } catch (e) {
      }
      tempPc.close();
    } catch (e) {
      canAddTransceiver = false;
    }
    return canAddTransceiver && function() {
      var isUnifiedPlanSupported = false;
      try {
        var pc = new RTCPeerConnection({ sdpSemantics: "unified-plan" });
        try {
          var config = pc.getConfiguration();
          isUnifiedPlanSupported = "unified-plan" == config.sdpSemantics || (config.sdpSemantics, false);
        } catch (e) {
          isUnifiedPlanSupported = false;
        }
      } catch (e) {
        isUnifiedPlanSupported = false;
      }
      return isUnifiedPlanSupported;
    }();
  }
  function setCordovaAPIs() {
    if ("undefined" != typeof cordova && void 0 !== cordova.plugins && void 0 !== cordova.plugins.iosrtc) {
      var iosrtc = cordova.plugins.iosrtc;
      window.webkitRTCPeerConnection = iosrtc.RTCPeerConnection, window.RTCSessionDescription = iosrtc.RTCSessionDescription, window.RTCIceCandidate = iosrtc.RTCIceCandidate, window.MediaStream = iosrtc.MediaStream, window.MediaStreamTrack = iosrtc.MediaStreamTrack, navigator.getUserMedia = navigator.webkitGetUserMedia = iosrtc.getUserMedia, iosrtc.debug.enable("iosrtc*"), "function" == typeof iosrtc.selectAudioOutput && iosrtc.selectAudioOutput(window.iOSDefaultAudioOutputDevice || "speaker"), iosrtc.registerGlobals();
    }
  }
  void 0 === MediaStream && "undefined" != typeof webkitMediaStream && (MediaStream = webkitMediaStream), void 0 !== MediaStream && ("stop" in MediaStream.prototype || (MediaStream.prototype.stop = function() {
    this.getTracks().forEach(function(track) {
      track.stop();
    });
  })), window.iOSDefaultAudioOutputDevice = window.iOSDefaultAudioOutputDevice || "speaker", document.addEventListener("deviceready", setCordovaAPIs, false), setCordovaAPIs();
  var RTCPeerConnection, defaults = {};
  function setSdpConstraints(config) {
    return { OfferToReceiveAudio: !!config.OfferToReceiveAudio, OfferToReceiveVideo: !!config.OfferToReceiveVideo };
  }
  void 0 !== window.RTCPeerConnection ? RTCPeerConnection = window.RTCPeerConnection : "undefined" != typeof mozRTCPeerConnection ? RTCPeerConnection = mozRTCPeerConnection : "undefined" != typeof webkitRTCPeerConnection && (RTCPeerConnection = webkitRTCPeerConnection);
  var RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription, RTCIceCandidate = window.RTCIceCandidate || window.mozRTCIceCandidate, MediaStreamTrack = window.MediaStreamTrack;
  function PeerInitiator(config) {
    if (void 0 !== window.RTCPeerConnection ? RTCPeerConnection = window.RTCPeerConnection : "undefined" != typeof mozRTCPeerConnection ? RTCPeerConnection = mozRTCPeerConnection : "undefined" != typeof webkitRTCPeerConnection && (RTCPeerConnection = webkitRTCPeerConnection), RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription, RTCIceCandidate = window.RTCIceCandidate || window.mozRTCIceCandidate, MediaStreamTrack = window.MediaStreamTrack, !RTCPeerConnection)
      throw "WebRTC 1.0 (RTCPeerConnection) API are NOT available in this browser.";
    var connection = config.rtcMultiConnection;
    this.extra = config.remoteSdp ? config.remoteSdp.extra : connection.extra, this.userid = config.userid, this.streams = [], this.channels = config.channels || [], this.connectionDescription = config.connectionDescription, this.addStream = function(session) {
      connection.addStream(session, self.userid);
    }, this.removeStream = function(streamid) {
      connection.removeStream(streamid, self.userid);
    };
    var self = this;
    config.remoteSdp && (this.connectionDescription = config.remoteSdp.connectionDescription);
    var peer, allRemoteStreams = {};
    defaults.sdpConstraints = setSdpConstraints({ OfferToReceiveAudio: true, OfferToReceiveVideo: true });
    var renegotiatingPeer = !!config.renegotiatingPeer;
    config.remoteSdp && (renegotiatingPeer = !!config.remoteSdp.renegotiatingPeer);
    var localStreams = [];
    if (connection.attachStreams.forEach(function(stream2) {
      stream2 && localStreams.push(stream2);
    }), renegotiatingPeer)
      peer = config.peerRef;
    else {
      var iceTransports = "all";
      (connection.candidates.turn || connection.candidates.relay) && (connection.candidates.stun || connection.candidates.reflexive || connection.candidates.host || (iceTransports = "relay"));
      try {
        var params = { iceServers: connection.iceServers, iceTransportPolicy: connection.iceTransportPolicy || iceTransports };
        void 0 !== connection.iceCandidatePoolSize && (params.iceCandidatePoolSize = connection.iceCandidatePoolSize), void 0 !== connection.bundlePolicy && (params.bundlePolicy = connection.bundlePolicy), void 0 !== connection.rtcpMuxPolicy && (params.rtcpMuxPolicy = connection.rtcpMuxPolicy), connection.sdpSemantics && (params.sdpSemantics = connection.sdpSemantics || "unified-plan"), connection.iceServers && connection.iceServers.length || (params = null, connection.optionalArgument = null), peer = new RTCPeerConnection(params, connection.optionalArgument);
      } catch (e) {
        try {
          params = { iceServers: connection.iceServers };
          peer = new RTCPeerConnection(params);
        } catch (e2) {
          peer = new RTCPeerConnection();
        }
      }
    }
    !peer.getRemoteStreams && peer.getReceivers && (peer.getRemoteStreams = function() {
      var stream2 = new MediaStream();
      return peer.getReceivers().forEach(function(receiver) {
        stream2.addTrack(receiver.track);
      }), [stream2];
    }), !peer.getLocalStreams && peer.getSenders && (peer.getLocalStreams = function() {
      var stream2 = new MediaStream();
      return peer.getSenders().forEach(function(sender) {
        stream2.addTrack(sender.track);
      }), [stream2];
    }), peer.onicecandidate = function(event2) {
      if (event2.candidate)
        connection.trickleIce && config.onLocalCandidate({ candidate: event2.candidate.candidate, sdpMid: event2.candidate.sdpMid, sdpMLineIndex: event2.candidate.sdpMLineIndex });
      else if (!connection.trickleIce) {
        var localSdp = peer.localDescription;
        config.onLocalSdp({ type: localSdp.type, sdp: localSdp.sdp, remotePeerSdpConstraints: config.remotePeerSdpConstraints || false, renegotiatingPeer: !!config.renegotiatingPeer || false, connectionDescription: self.connectionDescription, dontGetRemoteStream: !!config.dontGetRemoteStream, extra: connection ? connection.extra : {}, streamsToShare });
      }
    }, localStreams.forEach(function(localStream) {
      config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.dontGetRemoteStream || config.dontAttachLocalStream || (localStream = connection.beforeAddingStream(localStream, self)) && (peer.getLocalStreams().forEach(function(stream2) {
        localStream && stream2.id == localStream.id && (localStream = null);
      }), localStream && localStream.getTracks && localStream.getTracks().forEach(function(track) {
        try {
          peer.addTrack(track, localStream);
        } catch (e) {
        }
      }));
    }), peer.oniceconnectionstatechange = peer.onsignalingstatechange = function() {
      var extra = self.extra;
      connection.peers[self.userid] && (extra = connection.peers[self.userid].extra || extra), peer && (config.onPeerStateChanged({ iceConnectionState: peer.iceConnectionState, iceGatheringState: peer.iceGatheringState, signalingState: peer.signalingState, extra, userid: self.userid }), peer && peer.iceConnectionState && -1 !== peer.iceConnectionState.search(/closed|failed/gi) && self.streams instanceof Array && self.streams.forEach(function(stream2) {
        var streamEvent = connection.streamEvents[stream2.id] || { streamid: stream2.id, stream: stream2, type: "remote" };
        connection.onstreamended(streamEvent);
      }));
    };
    var sdpConstraints = { OfferToReceiveAudio: !!localStreams.length, OfferToReceiveVideo: !!localStreams.length };
    config.localPeerSdpConstraints && (sdpConstraints = config.localPeerSdpConstraints), defaults.sdpConstraints = setSdpConstraints(sdpConstraints);
    var dontDuplicate = {};
    peer.ontrack = function(event2) {
      if (event2 && "track" === event2.type)
        if (event2.stream = event2.streams[event2.streams.length - 1], event2.stream.id || (event2.stream.id = event2.track.id), dontDuplicate[event2.stream.id] && "Safari" !== DetectRTC.browser.name)
          event2.track && (event2.track.onended = function() {
            peer && peer.onremovestream(event2);
          });
        else {
          dontDuplicate[event2.stream.id] = event2.stream.id;
          var streamsToShare2 = {};
          config.remoteSdp && config.remoteSdp.streamsToShare ? streamsToShare2 = config.remoteSdp.streamsToShare : config.streamsToShare && (streamsToShare2 = config.streamsToShare);
          var streamToShare = streamsToShare2[event2.stream.id];
          streamToShare ? (event2.stream.isAudio = streamToShare.isAudio, event2.stream.isVideo = streamToShare.isVideo, event2.stream.isScreen = streamToShare.isScreen) : (event2.stream.isVideo = !!getTracks(event2.stream, "video").length, event2.stream.isAudio = !event2.stream.isVideo, event2.stream.isScreen = false), event2.stream.streamid = event2.stream.id, allRemoteStreams[event2.stream.id] = event2.stream, config.onRemoteStream(event2.stream), event2.stream.getTracks().forEach(function(track) {
            track.onended = function() {
              peer && peer.onremovestream(event2);
            };
          }), event2.stream.onremovetrack = function() {
            peer && peer.onremovestream(event2);
          };
        }
    }, peer.onremovestream = function(event2) {
      event2.stream.streamid = event2.stream.id, allRemoteStreams[event2.stream.id] && delete allRemoteStreams[event2.stream.id], config.onRemoteStreamRemoved(event2.stream);
    }, "function" != typeof peer.removeStream && (peer.removeStream = function(stream2) {
      stream2.getTracks().forEach(function(track) {
        peer.removeTrack(track, stream2);
      });
    }), this.addRemoteCandidate = function(remoteCandidate) {
      peer.addIceCandidate(new RTCIceCandidate(remoteCandidate));
    }, this.addRemoteSdp = function(remoteSdp, cb) {
      cb = cb || function() {
      }, "Safari" !== DetectRTC.browser.name && (remoteSdp.sdp = connection.processSdp(remoteSdp.sdp)), peer.setRemoteDescription(new RTCSessionDescription(remoteSdp)).then(cb, function(error) {
        connection.enableLogs && console.error("setRemoteDescription failed", "\n", error, "\n", remoteSdp.sdp), cb();
      }).catch(function(error) {
        connection.enableLogs && console.error("setRemoteDescription failed", "\n", error, "\n", remoteSdp.sdp), cb();
      });
    };
    var isOfferer = true;
    function setChannelEvents(channel) {
      channel.binaryType = "arraybuffer", channel.onmessage = function(event2) {
        config.onDataChannelMessage(event2.data);
      }, channel.onopen = function() {
        config.onDataChannelOpened(channel);
      }, channel.onerror = function(error) {
        config.onDataChannelError(error);
      }, channel.onclose = function(event2) {
        config.onDataChannelClosed(event2);
      }, channel.internalSend = channel.send, channel.send = function(data) {
        "open" === channel.readyState && channel.internalSend(data);
      }, peer.channel = channel;
    }
    config.remoteSdp && (isOfferer = false), this.createDataChannel = function() {
      setChannelEvents(peer.createDataChannel("sctp", {}));
    }, true !== connection.session.data || renegotiatingPeer || (isOfferer ? this.createDataChannel() : peer.ondatachannel = function(event2) {
      setChannelEvents(event2.channel);
    }), this.enableDisableVideoEncoding = function(enable) {
      var rtcp;
      if (peer.getSenders().forEach(function(sender) {
        rtcp || "video" !== sender.track.kind || (rtcp = sender);
      }), rtcp && rtcp.getParameters) {
        var parameters = rtcp.getParameters();
        parameters.encodings[1] && (parameters.encodings[1].active = !!enable), parameters.encodings[2] && (parameters.encodings[2].active = !!enable), rtcp.setParameters(parameters);
      }
    }, config.remoteSdp && (config.remoteSdp.remotePeerSdpConstraints && (sdpConstraints = config.remoteSdp.remotePeerSdpConstraints), defaults.sdpConstraints = setSdpConstraints(sdpConstraints), this.addRemoteSdp(config.remoteSdp, function() {
      createOfferOrAnswer("createAnswer");
    })), "two-way" != connection.session.audio && "two-way" != connection.session.video && "two-way" != connection.session.screen || (defaults.sdpConstraints = setSdpConstraints({ OfferToReceiveAudio: "two-way" == connection.session.audio || config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.OfferToReceiveAudio, OfferToReceiveVideo: "two-way" == connection.session.video || "two-way" == connection.session.screen || config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.OfferToReceiveAudio }));
    var streamsToShare = {};
    function createOfferOrAnswer(_method) {
      peer && peer[_method] && peer[_method](defaults.sdpConstraints).then(function(localSdp) {
        "Safari" !== DetectRTC.browser.name && (localSdp.sdp = connection.processSdp(localSdp.sdp)), peer && peer.setLocalDescription(localSdp).then(function() {
          connection.trickleIce && (config.onLocalSdp({ type: localSdp.type, sdp: localSdp.sdp, remotePeerSdpConstraints: config.remotePeerSdpConstraints || false, renegotiatingPeer: !!config.renegotiatingPeer || false, connectionDescription: self.connectionDescription, dontGetRemoteStream: !!config.dontGetRemoteStream, extra: connection ? connection.extra : {}, streamsToShare }), connection.onSettingLocalDescription(self));
        }, function(error) {
          connection.enableLogs && console.error("setLocalDescription error", error);
        });
      }, function(error) {
        connection.enableLogs && console.error("sdp-error", error);
      });
    }
    peer.getLocalStreams().forEach(function(stream2) {
      streamsToShare[stream2.streamid] = { isAudio: !!stream2.isAudio, isVideo: !!stream2.isVideo, isScreen: !!stream2.isScreen };
    }), isOfferer && createOfferOrAnswer("createOffer"), peer.nativeClose = peer.close, peer.close = function() {
      if (peer) {
        try {
          peer.nativeClose !== peer.close && peer.nativeClose();
        } catch (e) {
        }
        peer = null, self.peer = null;
      }
    }, this.peer = peer;
  }
  var CodecsHandler = function() {
    function preferCodec(sdp, codecName) {
      var info = splitLines(sdp);
      return info.videoCodecNumbers ? "vp8" === codecName && info.vp8LineNumber === info.videoCodecNumbers[0] || "vp9" === codecName && info.vp9LineNumber === info.videoCodecNumbers[0] || "h264" === codecName && info.h264LineNumber === info.videoCodecNumbers[0] ? sdp : sdp = preferCodecHelper(sdp, codecName, info) : sdp;
    }
    function preferCodecHelper(sdp, codec, info, ignore) {
      var preferCodecNumber = "";
      if ("vp8" === codec) {
        if (!info.vp8LineNumber)
          return sdp;
        preferCodecNumber = info.vp8LineNumber;
      }
      if ("vp9" === codec) {
        if (!info.vp9LineNumber)
          return sdp;
        preferCodecNumber = info.vp9LineNumber;
      }
      if ("h264" === codec) {
        if (!info.h264LineNumber)
          return sdp;
        preferCodecNumber = info.h264LineNumber;
      }
      var newLine = info.videoCodecNumbersOriginal.split("SAVPF")[0] + "SAVPF ", newOrder = [preferCodecNumber];
      return ignore && (newOrder = []), info.videoCodecNumbers.forEach(function(codecNumber) {
        codecNumber !== preferCodecNumber && newOrder.push(codecNumber);
      }), newLine += newOrder.join(" "), sdp = sdp.replace(info.videoCodecNumbersOriginal, newLine);
    }
    function splitLines(sdp) {
      var info = {};
      return sdp.split("\n").forEach(function(line) {
        0 === line.indexOf("m=video") && (info.videoCodecNumbers = [], line.split("SAVPF")[1].split(" ").forEach(function(codecNumber) {
          (codecNumber = codecNumber.trim()) && codecNumber.length && (info.videoCodecNumbers.push(codecNumber), info.videoCodecNumbersOriginal = line);
        })), -1 === line.indexOf("VP8/90000") || info.vp8LineNumber || (info.vp8LineNumber = line.replace("a=rtpmap:", "").split(" ")[0]), -1 === line.indexOf("VP9/90000") || info.vp9LineNumber || (info.vp9LineNumber = line.replace("a=rtpmap:", "").split(" ")[0]), -1 === line.indexOf("H264/90000") || info.h264LineNumber || (info.h264LineNumber = line.replace("a=rtpmap:", "").split(" ")[0]);
      }), info;
    }
    function findLine(sdpLines, prefix, substr) {
      return function(sdpLines2, startLine, endLine, prefix2, substr2) {
        for (var realEndLine = -1 !== endLine ? endLine : sdpLines2.length, i = startLine; i < realEndLine; ++i)
          if (0 === sdpLines2[i].indexOf(prefix2) && (!substr2 || -1 !== sdpLines2[i].toLowerCase().indexOf(substr2.toLowerCase())))
            return i;
        return null;
      }(sdpLines, 0, -1, prefix, substr);
    }
    function getCodecPayloadType(sdpLine) {
      var pattern = new RegExp("a=rtpmap:(\\d+) \\w+\\/\\d+"), result = sdpLine.match(pattern);
      return result && 2 === result.length ? result[1] : null;
    }
    return { removeVPX: function(sdp) {
      var info = splitLines(sdp);
      return sdp = preferCodecHelper(sdp, "vp9", info, true), sdp = preferCodecHelper(sdp, "vp8", info, true);
    }, disableNACK: function(sdp) {
      if (!sdp || "string" != typeof sdp)
        throw "Invalid arguments.";
      return sdp = (sdp = (sdp = (sdp = sdp.replace("a=rtcp-fb:126 nack\r\n", "")).replace("a=rtcp-fb:126 nack pli\r\n", "a=rtcp-fb:126 pli\r\n")).replace("a=rtcp-fb:97 nack\r\n", "")).replace("a=rtcp-fb:97 nack pli\r\n", "a=rtcp-fb:97 pli\r\n");
    }, prioritize: function(codecMimeType, peer) {
      if (peer && peer.getSenders && peer.getSenders().length) {
        if (!codecMimeType || "string" != typeof codecMimeType)
          throw "Invalid arguments.";
        peer.getSenders().forEach(function(sender) {
          for (var params = sender.getParameters(), i = 0; i < params.codecs.length; i++)
            if (params.codecs[i].mimeType == codecMimeType) {
              params.codecs.unshift(params.codecs.splice(i, 1));
              break;
            }
          sender.setParameters(params);
        });
      }
    }, removeNonG722: function(sdp) {
      return sdp.replace(/m=audio ([0-9]+) RTP\/SAVPF ([0-9 ]*)/g, "m=audio $1 RTP/SAVPF 9");
    }, setApplicationSpecificBandwidth: function(sdp, bandwidth, isScreen) {
      return function(sdp2, bandwidth2, isScreen2) {
        return bandwidth2 ? ("undefined" != typeof isFirefox && isFirefox || (isScreen2 && (bandwidth2.screen ? bandwidth2.screen < 300 && console.warn("It seems that you are using wrong bandwidth value for screen. Screen sharing is expected to fail.") : console.warn("It seems that you are not using bandwidth for screen. Screen sharing is expected to fail.")), bandwidth2.screen && isScreen2 && (sdp2 = (sdp2 = sdp2.replace(/b=AS([^\r\n]+\r\n)/g, "")).replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth2.screen + "\r\n")), (bandwidth2.audio || bandwidth2.video) && (sdp2 = sdp2.replace(/b=AS([^\r\n]+\r\n)/g, "")), bandwidth2.audio && (sdp2 = sdp2.replace(/a=mid:audio\r\n/g, "a=mid:audio\r\nb=AS:" + bandwidth2.audio + "\r\n")), bandwidth2.screen ? sdp2 = sdp2.replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth2.screen + "\r\n") : bandwidth2.video && (sdp2 = sdp2.replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth2.video + "\r\n"))), sdp2) : sdp2;
      }(sdp, bandwidth, isScreen);
    }, setVideoBitrates: function(sdp, params) {
      return function(sdp2, params2) {
        var vp8Payload, xgoogle_min_bitrate = (params2 = params2 || {}).min, xgoogle_max_bitrate = params2.max, sdpLines = sdp2.split("\r\n"), vp8Index = findLine(sdpLines, "a=rtpmap", "VP8/90000");
        if (vp8Index && (vp8Payload = getCodecPayloadType(sdpLines[vp8Index])), !vp8Payload)
          return sdp2;
        var rtxPayload, rtxIndex = findLine(sdpLines, "a=rtpmap", "rtx/90000");
        if (rtxIndex && (rtxPayload = getCodecPayloadType(sdpLines[rtxIndex])), !rtxIndex)
          return sdp2;
        var rtxFmtpLineIndex = findLine(sdpLines, "a=fmtp:" + rtxPayload.toString());
        if (null !== rtxFmtpLineIndex) {
          var appendrtxNext = "\r\n";
          appendrtxNext += "a=fmtp:" + vp8Payload + " x-google-min-bitrate=" + (xgoogle_min_bitrate || "228") + "; x-google-max-bitrate=" + (xgoogle_max_bitrate || "228"), sdpLines[rtxFmtpLineIndex] = sdpLines[rtxFmtpLineIndex].concat(appendrtxNext), sdp2 = sdpLines.join("\r\n");
        }
        return sdp2;
      }(sdp, params);
    }, setOpusAttributes: function(sdp, params) {
      return function(sdp2, params2) {
        params2 = params2 || {};
        var opusPayload, sdpLines = sdp2.split("\r\n"), opusIndex = findLine(sdpLines, "a=rtpmap", "opus/48000");
        if (opusIndex && (opusPayload = getCodecPayloadType(sdpLines[opusIndex])), !opusPayload)
          return sdp2;
        var opusFmtpLineIndex = findLine(sdpLines, "a=fmtp:" + opusPayload.toString());
        if (null === opusFmtpLineIndex)
          return sdp2;
        var appendOpusNext = "";
        return appendOpusNext += "; stereo=" + (void 0 !== params2.stereo ? params2.stereo : "1"), appendOpusNext += "; sprop-stereo=" + (void 0 !== params2["sprop-stereo"] ? params2["sprop-stereo"] : "1"), void 0 !== params2.maxaveragebitrate && (appendOpusNext += "; maxaveragebitrate=" + (params2.maxaveragebitrate || 1048576)), void 0 !== params2.maxplaybackrate && (appendOpusNext += "; maxplaybackrate=" + (params2.maxplaybackrate || 1048576)), void 0 !== params2.cbr && (appendOpusNext += "; cbr=" + (void 0 !== params2.cbr ? params2.cbr : "1")), void 0 !== params2.useinbandfec && (appendOpusNext += "; useinbandfec=" + params2.useinbandfec), void 0 !== params2.usedtx && (appendOpusNext += "; usedtx=" + params2.usedtx), void 0 !== params2.maxptime && (appendOpusNext += "\r\na=maxptime:" + params2.maxptime), sdpLines[opusFmtpLineIndex] = sdpLines[opusFmtpLineIndex].concat(appendOpusNext), sdpLines.join("\r\n");
      }(sdp, params);
    }, preferVP9: function(sdp) {
      return preferCodec(sdp, "vp9");
    }, preferCodec, forceStereoAudio: function(sdp) {
      for (var sdpLines = sdp.split("\r\n"), fmtpLineIndex = null, i = 0; i < sdpLines.length; i++)
        if (-1 !== sdpLines[i].search("opus/48000")) {
          var opusPayload = extractSdp(sdpLines[i], /:(\d+) opus\/48000/i);
          break;
        }
      for (i = 0; i < sdpLines.length; i++) {
        if (-1 !== sdpLines[i].search("a=fmtp")) {
          if (extractSdp(sdpLines[i], /a=fmtp:(\d+)/) === opusPayload) {
            fmtpLineIndex = i;
            break;
          }
        }
      }
      return null === fmtpLineIndex ? sdp : (sdpLines[fmtpLineIndex] = sdpLines[fmtpLineIndex].concat("; stereo=1; sprop-stereo=1"), sdp = sdpLines.join("\r\n"));
    } };
  }();
  window.BandwidthHandler = CodecsHandler;
  var OnIceCandidateHandler = { processCandidates: function(connection, icePair) {
    var candidate = icePair.candidate, iceRestrictions = connection.candidates, stun = iceRestrictions.stun, turn = iceRestrictions.turn;
    if (isNull(iceRestrictions.reflexive) || (stun = iceRestrictions.reflexive), isNull(iceRestrictions.relay) || (turn = iceRestrictions.relay), (iceRestrictions.host || !candidate.match(/typ host/g)) && (turn || !candidate.match(/typ relay/g)) && (stun || !candidate.match(/typ srflx/g))) {
      var protocol = connection.iceProtocols;
      if ((protocol.udp || !candidate.match(/ udp /g)) && (protocol.tcp || !candidate.match(/ tcp /g)))
        return connection.enableLogs && console.debug("Your candidate pairs:", candidate), { candidate, sdpMid: icePair.sdpMid, sdpMLineIndex: icePair.sdpMLineIndex };
    }
  } }, IceServersHandler = { getIceServers: function(connection) {
    return [{ urls: ["stun:stun.l.google.com:19302", "stun:stun1.l.google.com:19302", "stun:stun2.l.google.com:19302", "stun:stun.l.google.com:19302?transport=udp"] }];
  } };
  function getUserMediaHandler(options) {
    if (true !== currentUserMediaRequest.mutex) {
      currentUserMediaRequest.mutex = true;
      var idInstance = JSON.stringify(options.localMediaConstraints);
      if (currentUserMediaRequest.streams[idInstance])
        streaming(currentUserMediaRequest.streams[idInstance].stream, true);
      else {
        if (!!/BB10|BlackBerry/i.test(navigator.userAgent || "") || void 0 === navigator.mediaDevices || "function" != typeof navigator.mediaDevices.getUserMedia)
          return navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia, void navigator.getUserMedia(options.localMediaConstraints, function(stream2) {
            stream2.streamid = stream2.streamid || stream2.id || getRandomString(), stream2.idInstance = idInstance, streaming(stream2);
          }, function(error) {
            options.onLocalMediaError(error, options.localMediaConstraints);
          });
        if (void 0 === navigator.mediaDevices) {
          navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
          var getUserMediaStream, getUserMediaError, getUserMediaFailure = function() {
          };
          navigator.mediaDevices = { getUserMedia: function(hints) {
            return navigator.getUserMedia(hints, function(getUserMediaSuccess) {
              getUserMediaSuccess(stream), getUserMediaStream = stream;
            }, function(error) {
              getUserMediaFailure(error), getUserMediaError = error;
            }), { then: function(successCB) {
              if (!getUserMediaStream)
                return { then: function(failureCB) {
                  getUserMediaError ? failureCB(getUserMediaError) : getUserMediaFailure = failureCB;
                } };
              successCB(getUserMediaStream);
            } };
          } };
        }
        if (true === options.localMediaConstraints.isScreen) {
          if (navigator.mediaDevices.getDisplayMedia)
            navigator.mediaDevices.getDisplayMedia(options.localMediaConstraints).then(function(stream2) {
              stream2.streamid = stream2.streamid || stream2.id || getRandomString(), stream2.idInstance = idInstance, streaming(stream2);
            }).catch(function(error) {
              options.onLocalMediaError(error, options.localMediaConstraints);
            });
          else {
            if (!navigator.getDisplayMedia)
              throw new Error("getDisplayMedia API is not availabe in this browser.");
            navigator.getDisplayMedia(options.localMediaConstraints).then(function(stream2) {
              stream2.streamid = stream2.streamid || stream2.id || getRandomString(), stream2.idInstance = idInstance, streaming(stream2);
            }).catch(function(error) {
              options.onLocalMediaError(error, options.localMediaConstraints);
            });
          }
          return;
        }
        navigator.mediaDevices.getUserMedia(options.localMediaConstraints).then(function(stream2) {
          stream2.streamid = stream2.streamid || stream2.id || getRandomString(), stream2.idInstance = idInstance, streaming(stream2);
        }).catch(function(error) {
          options.onLocalMediaError(error, options.localMediaConstraints);
        });
      }
    } else
      currentUserMediaRequest.queueRequests.push(options);
    function streaming(stream2, returnBack) {
      !function(constraints, stream3) {
        constraints.mandatory && constraints.mandatory.chromeMediaSource || constraints.mozMediaSource || constraints.mediaSource ? stream3.isScreen = true : constraints.video ? stream3.isVideo = true : constraints.audio && (stream3.isAudio = true);
      }(options.localMediaConstraints, stream2);
      var streamEndedEvent = "ended";
      "oninactive" in stream2 && (streamEndedEvent = "inactive"), stream2.addEventListener(streamEndedEvent, function() {
        delete currentUserMediaRequest.streams[idInstance], currentUserMediaRequest.mutex = false, currentUserMediaRequest.queueRequests.indexOf(options) && (delete currentUserMediaRequest.queueRequests[currentUserMediaRequest.queueRequests.indexOf(options)], currentUserMediaRequest.queueRequests = removeNullEntries(currentUserMediaRequest.queueRequests));
      }, false), currentUserMediaRequest.streams[idInstance] = { stream: stream2 }, currentUserMediaRequest.mutex = false, currentUserMediaRequest.queueRequests.length && getUserMediaHandler(currentUserMediaRequest.queueRequests.shift()), options.onGettingLocalMedia(stream2, returnBack);
    }
  }
  window.currentUserMediaRequest = { streams: [], mutex: false, queueRequests: [], remove: function(idInstance) {
    this.mutex = false;
    var stream2 = this.streams[idInstance];
    if (stream2) {
      var options = (stream2 = stream2.stream).currentUserMediaRequestOptions;
      this.queueRequests.indexOf(options) && (delete this.queueRequests[this.queueRequests.indexOf(options)], this.queueRequests = removeNullEntries(this.queueRequests)), this.streams[idInstance].stream = null, delete this.streams[idInstance];
    }
  } };
  var StreamsHandler = function() {
    function handleType(type) {
      if (type)
        return "string" == typeof type || void 0 === type ? type : type.audio && type.video ? null : type.audio ? "audio" : type.video ? "video" : void 0;
    }
    function afterEach(setTimeoutInteval, numberOfTimes, callback, startedTimes) {
      (startedTimes = (startedTimes || 0) + 1) >= numberOfTimes || setTimeout(function() {
        callback(), afterEach(setTimeoutInteval, numberOfTimes, callback, startedTimes);
      }, setTimeoutInteval);
    }
    return { setHandlers: function(stream2, syncAction, connection) {
      if (stream2 && stream2.addEventListener) {
        if (void 0 === syncAction || 1 == syncAction) {
          var streamEndedEvent = "ended";
          "oninactive" in stream2 && (streamEndedEvent = "inactive"), stream2.addEventListener(streamEndedEvent, function() {
            StreamsHandler.onSyncNeeded(this.streamid, streamEndedEvent);
          }, false);
        }
        stream2.mute = function(type, isSyncAction) {
          type = handleType(type), void 0 !== isSyncAction && (syncAction = isSyncAction), void 0 !== type && "audio" != type || getTracks(stream2, "audio").forEach(function(track) {
            track.enabled = false, connection.streamEvents[stream2.streamid].isAudioMuted = true;
          }), void 0 !== type && "video" != type || getTracks(stream2, "video").forEach(function(track) {
            track.enabled = false;
          }), void 0 !== syncAction && 1 != syncAction || StreamsHandler.onSyncNeeded(stream2.streamid, "mute", type), connection.streamEvents[stream2.streamid].muteType = type || "both", fireEvent(stream2, "mute", type);
        }, stream2.unmute = function(type, isSyncAction) {
          type = handleType(type), void 0 !== isSyncAction && (syncAction = isSyncAction), function() {
            if (!connection.streamEvents[stream2.streamid].mediaElement)
              return;
            var mediaElement = connection.streamEvents[stream2.streamid].mediaElement;
            mediaElement.volume = 0, afterEach(200, 5, function() {
              try {
                mediaElement.volume += 0.2;
              } catch (e) {
                mediaElement.volume = 1;
              }
            });
          }(), void 0 !== type && "audio" != type || getTracks(stream2, "audio").forEach(function(track) {
            track.enabled = true, connection.streamEvents[stream2.streamid].isAudioMuted = false;
          }), void 0 !== type && "video" != type || (getTracks(stream2, "video").forEach(function(track) {
            track.enabled = true;
          }), void 0 !== type && "video" == type && connection.streamEvents[stream2.streamid].isAudioMuted && function looper(times) {
            times || (times = 0), ++times < 100 && connection.streamEvents[stream2.streamid].isAudioMuted && (stream2.mute("audio"), setTimeout(function() {
              looper(times);
            }, 50));
          }()), void 0 !== syncAction && 1 != syncAction || StreamsHandler.onSyncNeeded(stream2.streamid, "unmute", type), connection.streamEvents[stream2.streamid].unmuteType = type || "both", fireEvent(stream2, "unmute", type);
        };
      }
    }, onSyncNeeded: function(streamid, action, type) {
    } };
  }();
  function TextReceiver(connection) {
    var content = {};
    return { receive: function(data, userid, extra) {
      var uuid = data.uuid;
      if (content[uuid] || (content[uuid] = []), content[uuid].push(data.message), data.last) {
        var message = content[uuid].join("");
        data.isobject && (message = JSON.parse(message));
        var e = { data: message, userid, extra, latency: new Date().getTime() - data.sendingTime };
        connection.autoTranslateText ? (e.original = e.data, connection.Translator.TranslateText(e.data, function(translatedText) {
          e.data = translatedText, connection.onmessage(e);
        })) : connection.onmessage(e), delete content[uuid];
      }
    } };
  }
  var TextSender = { send: function(config) {
    var connection = config.connection, channel = config.channel, remoteUserId = config.remoteUserId, initialText = config.text, packetSize = connection.chunkSize || 1e3, textToTransfer = "", isobject = false;
    "string" != typeof initialText && (isobject = true, initialText = JSON.stringify(initialText));
    var uuid = getRandomString(), sendingTime = new Date().getTime();
    !function sendText(textMessage, text) {
      var data = { type: "text", uuid, sendingTime };
      textMessage && (text = textMessage, data.packets = parseInt(text.length / packetSize));
      text.length > packetSize ? data.message = text.slice(0, packetSize) : (data.message = text, data.last = true, data.isobject = isobject);
      channel.send(data, remoteUserId), (textToTransfer = text.slice(data.message.length)).length && setTimeout(function() {
        sendText(null, textToTransfer);
      }, connection.chunkInterval || 100);
    }(initialText);
  } }, FileProgressBarHandler = { handle: function(connection) {
    var progressHelper = {};
    connection.onFileStart = function(file) {
      var div = document.createElement("div");
      if (div.title = file.name, div.innerHTML = "<label>0%</label> <progress></progress>", file.remoteUserId && (div.innerHTML += " (Sharing with:" + file.remoteUserId + ")"), connection.filesContainer || (connection.filesContainer = document.body || document.documentElement), connection.filesContainer.insertBefore(div, connection.filesContainer.firstChild), !file.remoteUserId)
        return progressHelper[file.uuid] = { div, progress: div.querySelector("progress"), label: div.querySelector("label") }, void (progressHelper[file.uuid].progress.max = file.maxChunks);
      progressHelper[file.uuid] || (progressHelper[file.uuid] = {}), progressHelper[file.uuid][file.remoteUserId] = { div, progress: div.querySelector("progress"), label: div.querySelector("label") }, progressHelper[file.uuid][file.remoteUserId].progress.max = file.maxChunks;
    }, connection.onFileProgress = function(chunk) {
      var helper = progressHelper[chunk.uuid];
      helper && (chunk.remoteUserId && !(helper = progressHelper[chunk.uuid][chunk.remoteUserId]) || (helper.progress.value = chunk.currentPosition || chunk.maxChunks || helper.progress.max, function(progress, label) {
        if (-1 !== progress.position) {
          var position = +progress.position.toFixed(2).split(".")[1] || 100;
          label.innerHTML = position + "%";
        }
      }(helper.progress, helper.label)));
    }, connection.onFileEnd = function(file) {
      var helper = progressHelper[file.uuid];
      if (helper) {
        if (!file.remoteUserId || (helper = progressHelper[file.uuid][file.remoteUserId])) {
          var div = helper.div;
          -1 != file.type.indexOf("image") ? div.innerHTML = '<a href="' + file.url + '" download="' + file.name + '">Download <strong style="color:red;">' + file.name + '</strong> </a><br /><img src="' + file.url + '" title="' + file.name + '" style="max-width: 80%;">' : div.innerHTML = '<a href="' + file.url + '" download="' + file.name + '">Download <strong style="color:red;">' + file.name + '</strong> </a><br /><iframe src="' + file.url + '" title="' + file.name + '" style="width: 80%;border: 0;height: inherit;margin-top:1em;"></iframe>';
        }
      } else
        console.error("No such progress-helper element exist.", file);
    };
  } }, TranslationHandler = { handle: function(connection) {
    connection.autoTranslateText = false, connection.language = "en", connection.googKey = "AIzaSyCgB5hmFY74WYB-EoWkhr9cAGr6TiTHrEE", connection.Translator = { TranslateText: function(text, callback) {
      var newScript = document.createElement("script");
      newScript.type = "text/javascript";
      var sourceText = encodeURIComponent(text), randomNumber = "method" + connection.token();
      window[randomNumber] = function(response) {
        response.data && response.data.translations[0] && callback ? callback(response.data.translations[0].translatedText) : response.error && "Daily Limit Exceeded" === response.error.message ? console.error('Text translation failed. Error message: "Daily Limit Exceeded."') : response.error ? console.error(response.error.message) : console.error(response);
      };
      var source = "https://www.googleapis.com/language/translate/v2?key=" + connection.googKey + "&target=" + (connection.language || "en-US") + "&callback=window." + randomNumber + "&q=" + sourceText;
      newScript.src = source, document.getElementsByTagName("head")[0].appendChild(newScript);
    }, getListOfLanguages: function(callback) {
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = function() {
        if (xhr.readyState == XMLHttpRequest.DONE) {
          var response = JSON.parse(xhr.responseText);
          if (response && response.data && response.data.languages)
            return void callback(response.data.languages);
          if (response.error && "Daily Limit Exceeded" === response.error.message)
            return void console.error('Text translation failed. Error message: "Daily Limit Exceeded."');
          if (response.error)
            return void console.error(response.error.message);
          console.error(response);
        }
      };
      var url = "https://www.googleapis.com/language/translate/v2/languages?key=" + connection.googKey + "&target=en";
      xhr.open("GET", url, true), xhr.send(null);
    } };
  } };
  !function(connection) {
    forceOptions = forceOptions || { useDefaultDevices: true }, connection.channel = connection.sessionid = (roomid || location.href.replace(/\/|:|#|\?|\$|\^|%|\.|`|~|!|\+|@|\[|\||]|\|*. /g, "").split("\n").join("").split("\r").join("")) + "";
    var mPeer = new MultiPeers(connection), preventDuplicateOnStreamEvents = {};
    function connectSocket(connectCallback) {
      if (connection.socketAutoReConnect = true, connection.socket)
        connectCallback && connectCallback(connection.socket);
      else {
        if (void 0 === SocketConnection)
          if ("undefined" != typeof FirebaseConnection)
            window.SocketConnection = FirebaseConnection;
          else {
            if ("undefined" == typeof PubNubConnection)
              throw "SocketConnection.js seems missed.";
            window.SocketConnection = PubNubConnection;
          }
        new SocketConnection(connection, function(s) {
          connectCallback && connectCallback(connection.socket);
        });
      }
    }
    function joinRoom(connectionDescription, cb) {
      connection.socket.emit("join-room", { sessionid: connection.sessionid, session: connection.session, mediaConstraints: connection.mediaConstraints, sdpConstraints: connection.sdpConstraints, streams: getStreamInfoForAdmin(), extra: connection.extra, password: void 0 !== connection.password && "object" != typeof connection.password ? connection.password : "" }, function(isRoomJoined, error) {
        if (true === isRoomJoined) {
          if (connection.enableLogs && console.log("isRoomJoined: ", isRoomJoined, " roomid: ", connection.sessionid), connection.peers[connection.sessionid])
            return;
          mPeer.onNegotiationNeeded(connectionDescription);
        }
        false === isRoomJoined && connection.enableLogs && console.warn("isRoomJoined: ", error, " roomid: ", connection.sessionid), cb(isRoomJoined, connection.sessionid, error);
      });
    }
    function openRoom(callback) {
      connection.enableLogs && console.log("Sending open-room signal to socket.io"), connection.waitingForLocalMedia = false, connection.socket.emit("open-room", { sessionid: connection.sessionid, session: connection.session, mediaConstraints: connection.mediaConstraints, sdpConstraints: connection.sdpConstraints, streams: getStreamInfoForAdmin(), extra: connection.extra, identifier: connection.publicRoomIdentifier, password: void 0 !== connection.password && "object" != typeof connection.password ? connection.password : "" }, function(isRoomOpened, error) {
        true === isRoomOpened && (connection.enableLogs && console.log("isRoomOpened: ", isRoomOpened, " roomid: ", connection.sessionid), callback(isRoomOpened, connection.sessionid)), false === isRoomOpened && (connection.enableLogs && console.warn("isRoomOpened: ", error, " roomid: ", connection.sessionid), callback(isRoomOpened, connection.sessionid, error));
      });
    }
    function getStreamInfoForAdmin() {
      try {
        return connection.streamEvents.selectAll("local").map(function(event2) {
          return { streamid: event2.streamid, tracks: event2.stream.getTracks().length };
        });
      } catch (e) {
        return [];
      }
    }
    function beforeJoin(userPreferences, callback) {
      if (connection.dontCaptureUserMedia || userPreferences.isDataOnly)
        callback();
      else {
        var localMediaConstraints = {};
        userPreferences.localPeerSdpConstraints.OfferToReceiveAudio && (localMediaConstraints.audio = connection.mediaConstraints.audio), userPreferences.localPeerSdpConstraints.OfferToReceiveVideo && (localMediaConstraints.video = connection.mediaConstraints.video);
        var session = userPreferences.session || connection.session;
        session.oneway && "two-way" !== session.audio && "two-way" !== session.video && "two-way" !== session.screen ? callback() : (session.oneway && session.audio && "two-way" === session.audio && (session = { audio: true }), (session.audio || session.video || session.screen) && (session.screen ? "Edge" === DetectRTC.browser.name ? navigator.getDisplayMedia({ video: true, audio: isAudioPlusTab(connection) }).then(function(screen2) {
          screen2.isScreen = true, mPeer.onGettingLocalMedia(screen2), !session.audio && !session.video || isAudioPlusTab(connection) ? callback(screen2) : connection.invokeGetUserMedia(null, callback);
        }, function(error) {
          console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
        }) : connection.invokeGetUserMedia({ audio: isAudioPlusTab(connection), video: true, isScreen: true }, !session.audio && !session.video || isAudioPlusTab(connection) ? callback : connection.invokeGetUserMedia(null, callback)) : (session.audio || session.video) && connection.invokeGetUserMedia(null, callback, session)));
      }
    }
    function applyConstraints(stream2, mediaConstraints) {
      stream2 ? (mediaConstraints.audio && getTracks(stream2, "audio").forEach(function(track) {
        track.applyConstraints(mediaConstraints.audio);
      }), mediaConstraints.video && getTracks(stream2, "video").forEach(function(track) {
        track.applyConstraints(mediaConstraints.video);
      })) : connection.enableLogs && console.error("No stream to applyConstraints.");
    }
    function replaceTrack(track, remoteUserId, isVideoTrack, oldTrack) {
      remoteUserId ? mPeer.replaceTrack(track, remoteUserId, isVideoTrack, oldTrack) : connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.replaceTrack(track, participant, isVideoTrack, oldTrack);
      });
    }
    mPeer.onGettingLocalMedia = function(stream2, callback) {
      if (callback = callback || function() {
      }, preventDuplicateOnStreamEvents[stream2.streamid])
        callback();
      else {
        preventDuplicateOnStreamEvents[stream2.streamid] = true;
        try {
          stream2.type = "local";
        } catch (e) {
        }
        connection.setStreamEndHandler(stream2), getRMCMediaElement(stream2, function(mediaElement) {
          mediaElement.id = stream2.streamid, mediaElement.muted = true, mediaElement.volume = 0, -1 === connection.attachStreams.indexOf(stream2) && connection.attachStreams.push(stream2), void 0 !== StreamsHandler && StreamsHandler.setHandlers(stream2, true, connection);
          var isAudioMuted = 0 === stream2.getAudioTracks().filter(function(track) {
            return track.enabled;
          }).length;
          connection.streamEvents[stream2.streamid] = { stream: stream2, type: "local", mediaElement, userid: connection.userid, extra: connection.extra, streamid: stream2.streamid, isAudioMuted };
          try {
            !function(connection2, streamEvent) {
              if (streamEvent.stream && getTracks(streamEvent.stream, "audio").length) {
                if (!connection2 || !streamEvent)
                  throw "Both arguments are required.";
                if (connection2.onspeaking && connection2.onsilence) {
                  if ("undefined" == typeof hark)
                    throw "hark.js not found.";
                  hark(streamEvent.stream, { onspeaking: function() {
                    connection2.onspeaking(streamEvent);
                  }, onsilence: function() {
                    connection2.onsilence(streamEvent);
                  }, onvolumechange: function(volume, threshold) {
                    connection2.onvolumechange && connection2.onvolumechange(merge({ volume, threshold }, streamEvent));
                  } });
                }
              }
            }(connection, connection.streamEvents[stream2.streamid]), setMuteHandlers(connection, connection.streamEvents[stream2.streamid]), connection.onstream(connection.streamEvents[stream2.streamid]);
          } catch (e) {
          }
          callback();
        }, connection);
      }
    }, mPeer.onGettingRemoteMedia = function(stream2, remoteUserId) {
      try {
        stream2.type = "remote";
      } catch (e) {
      }
      connection.setStreamEndHandler(stream2, "remote-stream"), getRMCMediaElement(stream2, function(mediaElement) {
        mediaElement.id = stream2.streamid, void 0 !== StreamsHandler && StreamsHandler.setHandlers(stream2, false, connection), connection.streamEvents[stream2.streamid] = { stream: stream2, type: "remote", userid: remoteUserId, extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}, mediaElement, streamid: stream2.streamid }, setMuteHandlers(connection, connection.streamEvents[stream2.streamid]), connection.onstream(connection.streamEvents[stream2.streamid]);
      }, connection);
    }, mPeer.onRemovingRemoteMedia = function(stream2, remoteUserId) {
      var streamEvent = connection.streamEvents[stream2.streamid];
      streamEvent || (streamEvent = { stream: stream2, type: "remote", userid: remoteUserId, extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}, streamid: stream2.streamid, mediaElement: connection.streamEvents[stream2.streamid] ? connection.streamEvents[stream2.streamid].mediaElement : null }), connection.peersBackup[streamEvent.userid] && (streamEvent.extra = connection.peersBackup[streamEvent.userid].extra), connection.onstreamended(streamEvent), delete connection.streamEvents[stream2.streamid];
    }, mPeer.onNegotiationNeeded = function(message, remoteUserId, callback) {
      callback = callback || function() {
      };
      var messageToDeliver = { remoteUserId: remoteUserId = remoteUserId || message.remoteUserId, message: message = message || "", sender: connection.userid };
      message.remoteUserId && message.message && message.sender && (messageToDeliver = message), connectSocket(function() {
        connection.socket.emit(connection.socketMessageEvent, messageToDeliver, callback);
      });
    }, mPeer.onUserLeft = function(remoteUserId) {
      connection.deletePeer(remoteUserId);
    }, mPeer.disconnectWith = function(remoteUserId, callback) {
      connection.socket && connection.socket.emit("disconnect-with", remoteUserId, callback || function() {
      }), connection.deletePeer(remoteUserId);
    }, connection.socketOptions = { transport: "polling" }, connection.openOrJoin = function(roomid2, callback) {
      callback = callback || function() {
      }, connection.checkPresence(roomid2, function(isRoomExist, roomid3) {
        if (isRoomExist) {
          connection.sessionid = roomid3;
          var localPeerSdpConstraints, remotePeerSdpConstraints, isOneWay = !!connection.session.oneway, isDataOnly = isData(connection.session);
          remotePeerSdpConstraints = { OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo }, localPeerSdpConstraints = { OfferToReceiveAudio: isOneWay ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: isOneWay ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo };
          var connectionDescription = { remoteUserId: connection.sessionid, message: { newParticipationRequest: true, isOneWay, isDataOnly, localPeerSdpConstraints, remotePeerSdpConstraints }, sender: connection.userid };
          beforeJoin(connectionDescription.message, function() {
            joinRoom(connectionDescription, callback);
          });
        } else
          connection.waitingForLocalMedia = true, connection.isInitiator = true, connection.sessionid = roomid3 || connection.sessionid, isData(connection.session) ? openRoom(callback) : connection.captureUserMedia(function() {
            openRoom(callback);
          });
      });
    }, connection.waitingForLocalMedia = false, connection.open = function(roomid2, callback) {
      callback = callback || function() {
      }, connection.waitingForLocalMedia = true, connection.isInitiator = true, connection.sessionid = roomid2 || connection.sessionid, connectSocket(function() {
        isData(connection.session) ? openRoom(callback) : connection.captureUserMedia(function() {
          openRoom(callback);
        });
      });
    }, connection.peersBackup = {}, connection.deletePeer = function(remoteUserId) {
      if (remoteUserId && connection.peers[remoteUserId]) {
        var eventObject = { userid: remoteUserId, extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {} };
        if (connection.peersBackup[eventObject.userid] && (eventObject.extra = connection.peersBackup[eventObject.userid].extra), connection.onleave(eventObject), connection.peers[remoteUserId]) {
          connection.peers[remoteUserId].streams.forEach(function(stream2) {
            stream2.stop();
          });
          var peer = connection.peers[remoteUserId].peer;
          if (peer && "closed" !== peer.iceConnectionState)
            try {
              peer.close();
            } catch (e) {
            }
          connection.peers[remoteUserId] && (connection.peers[remoteUserId].peer = null, delete connection.peers[remoteUserId]);
        }
      }
    }, connection.rejoin = function(connectionDescription) {
      if (!connection.isInitiator && connectionDescription && Object.keys(connectionDescription).length) {
        var extra = {};
        connection.peers[connectionDescription.remoteUserId] && (extra = connection.peers[connectionDescription.remoteUserId].extra, connection.deletePeer(connectionDescription.remoteUserId)), connectionDescription && connectionDescription.remoteUserId && (connection.join(connectionDescription.remoteUserId), connection.onReConnecting({ userid: connectionDescription.remoteUserId, extra }));
      }
    }, connection.join = function(remoteUserId, options) {
      connection.sessionid = !!remoteUserId && (remoteUserId.sessionid || remoteUserId.remoteUserId || remoteUserId) || connection.sessionid, connection.sessionid += "";
      var localPeerSdpConstraints = false, remotePeerSdpConstraints = false, isOneWay = false, isDataOnly = false;
      if (remoteUserId && remoteUserId.session || !remoteUserId || "string" == typeof remoteUserId) {
        var session = remoteUserId && remoteUserId.session || connection.session;
        isOneWay = !!session.oneway, isDataOnly = isData(session), remotePeerSdpConstraints = { OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo }, localPeerSdpConstraints = { OfferToReceiveAudio: isOneWay ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio, OfferToReceiveVideo: isOneWay ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo };
      }
      var cb = function() {
      };
      "function" == typeof (options = options || {}) && (cb = options, options = {}), void 0 !== options.localPeerSdpConstraints && (localPeerSdpConstraints = options.localPeerSdpConstraints), void 0 !== options.remotePeerSdpConstraints && (remotePeerSdpConstraints = options.remotePeerSdpConstraints), void 0 !== options.isOneWay && (isOneWay = options.isOneWay), void 0 !== options.isDataOnly && (isDataOnly = options.isDataOnly);
      var connectionDescription = { remoteUserId: connection.sessionid, message: { newParticipationRequest: true, isOneWay, isDataOnly, localPeerSdpConstraints, remotePeerSdpConstraints }, sender: connection.userid };
      return beforeJoin(connectionDescription.message, function() {
        connectSocket(function() {
          joinRoom(connectionDescription, cb);
        });
      }), connectionDescription;
    }, connection.publicRoomIdentifier = "", connection.getUserMedia = connection.captureUserMedia = function(callback, sessionForced) {
      callback = callback || function() {
      };
      var session = sessionForced || connection.session;
      connection.dontCaptureUserMedia || isData(session) ? callback() : (session.audio || session.video || session.screen) && (session.screen ? "Edge" === DetectRTC.browser.name ? navigator.getDisplayMedia({ video: true, audio: isAudioPlusTab(connection) }).then(function(screen2) {
        if (screen2.isScreen = true, mPeer.onGettingLocalMedia(screen2), !session.audio && !session.video || isAudioPlusTab(connection))
          callback(screen2);
        else {
          var nonScreenSession = {};
          for (var s in session)
            "screen" !== s && (nonScreenSession[s] = session[s]);
          connection.invokeGetUserMedia(sessionForced, callback, nonScreenSession);
        }
      }, function(error) {
        console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
      }) : connection.invokeGetUserMedia({ audio: isAudioPlusTab(connection), video: true, isScreen: true }, function(stream2) {
        if (!session.audio && !session.video || isAudioPlusTab(connection))
          callback(stream2);
        else {
          var nonScreenSession = {};
          for (var s in session)
            "screen" !== s && (nonScreenSession[s] = session[s]);
          connection.invokeGetUserMedia(sessionForced, callback, nonScreenSession);
        }
      }) : (session.audio || session.video) && connection.invokeGetUserMedia(sessionForced, callback, session));
    }, connection.onbeforeunload = function(arg1, dontCloseSocket) {
      connection.closeBeforeUnload && (connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.onNegotiationNeeded({ userLeft: true }, participant), connection.peers[participant] && connection.peers[participant].peer && connection.peers[participant].peer.close(), delete connection.peers[participant];
      }), dontCloseSocket || connection.closeSocket(), connection.isInitiator = false);
    }, window.ignoreBeforeUnload ? connection.closeBeforeUnload = false : (connection.closeBeforeUnload = true, window.addEventListener("beforeunload", connection.onbeforeunload, false)), connection.userid = getRandomString(), connection.changeUserId = function(newUserId, callback) {
      callback = callback || function() {
      }, connection.userid = newUserId || getRandomString(), connection.socket.emit("changed-uuid", connection.userid, callback);
    }, connection.extra = {}, connection.attachStreams = [], connection.session = { audio: true, video: true }, connection.enableFileSharing = false, connection.bandwidth = { screen: false, audio: false, video: false }, connection.codecs = { audio: "opus", video: "VP9" }, connection.processSdp = function(sdp) {
      return isUnifiedPlanSupportedDefault() || "Safari" === DetectRTC.browser.name ? sdp : ("VP8" === connection.codecs.video.toUpperCase() && (sdp = CodecsHandler.preferCodec(sdp, "vp8")), "VP9" === connection.codecs.video.toUpperCase() && (sdp = CodecsHandler.preferCodec(sdp, "vp9")), "H264" === connection.codecs.video.toUpperCase() && (sdp = CodecsHandler.preferCodec(sdp, "h264")), "G722" === connection.codecs.audio && (sdp = CodecsHandler.removeNonG722(sdp)), "Firefox" === DetectRTC.browser.name || ((connection.bandwidth.video || connection.bandwidth.screen) && (sdp = CodecsHandler.setApplicationSpecificBandwidth(sdp, connection.bandwidth, !!connection.session.screen)), connection.bandwidth.video && (sdp = CodecsHandler.setVideoBitrates(sdp, { min: 8 * connection.bandwidth.video * 1024, max: 8 * connection.bandwidth.video * 1024 })), connection.bandwidth.audio && (sdp = CodecsHandler.setOpusAttributes(sdp, { maxaveragebitrate: 8 * connection.bandwidth.audio * 1024, maxplaybackrate: 8 * connection.bandwidth.audio * 1024, stereo: 1, maxptime: 3 }))), sdp);
    }, void 0 !== CodecsHandler && (connection.BandwidthHandler = connection.CodecsHandler = CodecsHandler), connection.mediaConstraints = { audio: { mandatory: {}, optional: connection.bandwidth.audio ? [{ bandwidth: 8 * connection.bandwidth.audio * 1024 || 1048576 }] : [] }, video: { mandatory: {}, optional: connection.bandwidth.video ? [{ bandwidth: 8 * connection.bandwidth.video * 1024 || 1048576 }, { facingMode: "user" }] : [{ facingMode: "user" }] } }, "Firefox" === DetectRTC.browser.name && (connection.mediaConstraints = { audio: true, video: true }), forceOptions.useDefaultDevices || DetectRTC.isMobileDevice || DetectRTC.load(function() {
      var lastAudioDevice, lastVideoDevice;
      if (DetectRTC.MediaDevices.forEach(function(device) {
        "audioinput" === device.kind && false !== connection.mediaConstraints.audio && (lastAudioDevice = device), "videoinput" === device.kind && false !== connection.mediaConstraints.video && (lastVideoDevice = device);
      }), lastAudioDevice) {
        if ("Firefox" === DetectRTC.browser.name)
          return void (true !== connection.mediaConstraints.audio ? connection.mediaConstraints.audio.deviceId = lastAudioDevice.id : connection.mediaConstraints.audio = { deviceId: lastAudioDevice.id });
        1 == connection.mediaConstraints.audio && (connection.mediaConstraints.audio = { mandatory: {}, optional: [] }), connection.mediaConstraints.audio.optional || (connection.mediaConstraints.audio.optional = []);
        var optional = [{ sourceId: lastAudioDevice.id }];
        connection.mediaConstraints.audio.optional = optional.concat(connection.mediaConstraints.audio.optional);
      }
      if (lastVideoDevice) {
        if ("Firefox" === DetectRTC.browser.name)
          return void (true !== connection.mediaConstraints.video ? connection.mediaConstraints.video.deviceId = lastVideoDevice.id : connection.mediaConstraints.video = { deviceId: lastVideoDevice.id });
        1 == connection.mediaConstraints.video && (connection.mediaConstraints.video = { mandatory: {}, optional: [] }), connection.mediaConstraints.video.optional || (connection.mediaConstraints.video.optional = []);
        optional = [{ sourceId: lastVideoDevice.id }];
        connection.mediaConstraints.video.optional = optional.concat(connection.mediaConstraints.video.optional);
      }
    }), connection.sdpConstraints = { mandatory: { OfferToReceiveAudio: true, OfferToReceiveVideo: true }, optional: [{ VoiceActivityDetection: false }] }, connection.sdpSemantics = null, connection.iceCandidatePoolSize = null, connection.bundlePolicy = null, connection.rtcpMuxPolicy = null, connection.iceTransportPolicy = null, connection.optionalArgument = { optional: [{ DtlsSrtpKeyAgreement: true }, { googImprovedWifiBwe: true }, { googScreencastMinBitrate: 300 }, { googIPv6: true }, { googDscp: true }, { googCpuUnderuseThreshold: 55 }, { googCpuOveruseThreshold: 85 }, { googSuspendBelowMinBitrate: true }, { googCpuOveruseDetection: true }], mandatory: {} }, connection.iceServers = IceServersHandler.getIceServers(connection), connection.candidates = { host: true, stun: true, turn: true }, connection.iceProtocols = { tcp: true, udp: true }, connection.onopen = function(event2) {
      connection.enableLogs && console.info("Data connection has been opened between you & ", event2.userid);
    }, connection.onclose = function(event2) {
      connection.enableLogs && console.warn("Data connection has been closed between you & ", event2.userid);
    }, connection.onerror = function(error) {
      connection.enableLogs && console.error(error.userid, "data-error", error);
    }, connection.onmessage = function(event2) {
      connection.enableLogs && console.debug("data-message", event2.userid, event2.data);
    }, connection.send = function(data, remoteUserId) {
      connection.peers.send(data, remoteUserId);
    }, connection.close = connection.disconnect = connection.leave = function() {
      connection.onbeforeunload(false, true);
    }, connection.closeEntireSession = function(callback) {
      callback = callback || function() {
      }, connection.socket.emit("close-entire-session", function looper() {
        connection.getAllParticipants().length ? setTimeout(looper, 100) : (connection.onEntireSessionClosed({ sessionid: connection.sessionid, userid: connection.userid, extra: connection.extra }), connection.changeUserId(null, function() {
          connection.close(), callback();
        }));
      });
    }, connection.onEntireSessionClosed = function(event2) {
      connection.enableLogs && console.info("Entire session is closed: ", event2.sessionid, event2.extra);
    }, connection.onstream = function(e) {
      var parentNode = connection.videosContainer;
      parentNode.insertBefore(e.mediaElement, parentNode.firstChild);
      var played = e.mediaElement.play();
      void 0 === played ? setTimeout(function() {
        e.mediaElement.play();
      }, 2e3) : played.catch(function() {
      }).then(function() {
        setTimeout(function() {
          e.mediaElement.play();
        }, 2e3);
      });
    }, connection.onstreamended = function(e) {
      e.mediaElement || (e.mediaElement = document.getElementById(e.streamid)), e.mediaElement && e.mediaElement.parentNode && e.mediaElement.parentNode.removeChild(e.mediaElement);
    }, connection.direction = "many-to-many", connection.removeStream = function(streamid, remoteUserId) {
      var stream2, streamIdx;
      connection.attachStreams.forEach(function(localStream, idx) {
        localStream.id === streamid && (stream2 = localStream, streamIdx = idx);
      }), stream2 ? (connection.peers.getAllParticipants().forEach(function(participant) {
        if (!remoteUserId || participant === remoteUserId) {
          var user = connection.peers[participant];
          try {
            user.peer.removeStream(stream2);
          } catch (e) {
          }
        }
      }), -1 !== streamIdx && (delete connection.attachStreams[streamIdx], console.log("Stream removed from attachStreams", connection.attachStreams)), connection.renegotiate()) : console.warn("No such stream exist.", streamid);
    }, connection.addStream = function(session, remoteUserId) {
      if (session.getTracks)
        return -1 === connection.attachStreams.indexOf(session) && (session.streamid || (session.streamid = session.id), connection.attachStreams.push(session)), void connection.renegotiate(remoteUserId);
      function gumCallback(stream2) {
        session.streamCallback && session.streamCallback(stream2), connection.renegotiate(remoteUserId);
      }
      isData(session) ? connection.renegotiate(remoteUserId) : (session.audio || session.video || session.screen) && (session.screen ? "Edge" === DetectRTC.browser.name ? navigator.getDisplayMedia({ video: true, audio: isAudioPlusTab(connection) }).then(function(screen2) {
        screen2.isScreen = true, mPeer.onGettingLocalMedia(screen2), !session.audio && !session.video || isAudioPlusTab(connection) ? gumCallback(screen2) : connection.invokeGetUserMedia(null, function(stream2) {
          gumCallback(stream2);
        });
      }, function(error) {
        console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
      }) : connection.invokeGetUserMedia({ audio: isAudioPlusTab(connection), video: true, isScreen: true }, function(stream2) {
        !session.audio && !session.video || isAudioPlusTab(connection) ? gumCallback(stream2) : connection.invokeGetUserMedia(null, function(stream3) {
          gumCallback(stream3);
        });
      }) : (session.audio || session.video) && connection.invokeGetUserMedia(null, gumCallback));
    }, connection.invokeGetUserMedia = function(localMediaConstraints, callback, session) {
      session || (session = connection.session), localMediaConstraints || (localMediaConstraints = connection.mediaConstraints), getUserMediaHandler({ onGettingLocalMedia: function(stream2) {
        var videoConstraints = localMediaConstraints.video;
        videoConstraints && (videoConstraints.mediaSource || videoConstraints.mozMediaSource || videoConstraints.mandatory && videoConstraints.mandatory.chromeMediaSource) && (stream2.isScreen = true), stream2.isScreen || (stream2.isVideo = !!getTracks(stream2, "video").length, stream2.isAudio = !stream2.isVideo && getTracks(stream2, "audio").length), mPeer.onGettingLocalMedia(stream2, function() {
          "function" == typeof callback && callback(stream2);
        });
      }, onLocalMediaError: function(error, constraints) {
        mPeer.onLocalMediaError(error, constraints);
      }, localMediaConstraints: localMediaConstraints || { audio: !!session.audio && localMediaConstraints.audio, video: !!session.video && localMediaConstraints.video } });
    }, connection.applyConstraints = function(mediaConstraints, streamid) {
      if (MediaStreamTrack && MediaStreamTrack.prototype.applyConstraints) {
        var stream2;
        if (streamid)
          return connection.streamEvents[streamid] && (stream2 = connection.streamEvents[streamid].stream), void applyConstraints(stream2, mediaConstraints);
        connection.attachStreams.forEach(function(stream3) {
          applyConstraints(stream3, mediaConstraints);
        });
      } else
        alert("track.applyConstraints is NOT supported in your browser.");
    }, connection.replaceTrack = function(session, remoteUserId, isVideoTrack, oldTrack) {
      if (session = session || {}, RTCPeerConnection.prototype.getSenders)
        if (session instanceof MediaStreamTrack)
          replaceTrack(session, remoteUserId, isVideoTrack, oldTrack);
        else {
          if (session instanceof MediaStream)
            return getTracks(session, "video").length && replaceTrack(getTracks(session, "video")[0], remoteUserId, true, oldTrack), void (getTracks(session, "audio").length && replaceTrack(getTracks(session, "audio")[0], remoteUserId, false, oldTrack));
          if (isData(session))
            throw "connection.replaceTrack requires audio and/or video and/or screen.";
          (session.audio || session.video || session.screen) && (session.screen ? "Edge" === DetectRTC.browser.name ? navigator.getDisplayMedia({ video: true, audio: isAudioPlusTab(connection) }).then(function(screen2) {
            screen2.isScreen = true, mPeer.onGettingLocalMedia(screen2), !session.audio && !session.video || isAudioPlusTab(connection) ? gumCallback(screen2) : connection.invokeGetUserMedia(null, gumCallback);
          }, function(error) {
            console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
          }) : connection.invokeGetUserMedia({ audio: isAudioPlusTab(connection), video: true, isScreen: true }, !session.audio && !session.video || isAudioPlusTab(connection) ? gumCallback : connection.invokeGetUserMedia(null, gumCallback)) : (session.audio || session.video) && connection.invokeGetUserMedia(null, gumCallback));
        }
      else
        connection.addStream(session);
      function gumCallback(stream2) {
        connection.replaceTrack(stream2, remoteUserId, isVideoTrack || session.video || session.screen, oldTrack);
      }
    }, connection.resetTrack = function(remoteUsersIds, isVideoTrack) {
      remoteUsersIds || (remoteUsersIds = connection.getAllParticipants()), "string" == typeof remoteUsersIds && (remoteUsersIds = [remoteUsersIds]), remoteUsersIds.forEach(function(participant) {
        var peer = connection.peers[participant].peer;
        void 0 !== isVideoTrack && true !== isVideoTrack || !peer.lastVideoTrack || connection.replaceTrack(peer.lastVideoTrack, participant, true), void 0 !== isVideoTrack && false !== isVideoTrack || !peer.lastAudioTrack || connection.replaceTrack(peer.lastAudioTrack, participant, false);
      });
    }, connection.renegotiate = function(remoteUserId) {
      remoteUserId ? mPeer.renegotiatePeer(remoteUserId) : connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.renegotiatePeer(participant);
      });
    }, connection.setStreamEndHandler = function(stream2, isRemote) {
      if (stream2 && stream2.addEventListener && (isRemote = !!isRemote, !stream2.alreadySetEndHandler)) {
        stream2.alreadySetEndHandler = true;
        var streamEndedEvent = "ended";
        "oninactive" in stream2 && (streamEndedEvent = "inactive"), stream2.addEventListener(streamEndedEvent, function() {
          if (stream2.idInstance && currentUserMediaRequest.remove(stream2.idInstance), !isRemote) {
            var streams = [];
            connection.attachStreams.forEach(function(s) {
              s.id != stream2.id && streams.push(s);
            }), connection.attachStreams = streams;
          }
          var streamEvent = connection.streamEvents[stream2.streamid];
          if (streamEvent || (streamEvent = { stream: stream2, streamid: stream2.streamid, type: isRemote ? "remote" : "local", userid: connection.userid, extra: connection.extra, mediaElement: connection.streamEvents[stream2.streamid] ? connection.streamEvents[stream2.streamid].mediaElement : null }), isRemote && connection.peers[streamEvent.userid]) {
            var peer = connection.peers[streamEvent.userid].peer;
            streams = [];
            peer.getRemoteStreams().forEach(function(s) {
              s.id != stream2.id && streams.push(s);
            }), connection.peers[streamEvent.userid].streams = streams;
          }
          streamEvent.userid === connection.userid && "remote" === streamEvent.type || (connection.peersBackup[streamEvent.userid] && (streamEvent.extra = connection.peersBackup[streamEvent.userid].extra), connection.onstreamended(streamEvent), delete connection.streamEvents[stream2.streamid]);
        }, false);
      }
    }, connection.onMediaError = function(error, constraints) {
      connection.enableLogs && console.error(error, constraints);
    }, connection.autoCloseEntireSession = false, connection.filesContainer = connection.videosContainer = document.body || document.documentElement, connection.isInitiator = false, connection.shareFile = mPeer.shareFile, void 0 !== FileProgressBarHandler && FileProgressBarHandler.handle(connection), void 0 !== TranslationHandler && TranslationHandler.handle(connection), connection.token = getRandomString, connection.onNewParticipant = function(participantId, userPreferences) {
      connection.acceptParticipationRequest(participantId, userPreferences);
    }, connection.acceptParticipationRequest = function(participantId, userPreferences) {
      userPreferences.successCallback && (userPreferences.successCallback(), delete userPreferences.successCallback), mPeer.createNewPeer(participantId, userPreferences);
    }, void 0 !== StreamsHandler && (connection.StreamsHandler = StreamsHandler), connection.onleave = function(userid) {
    }, connection.invokeSelectFileDialog = function(callback) {
      var selector = new FileSelector();
      selector.accept = "*.*", selector.selectSingleFile(callback);
    }, connection.onmute = function(e) {
      if (e && e.mediaElement)
        if ("both" === e.muteType || "video" === e.muteType) {
          e.mediaElement.src = null;
          var paused = e.mediaElement.pause();
          void 0 !== paused ? paused.then(function() {
            e.mediaElement.poster = e.snapshot || "https://cdn.webrtc-experiment.com/images/muted.png";
          }) : e.mediaElement.poster = e.snapshot || "https://cdn.webrtc-experiment.com/images/muted.png";
        } else
          "audio" === e.muteType && (e.mediaElement.muted = true);
    }, connection.onunmute = function(e) {
      e && e.mediaElement && e.stream && ("both" === e.unmuteType || "video" === e.unmuteType ? (e.mediaElement.poster = null, e.mediaElement.srcObject = e.stream, e.mediaElement.play()) : "audio" === e.unmuteType && (e.mediaElement.muted = false));
    }, connection.onExtraDataUpdated = function(event2) {
      event2.status = "online", connection.onUserStatusChanged(event2, true);
    }, connection.getAllParticipants = function(sender) {
      return connection.peers.getAllParticipants(sender);
    }, void 0 !== StreamsHandler && (StreamsHandler.onSyncNeeded = function(streamid, action, type) {
      connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.onNegotiationNeeded({ streamid, action, streamSyncNeeded: true, type: type || "both" }, participant);
      });
    }), connection.connectSocket = function(callback) {
      connectSocket(callback);
    }, connection.closeSocket = function() {
      try {
        io.sockets = {};
      } catch (e) {
      }
      connection.socket && ("function" == typeof connection.socket.disconnect && connection.socket.disconnect(), "function" == typeof connection.socket.resetProps && connection.socket.resetProps(), connection.socket = null);
    }, connection.getSocket = function(callback) {
      return !callback && connection.enableLogs && console.warn("getSocket.callback paramter is required."), callback = callback || function() {
      }, connection.socket ? callback(connection.socket) : connectSocket(function() {
        callback(connection.socket);
      }), connection.socket;
    }, connection.getRemoteStreams = mPeer.getRemoteStreams;
    var skipStreams = ["selectFirst", "selectAll", "forEach"];
    if (connection.streamEvents = { selectFirst: function(options) {
      return connection.streamEvents.selectAll(options)[0];
    }, selectAll: function(options) {
      options || (options = { local: true, remote: true, isScreen: true, isAudio: true, isVideo: true }), "local" == options && (options = { local: true }), "remote" == options && (options = { remote: true }), "screen" == options && (options = { isScreen: true }), "audio" == options && (options = { isAudio: true }), "video" == options && (options = { isVideo: true });
      var streams = [];
      return Object.keys(connection.streamEvents).forEach(function(key) {
        var event2 = connection.streamEvents[key];
        if (-1 === skipStreams.indexOf(key)) {
          var ignore = true;
          options.local && "local" === event2.type && (ignore = false), options.remote && "remote" === event2.type && (ignore = false), options.isScreen && event2.stream.isScreen && (ignore = false), options.isVideo && event2.stream.isVideo && (ignore = false), options.isAudio && event2.stream.isAudio && (ignore = false), options.userid && event2.userid === options.userid && (ignore = false), false === ignore && streams.push(event2);
        }
      }), streams;
    } }, connection.socketURL = "/", connection.socketMessageEvent = "RTCMultiConnection-Message", connection.socketCustomEvent = "RTCMultiConnection-Custom-Message", connection.DetectRTC = DetectRTC, connection.setCustomSocketEvent = function(customEvent) {
      customEvent && (connection.socketCustomEvent = customEvent), connection.socket && connection.socket.emit("set-custom-socket-event-listener", connection.socketCustomEvent);
    }, connection.getNumberOfBroadcastViewers = function(broadcastId, callback) {
      connection.socket && broadcastId && callback && connection.socket.emit("get-number-of-users-in-specific-broadcast", broadcastId, callback);
    }, connection.onNumberOfBroadcastViewersUpdated = function(event2) {
      connection.enableLogs && connection.isInitiator && console.info("Number of broadcast (", event2.broadcastId, ") viewers", event2.numberOfBroadcastViewers);
    }, connection.onUserStatusChanged = function(event2, dontWriteLogs) {
      connection.enableLogs && !dontWriteLogs && console.info(event2.userid, event2.status);
    }, connection.getUserMediaHandler = getUserMediaHandler, connection.multiPeersHandler = mPeer, connection.enableLogs = true, connection.setCustomSocketHandler = function(customSocketHandler) {
      void 0 !== SocketConnection && (SocketConnection = customSocketHandler);
    }, connection.chunkSize = 4e4, connection.maxParticipantsAllowed = 1e3, connection.disconnectWith = mPeer.disconnectWith, connection.checkPresence = function(roomid2, callback) {
      roomid2 = roomid2 || connection.sessionid, "SSEConnection" !== SocketConnection.name ? connection.socket ? connection.socket.emit("check-presence", roomid2 + "", function(isRoomExist, _roomid, extra) {
        connection.enableLogs && console.log("checkPresence.isRoomExist: ", isRoomExist, " roomid: ", _roomid), callback(isRoomExist, _roomid, extra);
      }) : connection.connectSocket(function() {
        connection.checkPresence(roomid2, callback);
      }) : SSEConnection.checkPresence(roomid2, function(isRoomExist, _roomid, extra) {
        if (!connection.socket)
          return isRoomExist || (connection.userid = _roomid), void connection.connectSocket(function() {
            callback(isRoomExist, _roomid, extra);
          });
        callback(isRoomExist, _roomid);
      });
    }, connection.onReadyForOffer = function(remoteUserId, userPreferences) {
      connection.multiPeersHandler.createNewPeer(remoteUserId, userPreferences);
    }, connection.setUserPreferences = function(userPreferences) {
      return connection.dontAttachStream && (userPreferences.dontAttachLocalStream = true), connection.dontGetRemoteStream && (userPreferences.dontGetRemoteStream = true), userPreferences;
    }, connection.updateExtraData = function() {
      connection.socket.emit("extra-data-updated", connection.extra);
    }, connection.enableScalableBroadcast = false, connection.maxRelayLimitPerUser = 3, connection.dontCaptureUserMedia = false, connection.dontAttachStream = false, connection.dontGetRemoteStream = false, connection.onReConnecting = function(event2) {
      connection.enableLogs && console.info("ReConnecting with", event2.userid, "...");
    }, connection.beforeAddingStream = function(stream2) {
      return stream2;
    }, connection.beforeRemovingStream = function(stream2) {
      return stream2;
    }, "undefined" != typeof isChromeExtensionAvailable && (connection.checkIfChromeExtensionAvailable = isChromeExtensionAvailable), "undefined" != typeof isFirefoxExtensionAvailable && (connection.checkIfChromeExtensionAvailable = isFirefoxExtensionAvailable), "undefined" != typeof getChromeExtensionStatus && (connection.getChromeExtensionStatus = getChromeExtensionStatus), connection.modifyScreenConstraints = function(screen_constraints) {
      return screen_constraints;
    }, connection.onPeerStateChanged = function(state) {
      connection.enableLogs && -1 !== state.iceConnectionState.search(/closed|failed/gi) && console.error("Peer connection is closed between you & ", state.userid, state.extra, "state:", state.iceConnectionState);
    }, connection.isOnline = true, listenEventHandler("online", function() {
      connection.isOnline = true;
    }), listenEventHandler("offline", function() {
      connection.isOnline = false;
    }), connection.isLowBandwidth = false, navigator && navigator.connection && navigator.connection.type && (connection.isLowBandwidth = -1 !== navigator.connection.type.toString().toLowerCase().search(/wifi|cell/g), connection.isLowBandwidth)) {
      if (connection.bandwidth = { audio: false, video: false, screen: false }, connection.mediaConstraints.audio && connection.mediaConstraints.audio.optional && connection.mediaConstraints.audio.optional.length) {
        var newArray = [];
        connection.mediaConstraints.audio.optional.forEach(function(opt) {
          void 0 === opt.bandwidth && newArray.push(opt);
        }), connection.mediaConstraints.audio.optional = newArray;
      }
      if (connection.mediaConstraints.video && connection.mediaConstraints.video.optional && connection.mediaConstraints.video.optional.length) {
        newArray = [];
        connection.mediaConstraints.video.optional.forEach(function(opt) {
          void 0 === opt.bandwidth && newArray.push(opt);
        }), connection.mediaConstraints.video.optional = newArray;
      }
    }
    connection.getExtraData = function(remoteUserId, callback) {
      if (!remoteUserId)
        throw "remoteUserId is required.";
      if ("function" != typeof callback)
        return connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : connection.peersBackup[remoteUserId] ? connection.peersBackup[remoteUserId].extra : {};
      connection.socket.emit("get-remote-user-extra-data", remoteUserId, function(extra, remoteUserId2, error) {
        callback(extra, remoteUserId2, error);
      });
    }, forceOptions.autoOpenOrJoin && connection.openOrJoin(connection.sessionid), connection.onUserIdAlreadyTaken = function(useridAlreadyTaken, yourNewUserId) {
      connection.close(), connection.closeSocket(), connection.isInitiator = false, connection.userid = connection.token(), connection.join(connection.sessionid), connection.enableLogs && console.warn("Userid already taken.", useridAlreadyTaken, "Your new userid:", connection.userid);
    }, connection.trickleIce = true, connection.version = "3.7.0", connection.onSettingLocalDescription = function(event2) {
      connection.enableLogs && console.info("Set local description for remote user", event2.userid);
    }, connection.resetScreen = function() {
      sourceId = null, DetectRTC && DetectRTC.screen && delete DetectRTC.screen.sourceId, currentUserMediaRequest = { streams: [], mutex: false, queueRequests: [] };
    }, connection.autoCreateMediaElement = true, connection.password = null, connection.setPassword = function(password, callback) {
      callback = callback || function() {
      }, connection.socket ? connection.socket.emit("set-password", password, callback) : (connection.password = password, callback(true, connection.sessionid, null));
    }, connection.onSocketDisconnect = function(event2) {
      connection.enableLogs && console.warn("socket.io connection is closed");
    }, connection.onSocketError = function(event2) {
      connection.enableLogs && console.warn("socket.io connection is failed");
    }, connection.errors = { ROOM_NOT_AVAILABLE: "Room not available", INVALID_PASSWORD: "Invalid password", USERID_NOT_AVAILABLE: "User ID does not exist", ROOM_PERMISSION_DENIED: "Room permission denied", ROOM_FULL: "Room full", DID_NOT_JOIN_ANY_ROOM: "Did not join any room yet", INVALID_SOCKET: "Invalid socket", PUBLIC_IDENTIFIER_MISSING: "publicRoomIdentifier is required", INVALID_ADMIN_CREDENTIAL: "Invalid username or password attempted" };
  }(this);
};
"undefined" != typeof module && (module.exports = exports = RTCMultiConnection), "function" == typeof define && define.amd && define("RTCMultiConnection", [], function() {
  return RTCMultiConnection;
});
export {
  RTCMultiConnection as R
};
//# sourceMappingURL=RTCMultiConnection.min.959809bc.js.map
