import { P as ProfileImageMaleKid, a as ProfileImageMaleTeen, b as ProfileImageFemaleKid, c as ProfileImageFemaleTeen, d as ProfileImageFemale } from "../default-profile-image-female.0dd92339.js";
import { P as ProfileImageMale } from "../default-profile-image-male.529a2fd5.js";
import { m as mapGetters } from "../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  name: "profile-card",
  components: {},
  props: {
    options: {
      type: Object,
      default() {
        return {
          imageType: "adult"
        };
      }
    },
    to: {
      type: Object,
      default: null
    },
    linkOne: {
      type: Object,
      default: null
    },
    linkTwo: {
      type: Object,
      default: null
    },
    name: {
      required: true
    },
    subHeading: {
      type: String,
      default: ""
    },
    profileExtraStyles: {
      type: String,
      default: ""
    },
    gender: {
      type: Object,
      default() {
        return { uuid: "male", name: "Male" };
      }
    },
    age: {
      type: Object,
      default() {
        return { years: 18, months: 0, days: 0 };
      }
    },
    image: {
      type: String,
      default: ""
    },
    coverImage: {
      type: String,
      default: ""
    },
    editImage: {
      type: Boolean,
      default: false
    },
    horizontal: {
      type: Boolean,
      default: true
    },
    showButtons: {
      type: Boolean,
      default: false
    },
    userStatus: {
      type: Boolean,
      default: false
    },
    nonPerson: {
      type: Boolean,
      default: false
    },
    user: {
      type: Object
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    computedImage() {
      if (!this.gender) {
        return ProfileImageMale;
      }
      if (this.gender.uuid === "male") {
        if (this.age) {
          if (this.age.years < 13) {
            return ProfileImageMaleKid;
          } else if (this.age.years < 18) {
            return ProfileImageMaleTeen;
          }
        }
        return ProfileImageMale;
      } else {
        if (this.age) {
          if (this.age.years < 13) {
            return ProfileImageFemaleKid;
          } else if (this.age.years < 18) {
            return ProfileImageFemaleTeen;
          }
        }
        return ProfileImageFemale;
      }
    },
    coverPageStyles() {
      return this.coverImage ? {
        backgroundImage: "url(" + this.coverImage + ")"
      } : {};
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { class: ["profile-card", { "horizontal-layout": _vm.horizontal }, { "has-edit-image": _vm.editImage }] }, [_c("div", { class: ["profile-image-background", { "has-cover-image": _vm.coverImage }], style: _vm.coverPageStyles }, [_vm.editImage ? _c("router-link", { staticClass: "edit-image-wrapper", attrs: { "to": { name: "appProfileViewImage", params: { uuid: _vm.user.uuid } } } }, [_c("i", { staticClass: "fas fa-image" })]) : _vm._e()], 1), _c("div", { staticClass: "profile-details-wrapper" }, [_c("div", { class: ["profile-image-wrapper", { "placeholder": !_vm.image }] }, [_vm.to ? [_c("router-link", { staticClass: "profile-image pointer", attrs: { "to": _vm.to, "tabindex": "-1" } }, [_c("user-avatar", { attrs: { "user": _vm.user, "size": 130, "background-color": _vm.vars.colors["white"], "foreground-color": _vm.vars.colors["primary"] } })], 1)] : [_c("div", { staticClass: "profile-image" }, [_c("user-avatar", { attrs: { "user": _vm.user, "size": 130, "background-color": _vm.vars.colors["white"], "foreground-color": _vm.vars.colors["primary"] } })], 1)], _vm.editImage ? _c("router-link", { staticClass: "edit-image-wrapper", attrs: { "to": { name: "appProfileViewImage", params: { uuid: _vm.user.uuid } } } }, [_c("i", { staticClass: "fas fa-image" })]) : _vm._e()], 2), _c("div", { staticClass: "profile-details" }, [_vm.to ? _c("router-link", { staticClass: "profile-heading pointer", attrs: { "to": _vm.to, "tabindex": "-1", "custom": "" }, scopedSlots: _vm._u([{ key: "default", fn: function({ navigate }) {
    return [_c("h5", { attrs: { "role": "link" }, on: { "click": navigate, "keypress": function($event) {
      if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
        return null;
      return navigate.apply(null, arguments);
    } } }, [_vm._v(_vm._s(_vm.name))])];
  } }], null, false, 2661043621) }) : _c("h5", { staticClass: "profile-heading" }, [_vm._v(_vm._s(_vm.name))]), _c("p", { staticClass: "profile-sub-heading text-muted" }, [_vm._v(_vm._s(_vm.subHeading))]), !_vm.$slots.extras && !_vm.nonPerson ? _c("p", { staticClass: "profile-extras text-muted comma-list" }, [_vm.gender ? _c("span", [_vm._v(_vm._s(_vm.gender.name))]) : _vm._e(), _vm.age && _vm.age.years ? _c("span", [_vm._v(_vm._s(_vm.$t("global.years_old", { attribute: _vm.age.years })))]) : _vm._e()]) : _c("div", { class: ["profile-extras has-slot", _vm.profileExtraStyles] }, [_vm._t("extras")], 2)], 1)]), _vm.nonPerson && _vm.showButtons && (_vm.linkOne || _vm.linkTwo) ? _c("popover-buttons", { attrs: { "link-one": _vm.linkOne, "link-two": _vm.linkTwo }, on: { "buttonClicked": function($event) {
    return _vm.$emit("buttonClicked");
  } } }) : _vm.showButtons && _vm.user ? _c("profile-buttons", { attrs: { "link": _vm.to, "user": _vm.user }, on: { "buttonClicked": function($event) {
    return _vm.$emit("buttonClicked");
  } } }) : _vm._e()], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ProfileCard = __component__.exports;
export {
  ProfileCard as default
};
//# sourceMappingURL=ProfileCard.e9a98af3.js.map
