import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const NavbarToggleButton_vue_vue_type_style_index_0_lang = "";
const _sfc_main$1 = {
  props: {
    target: {
      type: [String, Number],
      description: "Button target element"
    },
    toggled: {
      type: Boolean,
      default: false,
      description: "Whether button is toggled"
    }
  }
};
var _sfc_render$1 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("button", { staticClass: "navbar-toggler", attrs: { "type": "button", "data-toggle": "collapse", "data-target": _vm.target, "aria-controls": _vm.target, "aria-expanded": _vm.toggled, "aria-label": "Toggle navigation" } }, [_c("span", { staticClass: "navbar-toggler-icon" })]);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  null,
  null,
  null
);
const NavbarToggleButton = __component__$1.exports;
const BaseNav_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "base-nav",
  components: {
    NavbarToggleButton
  },
  props: {
    type: {
      type: String,
      default: "primary",
      description: "Navbar type (e.g default, primary etc)"
    },
    title: {
      type: String,
      default: "",
      description: "Title of navbar"
    },
    contentId: {
      type: [String, Number],
      default: Math.random().toString(),
      description: "Explicit id for the menu. By default it's a generated random number"
    },
    effect: {
      type: String,
      default: "dark",
      description: "Effect of the navbar (light|dark)"
    },
    round: {
      type: Boolean,
      default: false,
      description: "Whether nav has rounded corners"
    },
    transparent: {
      type: Boolean,
      default: false,
      description: "Whether navbar is transparent"
    },
    expand: {
      type: Boolean,
      default: false,
      description: "Whether navbar should contain `navbar-expand-lg` class"
    }
  },
  data() {
    return {
      toggled: false
    };
  },
  methods: {
    onTitleClick(evt) {
      this.$emit("title-click", evt);
    },
    closeMenu() {
      this.toggled = false;
    }
  }
};
var _sfc_render = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("nav", { staticClass: "navbar", class: [
    { "navbar-expand-lg": _vm.expand },
    { [`navbar-${_vm.effect}`]: _vm.effect },
    { "navbar-transparent": _vm.transparent },
    { [`bg-${_vm.type}`]: _vm.type },
    { "rounded": _vm.round }
  ] }, [_c("div", { staticClass: "container" }, [_vm._t("container-pre"), _vm._t("brand", function() {
    return [_c("a", { staticClass: "navbar-brand", attrs: { "href": "#" }, on: { "click": function($event) {
      $event.preventDefault();
      return _vm.onTitleClick.apply(null, arguments);
    } } }, [_vm._v(" " + _vm._s(_vm.title) + " ")])];
  }), _c("navbar-toggle-button", { attrs: { "toggled": _vm.toggled, "target": _vm.contentId }, nativeOn: { "click": function($event) {
    $event.stopPropagation();
    _vm.toggled = !_vm.toggled;
  } } }), _vm._t("container-after"), _c("div", { directives: [{ name: "click-outside", rawName: "v-click-outside", value: _vm.closeMenu, expression: "closeMenu" }], staticClass: "collapse navbar-collapse", class: { show: _vm.toggled }, attrs: { "id": _vm.contentId } }, [_c("div", { staticClass: "navbar-collapse-header" }, [_vm._t("content-header", null, { "closeMenu": _vm.closeMenu })], 2), _vm._t("default", null, { "closeMenu": _vm.closeMenu })], 2)], 2)]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const BaseNav = __component__.exports;
export {
  BaseNav as default
};
//# sourceMappingURL=BaseNav.e0e0ac33.js.map
