import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const Card_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "card",
  props: {
    type: {
      type: String,
      description: "Card type"
    },
    border: {
      type: String,
      description: "Border"
    },
    title: {
      type: String,
      description: "Card title"
    },
    image: {
      type: String,
      description: "Card Image"
    },
    imageOnTop: {
      type: Boolean,
      default: true
    },
    imageAlt: {
      type: String,
      default: "",
      description: "Image alt text"
    },
    gradient: {
      type: String,
      description: "Card background gradient type (warning,danger etc)"
    },
    lift: {
      type: Boolean,
      description: "Whether card should move on hover"
    },
    raise: {
      type: Boolean,
      description: "Whether card should get raised on hover"
    },
    canMinimize: {
      type: Boolean,
      default: false
    },
    canMaximize: {
      type: Boolean,
      default: false
    },
    canRefresh: {
      type: Boolean,
      default: false
    },
    refreshing: {
      type: Boolean,
      default: false
    },
    showFooter: {
      type: Boolean,
      default: false
    },
    shadow: {
      type: Boolean,
      description: "Whether card has shadow"
    },
    shadowSize: {
      type: String,
      description: "Card shadow size"
    },
    noBody: {
      type: Boolean,
      default: false,
      description: "Whether card should have wrapper body class"
    },
    bodyClasses: {
      type: [String, Object, Array],
      description: "Card body css classes"
    },
    bodyStyle: {
      type: Object,
      description: "Card body css style object",
      default() {
        return {};
      }
    },
    headerClasses: {
      type: [String, Object, Array],
      description: "Card header css classes"
    },
    cardTitleClasses: {
      type: [String, Object, Array],
      description: "Card header css classes"
    },
    footerClasses: {
      type: [String, Object, Array],
      description: "Card footer css classes"
    }
  },
  methods: {
    actionMinimize() {
      this.$emit("minimized");
    },
    actionMaximize() {
      this.$emit("maximized");
    },
    actionRefresh() {
      this.$emit("refresh");
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "card", class: [
    { "card-lift--hover": _vm.lift },
    `shadow${_vm.shadowSize ? "-" + _vm.shadowSize : ""}`,
    { [`shadow${_vm.shadowSize ? "-" + _vm.shadowSize : ""}--hover`]: _vm.raise },
    { [`bg-gradient-${_vm.gradient}`]: _vm.gradient },
    { [`bg-${_vm.type}`]: _vm.type },
    { [`border-color-${_vm.border}`]: _vm.border }
  ] }, [_vm._t("topImage", function() {
    return [_vm.image && _vm.imageOnTop ? _c("img", { directives: [{ name: "lazy", rawName: "v-lazy", value: _vm.image, expression: "image" }], staticClass: "card-img-top", attrs: { "alt": _vm.imageAlt } }) : _vm._e()];
  }), !(_vm.$slots.topImage || _vm.image && _vm.imageOnTop) && (_vm.$slots.header || _vm.$slots.title || _vm.$slots.actions || _vm.title) ? _c("div", { staticClass: "card-header", class: _vm.headerClasses }, [_vm._t("header", function() {
    return [_c("div", { class: ["card-title", _vm.cardTitleClasses] }, [_vm._t("title", function() {
      return [_c("h5", [_vm._v(_vm._s(_vm.title))])];
    })], 2), _c("div", { staticClass: "card-actions" }, [_vm._t("actions", function() {
      return [_vm.canRefresh ? _c("button", { staticClass: "btn action", attrs: { "type": "button" }, on: { "click": _vm.actionRefresh } }, [_c("i", { class: ["fas fa-sync-alt", { "fa-spin": _vm.refreshing }] })]) : _vm._e(), _vm.canMaximize ? _c("button", { staticClass: "btn action", attrs: { "type": "button" }, on: { "click": _vm.actionMaximize } }, [_c("i", { staticClass: "fas fa-expand" })]) : _vm._e(), _vm.canMinimize ? _c("button", { staticClass: "btn action", attrs: { "type": "button" }, on: { "click": _vm.actionMinimize } }, [_c("i", { staticClass: "fas fa-window-minimize" })]) : _vm._e()];
    })], 2)];
  })], 2) : _vm._e(), !_vm.noBody ? _c("div", { staticClass: "card-body", class: _vm.bodyClasses, style: _vm.bodyStyle }, [_vm._t("default")], 2) : _vm._e(), _vm.noBody ? _vm._t("default") : _vm._e(), _vm._t("bottomImage", function() {
    return [_vm.image && !_vm.imageOnTop ? _c("img", { directives: [{ name: "lazy", rawName: "v-lazy", value: _vm.image, expression: "image" }], staticClass: "card-img-bottom", attrs: { "alt": _vm.imageAlt } }) : _vm._e()];
  }), !(_vm.$slots.bottomImage || _vm.image && !_vm.imageOnTop) && _vm.$slots.footer || _vm.showFooter ? _c("div", { staticClass: "card-footer", class: _vm.footerClasses }, [_vm._t("footer")], 2) : _vm._e()], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const Card = __component__.exports;
export {
  Card as default
};
//# sourceMappingURL=Card.bd7558b7.js.map
