import { m as mapGetters } from "../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  name: "view-date",
  props: {
    label: {
      type: String,
      description: "View label (text before input)"
    },
    viewGroupClasses: {
      type: [String, Array],
      description: "View Group css classes",
      default: ""
    },
    labelClasses: {
      type: [String, Array],
      description: "View label css classes",
      default: "d-block"
    },
    dataClasses: {
      type: [String, Array],
      description: "View css classes"
    },
    prefix: {
      type: String,
      description: "Prefix"
    },
    suffix: {
      type: String,
      description: "Suffix"
    },
    prefixClasses: {
      type: [String, Array],
      description: "Prefix",
      default: "text-muted"
    },
    icon: {
      type: [String, Array],
      description: "Prefix",
      default: "fas fa-store-alt"
    },
    suffixClasses: {
      type: [String, Array],
      description: "Suffix",
      default: "text-muted"
    },
    value: {
      type: [String, Number, Boolean, Object],
      description: "View value"
    },
    tag: {
      type: String,
      description: "Tag value",
      default: "h6"
    },
    showIfExists: {
      type: String,
      default: ""
    },
    focusable: {
      type: Boolean,
      default: false
    },
    hideIfEmpty: {
      type: Boolean,
      default: false
    },
    isEntity: {
      type: Boolean,
      default: false
    },
    showIcon: {
      type: Boolean,
      default: false
    },
    withTz: {
      type: Boolean,
      default: false
    },
    fromFormat: {
      type: String
    },
    toFormat: {
      type: String
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    parseFormat() {
      return this.fromFormat ? this.fromFormat : [this.vars.serverDateFormat, this.vars.serverDateTimeFormat];
    },
    outputFormat() {
      return this.toFormat ? this.toFormat : this.vars.defaultDateFormat;
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return !_vm.hideIfEmpty || _vm.hideIfEmpty && _vm.value !== null && _vm.value !== "" ? _c("div", { staticClass: "base-view view-single view-date" }, [_c("div", { staticClass: "view-group", class: [
    { "has-label": _vm.label || _vm.$slots.label },
    { "is-entity": _vm.isEntity },
    { "not-empty": _vm.value || _vm.value === 0 },
    _vm.viewGroupClasses
  ] }, [_vm._t("label", function() {
    return [_vm.label ? _c("label", { class: _vm.labelClasses }, [_vm._v(" " + _vm._s(_vm.label) + " ")]) : _vm._e()];
  }), _vm._t("main", function() {
    return [_c("div", { staticClass: "view-data-wrapper" }, [_vm.value ? _c(_vm.tag, { tag: "component", class: ["view-data", { "focusable": _vm.focusable }, _vm.dataClasses] }, [_vm.showIcon && _vm.icon ? _c("div", { staticClass: "icon-wrapper" }, [_c("i", { class: _vm.icon })]) : _vm._e(), _vm.prefix ? _c("span", { class: _vm.prefixClasses }, [_vm._v(_vm._s(_vm.prefix) + " ")]) : _vm._e(), _vm.withTz ? _c("span", [_vm.showIfExists ? [_vm._v(" " + _vm._s(_vm._f("momentDateTimeTz")(_vm.value[_vm.showIfExists])) + " ")] : [_vm._v(_vm._s(_vm._f("momentDateTimeTz")(_vm.value)))]], 2) : _c("span", [_vm.showIfExists ? [_vm._v(" " + _vm._s(_vm._f("moment")([_vm.value[_vm.showIfExists], _vm.parseFormat], _vm.outputFormat)) + " ")] : [_vm._v(_vm._s(_vm._f("moment")([_vm.value, _vm.parseFormat], _vm.outputFormat)))]], 2), _vm.suffix ? _c("span", { class: _vm.suffixClasses }, [_vm._v(" " + _vm._s(_vm.suffix))]) : _vm._e()]) : _c("span", [_vm._v("-")])], 1)];
  })], 2), _vm._t("errorBlock")], 2) : _vm._e();
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ViewDate = __component__.exports;
export {
  ViewDate as default
};
//# sourceMappingURL=ViewDate.13ea2442.js.map
