import { m as mapGetters } from "./vendor/vendor-core.2a9962eb.js";
import { E as EventBus } from "./event-bus.0afcd682.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  props: {
    boxed: {
      type: Boolean,
      default: false
    },
    showCloseBtn: {
      type: Boolean,
      default: true
    },
    showFooter: {
      type: Boolean,
      default: true
    },
    isLoading: {
      type: Boolean,
      default: false
    },
    filterRouteFn: {
      type: Function
    }
  },
  computed: {
    ...mapGetters("common", [
      "filters"
    ]),
    ...mapGetters("config", [
      "vars"
    ])
  },
  methods: {
    submit() {
      const filterQuery = {
        ...this.$route.query,
        ...this.filters,
        filtered: true,
        filtered_at: moment().unix()
      };
      if (this.filterRouteFn && _.isFunction(this.filterRouteFn)) {
        this.filterRouteFn(filterQuery);
      } else {
        this.$router.push({ path: this.$route.path, query: filterQuery }).catch((err) => {
        });
      }
    },
    reset() {
      EventBus.$emit("CLEAR_FILTERS");
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { staticClass: "mb-element", attrs: { "boxed": _vm.boxed, "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.showCloseBtn ? _c("close-button", { attrs: { "title": _vm.$t("general.close") }, on: { "click": function($event) {
    return _vm.$emit("close");
  } } }) : _vm._e(), _c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_vm._t("default"), _vm._t("footer", function() {
    return [_vm.showFooter ? _c("div", { staticClass: "form-footer mt-3" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "disabled": _vm.isLoading }, on: { "click": function($event) {
      return _vm.$emit("close");
    } } }, [_vm._v(_vm._s(_vm.$t("general.close")))])], 1), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "disabled": _vm.isLoading }, on: { "click": _vm.reset } }, [_vm._v(_vm._s(_vm.$t("general.clear")))]), _c("base-button", { attrs: { "type": "submit", "design": "primary", "disabled": _vm.isLoading } }, [_vm._v(_vm._s(_vm.$t("general.filter")))])], 1)]) : _vm._e()];
  })], 2)], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const FilterWrapper = __component__.exports;
const filterForm = {
  components: {
    FilterWrapper
  },
  props: {
    preRequisite: {
      type: Object,
      default() {
        return {};
      }
    },
    boxed: {
      type: Boolean,
      default: false
    },
    isLoading: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    ...mapGetters("common", [
      "filters"
    ]),
    ...mapGetters("config", [
      "vars"
    ])
  }
};
export {
  filterForm as f
};
//# sourceMappingURL=filter-form.416a20d1.js.map
