import { l as lookup } from "../../index.b6800d1c.js";
import "../../vendor/vendor-webrtc-adapter.edd1a585.js";
import { h as hark$1 } from "../../vendor/vendor-hark.d59dd231.js";
import "../../vendor/vendor-others.d4f8aae2.js";
import { L as Logger } from "../../live-poll.3e39080e.js";
import "../../vendor/vendor-essential.31dae676.js";
import "../../vendor/vendor-core.2a9962eb.js";
import "../../app.9a8150b2.js";
import "../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../vendor/vendor-laravel-echo.c401b1a2.js";
import "../../vendor/vendor-pusher-js.2a02459b.js";
import "../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../form.ff4ac955.js";
import "../../header.a91390e7.js";
import "../../FileUploader.a3ada0d1.js";
import "../../uploader.39656730.js";
import "../../event-bus.0afcd682.js";
import "../../momentz.3304bf92.js";
import "../../vendor/vendor-vue-chartjs.7edfae0a.js";
var RTCMultiConnection = function(roomid, forceOptions) {
  var browserFakeUserAgent = "Fake/5.0 (FakeOS) AppleWebKit/123 (KHTML, like Gecko) Fake/12.3.4567.89 Fake/123.45";
  (function(that) {
    if (!that) {
      return;
    }
    if (typeof window !== "undefined") {
      return;
    }
    if (typeof global === "undefined") {
      return;
    }
    global.navigator = {
      userAgent: browserFakeUserAgent,
      getUserMedia: function() {
      }
    };
    if (!global.console) {
      global.console = {};
    }
    if (typeof global.console.debug === "undefined") {
      global.console.debug = global.console.info = global.console.error = global.console.log = global.console.log || function() {
        console.log(arguments);
      };
    }
    if (typeof document === "undefined") {
      that.document = {};
      document.createElement = document.captureStream = document.mozCaptureStream = function() {
        var obj = {
          getContext: function() {
            return obj;
          },
          play: function() {
          },
          pause: function() {
          },
          drawImage: function() {
          },
          toDataURL: function() {
            return "";
          }
        };
        return obj;
      };
      document.addEventListener = document.removeEventListener = that.addEventListener = that.removeEventListener = function() {
      };
      that.HTMLVideoElement = that.HTMLMediaElement = function() {
      };
    }
    if (typeof io === "undefined") {
      that.io = function() {
        return {
          on: function(eventName, callback) {
            callback = callback || function() {
            };
            if (eventName === "connect") {
              callback();
            }
          },
          emit: function(eventName, data, callback) {
            callback = callback || function() {
            };
            if (eventName === "open-room" || eventName === "join-room") {
              callback(true, data.sessionid, null);
            }
          }
        };
      };
    }
    if (typeof location === "undefined") {
      that.location = {
        protocol: "file:",
        href: "",
        hash: "",
        origin: "self"
      };
    }
    if (typeof screen === "undefined") {
      that.screen = {
        width: 0,
        height: 0
      };
    }
    if (typeof URL === "undefined") {
      that.URL = {
        createObjectURL: function() {
          return "";
        },
        revokeObjectURL: function() {
          return "";
        }
      };
    }
    that.window = global;
  })(typeof global !== "undefined" ? global : null);
  function SocketConnection(connection, connectCallback) {
    function isData2(session) {
      return !session.audio && !session.video && !session.screen && session.data;
    }
    var parameters = "";
    parameters += "?userid=" + connection.userid;
    parameters += "&sessionid=" + connection.sessionid;
    parameters += "&msgEvent=" + connection.socketMessageEvent;
    parameters += "&socketCustomEvent=" + connection.socketCustomEvent;
    parameters += "&autoCloseEntireSession=" + !!connection.autoCloseEntireSession;
    if (connection.session.broadcast === true) {
      parameters += "&oneToMany=true";
    }
    parameters += "&maxParticipantsAllowed=" + connection.maxParticipantsAllowed;
    if (connection.enableScalableBroadcast) {
      parameters += "&enableScalableBroadcast=true";
      parameters += "&maxRelayLimitPerUser=" + (connection.maxRelayLimitPerUser || 2);
    }
    parameters += "&extra=" + JSON.stringify(connection.extra || {});
    if (connection.socketCustomParameters) {
      parameters += connection.socketCustomParameters;
    }
    try {
      io.sockets = {};
    } catch (e) {
    }
    if (!connection.socketURL) {
      connection.socketURL = "/";
    }
    if (connection.socketURL.substr(connection.socketURL.length - 1, 1) != "/") {
      throw '"socketURL" MUST end with a slash.';
    }
    if (connection.enableLogs) {
      if (connection.socketURL == "/") {
        console.info("socket.io url is: ", location.origin + "/");
      } else {
        console.info("socket.io url is: ", connection.socketURL);
      }
    }
    try {
      connection.socket = io(connection.socketURL + parameters);
    } catch (e) {
      connection.socket = io.connect(connection.socketURL + parameters, connection.socketOptions);
    }
    var mPeer = connection.multiPeersHandler;
    connection.socket.on("extra-data-updated", function(remoteUserId, extra) {
      if (!connection.peers[remoteUserId])
        return;
      connection.peers[remoteUserId].extra = extra;
      connection.onExtraDataUpdated({
        userid: remoteUserId,
        extra
      });
      updateExtraBackup(remoteUserId, extra);
    });
    function updateExtraBackup(remoteUserId, extra) {
      if (!connection.peersBackup[remoteUserId]) {
        connection.peersBackup[remoteUserId] = {
          userid: remoteUserId,
          extra: {}
        };
      }
      connection.peersBackup[remoteUserId].extra = extra;
    }
    function onMessageEvent(message) {
      if (message.remoteUserId != connection.userid)
        return;
      if (connection.peers[message.sender] && connection.peers[message.sender].extra != message.message.extra) {
        connection.peers[message.sender].extra = message.extra;
        connection.onExtraDataUpdated({
          userid: message.sender,
          extra: message.extra
        });
        updateExtraBackup(message.sender, message.extra);
      }
      if (message.message.streamSyncNeeded && connection.peers[message.sender]) {
        var stream2 = connection.streamEvents[message.message.streamid];
        if (!stream2 || !stream2.stream) {
          return;
        }
        var action = message.message.action;
        if (action === "ended" || action === "inactive" || action === "stream-removed") {
          if (connection.peersBackup[stream2.userid]) {
            stream2.extra = connection.peersBackup[stream2.userid].extra;
          }
          connection.onstreamended(stream2);
          return;
        }
        var type = message.message.type != "both" ? message.message.type : null;
        if (typeof stream2.stream[action] == "function") {
          stream2.stream[action](type);
        }
        return;
      }
      if (message.message === "dropPeerConnection") {
        connection.deletePeer(message.sender);
        return;
      }
      if (message.message.allParticipants) {
        if (message.message.allParticipants.indexOf(message.sender) === -1) {
          message.message.allParticipants.push(message.sender);
        }
        message.message.allParticipants.forEach(function(participant) {
          mPeer[!connection.peers[participant] ? "createNewPeer" : "renegotiatePeer"](participant, {
            localPeerSdpConstraints: {
              OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio,
              OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo
            },
            remotePeerSdpConstraints: {
              OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio,
              OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo
            },
            isOneWay: !!connection.session.oneway || connection.direction === "one-way",
            isDataOnly: isData2(connection.session)
          });
        });
        return;
      }
      if (message.message.newParticipant) {
        if (message.message.newParticipant == connection.userid)
          return;
        if (!!connection.peers[message.message.newParticipant])
          return;
        mPeer.createNewPeer(message.message.newParticipant, message.message.userPreferences || {
          localPeerSdpConstraints: {
            OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo
          },
          remotePeerSdpConstraints: {
            OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo
          },
          isOneWay: !!connection.session.oneway || connection.direction === "one-way",
          isDataOnly: isData2(connection.session)
        });
        return;
      }
      if (message.message.readyForOffer) {
        if (connection.attachStreams.length) {
          connection.waitingForLocalMedia = false;
        }
        if (connection.waitingForLocalMedia) {
          setTimeout(function() {
            onMessageEvent(message);
          }, 1);
          return;
        }
      }
      if (message.message.newParticipationRequest && message.sender !== connection.userid) {
        if (connection.peers[message.sender]) {
          connection.deletePeer(message.sender);
        }
        var userPreferences = {
          extra: message.extra || {},
          localPeerSdpConstraints: message.message.remotePeerSdpConstraints || {
            OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo
          },
          remotePeerSdpConstraints: message.message.localPeerSdpConstraints || {
            OfferToReceiveAudio: connection.session.oneway ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: connection.session.oneway ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo
          },
          isOneWay: typeof message.message.isOneWay !== "undefined" ? message.message.isOneWay : !!connection.session.oneway || connection.direction === "one-way",
          isDataOnly: typeof message.message.isDataOnly !== "undefined" ? message.message.isDataOnly : isData2(connection.session),
          dontGetRemoteStream: typeof message.message.isOneWay !== "undefined" ? message.message.isOneWay : !!connection.session.oneway || connection.direction === "one-way",
          dontAttachLocalStream: !!message.message.dontGetRemoteStream,
          connectionDescription: message,
          successCallback: function() {
          }
        };
        connection.onNewParticipant(message.sender, userPreferences);
        return;
      }
      if (message.message.changedUUID) {
        if (connection.peers[message.message.oldUUID]) {
          connection.peers[message.message.newUUID] = connection.peers[message.message.oldUUID];
          delete connection.peers[message.message.oldUUID];
        }
      }
      if (message.message.userLeft) {
        mPeer.onUserLeft(message.sender);
        if (!!message.message.autoCloseEntireSession) {
          connection.leave();
        }
        return;
      }
      mPeer.addNegotiatedMessage(message.message, message.sender);
    }
    connection.socket.on(connection.socketMessageEvent, onMessageEvent);
    var alreadyConnected = false;
    connection.socket.resetProps = function() {
      alreadyConnected = false;
    };
    connection.socket.on("connect", function() {
      if (alreadyConnected) {
        return;
      }
      alreadyConnected = true;
      if (connection.enableLogs) {
        console.info("socket.io connection is opened.");
      }
      setTimeout(function() {
        connection.socket.emit("extra-data-updated", connection.extra);
      }, 1e3);
      if (connectCallback) {
        connectCallback(connection.socket);
      }
    });
    connection.socket.on("disconnect", function(event2) {
      connection.onSocketDisconnect(event2);
    });
    connection.socket.on("error", function(event2) {
      connection.onSocketError(event2);
    });
    connection.socket.on("user-disconnected", function(remoteUserId) {
      if (remoteUserId === connection.userid) {
        return;
      }
      connection.onUserStatusChanged({
        userid: remoteUserId,
        status: "offline",
        extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra || {} : {}
      });
      connection.deletePeer(remoteUserId);
    });
    connection.socket.on("user-connected", function(userid) {
      if (userid === connection.userid) {
        return;
      }
      connection.onUserStatusChanged({
        userid,
        status: "online",
        extra: connection.peers[userid] ? connection.peers[userid].extra || {} : {}
      });
    });
    connection.socket.on("closed-entire-session", function(sessionid, extra) {
      connection.leave();
      connection.onEntireSessionClosed({
        sessionid,
        userid: sessionid,
        extra
      });
    });
    connection.socket.on("userid-already-taken", function(useridAlreadyTaken, yourNewUserId) {
      connection.onUserIdAlreadyTaken(useridAlreadyTaken, yourNewUserId);
    });
    connection.socket.on("logs", function(log) {
      if (!connection.enableLogs)
        return;
      console.debug("server-logs", log);
    });
    connection.socket.on("number-of-broadcast-viewers-updated", function(data) {
      connection.onNumberOfBroadcastViewersUpdated(data);
    });
    connection.socket.on("set-isInitiator-true", function(sessionid) {
      if (sessionid != connection.sessionid)
        return;
      connection.isInitiator = true;
    });
  }
  function MultiPeers(connection) {
    var self = this;
    var skipPeers = ["getAllParticipants", "getLength", "selectFirst", "streams", "send", "forEach"];
    connection.peers = {
      getLength: function() {
        var numberOfPeers = 0;
        for (var peer in this) {
          if (skipPeers.indexOf(peer) == -1) {
            numberOfPeers++;
          }
        }
        return numberOfPeers;
      },
      selectFirst: function() {
        var firstPeer;
        for (var peer in this) {
          if (skipPeers.indexOf(peer) == -1) {
            firstPeer = this[peer];
          }
        }
        return firstPeer;
      },
      getAllParticipants: function(sender) {
        var allPeers = [];
        for (var peer in this) {
          if (skipPeers.indexOf(peer) == -1 && peer != sender) {
            allPeers.push(peer);
          }
        }
        return allPeers;
      },
      forEach: function(callback) {
        this.getAllParticipants().forEach(function(participant) {
          callback(connection.peers[participant]);
        });
      },
      send: function(data, remoteUserId) {
        var that = this;
        if (!isNull(data.size) && !isNull(data.type)) {
          if (connection.enableFileSharing) {
            self.shareFile(data, remoteUserId);
            return;
          }
          if (typeof data !== "string") {
            data = JSON.stringify(data);
          }
        }
        if (data.type !== "text" && !(data instanceof ArrayBuffer) && !(data instanceof DataView)) {
          TextSender.send({
            text: data,
            channel: this,
            connection,
            remoteUserId
          });
          return;
        }
        if (data.type === "text") {
          data = JSON.stringify(data);
        }
        if (remoteUserId) {
          var remoteUser = connection.peers[remoteUserId];
          if (remoteUser) {
            if (!remoteUser.channels.length) {
              connection.peers[remoteUserId].createDataChannel();
              connection.renegotiate(remoteUserId);
              setTimeout(function() {
                that.send(data, remoteUserId);
              }, 3e3);
              return;
            }
            remoteUser.channels.forEach(function(channel) {
              channel.send(data);
            });
            return;
          }
        }
        this.getAllParticipants().forEach(function(participant) {
          if (!that[participant].channels.length) {
            connection.peers[participant].createDataChannel();
            connection.renegotiate(participant);
            setTimeout(function() {
              that[participant].channels.forEach(function(channel) {
                channel.send(data);
              });
            }, 3e3);
            return;
          }
          that[participant].channels.forEach(function(channel) {
            channel.send(data);
          });
        });
      }
    };
    this.uuid = connection.userid;
    this.getLocalConfig = function(remoteSdp, remoteUserId, userPreferences) {
      if (!userPreferences) {
        userPreferences = {};
      }
      return {
        streamsToShare: userPreferences.streamsToShare || {},
        rtcMultiConnection: connection,
        connectionDescription: userPreferences.connectionDescription,
        userid: remoteUserId,
        localPeerSdpConstraints: userPreferences.localPeerSdpConstraints,
        remotePeerSdpConstraints: userPreferences.remotePeerSdpConstraints,
        dontGetRemoteStream: !!userPreferences.dontGetRemoteStream,
        dontAttachLocalStream: !!userPreferences.dontAttachLocalStream,
        renegotiatingPeer: !!userPreferences.renegotiatingPeer,
        peerRef: userPreferences.peerRef,
        channels: userPreferences.channels || [],
        onLocalSdp: function(localSdp) {
          self.onNegotiationNeeded(localSdp, remoteUserId);
        },
        onLocalCandidate: function(localCandidate) {
          localCandidate = OnIceCandidateHandler.processCandidates(connection, localCandidate);
          if (localCandidate) {
            self.onNegotiationNeeded(localCandidate, remoteUserId);
          }
        },
        remoteSdp,
        onDataChannelMessage: function(message) {
          if (!connection.fbr && connection.enableFileSharing)
            initFileBufferReader();
          if (typeof message == "string" || !connection.enableFileSharing) {
            self.onDataChannelMessage(message, remoteUserId);
            return;
          }
          var that = this;
          if (message instanceof ArrayBuffer || message instanceof DataView) {
            connection.fbr.convertToObject(message, function(object) {
              that.onDataChannelMessage(object);
            });
            return;
          }
          if (message.readyForNextChunk) {
            connection.fbr.getNextChunk(message, function(nextChunk, isLastChunk) {
              connection.peers[remoteUserId].channels.forEach(function(channel) {
                channel.send(nextChunk);
              });
            }, remoteUserId);
            return;
          }
          if (message.chunkMissing) {
            connection.fbr.chunkMissing(message);
            return;
          }
          connection.fbr.addChunk(message, function(promptNextChunk) {
            connection.peers[remoteUserId].peer.channel.send(promptNextChunk);
          });
        },
        onDataChannelError: function(error2) {
          self.onDataChannelError(error2, remoteUserId);
        },
        onDataChannelOpened: function(channel) {
          self.onDataChannelOpened(channel, remoteUserId);
        },
        onDataChannelClosed: function(event2) {
          self.onDataChannelClosed(event2, remoteUserId);
        },
        onRemoteStream: function(stream2) {
          if (connection.peers[remoteUserId]) {
            connection.peers[remoteUserId].streams.push(stream2);
          }
          self.onGettingRemoteMedia(stream2, remoteUserId);
        },
        onRemoteStreamRemoved: function(stream2) {
          self.onRemovingRemoteMedia(stream2, remoteUserId);
        },
        onPeerStateChanged: function(states) {
          self.onPeerStateChanged(states);
          if (states.iceConnectionState === "new") {
            self.onNegotiationStarted(remoteUserId, states);
          }
          if (states.iceConnectionState === "connected") {
            self.onNegotiationCompleted(remoteUserId, states);
          }
          if (states.iceConnectionState.search(/closed|failed/gi) !== -1) {
            self.onUserLeft(remoteUserId);
            self.disconnectWith(remoteUserId);
          }
        }
      };
    };
    this.createNewPeer = function(remoteUserId, userPreferences) {
      if (connection.maxParticipantsAllowed <= connection.getAllParticipants().length) {
        return;
      }
      userPreferences = userPreferences || {};
      if (connection.isInitiator && !!connection.session.audio && connection.session.audio === "two-way" && !userPreferences.streamsToShare) {
        userPreferences.isOneWay = false;
        userPreferences.isDataOnly = false;
        userPreferences.session = connection.session;
      }
      if (!userPreferences.isOneWay && !userPreferences.isDataOnly) {
        userPreferences.isOneWay = true;
        this.onNegotiationNeeded({
          enableMedia: true,
          userPreferences
        }, remoteUserId);
        return;
      }
      userPreferences = connection.setUserPreferences(userPreferences, remoteUserId);
      var localConfig = this.getLocalConfig(null, remoteUserId, userPreferences);
      connection.peers[remoteUserId] = new PeerInitiator(localConfig);
    };
    this.createAnsweringPeer = function(remoteSdp, remoteUserId, userPreferences) {
      userPreferences = connection.setUserPreferences(userPreferences || {}, remoteUserId);
      var localConfig = this.getLocalConfig(remoteSdp, remoteUserId, userPreferences);
      connection.peers[remoteUserId] = new PeerInitiator(localConfig);
    };
    this.renegotiatePeer = function(remoteUserId, userPreferences, remoteSdp) {
      if (!connection.peers[remoteUserId]) {
        if (connection.enableLogs) {
          console.error("Peer (" + remoteUserId + ") does not exist. Renegotiation skipped.");
        }
        return;
      }
      if (!userPreferences) {
        userPreferences = {};
      }
      userPreferences.renegotiatingPeer = true;
      userPreferences.peerRef = connection.peers[remoteUserId].peer;
      userPreferences.channels = connection.peers[remoteUserId].channels;
      var localConfig = this.getLocalConfig(remoteSdp, remoteUserId, userPreferences);
      connection.peers[remoteUserId] = new PeerInitiator(localConfig);
    };
    this.replaceTrack = function(track, remoteUserId, isVideoTrack, oldTrack) {
      if (!connection.peers[remoteUserId]) {
        throw "This peer (" + remoteUserId + ") does not exist.";
      }
      var peer = connection.peers[remoteUserId].peer;
      if (!!peer.getSenders && typeof peer.getSenders === "function" && peer.getSenders().length) {
        let replaceIt = function(rtpSender) {
          var key = "lastAudioTrack";
          if (isVideoTrack && rtpSender.track.kind === "video") {
            key = "lastVideoTrack";
          }
          connection.peers[remoteUserId].peer[key] = rtpSender.track;
          rtpSender.replaceTrack(track);
        };
        var selectedSender = null;
        var pSenders = peer.getSenders().filter(function(rtpSender) {
          return rtpSender.track;
        });
        if (oldTrack) {
          selectedSender = pSenders.find(function(rtpSender) {
            return rtpSender.track.id === oldTrack.id;
          });
        }
        if (selectedSender) {
          replaceIt(selectedSender);
        } else {
          pSenders.forEach(replaceIt);
        }
        return;
      }
      console.warn("RTPSender.replaceTrack is NOT supported.");
      this.renegotiatePeer(remoteUserId);
    };
    this.onNegotiationNeeded = function(message, remoteUserId) {
    };
    this.addNegotiatedMessage = function(message, remoteUserId) {
      if (message.type && message.sdp) {
        if (message.type == "answer") {
          if (connection.peers[remoteUserId]) {
            connection.peers[remoteUserId].addRemoteSdp(message);
          }
        }
        if (message.type == "offer") {
          if (message.renegotiatingPeer) {
            this.renegotiatePeer(remoteUserId, null, message);
          } else {
            this.createAnsweringPeer(message, remoteUserId);
          }
        }
        if (connection.enableLogs) {
          console.log("Remote peer's sdp:", message.sdp);
        }
        return;
      }
      if (message.candidate) {
        if (connection.peers[remoteUserId]) {
          connection.peers[remoteUserId].addRemoteCandidate(message);
        }
        if (connection.enableLogs) {
          console.log("Remote peer's candidate pairs:", message.candidate);
        }
        return;
      }
      if (message.enableMedia) {
        connection.session = message.userPreferences.session || connection.session;
        if (connection.session.oneway && connection.attachStreams.length) {
          connection.attachStreams = [];
        }
        if (message.userPreferences.isDataOnly && connection.attachStreams.length) {
          connection.attachStreams.length = [];
        }
        var streamsToShare = {};
        connection.attachStreams.forEach(function(stream2) {
          streamsToShare[stream2.streamid] = {
            isAudio: !!stream2.isAudio,
            isVideo: !!stream2.isVideo,
            isScreen: !!stream2.isScreen
          };
        });
        message.userPreferences.streamsToShare = streamsToShare;
        self.onNegotiationNeeded({
          readyForOffer: true,
          userPreferences: message.userPreferences
        }, remoteUserId);
      }
      if (message.readyForOffer) {
        connection.onReadyForOffer(remoteUserId, message.userPreferences);
      }
    };
    this.onGettingRemoteMedia = function(stream2, remoteUserId) {
    };
    this.onRemovingRemoteMedia = function(stream2, remoteUserId) {
    };
    this.onGettingLocalMedia = function(localStream) {
    };
    this.onLocalMediaError = function(error2, constraints) {
      connection.onMediaError(error2, constraints);
    };
    function initFileBufferReader() {
      connection.fbr = new FileBufferReader();
      connection.fbr.onProgress = function(chunk) {
        connection.onFileProgress(chunk);
      };
      connection.fbr.onBegin = function(file) {
        connection.onFileStart(file);
      };
      connection.fbr.onEnd = function(file) {
        connection.onFileEnd(file);
      };
    }
    this.shareFile = function(file, remoteUserId) {
      initFileBufferReader();
      connection.fbr.readAsArrayBuffer(file, function(uuid) {
        var arrayOfUsers = connection.getAllParticipants();
        if (remoteUserId) {
          arrayOfUsers = [remoteUserId];
        }
        arrayOfUsers.forEach(function(participant) {
          connection.fbr.getNextChunk(uuid, function(nextChunk) {
            connection.peers[participant].channels.forEach(function(channel) {
              channel.send(nextChunk);
            });
          }, participant);
        });
      }, {
        userid: connection.userid,
        chunkSize: DetectRTC.browser.name === "Firefox" ? 15 * 1e3 : connection.chunkSize || 0
      });
    };
    {
      var textReceiver = new TextReceiver(connection);
    }
    this.onDataChannelMessage = function(message, remoteUserId) {
      textReceiver.receive(JSON.parse(message), remoteUserId, connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {});
    };
    this.onDataChannelClosed = function(event2, remoteUserId) {
      event2.userid = remoteUserId;
      event2.extra = connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {};
      connection.onclose(event2);
    };
    this.onDataChannelError = function(error2, remoteUserId) {
      error2.userid = remoteUserId;
      event.extra = connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {};
      connection.onerror(error2);
    };
    this.onDataChannelOpened = function(channel, remoteUserId) {
      if (connection.peers[remoteUserId].channels.length) {
        connection.peers[remoteUserId].channels = [channel];
        return;
      }
      connection.peers[remoteUserId].channels.push(channel);
      connection.onopen({
        userid: remoteUserId,
        extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {},
        channel
      });
    };
    this.onPeerStateChanged = function(state) {
      connection.onPeerStateChanged(state);
    };
    this.onNegotiationStarted = function(remoteUserId, states) {
    };
    this.onNegotiationCompleted = function(remoteUserId, states) {
    };
    this.getRemoteStreams = function(remoteUserId) {
      remoteUserId = remoteUserId || connection.peers.getAllParticipants()[0];
      return connection.peers[remoteUserId] ? connection.peers[remoteUserId].streams : [];
    };
  }
  (function() {
    var browserFakeUserAgent2 = "Fake/5.0 (FakeOS) AppleWebKit/123 (KHTML, like Gecko) Fake/12.3.4567.89 Fake/123.45";
    var isNodejs = typeof process === "object" && typeof process.versions === "object" && process.versions.node && !process.browser;
    if (isNodejs) {
      var version = process.versions.node.toString().replace("v", "");
      browserFakeUserAgent2 = "Nodejs/" + version + " (NodeOS) AppleWebKit/" + version + " (KHTML, like Gecko) Nodejs/" + version + " Nodejs/" + version;
    }
    (function(that) {
      if (typeof window !== "undefined") {
        return;
      }
      if (typeof window === "undefined" && typeof global !== "undefined") {
        global.navigator = {
          userAgent: browserFakeUserAgent2,
          getUserMedia: function() {
          }
        };
        that.window = global;
      }
      if (typeof location === "undefined") {
        that.location = {
          protocol: "file:",
          href: "",
          hash: ""
        };
      }
      if (typeof screen === "undefined") {
        that.screen = {
          width: 0,
          height: 0
        };
      }
    })(typeof global !== "undefined" ? global : window);
    var navigator2 = window.navigator;
    if (typeof navigator2 !== "undefined") {
      if (typeof navigator2.webkitGetUserMedia !== "undefined") {
        navigator2.getUserMedia = navigator2.webkitGetUserMedia;
      }
      if (typeof navigator2.mozGetUserMedia !== "undefined") {
        navigator2.getUserMedia = navigator2.mozGetUserMedia;
      }
    } else {
      navigator2 = {
        getUserMedia: function() {
        },
        userAgent: browserFakeUserAgent2
      };
    }
    var isMobileDevice = !!/Android|webOS|iPhone|iPad|iPod|BB10|BlackBerry|IEMobile|Opera Mini|Mobile|mobile/i.test(navigator2.userAgent || "");
    var isEdge = navigator2.userAgent.indexOf("Edge") !== -1 && (!!navigator2.msSaveOrOpenBlob || !!navigator2.msSaveBlob);
    var isOpera = !!window.opera || navigator2.userAgent.indexOf(" OPR/") >= 0;
    var isFirefox2 = typeof window.InstallTrigger !== "undefined";
    var isSafari = /^((?!chrome|android).)*safari/i.test(navigator2.userAgent);
    var isChrome = !!window.chrome && !isOpera;
    var isIE = typeof document !== "undefined" && !!document.documentMode && !isEdge;
    function getBrowserInfo() {
      navigator2.appVersion;
      var nAgt = navigator2.userAgent;
      var browserName = navigator2.appName;
      var fullVersion = "" + parseFloat(navigator2.appVersion);
      var majorVersion = parseInt(navigator2.appVersion, 10);
      var nameOffset, verOffset, ix;
      if (isSafari && !isChrome && nAgt.indexOf("CriOS") !== -1) {
        isSafari = false;
        isChrome = true;
      }
      if (isOpera) {
        browserName = "Opera";
        try {
          fullVersion = navigator2.userAgent.split("OPR/")[1].split(" ")[0];
          majorVersion = fullVersion.split(".")[0];
        } catch (e) {
          fullVersion = "0.0.0.0";
          majorVersion = 0;
        }
      } else if (isIE) {
        verOffset = nAgt.indexOf("rv:");
        if (verOffset > 0) {
          fullVersion = nAgt.substring(verOffset + 3);
        } else {
          verOffset = nAgt.indexOf("MSIE");
          fullVersion = nAgt.substring(verOffset + 5);
        }
        browserName = "IE";
      } else if (isChrome) {
        verOffset = nAgt.indexOf("Chrome");
        browserName = "Chrome";
        fullVersion = nAgt.substring(verOffset + 7);
      } else if (isSafari) {
        verOffset = nAgt.indexOf("Safari");
        browserName = "Safari";
        fullVersion = nAgt.substring(verOffset + 7);
        if ((verOffset = nAgt.indexOf("Version")) !== -1) {
          fullVersion = nAgt.substring(verOffset + 8);
        }
        if (navigator2.userAgent.indexOf("Version/") !== -1) {
          fullVersion = navigator2.userAgent.split("Version/")[1].split(" ")[0];
        }
      } else if (isFirefox2) {
        verOffset = nAgt.indexOf("Firefox");
        browserName = "Firefox";
        fullVersion = nAgt.substring(verOffset + 8);
      } else if ((nameOffset = nAgt.lastIndexOf(" ") + 1) < (verOffset = nAgt.lastIndexOf("/"))) {
        browserName = nAgt.substring(nameOffset, verOffset);
        fullVersion = nAgt.substring(verOffset + 1);
        if (browserName.toLowerCase() === browserName.toUpperCase()) {
          browserName = navigator2.appName;
        }
      }
      if (isEdge) {
        browserName = "Edge";
        fullVersion = navigator2.userAgent.split("Edge/")[1];
      }
      if ((ix = fullVersion.search(/[; \)]/)) !== -1) {
        fullVersion = fullVersion.substring(0, ix);
      }
      majorVersion = parseInt("" + fullVersion, 10);
      if (isNaN(majorVersion)) {
        fullVersion = "" + parseFloat(navigator2.appVersion);
        majorVersion = parseInt(navigator2.appVersion, 10);
      }
      return {
        fullVersion,
        version: majorVersion,
        name: browserName,
        isPrivateBrowsing: false
      };
    }
    function retry(isDone, next) {
      var currentTrial = 0, maxRetry = 50, isTimeout = false;
      var id = window.setInterval(
        function() {
          if (isDone()) {
            window.clearInterval(id);
            next(isTimeout);
          }
          if (currentTrial++ > maxRetry) {
            window.clearInterval(id);
            isTimeout = true;
            next(isTimeout);
          }
        },
        10
      );
    }
    function isIE10OrLater(userAgent) {
      var ua = userAgent.toLowerCase();
      if (ua.indexOf("msie") === 0 && ua.indexOf("trident") === 0) {
        return false;
      }
      var match = /(?:msie|rv:)\s?([\d\.]+)/.exec(ua);
      if (match && parseInt(match[1], 10) >= 10) {
        return true;
      }
      return false;
    }
    function detectPrivateMode(callback) {
      var isPrivate;
      try {
        if (window.webkitRequestFileSystem) {
          window.webkitRequestFileSystem(
            window.TEMPORARY,
            1,
            function() {
              isPrivate = false;
            },
            function(e) {
              isPrivate = true;
            }
          );
        } else if (window.indexedDB && /Firefox/.test(window.navigator.userAgent)) {
          var db;
          try {
            db = window.indexedDB.open("test");
            db.onerror = function() {
              return true;
            };
          } catch (e) {
            isPrivate = true;
          }
          if (typeof isPrivate === "undefined") {
            retry(
              function isDone() {
                return db.readyState === "done" ? true : false;
              },
              function next(isTimeout) {
                if (!isTimeout) {
                  isPrivate = db.result ? false : true;
                }
              }
            );
          }
        } else if (isIE10OrLater(window.navigator.userAgent)) {
          isPrivate = false;
          try {
            if (!window.indexedDB) {
              isPrivate = true;
            }
          } catch (e) {
            isPrivate = true;
          }
        } else if (window.localStorage && /Safari/.test(window.navigator.userAgent)) {
          try {
            window.localStorage.setItem("test", 1);
          } catch (e) {
            isPrivate = true;
          }
          if (typeof isPrivate === "undefined") {
            isPrivate = false;
            window.localStorage.removeItem("test");
          }
        }
      } catch (e) {
        isPrivate = false;
      }
      retry(
        function isDone() {
          return typeof isPrivate !== "undefined" ? true : false;
        },
        function next(isTimeout) {
          callback(isPrivate);
        }
      );
    }
    var isMobile = {
      Android: function() {
        return navigator2.userAgent.match(/Android/i);
      },
      BlackBerry: function() {
        return navigator2.userAgent.match(/BlackBerry|BB10/i);
      },
      iOS: function() {
        return navigator2.userAgent.match(/iPhone|iPad|iPod/i);
      },
      Opera: function() {
        return navigator2.userAgent.match(/Opera Mini/i);
      },
      Windows: function() {
        return navigator2.userAgent.match(/IEMobile/i);
      },
      any: function() {
        return isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows();
      },
      getOsName: function() {
        var osName2 = "Unknown OS";
        if (isMobile.Android()) {
          osName2 = "Android";
        }
        if (isMobile.BlackBerry()) {
          osName2 = "BlackBerry";
        }
        if (isMobile.iOS()) {
          osName2 = "iOS";
        }
        if (isMobile.Opera()) {
          osName2 = "Opera Mini";
        }
        if (isMobile.Windows()) {
          osName2 = "Windows";
        }
        return osName2;
      }
    };
    function detectDesktopOS() {
      var unknown = "-";
      var nVer = navigator2.appVersion;
      var nAgt = navigator2.userAgent;
      var os = unknown;
      var clientStrings = [{
        s: "Windows 10",
        r: /(Windows 10.0|Windows NT 10.0)/
      }, {
        s: "Windows 8.1",
        r: /(Windows 8.1|Windows NT 6.3)/
      }, {
        s: "Windows 8",
        r: /(Windows 8|Windows NT 6.2)/
      }, {
        s: "Windows 7",
        r: /(Windows 7|Windows NT 6.1)/
      }, {
        s: "Windows Vista",
        r: /Windows NT 6.0/
      }, {
        s: "Windows Server 2003",
        r: /Windows NT 5.2/
      }, {
        s: "Windows XP",
        r: /(Windows NT 5.1|Windows XP)/
      }, {
        s: "Windows 2000",
        r: /(Windows NT 5.0|Windows 2000)/
      }, {
        s: "Windows ME",
        r: /(Win 9x 4.90|Windows ME)/
      }, {
        s: "Windows 98",
        r: /(Windows 98|Win98)/
      }, {
        s: "Windows 95",
        r: /(Windows 95|Win95|Windows_95)/
      }, {
        s: "Windows NT 4.0",
        r: /(Windows NT 4.0|WinNT4.0|WinNT|Windows NT)/
      }, {
        s: "Windows CE",
        r: /Windows CE/
      }, {
        s: "Windows 3.11",
        r: /Win16/
      }, {
        s: "Android",
        r: /Android/
      }, {
        s: "Open BSD",
        r: /OpenBSD/
      }, {
        s: "Sun OS",
        r: /SunOS/
      }, {
        s: "Linux",
        r: /(Linux|X11)/
      }, {
        s: "iOS",
        r: /(iPhone|iPad|iPod)/
      }, {
        s: "Mac OS X",
        r: /Mac OS X/
      }, {
        s: "Mac OS",
        r: /(MacPPC|MacIntel|Mac_PowerPC|Macintosh)/
      }, {
        s: "QNX",
        r: /QNX/
      }, {
        s: "UNIX",
        r: /UNIX/
      }, {
        s: "BeOS",
        r: /BeOS/
      }, {
        s: "OS/2",
        r: /OS\/2/
      }, {
        s: "Search Bot",
        r: /(nuhk|Googlebot|Yammybot|Openbot|Slurp|MSNBot|Ask Jeeves\/Teoma|ia_archiver)/
      }];
      for (var i = 0, cs; cs = clientStrings[i]; i++) {
        if (cs.r.test(nAgt)) {
          os = cs.s;
          break;
        }
      }
      var osVersion2 = unknown;
      if (/Windows/.test(os)) {
        if (/Windows (.*)/.test(os)) {
          osVersion2 = /Windows (.*)/.exec(os)[1];
        }
        os = "Windows";
      }
      switch (os) {
        case "Mac OS X":
          if (/Mac OS X (10[\.\_\d]+)/.test(nAgt)) {
            osVersion2 = /Mac OS X (10[\.\_\d]+)/.exec(nAgt)[1];
          }
          break;
        case "Android":
          if (/Android ([\.\_\d]+)/.test(nAgt)) {
            osVersion2 = /Android ([\.\_\d]+)/.exec(nAgt)[1];
          }
          break;
        case "iOS":
          if (/OS (\d+)_(\d+)_?(\d+)?/.test(nAgt)) {
            osVersion2 = /OS (\d+)_(\d+)_?(\d+)?/.exec(nVer);
            osVersion2 = osVersion2[1] + "." + osVersion2[2] + "." + (osVersion2[3] | 0);
          }
          break;
      }
      return {
        osName: os,
        osVersion: osVersion2
      };
    }
    var osName = "Unknown OS";
    var osVersion = "Unknown OS Version";
    function getAndroidVersion(ua) {
      ua = (ua || navigator2.userAgent).toLowerCase();
      var match = ua.match(/android\s([0-9\.]*)/);
      return match ? match[1] : false;
    }
    var osInfo = detectDesktopOS();
    if (osInfo && osInfo.osName && osInfo.osName != "-") {
      osName = osInfo.osName;
      osVersion = osInfo.osVersion;
    } else if (isMobile.any()) {
      osName = isMobile.getOsName();
      if (osName == "Android") {
        osVersion = getAndroidVersion();
      }
    }
    var isNodejs = typeof process === "object" && typeof process.versions === "object" && process.versions.node;
    if (osName === "Unknown OS" && isNodejs) {
      osName = "Nodejs";
      osVersion = process.versions.node.toString().replace("v", "");
    }
    var isCanvasSupportsStreamCapturing = false;
    var isVideoSupportsStreamCapturing = false;
    ["captureStream", "mozCaptureStream", "webkitCaptureStream"].forEach(function(item) {
      if (typeof document === "undefined" || typeof document.createElement !== "function") {
        return;
      }
      if (!isCanvasSupportsStreamCapturing && item in document.createElement("canvas")) {
        isCanvasSupportsStreamCapturing = true;
      }
      if (!isVideoSupportsStreamCapturing && item in document.createElement("video")) {
        isVideoSupportsStreamCapturing = true;
      }
    });
    var regexIpv4Local = /^(192\.168\.|169\.254\.|10\.|172\.(1[6-9]|2\d|3[01]))/, regexIpv4 = /([0-9]{1,3}(\.[0-9]{1,3}){3})/, regexIpv6 = /[a-f0-9]{1,4}(:[a-f0-9]{1,4}){7}/;
    function DetectLocalIPAddress(callback, stream2) {
      if (!DetectRTC2.isWebRTCSupported) {
        return;
      }
      var isPublic = true, isIpv4 = true;
      getIPs(function(ip) {
        if (!ip) {
          callback();
        } else if (ip.match(regexIpv4Local)) {
          isPublic = false;
          callback("Local: " + ip, isPublic, isIpv4);
        } else if (ip.match(regexIpv6)) {
          isIpv4 = false;
          callback("Public: " + ip, isPublic, isIpv4);
        } else {
          callback("Public: " + ip, isPublic, isIpv4);
        }
      }, stream2);
    }
    function getIPs(callback, stream2) {
      if (typeof document === "undefined" || typeof document.getElementById !== "function") {
        return;
      }
      var ipDuplicates = {};
      var RTCPeerConnection3 = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
      if (!RTCPeerConnection3) {
        var iframe = document.getElementById("iframe");
        if (!iframe) {
          return;
        }
        var win = iframe.contentWindow;
        RTCPeerConnection3 = win.RTCPeerConnection || win.mozRTCPeerConnection || win.webkitRTCPeerConnection;
      }
      if (!RTCPeerConnection3) {
        return;
      }
      var peerConfig = null;
      if (DetectRTC2.browser === "Chrome" && DetectRTC2.browser.version < 58) {
        peerConfig = {
          optional: [{
            RtpDataChannels: true
          }]
        };
      }
      var servers = {
        iceServers: [{
          urls: "stun:stun.l.google.com:19302"
        }]
      };
      var pc = new RTCPeerConnection3(servers, peerConfig);
      if (stream2) {
        if (pc.addStream) {
          pc.addStream(stream2);
        } else if (pc.addTrack && stream2.getTracks()[0]) {
          pc.addTrack(stream2.getTracks()[0], stream2);
        }
      }
      function handleCandidate(candidate) {
        if (!candidate) {
          callback();
          return;
        }
        var match = regexIpv4.exec(candidate);
        if (!match) {
          return;
        }
        var ipAddress = match[1];
        var isPublic = candidate.match(regexIpv4Local), isIpv4 = true;
        if (ipDuplicates[ipAddress] === void 0) {
          callback(ipAddress, isPublic, isIpv4);
        }
        ipDuplicates[ipAddress] = true;
      }
      pc.onicecandidate = function(event2) {
        if (event2.candidate && event2.candidate.candidate) {
          handleCandidate(event2.candidate.candidate);
        } else {
          handleCandidate();
        }
      };
      if (!stream2) {
        try {
          pc.createDataChannel("sctp", {});
        } catch (e) {
        }
      }
      if (DetectRTC2.isPromisesSupported) {
        pc.createOffer().then(function(result) {
          pc.setLocalDescription(result).then(afterCreateOffer);
        });
      } else {
        pc.createOffer(function(result) {
          pc.setLocalDescription(result, afterCreateOffer, function() {
          });
        }, function() {
        });
      }
      function afterCreateOffer() {
        var lines = pc.localDescription.sdp.split("\n");
        lines.forEach(function(line) {
          if (line && line.indexOf("a=candidate:") === 0) {
            handleCandidate(line);
          }
        });
      }
    }
    var MediaDevices = [];
    var audioInputDevices = [];
    var audioOutputDevices = [];
    var videoInputDevices = [];
    if (navigator2.mediaDevices && navigator2.mediaDevices.enumerateDevices) {
      navigator2.enumerateDevices = function(callback) {
        var enumerateDevices = navigator2.mediaDevices.enumerateDevices();
        if (enumerateDevices && enumerateDevices.then) {
          navigator2.mediaDevices.enumerateDevices().then(callback).catch(function() {
            callback([]);
          });
        } else {
          callback([]);
        }
      };
    }
    var canEnumerate = false;
    if (typeof MediaStreamTrack !== "undefined" && "getSources" in MediaStreamTrack) {
      canEnumerate = true;
    } else if (navigator2.mediaDevices && !!navigator2.mediaDevices.enumerateDevices) {
      canEnumerate = true;
    }
    var hasMicrophone = false;
    var hasSpeakers = false;
    var hasWebcam = false;
    var isWebsiteHasMicrophonePermissions = false;
    var isWebsiteHasWebcamPermissions = false;
    function checkDeviceSupport(callback) {
      if (!canEnumerate) {
        if (callback) {
          callback();
        }
        return;
      }
      if (!navigator2.enumerateDevices && window.MediaStreamTrack && window.MediaStreamTrack.getSources) {
        navigator2.enumerateDevices = window.MediaStreamTrack.getSources.bind(window.MediaStreamTrack);
      }
      if (!navigator2.enumerateDevices && navigator2.enumerateDevices) {
        navigator2.enumerateDevices = navigator2.enumerateDevices.bind(navigator2);
      }
      if (!navigator2.enumerateDevices) {
        if (callback) {
          callback();
        }
        return;
      }
      MediaDevices = [];
      audioInputDevices = [];
      audioOutputDevices = [];
      videoInputDevices = [];
      hasMicrophone = false;
      hasSpeakers = false;
      hasWebcam = false;
      isWebsiteHasMicrophonePermissions = false;
      isWebsiteHasWebcamPermissions = false;
      var alreadyUsedDevices = {};
      navigator2.enumerateDevices(function(devices) {
        devices.forEach(function(_device) {
          var device = {};
          for (var d in _device) {
            try {
              if (typeof _device[d] !== "function") {
                device[d] = _device[d];
              }
            } catch (e) {
            }
          }
          if (alreadyUsedDevices[device.deviceId + device.label + device.kind]) {
            return;
          }
          if (device.kind === "audio") {
            device.kind = "audioinput";
          }
          if (device.kind === "video") {
            device.kind = "videoinput";
          }
          if (!device.deviceId) {
            device.deviceId = device.id;
          }
          if (!device.id) {
            device.id = device.deviceId;
          }
          if (!device.label) {
            device.isCustomLabel = true;
            if (device.kind === "videoinput") {
              device.label = "Camera " + (videoInputDevices.length + 1);
            } else if (device.kind === "audioinput") {
              device.label = "Microphone " + (audioInputDevices.length + 1);
            } else if (device.kind === "audiooutput") {
              device.label = "Speaker " + (audioOutputDevices.length + 1);
            } else {
              device.label = "Please invoke getUserMedia once.";
            }
            if (typeof DetectRTC2 !== "undefined" && DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 46 && !/^(https:|chrome-extension:)$/g.test(location.protocol || "")) {
              if (typeof document !== "undefined" && typeof document.domain === "string" && document.domain.search && document.domain.search(/localhost|127.0./g) === -1) {
                device.label = "HTTPs is required to get label of this " + device.kind + " device.";
              }
            }
          } else {
            if (device.kind === "videoinput" && !isWebsiteHasWebcamPermissions) {
              isWebsiteHasWebcamPermissions = true;
            }
            if (device.kind === "audioinput" && !isWebsiteHasMicrophonePermissions) {
              isWebsiteHasMicrophonePermissions = true;
            }
          }
          if (device.kind === "audioinput") {
            hasMicrophone = true;
            if (audioInputDevices.indexOf(device) === -1) {
              audioInputDevices.push(device);
            }
          }
          if (device.kind === "audiooutput") {
            hasSpeakers = true;
            if (audioOutputDevices.indexOf(device) === -1) {
              audioOutputDevices.push(device);
            }
          }
          if (device.kind === "videoinput") {
            hasWebcam = true;
            if (videoInputDevices.indexOf(device) === -1) {
              videoInputDevices.push(device);
            }
          }
          MediaDevices.push(device);
          alreadyUsedDevices[device.deviceId + device.label + device.kind] = device;
        });
        if (typeof DetectRTC2 !== "undefined") {
          DetectRTC2.MediaDevices = MediaDevices;
          DetectRTC2.hasMicrophone = hasMicrophone;
          DetectRTC2.hasSpeakers = hasSpeakers;
          DetectRTC2.hasWebcam = hasWebcam;
          DetectRTC2.isWebsiteHasWebcamPermissions = isWebsiteHasWebcamPermissions;
          DetectRTC2.isWebsiteHasMicrophonePermissions = isWebsiteHasMicrophonePermissions;
          DetectRTC2.audioInputDevices = audioInputDevices;
          DetectRTC2.audioOutputDevices = audioOutputDevices;
          DetectRTC2.videoInputDevices = videoInputDevices;
        }
        if (callback) {
          callback();
        }
      });
    }
    var DetectRTC2 = window.DetectRTC || {};
    DetectRTC2.browser = getBrowserInfo();
    detectPrivateMode(function(isPrivateBrowsing) {
      DetectRTC2.browser.isPrivateBrowsing = !!isPrivateBrowsing;
    });
    DetectRTC2.browser["is" + DetectRTC2.browser.name] = true;
    DetectRTC2.osName = osName;
    DetectRTC2.osVersion = osVersion;
    typeof process === "object" && typeof process.versions === "object" && process.versions["node-webkit"];
    var isWebRTCSupported = false;
    ["RTCPeerConnection", "webkitRTCPeerConnection", "mozRTCPeerConnection", "RTCIceGatherer"].forEach(function(item) {
      if (isWebRTCSupported) {
        return;
      }
      if (item in window) {
        isWebRTCSupported = true;
      }
    });
    DetectRTC2.isWebRTCSupported = isWebRTCSupported;
    DetectRTC2.isORTCSupported = typeof RTCIceGatherer !== "undefined";
    var isScreenCapturingSupported = false;
    if (DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 35) {
      isScreenCapturingSupported = true;
    } else if (DetectRTC2.browser.isFirefox && DetectRTC2.browser.version >= 34) {
      isScreenCapturingSupported = true;
    } else if (DetectRTC2.browser.isEdge && DetectRTC2.browser.version >= 17) {
      isScreenCapturingSupported = true;
    } else if (DetectRTC2.osName === "Android" && DetectRTC2.browser.isChrome) {
      isScreenCapturingSupported = true;
    }
    if (!/^(https:|chrome-extension:)$/g.test(location.protocol || "")) {
      var isNonLocalHost = typeof document !== "undefined" && typeof document.domain === "string" && document.domain.search && document.domain.search(/localhost|127.0./g) === -1;
      if (isNonLocalHost && (DetectRTC2.browser.isChrome || DetectRTC2.browser.isEdge || DetectRTC2.browser.isOpera)) {
        isScreenCapturingSupported = false;
      } else if (DetectRTC2.browser.isFirefox) {
        isScreenCapturingSupported = false;
      }
    }
    DetectRTC2.isScreenCapturingSupported = isScreenCapturingSupported;
    var webAudio = {
      isSupported: false,
      isCreateMediaStreamSourceSupported: false
    };
    ["AudioContext", "webkitAudioContext", "mozAudioContext", "msAudioContext"].forEach(function(item) {
      if (webAudio.isSupported) {
        return;
      }
      if (item in window) {
        webAudio.isSupported = true;
        if (window[item] && "createMediaStreamSource" in window[item].prototype) {
          webAudio.isCreateMediaStreamSourceSupported = true;
        }
      }
    });
    DetectRTC2.isAudioContextSupported = webAudio.isSupported;
    DetectRTC2.isCreateMediaStreamSourceSupported = webAudio.isCreateMediaStreamSourceSupported;
    var isRtpDataChannelsSupported = false;
    if (DetectRTC2.browser.isChrome && DetectRTC2.browser.version > 31) {
      isRtpDataChannelsSupported = true;
    }
    DetectRTC2.isRtpDataChannelsSupported = isRtpDataChannelsSupported;
    var isSCTPSupportd = false;
    if (DetectRTC2.browser.isFirefox && DetectRTC2.browser.version > 28) {
      isSCTPSupportd = true;
    } else if (DetectRTC2.browser.isChrome && DetectRTC2.browser.version > 25) {
      isSCTPSupportd = true;
    } else if (DetectRTC2.browser.isOpera && DetectRTC2.browser.version >= 11) {
      isSCTPSupportd = true;
    }
    DetectRTC2.isSctpDataChannelsSupported = isSCTPSupportd;
    DetectRTC2.isMobileDevice = isMobileDevice;
    var isGetUserMediaSupported = false;
    if (navigator2.getUserMedia) {
      isGetUserMediaSupported = true;
    } else if (navigator2.mediaDevices && navigator2.mediaDevices.getUserMedia) {
      isGetUserMediaSupported = true;
    }
    if (DetectRTC2.browser.isChrome && DetectRTC2.browser.version >= 46 && !/^(https:|chrome-extension:)$/g.test(location.protocol || "")) {
      if (typeof document !== "undefined" && typeof document.domain === "string" && document.domain.search && document.domain.search(/localhost|127.0./g) === -1) {
        isGetUserMediaSupported = "Requires HTTPs";
      }
    }
    if (DetectRTC2.osName === "Nodejs") {
      isGetUserMediaSupported = false;
    }
    DetectRTC2.isGetUserMediaSupported = isGetUserMediaSupported;
    var displayResolution = "";
    if (screen.width) {
      var width = screen.width ? screen.width : "";
      var height = screen.height ? screen.height : "";
      displayResolution += "" + width + " x " + height;
    }
    DetectRTC2.displayResolution = displayResolution;
    function getAspectRatio(w, h) {
      function gcd(a, b) {
        return b == 0 ? a : gcd(b, a % b);
      }
      var r = gcd(w, h);
      return w / r / (h / r);
    }
    DetectRTC2.displayAspectRatio = getAspectRatio(screen.width, screen.height).toFixed(2);
    DetectRTC2.isCanvasSupportsStreamCapturing = isCanvasSupportsStreamCapturing;
    DetectRTC2.isVideoSupportsStreamCapturing = isVideoSupportsStreamCapturing;
    if (DetectRTC2.browser.name == "Chrome" && DetectRTC2.browser.version >= 53) {
      if (!DetectRTC2.isCanvasSupportsStreamCapturing) {
        DetectRTC2.isCanvasSupportsStreamCapturing = "Requires chrome flag: enable-experimental-web-platform-features";
      }
      if (!DetectRTC2.isVideoSupportsStreamCapturing) {
        DetectRTC2.isVideoSupportsStreamCapturing = "Requires chrome flag: enable-experimental-web-platform-features";
      }
    }
    DetectRTC2.DetectLocalIPAddress = DetectLocalIPAddress;
    DetectRTC2.isWebSocketsSupported = "WebSocket" in window && 2 === window.WebSocket.CLOSING;
    DetectRTC2.isWebSocketsBlocked = !DetectRTC2.isWebSocketsSupported;
    if (DetectRTC2.osName === "Nodejs") {
      DetectRTC2.isWebSocketsSupported = true;
      DetectRTC2.isWebSocketsBlocked = false;
    }
    DetectRTC2.checkWebSocketsSupport = function(callback) {
      callback = callback || function() {
      };
      try {
        var starttime;
        var websocket = new WebSocket("wss://echo.websocket.org:443/");
        websocket.onopen = function() {
          DetectRTC2.isWebSocketsBlocked = false;
          starttime = new Date().getTime();
          websocket.send("ping");
        };
        websocket.onmessage = function() {
          DetectRTC2.WebsocketLatency = new Date().getTime() - starttime + "ms";
          callback();
          websocket.close();
          websocket = null;
        };
        websocket.onerror = function() {
          DetectRTC2.isWebSocketsBlocked = true;
          callback();
        };
      } catch (e) {
        DetectRTC2.isWebSocketsBlocked = true;
        callback();
      }
    };
    DetectRTC2.load = function(callback) {
      callback = callback || function() {
      };
      checkDeviceSupport(callback);
    };
    if (typeof MediaDevices !== "undefined") {
      DetectRTC2.MediaDevices = MediaDevices;
    } else {
      DetectRTC2.MediaDevices = [];
    }
    DetectRTC2.hasMicrophone = hasMicrophone;
    DetectRTC2.hasSpeakers = hasSpeakers;
    DetectRTC2.hasWebcam = hasWebcam;
    DetectRTC2.isWebsiteHasWebcamPermissions = isWebsiteHasWebcamPermissions;
    DetectRTC2.isWebsiteHasMicrophonePermissions = isWebsiteHasMicrophonePermissions;
    DetectRTC2.audioInputDevices = audioInputDevices;
    DetectRTC2.audioOutputDevices = audioOutputDevices;
    DetectRTC2.videoInputDevices = videoInputDevices;
    var isSetSinkIdSupported = false;
    if (typeof document !== "undefined" && typeof document.createElement === "function" && "setSinkId" in document.createElement("video")) {
      isSetSinkIdSupported = true;
    }
    DetectRTC2.isSetSinkIdSupported = isSetSinkIdSupported;
    var isRTPSenderReplaceTracksSupported = false;
    if (DetectRTC2.browser.isFirefox && typeof mozRTCPeerConnection !== "undefined") {
      if ("getSenders" in mozRTCPeerConnection.prototype) {
        isRTPSenderReplaceTracksSupported = true;
      }
    } else if (DetectRTC2.browser.isChrome && typeof webkitRTCPeerConnection !== "undefined") {
      if ("getSenders" in webkitRTCPeerConnection.prototype) {
        isRTPSenderReplaceTracksSupported = true;
      }
    }
    DetectRTC2.isRTPSenderReplaceTracksSupported = isRTPSenderReplaceTracksSupported;
    var isRemoteStreamProcessingSupported = false;
    if (DetectRTC2.browser.isFirefox && DetectRTC2.browser.version > 38) {
      isRemoteStreamProcessingSupported = true;
    }
    DetectRTC2.isRemoteStreamProcessingSupported = isRemoteStreamProcessingSupported;
    var isApplyConstraintsSupported = false;
    if (typeof MediaStreamTrack !== "undefined" && "applyConstraints" in MediaStreamTrack.prototype) {
      isApplyConstraintsSupported = true;
    }
    DetectRTC2.isApplyConstraintsSupported = isApplyConstraintsSupported;
    var isMultiMonitorScreenCapturingSupported = false;
    if (DetectRTC2.browser.isFirefox && DetectRTC2.browser.version >= 43) {
      isMultiMonitorScreenCapturingSupported = true;
    }
    DetectRTC2.isMultiMonitorScreenCapturingSupported = isMultiMonitorScreenCapturingSupported;
    DetectRTC2.isPromisesSupported = !!("Promise" in window);
    DetectRTC2.version = "1.3.9";
    if (typeof DetectRTC2 === "undefined") {
      window.DetectRTC = {};
    }
    var MediaStream2 = window.MediaStream;
    if (typeof MediaStream2 === "undefined" && typeof webkitMediaStream !== "undefined") {
      MediaStream2 = webkitMediaStream;
    }
    if (typeof MediaStream2 !== "undefined" && typeof MediaStream2 === "function") {
      DetectRTC2.MediaStream = Object.keys(MediaStream2.prototype);
    } else
      DetectRTC2.MediaStream = false;
    if (typeof MediaStreamTrack !== "undefined") {
      DetectRTC2.MediaStreamTrack = Object.keys(MediaStreamTrack.prototype);
    } else
      DetectRTC2.MediaStreamTrack = false;
    var RTCPeerConnection2 = window.RTCPeerConnection || window.mozRTCPeerConnection || window.webkitRTCPeerConnection;
    if (typeof RTCPeerConnection2 !== "undefined") {
      DetectRTC2.RTCPeerConnection = Object.keys(RTCPeerConnection2.prototype);
    } else
      DetectRTC2.RTCPeerConnection = false;
    window.DetectRTC = DetectRTC2;
    if (typeof module !== "undefined") {
      module.exports = DetectRTC2;
    }
    if (typeof define === "function" && define.amd) {
      define("DetectRTC", [], function() {
        return DetectRTC2;
      });
    }
  })();
  if (typeof cordova !== "undefined") {
    DetectRTC.isMobileDevice = true;
    DetectRTC.browser.name = "Chrome";
  }
  if (navigator && navigator.userAgent && navigator.userAgent.indexOf("Crosswalk") !== -1) {
    DetectRTC.isMobileDevice = true;
    DetectRTC.browser.name = "Chrome";
  }
  function fireEvent(obj, eventName, args) {
    if (typeof CustomEvent === "undefined") {
      return;
    }
    var eventDetail = {
      arguments: args,
      __exposedProps__: args
    };
    var event2 = new CustomEvent(eventName, eventDetail);
    obj.dispatchEvent(event2);
  }
  function setHarkEvents(connection, streamEvent) {
    if (!streamEvent.stream || !getTracks(streamEvent.stream, "audio").length)
      return;
    if (!connection || !streamEvent) {
      throw "Both arguments are required.";
    }
    if (!connection.onspeaking || !connection.onsilence) {
      return;
    }
    if (typeof hark === "undefined") {
      throw "hark.js not found.";
    }
    hark(streamEvent.stream, {
      onspeaking: function() {
        connection.onspeaking(streamEvent);
      },
      onsilence: function() {
        connection.onsilence(streamEvent);
      },
      onvolumechange: function(volume, threshold) {
        if (!connection.onvolumechange) {
          return;
        }
        connection.onvolumechange(merge({
          volume,
          threshold
        }, streamEvent));
      }
    });
  }
  function setMuteHandlers(connection, streamEvent) {
    if (!streamEvent.stream || !streamEvent.stream || !streamEvent.stream.addEventListener)
      return;
    streamEvent.stream.addEventListener("mute", function(event2) {
      event2 = connection.streamEvents[streamEvent.streamid];
      event2.session = {
        audio: event2.muteType === "audio",
        video: event2.muteType === "video"
      };
      connection.onmute(event2);
    }, false);
    streamEvent.stream.addEventListener("unmute", function(event2) {
      event2 = connection.streamEvents[streamEvent.streamid];
      event2.session = {
        audio: event2.unmuteType === "audio",
        video: event2.unmuteType === "video"
      };
      connection.onunmute(event2);
    }, false);
  }
  function getRandomString() {
    if (window.crypto && window.crypto.getRandomValues && navigator.userAgent.indexOf("Safari") === -1) {
      var a = window.crypto.getRandomValues(new Uint32Array(3)), token = "";
      for (var i = 0, l = a.length; i < l; i++) {
        token += a[i].toString(36);
      }
      return token;
    } else {
      return (Math.random() * new Date().getTime()).toString(36).replace(/\./g, "");
    }
  }
  function getRMCMediaElement(stream2, callback, connection) {
    if (!connection.autoCreateMediaElement) {
      callback({});
      return;
    }
    var isAudioOnly = false;
    if (!getTracks(stream2, "video").length && !stream2.isVideo && !stream2.isScreen) {
      isAudioOnly = true;
    }
    if (DetectRTC.browser.name === "Firefox") {
      if (connection.session.video || connection.session.screen) {
        isAudioOnly = false;
      }
    }
    var mediaElement = document.createElement(isAudioOnly ? "audio" : "video");
    mediaElement.srcObject = stream2;
    mediaElement.setAttribute("autoplay", true);
    mediaElement.setAttribute("playsinline", true);
    mediaElement.setAttribute("controls", true);
    mediaElement.setAttribute("muted", false);
    mediaElement.setAttribute("volume", 1);
    if (DetectRTC.browser.name === "Firefox") {
      var streamEndedEvent = "ended";
      if ("oninactive" in mediaElement) {
        streamEndedEvent = "inactive";
      }
      mediaElement.addEventListener(streamEndedEvent, function() {
        currentUserMediaRequest.remove(stream2.idInstance);
        if (stream2.type === "local") {
          streamEndedEvent = "ended";
          if ("oninactive" in stream2) {
            streamEndedEvent = "inactive";
          }
          StreamsHandler.onSyncNeeded(stream2.streamid, streamEndedEvent);
          connection.attachStreams.forEach(function(aStream, idx) {
            if (stream2.streamid === aStream.streamid) {
              delete connection.attachStreams[idx];
            }
          });
          var newStreamsArray = [];
          connection.attachStreams.forEach(function(aStream) {
            if (aStream) {
              newStreamsArray.push(aStream);
            }
          });
          connection.attachStreams = newStreamsArray;
          var streamEvent = connection.streamEvents[stream2.streamid];
          if (streamEvent) {
            connection.onstreamended(streamEvent);
            return;
          }
          if (this.parentNode) {
            this.parentNode.removeChild(this);
          }
        }
      }, false);
    }
    var played = mediaElement.play();
    if (typeof played !== "undefined") {
      var cbFired = false;
      setTimeout(function() {
        if (!cbFired) {
          cbFired = true;
          callback(mediaElement);
        }
      }, 1e3);
      played.then(function() {
        if (cbFired)
          return;
        cbFired = true;
        callback(mediaElement);
      }).catch(function(error2) {
        if (cbFired)
          return;
        cbFired = true;
        callback(mediaElement);
      });
    } else {
      callback(mediaElement);
    }
  }
  if (!window.addEventListener) {
    window.addEventListener = function(el, eventName, eventHandler) {
      if (!el.attachEvent) {
        return;
      }
      el.attachEvent("on" + eventName, eventHandler);
    };
  }
  function listenEventHandler(eventName, eventHandler) {
    window.removeEventListener(eventName, eventHandler);
    window.addEventListener(eventName, eventHandler, false);
  }
  window.attachEventListener = function(video, type, listener, useCapture) {
    video.addEventListener(type, listener, useCapture);
  };
  function removeNullEntries(array) {
    var newArray = [];
    array.forEach(function(item) {
      if (item) {
        newArray.push(item);
      }
    });
    return newArray;
  }
  function isData(session) {
    return !session.audio && !session.video && !session.screen && session.data;
  }
  function isNull(obj) {
    return typeof obj === "undefined";
  }
  function isString(obj) {
    return typeof obj === "string";
  }
  var MediaStream = window.MediaStream;
  if (typeof MediaStream === "undefined" && typeof webkitMediaStream !== "undefined") {
    MediaStream = webkitMediaStream;
  }
  if (typeof MediaStream !== "undefined") {
    if (!("stop" in MediaStream.prototype)) {
      MediaStream.prototype.stop = function() {
        this.getTracks().forEach(function(track) {
          track.stop();
        });
      };
    }
  }
  function isAudioPlusTab(connection, audioPlusTab) {
    if (connection.session.audio && connection.session.audio === "two-way") {
      return false;
    }
    if (DetectRTC.browser.name === "Firefox" && audioPlusTab !== false) {
      return true;
    }
    if (DetectRTC.browser.name !== "Chrome" || DetectRTC.browser.version < 50)
      return false;
    if (typeof audioPlusTab === true) {
      return true;
    }
    if (typeof audioPlusTab === "undefined" && connection.session.audio && connection.session.screen && !connection.session.video) {
      audioPlusTab = true;
      return true;
    }
    return false;
  }
  window.iOSDefaultAudioOutputDevice = window.iOSDefaultAudioOutputDevice || "speaker";
  function getTracks(stream2, kind) {
    if (!stream2 || !stream2.getTracks) {
      return [];
    }
    return stream2.getTracks().filter(function(t) {
      return t.kind === (kind || "audio");
    });
  }
  function isUnifiedPlanSupportedDefault() {
    var canAddTransceiver = false;
    try {
      if (typeof RTCRtpTransceiver === "undefined")
        return false;
      if (!("currentDirection" in RTCRtpTransceiver.prototype))
        return false;
      var tempPc = new RTCPeerConnection();
      try {
        tempPc.addTransceiver("audio");
        canAddTransceiver = true;
      } catch (e) {
      }
      tempPc.close();
    } catch (e) {
      canAddTransceiver = false;
    }
    return canAddTransceiver && isUnifiedPlanSuppored();
  }
  function isUnifiedPlanSuppored() {
    var isUnifiedPlanSupported = false;
    try {
      var pc = new RTCPeerConnection({
        sdpSemantics: "unified-plan"
      });
      try {
        var config = pc.getConfiguration();
        if (config.sdpSemantics == "unified-plan")
          isUnifiedPlanSupported = true;
        else if (config.sdpSemantics == "plan-b")
          isUnifiedPlanSupported = false;
        else
          isUnifiedPlanSupported = false;
      } catch (e) {
        isUnifiedPlanSupported = false;
      }
    } catch (e) {
      isUnifiedPlanSupported = false;
    }
    return isUnifiedPlanSupported;
  }
  function setCordovaAPIs() {
    if (typeof cordova === "undefined" || typeof cordova.plugins === "undefined" || typeof cordova.plugins.iosrtc === "undefined")
      return;
    var iosrtc = cordova.plugins.iosrtc;
    window.webkitRTCPeerConnection = iosrtc.RTCPeerConnection;
    window.RTCSessionDescription = iosrtc.RTCSessionDescription;
    window.RTCIceCandidate = iosrtc.RTCIceCandidate;
    window.MediaStream = iosrtc.MediaStream;
    window.MediaStreamTrack = iosrtc.MediaStreamTrack;
    navigator.getUserMedia = navigator.webkitGetUserMedia = iosrtc.getUserMedia;
    iosrtc.debug.enable("iosrtc*");
    if (typeof iosrtc.selectAudioOutput == "function") {
      iosrtc.selectAudioOutput(window.iOSDefaultAudioOutputDevice || "speaker");
    }
    iosrtc.registerGlobals();
  }
  document.addEventListener("deviceready", setCordovaAPIs, false);
  setCordovaAPIs();
  var defaults = {};
  function setSdpConstraints(config) {
    var sdpConstraints = {
      OfferToReceiveAudio: !!config.OfferToReceiveAudio,
      OfferToReceiveVideo: !!config.OfferToReceiveVideo
    };
    return sdpConstraints;
  }
  var RTCPeerConnection;
  if (typeof window.RTCPeerConnection !== "undefined") {
    RTCPeerConnection = window.RTCPeerConnection;
  } else if (typeof mozRTCPeerConnection !== "undefined") {
    RTCPeerConnection = mozRTCPeerConnection;
  } else if (typeof webkitRTCPeerConnection !== "undefined") {
    RTCPeerConnection = webkitRTCPeerConnection;
  }
  var RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription;
  var RTCIceCandidate = window.RTCIceCandidate || window.mozRTCIceCandidate;
  var MediaStreamTrack = window.MediaStreamTrack;
  function PeerInitiator(config) {
    if (typeof window.RTCPeerConnection !== "undefined") {
      RTCPeerConnection = window.RTCPeerConnection;
    } else if (typeof mozRTCPeerConnection !== "undefined") {
      RTCPeerConnection = mozRTCPeerConnection;
    } else if (typeof webkitRTCPeerConnection !== "undefined") {
      RTCPeerConnection = webkitRTCPeerConnection;
    }
    RTCSessionDescription = window.RTCSessionDescription || window.mozRTCSessionDescription;
    RTCIceCandidate = window.RTCIceCandidate || window.mozRTCIceCandidate;
    MediaStreamTrack = window.MediaStreamTrack;
    if (!RTCPeerConnection) {
      throw "WebRTC 1.0 (RTCPeerConnection) API are NOT available in this browser.";
    }
    var connection = config.rtcMultiConnection;
    this.extra = config.remoteSdp ? config.remoteSdp.extra : connection.extra;
    this.userid = config.userid;
    this.streams = [];
    this.channels = config.channels || [];
    this.connectionDescription = config.connectionDescription;
    this.addStream = function(session) {
      connection.addStream(session, self.userid);
    };
    this.removeStream = function(streamid) {
      connection.removeStream(streamid, self.userid);
    };
    var self = this;
    if (config.remoteSdp) {
      this.connectionDescription = config.remoteSdp.connectionDescription;
    }
    var allRemoteStreams = {};
    defaults.sdpConstraints = setSdpConstraints({
      OfferToReceiveAudio: true,
      OfferToReceiveVideo: true
    });
    var peer;
    var renegotiatingPeer = !!config.renegotiatingPeer;
    if (config.remoteSdp) {
      renegotiatingPeer = !!config.remoteSdp.renegotiatingPeer;
    }
    var localStreams = [];
    connection.attachStreams.forEach(function(stream2) {
      if (!!stream2) {
        localStreams.push(stream2);
      }
    });
    if (!renegotiatingPeer) {
      var iceTransports = "all";
      if (connection.candidates.turn || connection.candidates.relay) {
        if (!connection.candidates.stun && !connection.candidates.reflexive && !connection.candidates.host) {
          iceTransports = "relay";
        }
      }
      try {
        var params = {
          iceServers: connection.iceServers,
          iceTransportPolicy: connection.iceTransportPolicy || iceTransports
        };
        if (typeof connection.iceCandidatePoolSize !== "undefined") {
          params.iceCandidatePoolSize = connection.iceCandidatePoolSize;
        }
        if (typeof connection.bundlePolicy !== "undefined") {
          params.bundlePolicy = connection.bundlePolicy;
        }
        if (typeof connection.rtcpMuxPolicy !== "undefined") {
          params.rtcpMuxPolicy = connection.rtcpMuxPolicy;
        }
        if (!!connection.sdpSemantics) {
          params.sdpSemantics = connection.sdpSemantics || "unified-plan";
        }
        if (!connection.iceServers || !connection.iceServers.length) {
          params = null;
          connection.optionalArgument = null;
        }
        peer = new RTCPeerConnection(params, connection.optionalArgument);
      } catch (e) {
        try {
          var params = {
            iceServers: connection.iceServers
          };
          peer = new RTCPeerConnection(params);
        } catch (e2) {
          peer = new RTCPeerConnection();
        }
      }
    } else {
      peer = config.peerRef;
    }
    if (!peer.getRemoteStreams && peer.getReceivers) {
      peer.getRemoteStreams = function() {
        var stream2 = new MediaStream();
        peer.getReceivers().forEach(function(receiver) {
          stream2.addTrack(receiver.track);
        });
        return [stream2];
      };
    }
    if (!peer.getLocalStreams && peer.getSenders) {
      peer.getLocalStreams = function() {
        var stream2 = new MediaStream();
        peer.getSenders().forEach(function(sender) {
          stream2.addTrack(sender.track);
        });
        return [stream2];
      };
    }
    peer.onicecandidate = function(event2) {
      if (!event2.candidate) {
        if (!connection.trickleIce) {
          var localSdp = peer.localDescription;
          config.onLocalSdp({
            type: localSdp.type,
            sdp: localSdp.sdp,
            remotePeerSdpConstraints: config.remotePeerSdpConstraints || false,
            renegotiatingPeer: !!config.renegotiatingPeer || false,
            connectionDescription: self.connectionDescription,
            dontGetRemoteStream: !!config.dontGetRemoteStream,
            extra: connection ? connection.extra : {},
            streamsToShare
          });
        }
        return;
      }
      if (!connection.trickleIce)
        return;
      config.onLocalCandidate({
        candidate: event2.candidate.candidate,
        sdpMid: event2.candidate.sdpMid,
        sdpMLineIndex: event2.candidate.sdpMLineIndex
      });
    };
    localStreams.forEach(function(localStream) {
      if (config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.dontGetRemoteStream) {
        return;
      }
      if (config.dontAttachLocalStream) {
        return;
      }
      localStream = connection.beforeAddingStream(localStream, self);
      if (!localStream)
        return;
      peer.getLocalStreams().forEach(function(stream2) {
        if (localStream && stream2.id == localStream.id) {
          localStream = null;
        }
      });
      if (localStream && localStream.getTracks) {
        localStream.getTracks().forEach(function(track) {
          try {
            peer.addTrack(track, localStream);
          } catch (e) {
          }
        });
      }
    });
    peer.oniceconnectionstatechange = peer.onsignalingstatechange = function() {
      var extra = self.extra;
      if (connection.peers[self.userid]) {
        extra = connection.peers[self.userid].extra || extra;
      }
      if (!peer) {
        return;
      }
      config.onPeerStateChanged({
        iceConnectionState: peer.iceConnectionState,
        iceGatheringState: peer.iceGatheringState,
        signalingState: peer.signalingState,
        extra,
        userid: self.userid
      });
      if (peer && peer.iceConnectionState && peer.iceConnectionState.search(/closed|failed/gi) !== -1 && self.streams instanceof Array) {
        self.streams.forEach(function(stream2) {
          var streamEvent = connection.streamEvents[stream2.id] || {
            streamid: stream2.id,
            stream: stream2,
            type: "remote"
          };
          connection.onstreamended(streamEvent);
        });
      }
    };
    var sdpConstraints = {
      OfferToReceiveAudio: !!localStreams.length,
      OfferToReceiveVideo: !!localStreams.length
    };
    if (config.localPeerSdpConstraints)
      sdpConstraints = config.localPeerSdpConstraints;
    defaults.sdpConstraints = setSdpConstraints(sdpConstraints);
    var dontDuplicate = {};
    peer.ontrack = function(event2) {
      if (!event2 || event2.type !== "track")
        return;
      event2.stream = event2.streams[event2.streams.length - 1];
      if (!event2.stream.id) {
        event2.stream.id = event2.track.id;
      }
      if (dontDuplicate[event2.stream.id] && DetectRTC.browser.name !== "Safari") {
        if (event2.track) {
          event2.track.onended = function() {
            peer && peer.onremovestream(event2);
          };
        }
        return;
      }
      dontDuplicate[event2.stream.id] = event2.stream.id;
      var streamsToShare2 = {};
      if (config.remoteSdp && config.remoteSdp.streamsToShare) {
        streamsToShare2 = config.remoteSdp.streamsToShare;
      } else if (config.streamsToShare) {
        streamsToShare2 = config.streamsToShare;
      }
      var streamToShare = streamsToShare2[event2.stream.id];
      if (streamToShare) {
        event2.stream.isAudio = streamToShare.isAudio;
        event2.stream.isVideo = streamToShare.isVideo;
        event2.stream.isScreen = streamToShare.isScreen;
      } else {
        event2.stream.isVideo = !!getTracks(event2.stream, "video").length;
        event2.stream.isAudio = !event2.stream.isVideo;
        event2.stream.isScreen = false;
      }
      event2.stream.streamid = event2.stream.id;
      allRemoteStreams[event2.stream.id] = event2.stream;
      config.onRemoteStream(event2.stream);
      event2.stream.getTracks().forEach(function(track) {
        track.onended = function() {
          peer && peer.onremovestream(event2);
        };
      });
      event2.stream.onremovetrack = function() {
        peer && peer.onremovestream(event2);
      };
    };
    peer.onremovestream = function(event2) {
      event2.stream.streamid = event2.stream.id;
      if (allRemoteStreams[event2.stream.id]) {
        delete allRemoteStreams[event2.stream.id];
      }
      config.onRemoteStreamRemoved(event2.stream);
    };
    if (typeof peer.removeStream !== "function") {
      peer.removeStream = function(stream2) {
        stream2.getTracks().forEach(function(track) {
          peer.removeTrack(track, stream2);
        });
      };
    }
    this.addRemoteCandidate = function(remoteCandidate) {
      peer.addIceCandidate(new RTCIceCandidate(remoteCandidate));
    };
    this.addRemoteSdp = function(remoteSdp, cb) {
      cb = cb || function() {
      };
      if (DetectRTC.browser.name !== "Safari") {
        remoteSdp.sdp = connection.processSdp(remoteSdp.sdp);
      }
      peer.setRemoteDescription(new RTCSessionDescription(remoteSdp)).then(cb, function(error2) {
        if (!!connection.enableLogs) {
          console.error("setRemoteDescription failed", "\n", error2, "\n", remoteSdp.sdp);
        }
        cb();
      }).catch(function(error2) {
        if (!!connection.enableLogs) {
          console.error("setRemoteDescription failed", "\n", error2, "\n", remoteSdp.sdp);
        }
        cb();
      });
    };
    var isOfferer = true;
    if (config.remoteSdp) {
      isOfferer = false;
    }
    this.createDataChannel = function() {
      var channel = peer.createDataChannel("sctp", {});
      setChannelEvents(channel);
    };
    if (connection.session.data === true && !renegotiatingPeer) {
      if (!isOfferer) {
        peer.ondatachannel = function(event2) {
          var channel = event2.channel;
          setChannelEvents(channel);
        };
      } else {
        this.createDataChannel();
      }
    }
    this.enableDisableVideoEncoding = function(enable) {
      var rtcp;
      peer.getSenders().forEach(function(sender) {
        if (!rtcp && sender.track.kind === "video") {
          rtcp = sender;
        }
      });
      if (!rtcp || !rtcp.getParameters)
        return;
      var parameters = rtcp.getParameters();
      parameters.encodings[1] && (parameters.encodings[1].active = !!enable);
      parameters.encodings[2] && (parameters.encodings[2].active = !!enable);
      rtcp.setParameters(parameters);
    };
    if (config.remoteSdp) {
      if (config.remoteSdp.remotePeerSdpConstraints) {
        sdpConstraints = config.remoteSdp.remotePeerSdpConstraints;
      }
      defaults.sdpConstraints = setSdpConstraints(sdpConstraints);
      this.addRemoteSdp(config.remoteSdp, function() {
        createOfferOrAnswer("createAnswer");
      });
    }
    function setChannelEvents(channel) {
      channel.binaryType = "arraybuffer";
      channel.onmessage = function(event2) {
        config.onDataChannelMessage(event2.data);
      };
      channel.onopen = function() {
        config.onDataChannelOpened(channel);
      };
      channel.onerror = function(error2) {
        config.onDataChannelError(error2);
      };
      channel.onclose = function(event2) {
        config.onDataChannelClosed(event2);
      };
      channel.internalSend = channel.send;
      channel.send = function(data) {
        if (channel.readyState !== "open") {
          return;
        }
        channel.internalSend(data);
      };
      peer.channel = channel;
    }
    if (connection.session.audio == "two-way" || connection.session.video == "two-way" || connection.session.screen == "two-way") {
      defaults.sdpConstraints = setSdpConstraints({
        OfferToReceiveAudio: connection.session.audio == "two-way" || config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.OfferToReceiveAudio,
        OfferToReceiveVideo: connection.session.video == "two-way" || connection.session.screen == "two-way" || config.remoteSdp && config.remoteSdp.remotePeerSdpConstraints && config.remoteSdp.remotePeerSdpConstraints.OfferToReceiveAudio
      });
    }
    var streamsToShare = {};
    peer.getLocalStreams().forEach(function(stream2) {
      streamsToShare[stream2.streamid] = {
        isAudio: !!stream2.isAudio,
        isVideo: !!stream2.isVideo,
        isScreen: !!stream2.isScreen
      };
    });
    function createOfferOrAnswer(_method) {
      if (!peer || !peer[_method]) {
        return;
      }
      peer[_method](defaults.sdpConstraints).then(function(localSdp) {
        if (DetectRTC.browser.name !== "Safari") {
          localSdp.sdp = connection.processSdp(localSdp.sdp);
        }
        if (!peer) {
          return;
        }
        peer.setLocalDescription(localSdp).then(function() {
          if (!connection.trickleIce)
            return;
          config.onLocalSdp({
            type: localSdp.type,
            sdp: localSdp.sdp,
            remotePeerSdpConstraints: config.remotePeerSdpConstraints || false,
            renegotiatingPeer: !!config.renegotiatingPeer || false,
            connectionDescription: self.connectionDescription,
            dontGetRemoteStream: !!config.dontGetRemoteStream,
            extra: connection ? connection.extra : {},
            streamsToShare
          });
          connection.onSettingLocalDescription(self);
        }, function(error2) {
          if (!connection.enableLogs)
            return;
          console.error("setLocalDescription error", error2);
        });
      }, function(error2) {
        if (!!connection.enableLogs) {
          console.error("sdp-error", error2);
        }
      });
    }
    if (isOfferer) {
      createOfferOrAnswer("createOffer");
    }
    peer.nativeClose = peer.close;
    peer.close = function() {
      if (!peer) {
        return;
      }
      try {
        if (peer.nativeClose !== peer.close) {
          peer.nativeClose();
        }
      } catch (e) {
      }
      peer = null;
      self.peer = null;
    };
    this.peer = peer;
  }
  var CodecsHandler = function() {
    function preferCodec(sdp, codecName) {
      var info = splitLines(sdp);
      if (!info.videoCodecNumbers) {
        return sdp;
      }
      if (codecName === "vp8" && info.vp8LineNumber === info.videoCodecNumbers[0]) {
        return sdp;
      }
      if (codecName === "vp9" && info.vp9LineNumber === info.videoCodecNumbers[0]) {
        return sdp;
      }
      if (codecName === "h264" && info.h264LineNumber === info.videoCodecNumbers[0]) {
        return sdp;
      }
      sdp = preferCodecHelper(sdp, codecName, info);
      return sdp;
    }
    function preferCodecHelper(sdp, codec, info, ignore) {
      var preferCodecNumber = "";
      if (codec === "vp8") {
        if (!info.vp8LineNumber) {
          return sdp;
        }
        preferCodecNumber = info.vp8LineNumber;
      }
      if (codec === "vp9") {
        if (!info.vp9LineNumber) {
          return sdp;
        }
        preferCodecNumber = info.vp9LineNumber;
      }
      if (codec === "h264") {
        if (!info.h264LineNumber) {
          return sdp;
        }
        preferCodecNumber = info.h264LineNumber;
      }
      var newLine = info.videoCodecNumbersOriginal.split("SAVPF")[0] + "SAVPF ";
      var newOrder = [preferCodecNumber];
      if (ignore) {
        newOrder = [];
      }
      info.videoCodecNumbers.forEach(function(codecNumber) {
        if (codecNumber === preferCodecNumber)
          return;
        newOrder.push(codecNumber);
      });
      newLine += newOrder.join(" ");
      sdp = sdp.replace(info.videoCodecNumbersOriginal, newLine);
      return sdp;
    }
    function splitLines(sdp) {
      var info = {};
      sdp.split("\n").forEach(function(line) {
        if (line.indexOf("m=video") === 0) {
          info.videoCodecNumbers = [];
          line.split("SAVPF")[1].split(" ").forEach(function(codecNumber) {
            codecNumber = codecNumber.trim();
            if (!codecNumber || !codecNumber.length)
              return;
            info.videoCodecNumbers.push(codecNumber);
            info.videoCodecNumbersOriginal = line;
          });
        }
        if (line.indexOf("VP8/90000") !== -1 && !info.vp8LineNumber) {
          info.vp8LineNumber = line.replace("a=rtpmap:", "").split(" ")[0];
        }
        if (line.indexOf("VP9/90000") !== -1 && !info.vp9LineNumber) {
          info.vp9LineNumber = line.replace("a=rtpmap:", "").split(" ")[0];
        }
        if (line.indexOf("H264/90000") !== -1 && !info.h264LineNumber) {
          info.h264LineNumber = line.replace("a=rtpmap:", "").split(" ")[0];
        }
      });
      return info;
    }
    function removeVPX(sdp) {
      var info = splitLines(sdp);
      sdp = preferCodecHelper(sdp, "vp9", info, true);
      sdp = preferCodecHelper(sdp, "vp8", info, true);
      return sdp;
    }
    function disableNACK(sdp) {
      if (!sdp || typeof sdp !== "string") {
        throw "Invalid arguments.";
      }
      sdp = sdp.replace("a=rtcp-fb:126 nack\r\n", "");
      sdp = sdp.replace("a=rtcp-fb:126 nack pli\r\n", "a=rtcp-fb:126 pli\r\n");
      sdp = sdp.replace("a=rtcp-fb:97 nack\r\n", "");
      sdp = sdp.replace("a=rtcp-fb:97 nack pli\r\n", "a=rtcp-fb:97 pli\r\n");
      return sdp;
    }
    function prioritize(codecMimeType, peer) {
      if (!peer || !peer.getSenders || !peer.getSenders().length) {
        return;
      }
      if (!codecMimeType || typeof codecMimeType !== "string") {
        throw "Invalid arguments.";
      }
      peer.getSenders().forEach(function(sender) {
        var params = sender.getParameters();
        for (var i = 0; i < params.codecs.length; i++) {
          if (params.codecs[i].mimeType == codecMimeType) {
            params.codecs.unshift(params.codecs.splice(i, 1));
            break;
          }
        }
        sender.setParameters(params);
      });
    }
    function removeNonG722(sdp) {
      return sdp.replace(/m=audio ([0-9]+) RTP\/SAVPF ([0-9 ]*)/g, "m=audio $1 RTP/SAVPF 9");
    }
    function setBAS(sdp, bandwidth, isScreen) {
      if (!bandwidth) {
        return sdp;
      }
      if (typeof isFirefox !== "undefined" && isFirefox) {
        return sdp;
      }
      if (isScreen) {
        if (!bandwidth.screen) {
          console.warn("It seems that you are not using bandwidth for screen. Screen sharing is expected to fail.");
        } else if (bandwidth.screen < 300) {
          console.warn("It seems that you are using wrong bandwidth value for screen. Screen sharing is expected to fail.");
        }
      }
      if (bandwidth.screen && isScreen) {
        sdp = sdp.replace(/b=AS([^\r\n]+\r\n)/g, "");
        sdp = sdp.replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth.screen + "\r\n");
      }
      if (bandwidth.audio || bandwidth.video) {
        sdp = sdp.replace(/b=AS([^\r\n]+\r\n)/g, "");
      }
      if (bandwidth.audio) {
        sdp = sdp.replace(/a=mid:audio\r\n/g, "a=mid:audio\r\nb=AS:" + bandwidth.audio + "\r\n");
      }
      if (bandwidth.screen) {
        sdp = sdp.replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth.screen + "\r\n");
      } else if (bandwidth.video) {
        sdp = sdp.replace(/a=mid:video\r\n/g, "a=mid:video\r\nb=AS:" + bandwidth.video + "\r\n");
      }
      return sdp;
    }
    function findLine(sdpLines, prefix, substr) {
      return findLineInRange(sdpLines, 0, -1, prefix, substr);
    }
    function findLineInRange(sdpLines, startLine, endLine, prefix, substr) {
      var realEndLine = endLine !== -1 ? endLine : sdpLines.length;
      for (var i = startLine; i < realEndLine; ++i) {
        if (sdpLines[i].indexOf(prefix) === 0) {
          if (!substr || sdpLines[i].toLowerCase().indexOf(substr.toLowerCase()) !== -1) {
            return i;
          }
        }
      }
      return null;
    }
    function getCodecPayloadType(sdpLine) {
      var pattern = new RegExp("a=rtpmap:(\\d+) \\w+\\/\\d+");
      var result = sdpLine.match(pattern);
      return result && result.length === 2 ? result[1] : null;
    }
    function setVideoBitrates(sdp, params) {
      params = params || {};
      var xgoogle_min_bitrate = params.min;
      var xgoogle_max_bitrate = params.max;
      var sdpLines = sdp.split("\r\n");
      var vp8Index = findLine(sdpLines, "a=rtpmap", "VP8/90000");
      var vp8Payload;
      if (vp8Index) {
        vp8Payload = getCodecPayloadType(sdpLines[vp8Index]);
      }
      if (!vp8Payload) {
        return sdp;
      }
      var rtxIndex = findLine(sdpLines, "a=rtpmap", "rtx/90000");
      var rtxPayload;
      if (rtxIndex) {
        rtxPayload = getCodecPayloadType(sdpLines[rtxIndex]);
      }
      if (!rtxIndex) {
        return sdp;
      }
      var rtxFmtpLineIndex = findLine(sdpLines, "a=fmtp:" + rtxPayload.toString());
      if (rtxFmtpLineIndex !== null) {
        var appendrtxNext = "\r\n";
        appendrtxNext += "a=fmtp:" + vp8Payload + " x-google-min-bitrate=" + (xgoogle_min_bitrate || "228") + "; x-google-max-bitrate=" + (xgoogle_max_bitrate || "228");
        sdpLines[rtxFmtpLineIndex] = sdpLines[rtxFmtpLineIndex].concat(appendrtxNext);
        sdp = sdpLines.join("\r\n");
      }
      return sdp;
    }
    function setOpusAttributes(sdp, params) {
      params = params || {};
      var sdpLines = sdp.split("\r\n");
      var opusIndex = findLine(sdpLines, "a=rtpmap", "opus/48000");
      var opusPayload;
      if (opusIndex) {
        opusPayload = getCodecPayloadType(sdpLines[opusIndex]);
      }
      if (!opusPayload) {
        return sdp;
      }
      var opusFmtpLineIndex = findLine(sdpLines, "a=fmtp:" + opusPayload.toString());
      if (opusFmtpLineIndex === null) {
        return sdp;
      }
      var appendOpusNext = "";
      appendOpusNext += "; stereo=" + (typeof params.stereo != "undefined" ? params.stereo : "1");
      appendOpusNext += "; sprop-stereo=" + (typeof params["sprop-stereo"] != "undefined" ? params["sprop-stereo"] : "1");
      if (typeof params.maxaveragebitrate != "undefined") {
        appendOpusNext += "; maxaveragebitrate=" + (params.maxaveragebitrate || 128 * 1024 * 8);
      }
      if (typeof params.maxplaybackrate != "undefined") {
        appendOpusNext += "; maxplaybackrate=" + (params.maxplaybackrate || 128 * 1024 * 8);
      }
      if (typeof params.cbr != "undefined") {
        appendOpusNext += "; cbr=" + (typeof params.cbr != "undefined" ? params.cbr : "1");
      }
      if (typeof params.useinbandfec != "undefined") {
        appendOpusNext += "; useinbandfec=" + params.useinbandfec;
      }
      if (typeof params.usedtx != "undefined") {
        appendOpusNext += "; usedtx=" + params.usedtx;
      }
      if (typeof params.maxptime != "undefined") {
        appendOpusNext += "\r\na=maxptime:" + params.maxptime;
      }
      sdpLines[opusFmtpLineIndex] = sdpLines[opusFmtpLineIndex].concat(appendOpusNext);
      sdp = sdpLines.join("\r\n");
      return sdp;
    }
    function forceStereoAudio(sdp) {
      var sdpLines = sdp.split("\r\n");
      var fmtpLineIndex = null;
      for (var i = 0; i < sdpLines.length; i++) {
        if (sdpLines[i].search("opus/48000") !== -1) {
          var opusPayload = extractSdp(sdpLines[i], /:(\d+) opus\/48000/i);
          break;
        }
      }
      for (var i = 0; i < sdpLines.length; i++) {
        if (sdpLines[i].search("a=fmtp") !== -1) {
          var payload = extractSdp(sdpLines[i], /a=fmtp:(\d+)/);
          if (payload === opusPayload) {
            fmtpLineIndex = i;
            break;
          }
        }
      }
      if (fmtpLineIndex === null)
        return sdp;
      sdpLines[fmtpLineIndex] = sdpLines[fmtpLineIndex].concat("; stereo=1; sprop-stereo=1");
      sdp = sdpLines.join("\r\n");
      return sdp;
    }
    return {
      removeVPX,
      disableNACK,
      prioritize,
      removeNonG722,
      setApplicationSpecificBandwidth: function(sdp, bandwidth, isScreen) {
        return setBAS(sdp, bandwidth, isScreen);
      },
      setVideoBitrates: function(sdp, params) {
        return setVideoBitrates(sdp, params);
      },
      setOpusAttributes: function(sdp, params) {
        return setOpusAttributes(sdp, params);
      },
      preferVP9: function(sdp) {
        return preferCodec(sdp, "vp9");
      },
      preferCodec,
      forceStereoAudio
    };
  }();
  window.BandwidthHandler = CodecsHandler;
  var OnIceCandidateHandler = function() {
    function processCandidates(connection, icePair) {
      var candidate = icePair.candidate;
      var iceRestrictions = connection.candidates;
      var stun = iceRestrictions.stun;
      var turn = iceRestrictions.turn;
      if (!isNull(iceRestrictions.reflexive)) {
        stun = iceRestrictions.reflexive;
      }
      if (!isNull(iceRestrictions.relay)) {
        turn = iceRestrictions.relay;
      }
      if (!iceRestrictions.host && !!candidate.match(/typ host/g)) {
        return;
      }
      if (!turn && !!candidate.match(/typ relay/g)) {
        return;
      }
      if (!stun && !!candidate.match(/typ srflx/g)) {
        return;
      }
      var protocol = connection.iceProtocols;
      if (!protocol.udp && !!candidate.match(/ udp /g)) {
        return;
      }
      if (!protocol.tcp && !!candidate.match(/ tcp /g)) {
        return;
      }
      if (connection.enableLogs) {
        console.debug("Your candidate pairs:", candidate);
      }
      return {
        candidate,
        sdpMid: icePair.sdpMid,
        sdpMLineIndex: icePair.sdpMLineIndex
      };
    }
    return {
      processCandidates
    };
  }();
  var IceServersHandler = function() {
    function getIceServers(connection) {
      var iceServers = [{
        "urls": [
          "stun:stun.l.google.com:19302",
          "stun:stun1.l.google.com:19302",
          "stun:stun2.l.google.com:19302",
          "stun:stun.l.google.com:19302?transport=udp"
        ]
      }];
      return iceServers;
    }
    return {
      getIceServers
    };
  }();
  function setStreamType(constraints, stream2) {
    if (constraints.mandatory && constraints.mandatory.chromeMediaSource) {
      stream2.isScreen = true;
    } else if (constraints.mozMediaSource || constraints.mediaSource) {
      stream2.isScreen = true;
    } else if (constraints.video) {
      stream2.isVideo = true;
    } else if (constraints.audio) {
      stream2.isAudio = true;
    }
  }
  window.currentUserMediaRequest = {
    streams: [],
    mutex: false,
    queueRequests: [],
    remove: function(idInstance) {
      this.mutex = false;
      var stream2 = this.streams[idInstance];
      if (!stream2) {
        return;
      }
      stream2 = stream2.stream;
      var options = stream2.currentUserMediaRequestOptions;
      if (this.queueRequests.indexOf(options)) {
        delete this.queueRequests[this.queueRequests.indexOf(options)];
        this.queueRequests = removeNullEntries(this.queueRequests);
      }
      this.streams[idInstance].stream = null;
      delete this.streams[idInstance];
    }
  };
  function getUserMediaHandler(options) {
    if (currentUserMediaRequest.mutex === true) {
      currentUserMediaRequest.queueRequests.push(options);
      return;
    }
    currentUserMediaRequest.mutex = true;
    var idInstance = JSON.stringify(options.localMediaConstraints);
    function streaming(stream2, returnBack) {
      setStreamType(options.localMediaConstraints, stream2);
      var streamEndedEvent = "ended";
      if ("oninactive" in stream2) {
        streamEndedEvent = "inactive";
      }
      stream2.addEventListener(streamEndedEvent, function() {
        delete currentUserMediaRequest.streams[idInstance];
        currentUserMediaRequest.mutex = false;
        if (currentUserMediaRequest.queueRequests.indexOf(options)) {
          delete currentUserMediaRequest.queueRequests[currentUserMediaRequest.queueRequests.indexOf(options)];
          currentUserMediaRequest.queueRequests = removeNullEntries(currentUserMediaRequest.queueRequests);
        }
      }, false);
      currentUserMediaRequest.streams[idInstance] = {
        stream: stream2
      };
      currentUserMediaRequest.mutex = false;
      if (currentUserMediaRequest.queueRequests.length) {
        getUserMediaHandler(currentUserMediaRequest.queueRequests.shift());
      }
      options.onGettingLocalMedia(stream2, returnBack);
    }
    if (currentUserMediaRequest.streams[idInstance]) {
      streaming(currentUserMediaRequest.streams[idInstance].stream, true);
    } else {
      var isBlackBerry = !!/BB10|BlackBerry/i.test(navigator.userAgent || "");
      if (isBlackBerry || typeof navigator.mediaDevices === "undefined" || typeof navigator.mediaDevices.getUserMedia !== "function") {
        navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
        navigator.getUserMedia(options.localMediaConstraints, function(stream2) {
          stream2.streamid = stream2.streamid || stream2.id || getRandomString();
          stream2.idInstance = idInstance;
          streaming(stream2);
        }, function(error2) {
          options.onLocalMediaError(error2, options.localMediaConstraints);
        });
        return;
      }
      if (typeof navigator.mediaDevices === "undefined") {
        navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
        var getUserMediaFailure = function() {
        };
        var getUserMediaStream, getUserMediaError;
        navigator.mediaDevices = {
          getUserMedia: function(hints) {
            navigator.getUserMedia(hints, function(getUserMediaSuccess) {
              getUserMediaSuccess(stream);
              getUserMediaStream = stream;
            }, function(error2) {
              getUserMediaFailure(error2);
              getUserMediaError = error2;
            });
            return {
              then: function(successCB) {
                if (getUserMediaStream) {
                  successCB(getUserMediaStream);
                  return;
                }
                return {
                  then: function(failureCB) {
                    if (getUserMediaError) {
                      failureCB(getUserMediaError);
                      return;
                    }
                    getUserMediaFailure = failureCB;
                  }
                };
              }
            };
          }
        };
      }
      if (options.localMediaConstraints.isScreen === true) {
        if (navigator.mediaDevices.getDisplayMedia) {
          navigator.mediaDevices.getDisplayMedia(options.localMediaConstraints).then(function(stream2) {
            stream2.streamid = stream2.streamid || stream2.id || getRandomString();
            stream2.idInstance = idInstance;
            streaming(stream2);
          }).catch(function(error2) {
            options.onLocalMediaError(error2, options.localMediaConstraints);
          });
        } else if (navigator.getDisplayMedia) {
          navigator.getDisplayMedia(options.localMediaConstraints).then(function(stream2) {
            stream2.streamid = stream2.streamid || stream2.id || getRandomString();
            stream2.idInstance = idInstance;
            streaming(stream2);
          }).catch(function(error2) {
            options.onLocalMediaError(error2, options.localMediaConstraints);
          });
        } else {
          throw new Error("getDisplayMedia API is not availabe in this browser.");
        }
        return;
      }
      navigator.mediaDevices.getUserMedia(options.localMediaConstraints).then(function(stream2) {
        stream2.streamid = stream2.streamid || stream2.id || getRandomString();
        stream2.idInstance = idInstance;
        streaming(stream2);
      }).catch(function(error2) {
        options.onLocalMediaError(error2, options.localMediaConstraints);
      });
    }
  }
  var StreamsHandler = function() {
    function handleType(type) {
      if (!type) {
        return;
      }
      if (typeof type === "string" || typeof type === "undefined") {
        return type;
      }
      if (type.audio && type.video) {
        return null;
      }
      if (type.audio) {
        return "audio";
      }
      if (type.video) {
        return "video";
      }
      return;
    }
    function setHandlers(stream2, syncAction, connection) {
      if (!stream2 || !stream2.addEventListener)
        return;
      if (typeof syncAction == "undefined" || syncAction == true) {
        var streamEndedEvent = "ended";
        if ("oninactive" in stream2) {
          streamEndedEvent = "inactive";
        }
        stream2.addEventListener(streamEndedEvent, function() {
          StreamsHandler.onSyncNeeded(this.streamid, streamEndedEvent);
        }, false);
      }
      stream2.mute = function(type, isSyncAction) {
        type = handleType(type);
        if (typeof isSyncAction !== "undefined") {
          syncAction = isSyncAction;
        }
        if (typeof type == "undefined" || type == "audio") {
          getTracks(stream2, "audio").forEach(function(track) {
            track.enabled = false;
            connection.streamEvents[stream2.streamid].isAudioMuted = true;
          });
        }
        if (typeof type == "undefined" || type == "video") {
          getTracks(stream2, "video").forEach(function(track) {
            track.enabled = false;
          });
        }
        if (typeof syncAction == "undefined" || syncAction == true) {
          StreamsHandler.onSyncNeeded(stream2.streamid, "mute", type);
        }
        connection.streamEvents[stream2.streamid].muteType = type || "both";
        fireEvent(stream2, "mute", type);
      };
      stream2.unmute = function(type, isSyncAction) {
        type = handleType(type);
        if (typeof isSyncAction !== "undefined") {
          syncAction = isSyncAction;
        }
        graduallyIncreaseVolume();
        if (typeof type == "undefined" || type == "audio") {
          getTracks(stream2, "audio").forEach(function(track) {
            track.enabled = true;
            connection.streamEvents[stream2.streamid].isAudioMuted = false;
          });
        }
        if (typeof type == "undefined" || type == "video") {
          getTracks(stream2, "video").forEach(function(track) {
            track.enabled = true;
          });
          if (typeof type !== "undefined" && type == "video" && connection.streamEvents[stream2.streamid].isAudioMuted) {
            (function looper(times) {
              if (!times) {
                times = 0;
              }
              times++;
              if (times < 100 && connection.streamEvents[stream2.streamid].isAudioMuted) {
                stream2.mute("audio");
                setTimeout(function() {
                  looper(times);
                }, 50);
              }
            })();
          }
        }
        if (typeof syncAction == "undefined" || syncAction == true) {
          StreamsHandler.onSyncNeeded(stream2.streamid, "unmute", type);
        }
        connection.streamEvents[stream2.streamid].unmuteType = type || "both";
        fireEvent(stream2, "unmute", type);
      };
      function graduallyIncreaseVolume() {
        if (!connection.streamEvents[stream2.streamid].mediaElement) {
          return;
        }
        var mediaElement = connection.streamEvents[stream2.streamid].mediaElement;
        mediaElement.volume = 0;
        afterEach(200, 5, function() {
          try {
            mediaElement.volume += 0.2;
          } catch (e) {
            mediaElement.volume = 1;
          }
        });
      }
    }
    function afterEach(setTimeoutInteval, numberOfTimes, callback, startedTimes) {
      startedTimes = (startedTimes || 0) + 1;
      if (startedTimes >= numberOfTimes)
        return;
      setTimeout(function() {
        callback();
        afterEach(setTimeoutInteval, numberOfTimes, callback, startedTimes);
      }, setTimeoutInteval);
    }
    return {
      setHandlers,
      onSyncNeeded: function(streamid, action, type) {
      }
    };
  }();
  function TextReceiver(connection) {
    var content = {};
    function receive(data, userid, extra) {
      var uuid = data.uuid;
      if (!content[uuid]) {
        content[uuid] = [];
      }
      content[uuid].push(data.message);
      if (data.last) {
        var message = content[uuid].join("");
        if (data.isobject) {
          message = JSON.parse(message);
        }
        var receivingTime = new Date().getTime();
        var latency = receivingTime - data.sendingTime;
        var e = {
          data: message,
          userid,
          extra,
          latency
        };
        if (connection.autoTranslateText) {
          e.original = e.data;
          connection.Translator.TranslateText(e.data, function(translatedText) {
            e.data = translatedText;
            connection.onmessage(e);
          });
        } else {
          connection.onmessage(e);
        }
        delete content[uuid];
      }
    }
    return {
      receive
    };
  }
  var TextSender = {
    send: function(config) {
      var connection = config.connection;
      var channel = config.channel, remoteUserId = config.remoteUserId, initialText = config.text, packetSize = connection.chunkSize || 1e3, textToTransfer = "", isobject = false;
      if (!isString(initialText)) {
        isobject = true;
        initialText = JSON.stringify(initialText);
      }
      var uuid = getRandomString();
      var sendingTime = new Date().getTime();
      sendText(initialText);
      function sendText(textMessage, text) {
        var data = {
          type: "text",
          uuid,
          sendingTime
        };
        if (textMessage) {
          text = textMessage;
          data.packets = parseInt(text.length / packetSize);
        }
        if (text.length > packetSize) {
          data.message = text.slice(0, packetSize);
        } else {
          data.message = text;
          data.last = true;
          data.isobject = isobject;
        }
        channel.send(data, remoteUserId);
        textToTransfer = text.slice(data.message.length);
        if (textToTransfer.length) {
          setTimeout(function() {
            sendText(null, textToTransfer);
          }, connection.chunkInterval || 100);
        }
      }
    }
  };
  var FileProgressBarHandler = function() {
    function handle(connection) {
      var progressHelper = {};
      connection.onFileStart = function(file) {
        var div = document.createElement("div");
        div.title = file.name;
        div.innerHTML = "<label>0%</label> <progress></progress>";
        if (file.remoteUserId) {
          div.innerHTML += " (Sharing with:" + file.remoteUserId + ")";
        }
        if (!connection.filesContainer) {
          connection.filesContainer = document.body || document.documentElement;
        }
        connection.filesContainer.insertBefore(div, connection.filesContainer.firstChild);
        if (!file.remoteUserId) {
          progressHelper[file.uuid] = {
            div,
            progress: div.querySelector("progress"),
            label: div.querySelector("label")
          };
          progressHelper[file.uuid].progress.max = file.maxChunks;
          return;
        }
        if (!progressHelper[file.uuid]) {
          progressHelper[file.uuid] = {};
        }
        progressHelper[file.uuid][file.remoteUserId] = {
          div,
          progress: div.querySelector("progress"),
          label: div.querySelector("label")
        };
        progressHelper[file.uuid][file.remoteUserId].progress.max = file.maxChunks;
      };
      connection.onFileProgress = function(chunk) {
        var helper = progressHelper[chunk.uuid];
        if (!helper) {
          return;
        }
        if (chunk.remoteUserId) {
          helper = progressHelper[chunk.uuid][chunk.remoteUserId];
          if (!helper) {
            return;
          }
        }
        helper.progress.value = chunk.currentPosition || chunk.maxChunks || helper.progress.max;
        updateLabel(helper.progress, helper.label);
      };
      connection.onFileEnd = function(file) {
        var helper = progressHelper[file.uuid];
        if (!helper) {
          console.error("No such progress-helper element exist.", file);
          return;
        }
        if (file.remoteUserId) {
          helper = progressHelper[file.uuid][file.remoteUserId];
          if (!helper) {
            return;
          }
        }
        var div = helper.div;
        if (file.type.indexOf("image") != -1) {
          div.innerHTML = '<a href="' + file.url + '" download="' + file.name + '">Download <strong style="color:red;">' + file.name + '</strong> </a><br /><img src="' + file.url + '" title="' + file.name + '" style="max-width: 80%;">';
        } else {
          div.innerHTML = '<a href="' + file.url + '" download="' + file.name + '">Download <strong style="color:red;">' + file.name + '</strong> </a><br /><iframe src="' + file.url + '" title="' + file.name + '" style="width: 80%;border: 0;height: inherit;margin-top:1em;"></iframe>';
        }
      };
      function updateLabel(progress, label) {
        if (progress.position === -1) {
          return;
        }
        var position = +progress.position.toFixed(2).split(".")[1] || 100;
        label.innerHTML = position + "%";
      }
    }
    return {
      handle
    };
  }();
  var TranslationHandler = function() {
    function handle(connection) {
      connection.autoTranslateText = false;
      connection.language = "en";
      connection.googKey = "AIzaSyCgB5hmFY74WYB-EoWkhr9cAGr6TiTHrEE";
      connection.Translator = {
        TranslateText: function(text, callback) {
          var newScript = document.createElement("script");
          newScript.type = "text/javascript";
          var sourceText = encodeURIComponent(text);
          var randomNumber = "method" + connection.token();
          window[randomNumber] = function(response) {
            if (response.data && response.data.translations[0] && callback) {
              callback(response.data.translations[0].translatedText);
              return;
            }
            if (response.error && response.error.message === "Daily Limit Exceeded") {
              console.error('Text translation failed. Error message: "Daily Limit Exceeded."');
              return;
            }
            if (response.error) {
              console.error(response.error.message);
              return;
            }
            console.error(response);
          };
          var source = "https://www.googleapis.com/language/translate/v2?key=" + connection.googKey + "&target=" + (connection.language || "en-US") + "&callback=window." + randomNumber + "&q=" + sourceText;
          newScript.src = source;
          document.getElementsByTagName("head")[0].appendChild(newScript);
        },
        getListOfLanguages: function(callback) {
          var xhr = new XMLHttpRequest();
          xhr.onreadystatechange = function() {
            if (xhr.readyState == XMLHttpRequest.DONE) {
              var response = JSON.parse(xhr.responseText);
              if (response && response.data && response.data.languages) {
                callback(response.data.languages);
                return;
              }
              if (response.error && response.error.message === "Daily Limit Exceeded") {
                console.error('Text translation failed. Error message: "Daily Limit Exceeded."');
                return;
              }
              if (response.error) {
                console.error(response.error.message);
                return;
              }
              console.error(response);
            }
          };
          var url = "https://www.googleapis.com/language/translate/v2/languages?key=" + connection.googKey + "&target=en";
          xhr.open("GET", url, true);
          xhr.send(null);
        }
      };
    }
    return {
      handle
    };
  }();
  (function(connection) {
    forceOptions = forceOptions || {
      useDefaultDevices: true
    };
    connection.channel = connection.sessionid = (roomid || location.href.replace(/\/|:|#|\?|\$|\^|%|\.|`|~|!|\+|@|\[|\||]|\|*. /g, "").split("\n").join("").split("\r").join("")) + "";
    var mPeer = new MultiPeers(connection);
    var preventDuplicateOnStreamEvents = {};
    mPeer.onGettingLocalMedia = function(stream2, callback) {
      callback = callback || function() {
      };
      if (preventDuplicateOnStreamEvents[stream2.streamid]) {
        callback();
        return;
      }
      preventDuplicateOnStreamEvents[stream2.streamid] = true;
      try {
        stream2.type = "local";
      } catch (e) {
      }
      connection.setStreamEndHandler(stream2);
      getRMCMediaElement(stream2, function(mediaElement) {
        mediaElement.id = stream2.streamid;
        mediaElement.muted = true;
        mediaElement.volume = 0;
        if (connection.attachStreams.indexOf(stream2) === -1) {
          connection.attachStreams.push(stream2);
        }
        if (typeof StreamsHandler !== "undefined") {
          StreamsHandler.setHandlers(stream2, true, connection);
        }
        var isAudioMuted = stream2.getAudioTracks().filter(function(track) {
          return track.enabled;
        }).length === 0;
        connection.streamEvents[stream2.streamid] = {
          stream: stream2,
          type: "local",
          mediaElement,
          userid: connection.userid,
          extra: connection.extra,
          streamid: stream2.streamid,
          isAudioMuted
        };
        try {
          setHarkEvents(connection, connection.streamEvents[stream2.streamid]);
          setMuteHandlers(connection, connection.streamEvents[stream2.streamid]);
          connection.onstream(connection.streamEvents[stream2.streamid]);
        } catch (e) {
        }
        callback();
      }, connection);
    };
    mPeer.onGettingRemoteMedia = function(stream2, remoteUserId) {
      try {
        stream2.type = "remote";
      } catch (e) {
      }
      connection.setStreamEndHandler(stream2, "remote-stream");
      getRMCMediaElement(stream2, function(mediaElement) {
        mediaElement.id = stream2.streamid;
        if (typeof StreamsHandler !== "undefined") {
          StreamsHandler.setHandlers(stream2, false, connection);
        }
        connection.streamEvents[stream2.streamid] = {
          stream: stream2,
          type: "remote",
          userid: remoteUserId,
          extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {},
          mediaElement,
          streamid: stream2.streamid
        };
        setMuteHandlers(connection, connection.streamEvents[stream2.streamid]);
        connection.onstream(connection.streamEvents[stream2.streamid]);
      }, connection);
    };
    mPeer.onRemovingRemoteMedia = function(stream2, remoteUserId) {
      var streamEvent = connection.streamEvents[stream2.streamid];
      if (!streamEvent) {
        streamEvent = {
          stream: stream2,
          type: "remote",
          userid: remoteUserId,
          extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {},
          streamid: stream2.streamid,
          mediaElement: connection.streamEvents[stream2.streamid] ? connection.streamEvents[stream2.streamid].mediaElement : null
        };
      }
      if (connection.peersBackup[streamEvent.userid]) {
        streamEvent.extra = connection.peersBackup[streamEvent.userid].extra;
      }
      connection.onstreamended(streamEvent);
      delete connection.streamEvents[stream2.streamid];
    };
    mPeer.onNegotiationNeeded = function(message, remoteUserId, callback) {
      callback = callback || function() {
      };
      remoteUserId = remoteUserId || message.remoteUserId;
      message = message || "";
      var messageToDeliver = {
        remoteUserId,
        message,
        sender: connection.userid
      };
      if (message.remoteUserId && message.message && message.sender) {
        messageToDeliver = message;
      }
      connectSocket(function() {
        connection.socket.emit(connection.socketMessageEvent, messageToDeliver, callback);
      });
    };
    function onUserLeft(remoteUserId) {
      connection.deletePeer(remoteUserId);
    }
    mPeer.onUserLeft = onUserLeft;
    mPeer.disconnectWith = function(remoteUserId, callback) {
      if (connection.socket) {
        connection.socket.emit("disconnect-with", remoteUserId, callback || function() {
        });
      }
      connection.deletePeer(remoteUserId);
    };
    connection.socketOptions = {
      "transport": "polling"
    };
    function connectSocket(connectCallback) {
      connection.socketAutoReConnect = true;
      if (connection.socket) {
        if (connectCallback) {
          connectCallback(connection.socket);
        }
        return;
      }
      if (typeof SocketConnection === "undefined") {
        if (typeof FirebaseConnection !== "undefined") {
          window.SocketConnection = FirebaseConnection;
        } else if (typeof PubNubConnection !== "undefined") {
          window.SocketConnection = PubNubConnection;
        } else {
          throw "SocketConnection.js seems missed.";
        }
      }
      new SocketConnection(connection, function(s) {
        if (connectCallback) {
          connectCallback(connection.socket);
        }
      });
    }
    connection.openOrJoin = function(roomid2, callback) {
      callback = callback || function() {
      };
      connection.checkPresence(roomid2, function(isRoomExist, roomid3) {
        if (isRoomExist) {
          connection.sessionid = roomid3;
          var localPeerSdpConstraints = false;
          var remotePeerSdpConstraints = false;
          var isOneWay = !!connection.session.oneway;
          var isDataOnly = isData(connection.session);
          remotePeerSdpConstraints = {
            OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo
          };
          localPeerSdpConstraints = {
            OfferToReceiveAudio: isOneWay ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio,
            OfferToReceiveVideo: isOneWay ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo
          };
          var connectionDescription = {
            remoteUserId: connection.sessionid,
            message: {
              newParticipationRequest: true,
              isOneWay,
              isDataOnly,
              localPeerSdpConstraints,
              remotePeerSdpConstraints
            },
            sender: connection.userid
          };
          beforeJoin(connectionDescription.message, function() {
            joinRoom(connectionDescription, callback);
          });
          return;
        }
        connection.waitingForLocalMedia = true;
        connection.isInitiator = true;
        connection.sessionid = roomid3 || connection.sessionid;
        if (isData(connection.session)) {
          openRoom(callback);
          return;
        }
        connection.captureUserMedia(function() {
          openRoom(callback);
        });
      });
    };
    connection.waitingForLocalMedia = false;
    connection.open = function(roomid2, callback) {
      callback = callback || function() {
      };
      connection.waitingForLocalMedia = true;
      connection.isInitiator = true;
      connection.sessionid = roomid2 || connection.sessionid;
      connectSocket(function() {
        if (isData(connection.session)) {
          openRoom(callback);
          return;
        }
        connection.captureUserMedia(function() {
          openRoom(callback);
        });
      });
    };
    connection.peersBackup = {};
    connection.deletePeer = function(remoteUserId) {
      if (!remoteUserId || !connection.peers[remoteUserId]) {
        return;
      }
      var eventObject = {
        userid: remoteUserId,
        extra: connection.peers[remoteUserId] ? connection.peers[remoteUserId].extra : {}
      };
      if (connection.peersBackup[eventObject.userid]) {
        eventObject.extra = connection.peersBackup[eventObject.userid].extra;
      }
      connection.onleave(eventObject);
      if (!!connection.peers[remoteUserId]) {
        connection.peers[remoteUserId].streams.forEach(function(stream2) {
          stream2.stop();
        });
        var peer = connection.peers[remoteUserId].peer;
        if (peer && peer.iceConnectionState !== "closed") {
          try {
            peer.close();
          } catch (e) {
          }
        }
        if (connection.peers[remoteUserId]) {
          connection.peers[remoteUserId].peer = null;
          delete connection.peers[remoteUserId];
        }
      }
    };
    connection.rejoin = function(connectionDescription) {
      if (connection.isInitiator || !connectionDescription || !Object.keys(connectionDescription).length) {
        return;
      }
      var extra = {};
      if (connection.peers[connectionDescription.remoteUserId]) {
        extra = connection.peers[connectionDescription.remoteUserId].extra;
        connection.deletePeer(connectionDescription.remoteUserId);
      }
      if (connectionDescription && connectionDescription.remoteUserId) {
        connection.join(connectionDescription.remoteUserId);
        connection.onReConnecting({
          userid: connectionDescription.remoteUserId,
          extra
        });
      }
    };
    connection.join = function(remoteUserId, options) {
      connection.sessionid = (remoteUserId ? remoteUserId.sessionid || remoteUserId.remoteUserId || remoteUserId : false) || connection.sessionid;
      connection.sessionid += "";
      var localPeerSdpConstraints = false;
      var remotePeerSdpConstraints = false;
      var isOneWay = false;
      var isDataOnly = false;
      if (remoteUserId && remoteUserId.session || !remoteUserId || typeof remoteUserId === "string") {
        var session = remoteUserId ? remoteUserId.session || connection.session : connection.session;
        isOneWay = !!session.oneway;
        isDataOnly = isData(session);
        remotePeerSdpConstraints = {
          OfferToReceiveAudio: connection.sdpConstraints.mandatory.OfferToReceiveAudio,
          OfferToReceiveVideo: connection.sdpConstraints.mandatory.OfferToReceiveVideo
        };
        localPeerSdpConstraints = {
          OfferToReceiveAudio: isOneWay ? !!connection.session.audio : connection.sdpConstraints.mandatory.OfferToReceiveAudio,
          OfferToReceiveVideo: isOneWay ? !!connection.session.video || !!connection.session.screen : connection.sdpConstraints.mandatory.OfferToReceiveVideo
        };
      }
      options = options || {};
      var cb = function() {
      };
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      if (typeof options.localPeerSdpConstraints !== "undefined") {
        localPeerSdpConstraints = options.localPeerSdpConstraints;
      }
      if (typeof options.remotePeerSdpConstraints !== "undefined") {
        remotePeerSdpConstraints = options.remotePeerSdpConstraints;
      }
      if (typeof options.isOneWay !== "undefined") {
        isOneWay = options.isOneWay;
      }
      if (typeof options.isDataOnly !== "undefined") {
        isDataOnly = options.isDataOnly;
      }
      var connectionDescription = {
        remoteUserId: connection.sessionid,
        message: {
          newParticipationRequest: true,
          isOneWay,
          isDataOnly,
          localPeerSdpConstraints,
          remotePeerSdpConstraints
        },
        sender: connection.userid
      };
      beforeJoin(connectionDescription.message, function() {
        connectSocket(function() {
          joinRoom(connectionDescription, cb);
        });
      });
      return connectionDescription;
    };
    function joinRoom(connectionDescription, cb) {
      connection.socket.emit("join-room", {
        sessionid: connection.sessionid,
        session: connection.session,
        mediaConstraints: connection.mediaConstraints,
        sdpConstraints: connection.sdpConstraints,
        streams: getStreamInfoForAdmin(),
        extra: connection.extra,
        password: typeof connection.password !== "undefined" && typeof connection.password !== "object" ? connection.password : ""
      }, function(isRoomJoined, error2) {
        if (isRoomJoined === true) {
          if (connection.enableLogs) {
            console.log("isRoomJoined: ", isRoomJoined, " roomid: ", connection.sessionid);
          }
          if (!!connection.peers[connection.sessionid]) {
            return;
          }
          mPeer.onNegotiationNeeded(connectionDescription);
        }
        if (isRoomJoined === false) {
          if (connection.enableLogs) {
            console.warn("isRoomJoined: ", error2, " roomid: ", connection.sessionid);
          }
        }
        cb(isRoomJoined, connection.sessionid, error2);
      });
    }
    connection.publicRoomIdentifier = "";
    function openRoom(callback) {
      if (connection.enableLogs) {
        console.log("Sending open-room signal to socket.io");
      }
      connection.waitingForLocalMedia = false;
      connection.socket.emit("open-room", {
        sessionid: connection.sessionid,
        session: connection.session,
        mediaConstraints: connection.mediaConstraints,
        sdpConstraints: connection.sdpConstraints,
        streams: getStreamInfoForAdmin(),
        extra: connection.extra,
        identifier: connection.publicRoomIdentifier,
        password: typeof connection.password !== "undefined" && typeof connection.password !== "object" ? connection.password : ""
      }, function(isRoomOpened, error2) {
        if (isRoomOpened === true) {
          if (connection.enableLogs) {
            console.log("isRoomOpened: ", isRoomOpened, " roomid: ", connection.sessionid);
          }
          callback(isRoomOpened, connection.sessionid);
        }
        if (isRoomOpened === false) {
          if (connection.enableLogs) {
            console.warn("isRoomOpened: ", error2, " roomid: ", connection.sessionid);
          }
          callback(isRoomOpened, connection.sessionid, error2);
        }
      });
    }
    function getStreamInfoForAdmin() {
      try {
        return connection.streamEvents.selectAll("local").map(function(event2) {
          return {
            streamid: event2.streamid,
            tracks: event2.stream.getTracks().length
          };
        });
      } catch (e) {
        return [];
      }
    }
    function beforeJoin(userPreferences, callback) {
      if (connection.dontCaptureUserMedia || userPreferences.isDataOnly) {
        callback();
        return;
      }
      if (userPreferences.localPeerSdpConstraints.OfferToReceiveAudio) {
        connection.mediaConstraints.audio;
      }
      if (userPreferences.localPeerSdpConstraints.OfferToReceiveVideo) {
        connection.mediaConstraints.video;
      }
      var session = userPreferences.session || connection.session;
      if (session.oneway && session.audio !== "two-way" && session.video !== "two-way" && session.screen !== "two-way") {
        callback();
        return;
      }
      if (session.oneway && session.audio && session.audio === "two-way") {
        session = {
          audio: true
        };
      }
      if (session.audio || session.video || session.screen) {
        if (session.screen) {
          if (DetectRTC.browser.name === "Edge") {
            navigator.getDisplayMedia({
              video: true,
              audio: isAudioPlusTab(connection)
            }).then(function(screen2) {
              screen2.isScreen = true;
              mPeer.onGettingLocalMedia(screen2);
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                connection.invokeGetUserMedia(null, callback);
              } else {
                callback(screen2);
              }
            }, function(error2) {
              console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
            });
          } else {
            connection.invokeGetUserMedia({
              audio: isAudioPlusTab(connection),
              video: true,
              isScreen: true
            }, (session.audio || session.video) && !isAudioPlusTab(connection) ? connection.invokeGetUserMedia(null, callback) : callback);
          }
        } else if (session.audio || session.video) {
          connection.invokeGetUserMedia(null, callback, session);
        }
      }
    }
    connection.getUserMedia = connection.captureUserMedia = function(callback, sessionForced) {
      callback = callback || function() {
      };
      var session = sessionForced || connection.session;
      if (connection.dontCaptureUserMedia || isData(session)) {
        callback();
        return;
      }
      if (session.audio || session.video || session.screen) {
        if (session.screen) {
          if (DetectRTC.browser.name === "Edge") {
            navigator.getDisplayMedia({
              video: true,
              audio: isAudioPlusTab(connection)
            }).then(function(screen2) {
              screen2.isScreen = true;
              mPeer.onGettingLocalMedia(screen2);
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                var nonScreenSession = {};
                for (var s in session) {
                  if (s !== "screen") {
                    nonScreenSession[s] = session[s];
                  }
                }
                connection.invokeGetUserMedia(sessionForced, callback, nonScreenSession);
                return;
              }
              callback(screen2);
            }, function(error2) {
              console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
            });
          } else {
            connection.invokeGetUserMedia({
              audio: isAudioPlusTab(connection),
              video: true,
              isScreen: true
            }, function(stream2) {
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                var nonScreenSession = {};
                for (var s in session) {
                  if (s !== "screen") {
                    nonScreenSession[s] = session[s];
                  }
                }
                connection.invokeGetUserMedia(sessionForced, callback, nonScreenSession);
                return;
              }
              callback(stream2);
            });
          }
        } else if (session.audio || session.video) {
          connection.invokeGetUserMedia(sessionForced, callback, session);
        }
      }
    };
    connection.onbeforeunload = function(arg1, dontCloseSocket) {
      if (!connection.closeBeforeUnload) {
        return;
      }
      connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.onNegotiationNeeded({
          userLeft: true
        }, participant);
        if (connection.peers[participant] && connection.peers[participant].peer) {
          connection.peers[participant].peer.close();
        }
        delete connection.peers[participant];
      });
      if (!dontCloseSocket) {
        connection.closeSocket();
      }
      connection.isInitiator = false;
    };
    if (!window.ignoreBeforeUnload) {
      connection.closeBeforeUnload = true;
      window.addEventListener("beforeunload", connection.onbeforeunload, false);
    } else {
      connection.closeBeforeUnload = false;
    }
    connection.userid = getRandomString();
    connection.changeUserId = function(newUserId, callback) {
      callback = callback || function() {
      };
      connection.userid = newUserId || getRandomString();
      connection.socket.emit("changed-uuid", connection.userid, callback);
    };
    connection.extra = {};
    connection.attachStreams = [];
    connection.session = {
      audio: true,
      video: true
    };
    connection.enableFileSharing = false;
    connection.bandwidth = {
      screen: false,
      audio: false,
      video: false
    };
    connection.codecs = {
      audio: "opus",
      video: "VP9"
    };
    connection.processSdp = function(sdp) {
      if (isUnifiedPlanSupportedDefault()) {
        return sdp;
      }
      if (DetectRTC.browser.name === "Safari") {
        return sdp;
      }
      if (connection.codecs.video.toUpperCase() === "VP8") {
        sdp = CodecsHandler.preferCodec(sdp, "vp8");
      }
      if (connection.codecs.video.toUpperCase() === "VP9") {
        sdp = CodecsHandler.preferCodec(sdp, "vp9");
      }
      if (connection.codecs.video.toUpperCase() === "H264") {
        sdp = CodecsHandler.preferCodec(sdp, "h264");
      }
      if (connection.codecs.audio === "G722") {
        sdp = CodecsHandler.removeNonG722(sdp);
      }
      if (DetectRTC.browser.name === "Firefox") {
        return sdp;
      }
      if (connection.bandwidth.video || connection.bandwidth.screen) {
        sdp = CodecsHandler.setApplicationSpecificBandwidth(sdp, connection.bandwidth, !!connection.session.screen);
      }
      if (connection.bandwidth.video) {
        sdp = CodecsHandler.setVideoBitrates(sdp, {
          min: connection.bandwidth.video * 8 * 1024,
          max: connection.bandwidth.video * 8 * 1024
        });
      }
      if (connection.bandwidth.audio) {
        sdp = CodecsHandler.setOpusAttributes(sdp, {
          maxaveragebitrate: connection.bandwidth.audio * 8 * 1024,
          maxplaybackrate: connection.bandwidth.audio * 8 * 1024,
          stereo: 1,
          maxptime: 3
        });
      }
      return sdp;
    };
    if (typeof CodecsHandler !== "undefined") {
      connection.BandwidthHandler = connection.CodecsHandler = CodecsHandler;
    }
    connection.mediaConstraints = {
      audio: {
        mandatory: {},
        optional: connection.bandwidth.audio ? [{
          bandwidth: connection.bandwidth.audio * 8 * 1024 || 128 * 8 * 1024
        }] : []
      },
      video: {
        mandatory: {},
        optional: connection.bandwidth.video ? [{
          bandwidth: connection.bandwidth.video * 8 * 1024 || 128 * 8 * 1024
        }, {
          facingMode: "user"
        }] : [{
          facingMode: "user"
        }]
      }
    };
    if (DetectRTC.browser.name === "Firefox") {
      connection.mediaConstraints = {
        audio: true,
        video: true
      };
    }
    if (!forceOptions.useDefaultDevices && !DetectRTC.isMobileDevice) {
      DetectRTC.load(function() {
        var lastAudioDevice, lastVideoDevice;
        DetectRTC.MediaDevices.forEach(function(device) {
          if (device.kind === "audioinput" && connection.mediaConstraints.audio !== false) {
            lastAudioDevice = device;
          }
          if (device.kind === "videoinput" && connection.mediaConstraints.video !== false) {
            lastVideoDevice = device;
          }
        });
        if (lastAudioDevice) {
          if (DetectRTC.browser.name === "Firefox") {
            if (connection.mediaConstraints.audio !== true) {
              connection.mediaConstraints.audio.deviceId = lastAudioDevice.id;
            } else {
              connection.mediaConstraints.audio = {
                deviceId: lastAudioDevice.id
              };
            }
            return;
          }
          if (connection.mediaConstraints.audio == true) {
            connection.mediaConstraints.audio = {
              mandatory: {},
              optional: []
            };
          }
          if (!connection.mediaConstraints.audio.optional) {
            connection.mediaConstraints.audio.optional = [];
          }
          var optional = [{
            sourceId: lastAudioDevice.id
          }];
          connection.mediaConstraints.audio.optional = optional.concat(connection.mediaConstraints.audio.optional);
        }
        if (lastVideoDevice) {
          if (DetectRTC.browser.name === "Firefox") {
            if (connection.mediaConstraints.video !== true) {
              connection.mediaConstraints.video.deviceId = lastVideoDevice.id;
            } else {
              connection.mediaConstraints.video = {
                deviceId: lastVideoDevice.id
              };
            }
            return;
          }
          if (connection.mediaConstraints.video == true) {
            connection.mediaConstraints.video = {
              mandatory: {},
              optional: []
            };
          }
          if (!connection.mediaConstraints.video.optional) {
            connection.mediaConstraints.video.optional = [];
          }
          var optional = [{
            sourceId: lastVideoDevice.id
          }];
          connection.mediaConstraints.video.optional = optional.concat(connection.mediaConstraints.video.optional);
        }
      });
    }
    connection.sdpConstraints = {
      mandatory: {
        OfferToReceiveAudio: true,
        OfferToReceiveVideo: true
      },
      optional: [{
        VoiceActivityDetection: false
      }]
    };
    connection.sdpSemantics = null;
    connection.iceCandidatePoolSize = null;
    connection.bundlePolicy = null;
    connection.rtcpMuxPolicy = null;
    connection.iceTransportPolicy = null;
    connection.optionalArgument = {
      optional: [{
        DtlsSrtpKeyAgreement: true
      }, {
        googImprovedWifiBwe: true
      }, {
        googScreencastMinBitrate: 300
      }, {
        googIPv6: true
      }, {
        googDscp: true
      }, {
        googCpuUnderuseThreshold: 55
      }, {
        googCpuOveruseThreshold: 85
      }, {
        googSuspendBelowMinBitrate: true
      }, {
        googCpuOveruseDetection: true
      }],
      mandatory: {}
    };
    connection.iceServers = IceServersHandler.getIceServers(connection);
    connection.candidates = {
      host: true,
      stun: true,
      turn: true
    };
    connection.iceProtocols = {
      tcp: true,
      udp: true
    };
    connection.onopen = function(event2) {
      if (!!connection.enableLogs) {
        console.info("Data connection has been opened between you & ", event2.userid);
      }
    };
    connection.onclose = function(event2) {
      if (!!connection.enableLogs) {
        console.warn("Data connection has been closed between you & ", event2.userid);
      }
    };
    connection.onerror = function(error2) {
      if (!!connection.enableLogs) {
        console.error(error2.userid, "data-error", error2);
      }
    };
    connection.onmessage = function(event2) {
      if (!!connection.enableLogs) {
        console.debug("data-message", event2.userid, event2.data);
      }
    };
    connection.send = function(data, remoteUserId) {
      connection.peers.send(data, remoteUserId);
    };
    connection.close = connection.disconnect = connection.leave = function() {
      connection.onbeforeunload(false, true);
    };
    connection.closeEntireSession = function(callback) {
      callback = callback || function() {
      };
      connection.socket.emit("close-entire-session", function looper() {
        if (connection.getAllParticipants().length) {
          setTimeout(looper, 100);
          return;
        }
        connection.onEntireSessionClosed({
          sessionid: connection.sessionid,
          userid: connection.userid,
          extra: connection.extra
        });
        connection.changeUserId(null, function() {
          connection.close();
          callback();
        });
      });
    };
    connection.onEntireSessionClosed = function(event2) {
      if (!connection.enableLogs)
        return;
      console.info("Entire session is closed: ", event2.sessionid, event2.extra);
    };
    connection.onstream = function(e) {
      var parentNode = connection.videosContainer;
      parentNode.insertBefore(e.mediaElement, parentNode.firstChild);
      var played = e.mediaElement.play();
      if (typeof played !== "undefined") {
        played.catch(function() {
        }).then(function() {
          setTimeout(function() {
            e.mediaElement.play();
          }, 2e3);
        });
        return;
      }
      setTimeout(function() {
        e.mediaElement.play();
      }, 2e3);
    };
    connection.onstreamended = function(e) {
      if (!e.mediaElement) {
        e.mediaElement = document.getElementById(e.streamid);
      }
      if (!e.mediaElement || !e.mediaElement.parentNode) {
        return;
      }
      e.mediaElement.parentNode.removeChild(e.mediaElement);
    };
    connection.direction = "many-to-many";
    connection.removeStream = function(streamid, remoteUserId) {
      var stream2;
      var streamIdx;
      connection.attachStreams.forEach(function(localStream, idx) {
        if (localStream.id === streamid) {
          stream2 = localStream;
          streamIdx = idx;
        }
      });
      if (!stream2) {
        console.warn("No such stream exist.", streamid);
        return;
      }
      connection.peers.getAllParticipants().forEach(function(participant) {
        if (remoteUserId && participant !== remoteUserId) {
          return;
        }
        var user = connection.peers[participant];
        try {
          user.peer.removeStream(stream2);
        } catch (e) {
        }
      });
      if (streamIdx !== -1) {
        delete connection.attachStreams[streamIdx];
        console.log("Stream removed from attachStreams", connection.attachStreams);
      }
      connection.renegotiate();
    };
    connection.addStream = function(session, remoteUserId) {
      if (!!session.getTracks) {
        if (connection.attachStreams.indexOf(session) === -1) {
          if (!session.streamid) {
            session.streamid = session.id;
          }
          connection.attachStreams.push(session);
        }
        connection.renegotiate(remoteUserId);
        return;
      }
      if (isData(session)) {
        connection.renegotiate(remoteUserId);
        return;
      }
      if (session.audio || session.video || session.screen) {
        if (session.screen) {
          if (DetectRTC.browser.name === "Edge") {
            navigator.getDisplayMedia({
              video: true,
              audio: isAudioPlusTab(connection)
            }).then(function(screen2) {
              screen2.isScreen = true;
              mPeer.onGettingLocalMedia(screen2);
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                connection.invokeGetUserMedia(null, function(stream2) {
                  gumCallback(stream2);
                });
              } else {
                gumCallback(screen2);
              }
            }, function(error2) {
              console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
            });
          } else {
            connection.invokeGetUserMedia({
              audio: isAudioPlusTab(connection),
              video: true,
              isScreen: true
            }, function(stream2) {
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                connection.invokeGetUserMedia(null, function(stream3) {
                  gumCallback(stream3);
                });
              } else {
                gumCallback(stream2);
              }
            });
          }
        } else if (session.audio || session.video) {
          connection.invokeGetUserMedia(null, gumCallback);
        }
      }
      function gumCallback(stream2) {
        if (session.streamCallback) {
          session.streamCallback(stream2);
        }
        connection.renegotiate(remoteUserId);
      }
    };
    connection.invokeGetUserMedia = function(localMediaConstraints, callback, session) {
      if (!session) {
        session = connection.session;
      }
      if (!localMediaConstraints) {
        localMediaConstraints = connection.mediaConstraints;
      }
      getUserMediaHandler({
        onGettingLocalMedia: function(stream2) {
          var videoConstraints = localMediaConstraints.video;
          if (videoConstraints) {
            if (videoConstraints.mediaSource || videoConstraints.mozMediaSource) {
              stream2.isScreen = true;
            } else if (videoConstraints.mandatory && videoConstraints.mandatory.chromeMediaSource) {
              stream2.isScreen = true;
            }
          }
          if (!stream2.isScreen) {
            stream2.isVideo = !!getTracks(stream2, "video").length;
            stream2.isAudio = !stream2.isVideo && getTracks(stream2, "audio").length;
          }
          mPeer.onGettingLocalMedia(stream2, function() {
            if (typeof callback === "function") {
              callback(stream2);
            }
          });
        },
        onLocalMediaError: function(error2, constraints) {
          mPeer.onLocalMediaError(error2, constraints);
        },
        localMediaConstraints: localMediaConstraints || {
          audio: session.audio ? localMediaConstraints.audio : false,
          video: session.video ? localMediaConstraints.video : false
        }
      });
    };
    function applyConstraints(stream2, mediaConstraints) {
      if (!stream2) {
        if (!!connection.enableLogs) {
          console.error("No stream to applyConstraints.");
        }
        return;
      }
      if (mediaConstraints.audio) {
        getTracks(stream2, "audio").forEach(function(track) {
          track.applyConstraints(mediaConstraints.audio);
        });
      }
      if (mediaConstraints.video) {
        getTracks(stream2, "video").forEach(function(track) {
          track.applyConstraints(mediaConstraints.video);
        });
      }
    }
    connection.applyConstraints = function(mediaConstraints, streamid) {
      if (!MediaStreamTrack || !MediaStreamTrack.prototype.applyConstraints) {
        alert("track.applyConstraints is NOT supported in your browser.");
        return;
      }
      if (streamid) {
        var stream2;
        if (connection.streamEvents[streamid]) {
          stream2 = connection.streamEvents[streamid].stream;
        }
        applyConstraints(stream2, mediaConstraints);
        return;
      }
      connection.attachStreams.forEach(function(stream3) {
        applyConstraints(stream3, mediaConstraints);
      });
    };
    function replaceTrack(track, remoteUserId, isVideoTrack, oldTrack) {
      if (remoteUserId) {
        mPeer.replaceTrack(track, remoteUserId, isVideoTrack, oldTrack);
        return;
      }
      connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.replaceTrack(track, participant, isVideoTrack, oldTrack);
      });
    }
    connection.replaceTrack = function(session, remoteUserId, isVideoTrack, oldTrack) {
      session = session || {};
      if (!RTCPeerConnection.prototype.getSenders) {
        connection.addStream(session);
        return;
      }
      if (session instanceof MediaStreamTrack) {
        replaceTrack(session, remoteUserId, isVideoTrack, oldTrack);
        return;
      }
      if (session instanceof MediaStream) {
        if (getTracks(session, "video").length) {
          replaceTrack(getTracks(session, "video")[0], remoteUserId, true, oldTrack);
        }
        if (getTracks(session, "audio").length) {
          replaceTrack(getTracks(session, "audio")[0], remoteUserId, false, oldTrack);
        }
        return;
      }
      if (isData(session)) {
        throw "connection.replaceTrack requires audio and/or video and/or screen.";
      }
      if (session.audio || session.video || session.screen) {
        if (session.screen) {
          if (DetectRTC.browser.name === "Edge") {
            navigator.getDisplayMedia({
              video: true,
              audio: isAudioPlusTab(connection)
            }).then(function(screen2) {
              screen2.isScreen = true;
              mPeer.onGettingLocalMedia(screen2);
              if ((session.audio || session.video) && !isAudioPlusTab(connection)) {
                connection.invokeGetUserMedia(null, gumCallback);
              } else {
                gumCallback(screen2);
              }
            }, function(error2) {
              console.error("Unable to capture screen on Edge. HTTPs and version 17+ is required.");
            });
          } else {
            connection.invokeGetUserMedia({
              audio: isAudioPlusTab(connection),
              video: true,
              isScreen: true
            }, (session.audio || session.video) && !isAudioPlusTab(connection) ? connection.invokeGetUserMedia(null, gumCallback) : gumCallback);
          }
        } else if (session.audio || session.video) {
          connection.invokeGetUserMedia(null, gumCallback);
        }
      }
      function gumCallback(stream2) {
        connection.replaceTrack(stream2, remoteUserId, isVideoTrack || session.video || session.screen, oldTrack);
      }
    };
    connection.resetTrack = function(remoteUsersIds, isVideoTrack) {
      if (!remoteUsersIds) {
        remoteUsersIds = connection.getAllParticipants();
      }
      if (typeof remoteUsersIds == "string") {
        remoteUsersIds = [remoteUsersIds];
      }
      remoteUsersIds.forEach(function(participant) {
        var peer = connection.peers[participant].peer;
        if ((typeof isVideoTrack === "undefined" || isVideoTrack === true) && peer.lastVideoTrack) {
          connection.replaceTrack(peer.lastVideoTrack, participant, true);
        }
        if ((typeof isVideoTrack === "undefined" || isVideoTrack === false) && peer.lastAudioTrack) {
          connection.replaceTrack(peer.lastAudioTrack, participant, false);
        }
      });
    };
    connection.renegotiate = function(remoteUserId) {
      if (remoteUserId) {
        mPeer.renegotiatePeer(remoteUserId);
        return;
      }
      connection.peers.getAllParticipants().forEach(function(participant) {
        mPeer.renegotiatePeer(participant);
      });
    };
    connection.setStreamEndHandler = function(stream2, isRemote) {
      if (!stream2 || !stream2.addEventListener)
        return;
      isRemote = !!isRemote;
      if (stream2.alreadySetEndHandler) {
        return;
      }
      stream2.alreadySetEndHandler = true;
      var streamEndedEvent = "ended";
      if ("oninactive" in stream2) {
        streamEndedEvent = "inactive";
      }
      stream2.addEventListener(streamEndedEvent, function() {
        if (stream2.idInstance) {
          currentUserMediaRequest.remove(stream2.idInstance);
        }
        if (!isRemote) {
          var streams = [];
          connection.attachStreams.forEach(function(s) {
            if (s.id != stream2.id) {
              streams.push(s);
            }
          });
          connection.attachStreams = streams;
        }
        var streamEvent = connection.streamEvents[stream2.streamid];
        if (!streamEvent) {
          streamEvent = {
            stream: stream2,
            streamid: stream2.streamid,
            type: isRemote ? "remote" : "local",
            userid: connection.userid,
            extra: connection.extra,
            mediaElement: connection.streamEvents[stream2.streamid] ? connection.streamEvents[stream2.streamid].mediaElement : null
          };
        }
        if (isRemote && connection.peers[streamEvent.userid]) {
          var peer = connection.peers[streamEvent.userid].peer;
          var streams = [];
          peer.getRemoteStreams().forEach(function(s) {
            if (s.id != stream2.id) {
              streams.push(s);
            }
          });
          connection.peers[streamEvent.userid].streams = streams;
        }
        if (streamEvent.userid === connection.userid && streamEvent.type === "remote") {
          return;
        }
        if (connection.peersBackup[streamEvent.userid]) {
          streamEvent.extra = connection.peersBackup[streamEvent.userid].extra;
        }
        connection.onstreamended(streamEvent);
        delete connection.streamEvents[stream2.streamid];
      }, false);
    };
    connection.onMediaError = function(error2, constraints) {
      if (!!connection.enableLogs) {
        console.error(error2, constraints);
      }
    };
    connection.autoCloseEntireSession = false;
    connection.filesContainer = connection.videosContainer = document.body || document.documentElement;
    connection.isInitiator = false;
    connection.shareFile = mPeer.shareFile;
    if (typeof FileProgressBarHandler !== "undefined") {
      FileProgressBarHandler.handle(connection);
    }
    if (typeof TranslationHandler !== "undefined") {
      TranslationHandler.handle(connection);
    }
    connection.token = getRandomString;
    connection.onNewParticipant = function(participantId, userPreferences) {
      connection.acceptParticipationRequest(participantId, userPreferences);
    };
    connection.acceptParticipationRequest = function(participantId, userPreferences) {
      if (userPreferences.successCallback) {
        userPreferences.successCallback();
        delete userPreferences.successCallback;
      }
      mPeer.createNewPeer(participantId, userPreferences);
    };
    if (typeof StreamsHandler !== "undefined") {
      connection.StreamsHandler = StreamsHandler;
    }
    connection.onleave = function(userid) {
    };
    connection.invokeSelectFileDialog = function(callback) {
      var selector = new FileSelector();
      selector.accept = "*.*";
      selector.selectSingleFile(callback);
    };
    connection.onmute = function(e) {
      if (!e || !e.mediaElement) {
        return;
      }
      if (e.muteType === "both" || e.muteType === "video") {
        e.mediaElement.src = null;
        var paused = e.mediaElement.pause();
        if (typeof paused !== "undefined") {
          paused.then(function() {
            e.mediaElement.poster = e.snapshot || "https://cdn.webrtc-experiment.com/images/muted.png";
          });
        } else {
          e.mediaElement.poster = e.snapshot || "https://cdn.webrtc-experiment.com/images/muted.png";
        }
      } else if (e.muteType === "audio") {
        e.mediaElement.muted = true;
      }
    };
    connection.onunmute = function(e) {
      if (!e || !e.mediaElement || !e.stream) {
        return;
      }
      if (e.unmuteType === "both" || e.unmuteType === "video") {
        e.mediaElement.poster = null;
        e.mediaElement.srcObject = e.stream;
        e.mediaElement.play();
      } else if (e.unmuteType === "audio") {
        e.mediaElement.muted = false;
      }
    };
    connection.onExtraDataUpdated = function(event2) {
      event2.status = "online";
      connection.onUserStatusChanged(event2, true);
    };
    connection.getAllParticipants = function(sender) {
      return connection.peers.getAllParticipants(sender);
    };
    if (typeof StreamsHandler !== "undefined") {
      StreamsHandler.onSyncNeeded = function(streamid, action, type) {
        connection.peers.getAllParticipants().forEach(function(participant) {
          mPeer.onNegotiationNeeded({
            streamid,
            action,
            streamSyncNeeded: true,
            type: type || "both"
          }, participant);
        });
      };
    }
    connection.connectSocket = function(callback) {
      connectSocket(callback);
    };
    connection.closeSocket = function() {
      try {
        io.sockets = {};
      } catch (e) {
      }
      if (!connection.socket)
        return;
      if (typeof connection.socket.disconnect === "function") {
        connection.socket.disconnect();
      }
      if (typeof connection.socket.resetProps === "function") {
        connection.socket.resetProps();
      }
      connection.socket = null;
    };
    connection.getSocket = function(callback) {
      if (!callback && connection.enableLogs) {
        console.warn("getSocket.callback paramter is required.");
      }
      callback = callback || function() {
      };
      if (!connection.socket) {
        connectSocket(function() {
          callback(connection.socket);
        });
      } else {
        callback(connection.socket);
      }
      return connection.socket;
    };
    connection.getRemoteStreams = mPeer.getRemoteStreams;
    var skipStreams = ["selectFirst", "selectAll", "forEach"];
    connection.streamEvents = {
      selectFirst: function(options) {
        return connection.streamEvents.selectAll(options)[0];
      },
      selectAll: function(options) {
        if (!options) {
          options = {
            local: true,
            remote: true,
            isScreen: true,
            isAudio: true,
            isVideo: true
          };
        }
        if (options == "local") {
          options = {
            local: true
          };
        }
        if (options == "remote") {
          options = {
            remote: true
          };
        }
        if (options == "screen") {
          options = {
            isScreen: true
          };
        }
        if (options == "audio") {
          options = {
            isAudio: true
          };
        }
        if (options == "video") {
          options = {
            isVideo: true
          };
        }
        var streams = [];
        Object.keys(connection.streamEvents).forEach(function(key) {
          var event2 = connection.streamEvents[key];
          if (skipStreams.indexOf(key) !== -1)
            return;
          var ignore = true;
          if (options.local && event2.type === "local") {
            ignore = false;
          }
          if (options.remote && event2.type === "remote") {
            ignore = false;
          }
          if (options.isScreen && event2.stream.isScreen) {
            ignore = false;
          }
          if (options.isVideo && event2.stream.isVideo) {
            ignore = false;
          }
          if (options.isAudio && event2.stream.isAudio) {
            ignore = false;
          }
          if (options.userid && event2.userid === options.userid) {
            ignore = false;
          }
          if (ignore === false) {
            streams.push(event2);
          }
        });
        return streams;
      }
    };
    connection.socketURL = "/";
    connection.socketMessageEvent = "RTCMultiConnection-Message";
    connection.socketCustomEvent = "RTCMultiConnection-Custom-Message";
    connection.DetectRTC = DetectRTC;
    connection.setCustomSocketEvent = function(customEvent) {
      if (customEvent) {
        connection.socketCustomEvent = customEvent;
      }
      if (!connection.socket) {
        return;
      }
      connection.socket.emit("set-custom-socket-event-listener", connection.socketCustomEvent);
    };
    connection.getNumberOfBroadcastViewers = function(broadcastId, callback) {
      if (!connection.socket || !broadcastId || !callback)
        return;
      connection.socket.emit("get-number-of-users-in-specific-broadcast", broadcastId, callback);
    };
    connection.onNumberOfBroadcastViewersUpdated = function(event2) {
      if (!connection.enableLogs || !connection.isInitiator)
        return;
      console.info("Number of broadcast (", event2.broadcastId, ") viewers", event2.numberOfBroadcastViewers);
    };
    connection.onUserStatusChanged = function(event2, dontWriteLogs) {
      if (!!connection.enableLogs && !dontWriteLogs) {
        console.info(event2.userid, event2.status);
      }
    };
    connection.getUserMediaHandler = getUserMediaHandler;
    connection.multiPeersHandler = mPeer;
    connection.enableLogs = true;
    connection.setCustomSocketHandler = function(customSocketHandler) {
      if (typeof SocketConnection !== "undefined") {
        SocketConnection = customSocketHandler;
      }
    };
    connection.chunkSize = 40 * 1e3;
    connection.maxParticipantsAllowed = 1e3;
    connection.disconnectWith = mPeer.disconnectWith;
    connection.checkPresence = function(roomid2, callback) {
      roomid2 = roomid2 || connection.sessionid;
      if (SocketConnection.name === "SSEConnection") {
        SSEConnection.checkPresence(roomid2, function(isRoomExist, _roomid, extra) {
          if (!connection.socket) {
            if (!isRoomExist) {
              connection.userid = _roomid;
            }
            connection.connectSocket(function() {
              callback(isRoomExist, _roomid, extra);
            });
            return;
          }
          callback(isRoomExist, _roomid);
        });
        return;
      }
      if (!connection.socket) {
        connection.connectSocket(function() {
          connection.checkPresence(roomid2, callback);
        });
        return;
      }
      connection.socket.emit("check-presence", roomid2 + "", function(isRoomExist, _roomid, extra) {
        if (connection.enableLogs) {
          console.log("checkPresence.isRoomExist: ", isRoomExist, " roomid: ", _roomid);
        }
        callback(isRoomExist, _roomid, extra);
      });
    };
    connection.onReadyForOffer = function(remoteUserId, userPreferences) {
      connection.multiPeersHandler.createNewPeer(remoteUserId, userPreferences);
    };
    connection.setUserPreferences = function(userPreferences) {
      if (connection.dontAttachStream) {
        userPreferences.dontAttachLocalStream = true;
      }
      if (connection.dontGetRemoteStream) {
        userPreferences.dontGetRemoteStream = true;
      }
      return userPreferences;
    };
    connection.updateExtraData = function() {
      connection.socket.emit("extra-data-updated", connection.extra);
    };
    connection.enableScalableBroadcast = false;
    connection.maxRelayLimitPerUser = 3;
    connection.dontCaptureUserMedia = false;
    connection.dontAttachStream = false;
    connection.dontGetRemoteStream = false;
    connection.onReConnecting = function(event2) {
      if (connection.enableLogs) {
        console.info("ReConnecting with", event2.userid, "...");
      }
    };
    connection.beforeAddingStream = function(stream2) {
      return stream2;
    };
    connection.beforeRemovingStream = function(stream2) {
      return stream2;
    };
    if (typeof isChromeExtensionAvailable !== "undefined") {
      connection.checkIfChromeExtensionAvailable = isChromeExtensionAvailable;
    }
    if (typeof isFirefoxExtensionAvailable !== "undefined") {
      connection.checkIfChromeExtensionAvailable = isFirefoxExtensionAvailable;
    }
    if (typeof getChromeExtensionStatus !== "undefined") {
      connection.getChromeExtensionStatus = getChromeExtensionStatus;
    }
    connection.modifyScreenConstraints = function(screen_constraints) {
      return screen_constraints;
    };
    connection.onPeerStateChanged = function(state) {
      if (connection.enableLogs) {
        if (state.iceConnectionState.search(/closed|failed/gi) !== -1) {
          console.error("Peer connection is closed between you & ", state.userid, state.extra, "state:", state.iceConnectionState);
        }
      }
    };
    connection.isOnline = true;
    listenEventHandler("online", function() {
      connection.isOnline = true;
    });
    listenEventHandler("offline", function() {
      connection.isOnline = false;
    });
    connection.isLowBandwidth = false;
    if (navigator && navigator.connection && navigator.connection.type) {
      connection.isLowBandwidth = navigator.connection.type.toString().toLowerCase().search(/wifi|cell/g) !== -1;
      if (connection.isLowBandwidth) {
        connection.bandwidth = {
          audio: false,
          video: false,
          screen: false
        };
        if (connection.mediaConstraints.audio && connection.mediaConstraints.audio.optional && connection.mediaConstraints.audio.optional.length) {
          var newArray = [];
          connection.mediaConstraints.audio.optional.forEach(function(opt) {
            if (typeof opt.bandwidth === "undefined") {
              newArray.push(opt);
            }
          });
          connection.mediaConstraints.audio.optional = newArray;
        }
        if (connection.mediaConstraints.video && connection.mediaConstraints.video.optional && connection.mediaConstraints.video.optional.length) {
          var newArray = [];
          connection.mediaConstraints.video.optional.forEach(function(opt) {
            if (typeof opt.bandwidth === "undefined") {
              newArray.push(opt);
            }
          });
          connection.mediaConstraints.video.optional = newArray;
        }
      }
    }
    connection.getExtraData = function(remoteUserId, callback) {
      if (!remoteUserId)
        throw "remoteUserId is required.";
      if (typeof callback === "function") {
        connection.socket.emit("get-remote-user-extra-data", remoteUserId, function(extra, remoteUserId2, error2) {
          callback(extra, remoteUserId2, error2);
        });
        return;
      }
      if (!connection.peers[remoteUserId]) {
        if (connection.peersBackup[remoteUserId]) {
          return connection.peersBackup[remoteUserId].extra;
        }
        return {};
      }
      return connection.peers[remoteUserId].extra;
    };
    if (!!forceOptions.autoOpenOrJoin) {
      connection.openOrJoin(connection.sessionid);
    }
    connection.onUserIdAlreadyTaken = function(useridAlreadyTaken, yourNewUserId) {
      connection.close();
      connection.closeSocket();
      connection.isInitiator = false;
      connection.userid = connection.token();
      connection.join(connection.sessionid);
      if (connection.enableLogs) {
        console.warn("Userid already taken.", useridAlreadyTaken, "Your new userid:", connection.userid);
      }
    };
    connection.trickleIce = true;
    connection.version = "3.7.0";
    connection.onSettingLocalDescription = function(event2) {
      if (connection.enableLogs) {
        console.info("Set local description for remote user", event2.userid);
      }
    };
    connection.resetScreen = function() {
      sourceId = null;
      if (DetectRTC && DetectRTC.screen) {
        delete DetectRTC.screen.sourceId;
      }
      currentUserMediaRequest = {
        streams: [],
        mutex: false,
        queueRequests: []
      };
    };
    connection.autoCreateMediaElement = true;
    connection.password = null;
    connection.setPassword = function(password, callback) {
      callback = callback || function() {
      };
      if (connection.socket) {
        connection.socket.emit("set-password", password, callback);
      } else {
        connection.password = password;
        callback(true, connection.sessionid, null);
      }
    };
    connection.onSocketDisconnect = function(event2) {
      if (connection.enableLogs) {
        console.warn("socket.io connection is closed");
      }
    };
    connection.onSocketError = function(event2) {
      if (connection.enableLogs) {
        console.warn("socket.io connection is failed");
      }
    };
    connection.errors = {
      ROOM_NOT_AVAILABLE: "Room not available",
      INVALID_PASSWORD: "Invalid password",
      USERID_NOT_AVAILABLE: "User ID does not exist",
      ROOM_PERMISSION_DENIED: "Room permission denied",
      ROOM_FULL: "Room full",
      DID_NOT_JOIN_ANY_ROOM: "Did not join any room yet",
      INVALID_SOCKET: "Invalid socket",
      PUBLIC_IDENTIFIER_MISSING: "publicRoomIdentifier is required",
      INVALID_ADMIN_CREDENTIAL: "Invalid username or password attempted"
    };
  })(this);
};
if (typeof module !== "undefined") {
  module.exports = exports = RTCMultiConnection;
}
if (typeof define === "function" && define.amd) {
  define("RTCMultiConnection", [], function() {
    return RTCMultiConnection;
  });
}
let ebml = document.createElement("script");
ebml.setAttribute("src", "/js/EBML.js");
document.head.appendChild(ebml);
window.io = lookup;
window.hark = hark$1;
function rtcRtcmc() {
  const SIGNAL_URL = window.atob("aHR0cHM6Ly9zaWduYWx2Mi5rb2RlbWludC5pbjo5MDAyLw==");
  let rtcmc = null, roomJoined = false, localStreamMidMap = {};
  let config = {
    debug: false,
    iceServers: [],
    mediaServers: [],
    signalServer: SIGNAL_URL,
    opaqueId: "KMConnect",
    maxParticipants: 1e3
  };
  let callbacks = {};
  let meeting = {};
  let meetingConfigs = {};
  let meetingRules = {};
  let alreadyAcceptedParticipants = {};
  let connectedWith = {};
  let newParticipantsList = [];
  const logger = new Logger();
  let speechEvents = null;
  logger.log("RTC Library RTCMC Loaded!");
  async function init(opts = {}) {
    if (!opts.config) {
      throw "RTC Library config not defined!";
    }
    config = Object.assign(config, opts.config);
    if (opts.callbacks) {
      callbacks = Object.assign(callbacks, opts.callbacks);
    }
    logger.setDebug(config.debug);
    logger.log("RTCMC - init called", opts);
    if (!rtcmc && opts.options) {
      const options = { ...opts.options };
      initSession(options);
    }
    return {
      getInstance,
      getUserInfo,
      getInstanceUserId,
      initSession,
      setupFileSharing,
      startMeeting,
      joinMeeting,
      leaveMeeting,
      publishFeed,
      updatePublishedFeed,
      sendMessage,
      acceptJoiningRequest,
      roomExists,
      close,
      shareFile,
      getAllStreams,
      updateSessionOptions
    };
  }
  function getInstance() {
    return rtcmc;
  }
  function getUserInfo() {
    var _a;
    return (_a = rtcmc.extra) == null ? void 0 : _a.user;
  }
  function getInstanceUserId() {
    return rtcmc.userid;
  }
  function initSession(opts = {}) {
    const options = processOptions(opts);
    logger.log("RTCMC - initSession called", options);
    createSession(options);
  }
  function setupFileSharing(opts = {}) {
    if (opts.callbacks) {
      callbacks = Object.assign(callbacks, opts.callbacks);
    }
    rtcmc.enableFileSharing = true;
    rtcmc.chunkSize = 15 * 1e3;
    rtcmc.onFileStart = rtcmOnFileStart;
    rtcmc.onFileProgress = rtcmOnFileProgress;
    rtcmc.onFileEnd = rtcmOnFileEnd;
  }
  function startMeeting(opts = {}) {
    const options = processOptions(opts);
    logger.log("RTCMC - startMeeting called", options);
    const startMeetingProcess = () => {
      if (rtcmc.enableScalableBroadcast) {
        rtcmc.userid = options.room;
        rtcmc.connectSocket((socket) => {
          logger.log("RTCMC - startMeeting socket join-broadcast");
          socket.emit("join-broadcast", {
            broadcastId: options.room,
            userid: rtcmc.userid,
            typeOfStreams: rtcmc.session
          });
        });
      } else {
        logger.log("RTCMC - startMeeting createRoom");
        createRoom(options);
      }
    };
    if (!rtcmc) {
      options.success = () => {
        startMeetingProcess();
      };
      createSession(options);
    } else {
      startMeetingProcess();
    }
  }
  function joinMeeting(opts = {}) {
    const options = processOptions(opts);
    logger.log("RTCMC - joinMeeting called", options);
    const joinMeetingProcess = () => {
      if (rtcmc.enableScalableBroadcast) {
        rtcmc.connectSocket((socket) => {
          socket.emit("join-broadcast", {
            broadcastId: options.room,
            userid: rtcmc.userid,
            typeOfStreams: rtcmc.session
          });
        });
      } else {
        joinRoom(options);
      }
    };
    if (!rtcmc) {
      options.success = () => {
        joinMeetingProcess();
      };
      createSession(options);
    } else {
      joinMeetingProcess();
    }
  }
  function leaveMeeting(opts = {}) {
    logger.log("RTCMC - leaveMeeting called", opts);
    rtcmc.userid;
    close({
      ...opts,
      callback: () => {
        eventCallback("leftMeeting");
      }
    });
  }
  function sendMessage({ event: event2, type, data = {}, timeout = 0, callback }) {
    if (!rtcmc) {
      return;
    }
    if (event2 && rtcmc.socket) {
      try {
        window.setTimeout(() => {
          rtcmc.socket.emit("Connect-Whisper-" + meeting.uuid, {
            event: event2,
            data: {
              userId: rtcmc.userid,
              extra: rtcmc.extra,
              ...data
            }
          });
          if (callback && _.isFunction(callback)) {
            callback();
          }
        }, timeout);
      } catch (e) {
      }
      return;
    }
    try {
      window.setTimeout(() => {
        rtcmc.send({
          type,
          data
        });
        if (callback && _.isFunction(callback)) {
          callback();
        }
      }, timeout);
    } catch (e) {
    }
  }
  function acceptJoiningRequest({ participantId, userId, userPreferences }) {
    rtcmc.acceptParticipationRequest(participantId, userPreferences);
    alreadyAcceptedParticipants[userId] = true;
    checkNumberOfParticipants();
    logger.log("RTCMC - On rtcmOnNewParticipant - manually accepted!");
    eventCallback("participantJoined", {
      participantId,
      userId,
      userPreferences
    });
  }
  function updateSessionOptions(opts = {}) {
    var _a, _b;
    logger.log("RTCMC - updateSessionOptions called", opts);
    const options = processOptions(opts);
    Object.assign(rtcmc.extra, {
      user: {
        username: options.userObject.username,
        uuid: options.userObject.uuid,
        name: options.userObject.name,
        avatar: (_a = options.userObject.profile) == null ? void 0 : _a.avatar,
        cover: (_b = options.userObject.profile) == null ? void 0 : _b.cover
      },
      isHost: options.meeting.isHost,
      canModerate: options.meeting.canModerate,
      canToggleAudio: options.meetingConfigs.canToggleAudio,
      canToggleVideo: options.meetingConfigs.canToggleVideo,
      canHaveStream: options.meetingRules.sendAudio || options.meetingRules.sendVideo
    });
    updateExtraData();
  }
  function eventCallback(functionName, data) {
    logger.debug("Got a eventCallback", functionName);
    logger.debug("Got a eventCallback - data", data);
    if (functionName && callbacks.hasOwnProperty(functionName) && _.isFunction(callbacks[functionName])) {
      callbacks[functionName](data);
    }
  }
  function processOptions(opts = {}) {
    const options = { ...opts };
    if (_.isObject(options.user)) {
      options.userObject = { ...options.user };
      options.user = JSON.stringify(options.user);
    }
    options.user;
    options.config = Object.assign({}, config, options.config);
    meeting = options.meeting ? options.meeting : meeting;
    meetingConfigs = options.meetingConfigs ? options.meetingConfigs : meetingConfigs;
    meetingRules = options.meetingRules ? options.meetingRules : meetingRules;
    return options;
  }
  async function getSocket(callback) {
    return await rtcmc.getSocket((socket) => {
      if (socket) {
        return socket;
      } else {
        throw "RTCMC - Socket not found!";
      }
    });
  }
  function createSession(opts = {}) {
    var _a, _b;
    logger.log("RTCMC - createSession called", opts);
    if (rtcmc) {
      return;
    }
    rtcmc = new RTCMultiConnection();
    window.rtcmc = rtcmc;
    rtcmc.socketURL = opts.config.signalServer || SIGNAL_URL;
    logger.log("RTCMC - socketURL", rtcmc.socketURL);
    rtcmc.iceServers = opts.config.iceServers;
    rtcmc.autoCreateMediaElement = false;
    rtcmc.enableLogs = opts.config.debug;
    if (opts.config.forceTurn) {
      rtcmc.candidates = {
        turn: true,
        stun: false,
        host: false
      };
    }
    rtcmc.onopen = rtcmOnOpen;
    rtcmc.onmessage = rtcmOnMessage;
    rtcmc.onNewParticipant = rtcmOnNewParticipant;
    rtcmc.onNumberOfBroadcastViewersUpdated = onNumberOfBroadcastViewersUpdated;
    rtcmc.onstream = rtcmOnStream;
    rtcmc.onstreamended = rtcmOnStreamEnded;
    rtcmc.onMediaError = rtcmOnMediaError;
    rtcmc.onerror = rtcmOnError;
    rtcmc.onUserIdAlreadyTaken = rtcmOnUserIdAlreadyTaken;
    rtcmc.onExtraDataUpdated = rtcmOnExtraDataUpdated;
    rtcmc.onUserStatusChanged = rtcmOnUserStatusChanged;
    rtcmc.onSocketDisconnect = rtcmOnSocketDisconnect;
    rtcmc.socketMessageEvent = "Connect-Message-" + meeting.uuid;
    rtcmc.setCustomSocketEvent("Connect-Whisper-" + meeting.uuid);
    alreadyAcceptedParticipants = {};
    connectedWith = {};
    rtcmc.maxParticipantsAllowed = opts.config.maxParticipants;
    rtcmc.mediaConstraints = {
      video: false,
      audio: false,
      screen: false
    };
    rtcmc.dontCaptureUserMedia = true;
    if (opts.meetingRules) {
      rtcmc.session = opts.meetingRules.session;
      rtcmc.sdpConstraints.mandatory = {
        OfferToReceiveAudio: opts.meetingRules.receiveAudio,
        OfferToReceiveVideo: opts.meetingRules.receiveVideo
      };
      if (opts.meetingRules.session.oneway) {
        rtcmc.enableScalableBroadcast = true;
        rtcmc.autoCloseEntireSession = true;
        rtcmc.maxRelayLimitPerUser = 1;
        rtcmc.socketMessageEvent = "scalable-media-broadcast-demo";
        rtcmc.connectSocket((socket) => {
          socket.on("join-broadcaster", (hintsToJoinBroadcast) => {
            logger.log("RTCMC - socket join-broadcaster", hintsToJoinBroadcast);
            rtcmc.session = hintsToJoinBroadcast.typeOfStreams;
            rtcmc.sdpConstraints.mandatory = {
              OfferToReceiveVideo: !!rtcmc.session.video,
              OfferToReceiveAudio: !!rtcmc.session.audio
            };
            rtcmc.broadcastId = hintsToJoinBroadcast.broadcastId;
            joinRoom({
              room: hintsToJoinBroadcast.userid,
              force: true
            });
          });
          socket.on("rejoin-broadcast", (broadcastId) => {
            logger.log("RTCMC - socket rejoin-broadcast", broadcastId);
            rtcmc.attachStreams = [];
            socket.emit("check-broadcast-presence", broadcastId, (isBroadcastExists) => {
              logger.log("RTCMC - socket check-broadcast-presence", broadcastId, isBroadcastExists);
              if (isBroadcastExists) {
                logger.log("RTCMC - socket rejoin-broadcast - emitting join-broadcast to join broadcasting");
                socket.emit("join-broadcast", {
                  broadcastId,
                  userid: rtcmc.userid,
                  typeOfStreams: rtcmc.session
                });
              } else {
                if (opts.meeting.canModerate) {
                  rtcmc.userid = broadcastId;
                  logger.log("RTCMC - socket rejoin-broadcast - emitting join-broadcast to start broadcasting");
                  socket.emit("join-broadcast", {
                    broadcastId,
                    userid: rtcmc.userid,
                    typeOfStreams: rtcmc.session
                  });
                } else {
                  eventCallback("roomNotFound");
                }
              }
            });
          });
          socket.on("broadcast-stopped", (broadcastId) => {
            logger.log("RTCMC - socket broadcast-stopped", broadcastId);
            eventCallback("broadcastStopped", broadcastId);
          });
          socket.on("start-broadcasting", (typeOfStreams) => {
            logger.log("RTCMC - socket start-broadcasting", typeOfStreams);
            if (meeting.canModerate) {
              rtcmc.sdpConstraints.mandatory = {
                OfferToReceiveVideo: false,
                OfferToReceiveAudio: false
              };
              rtcmc.session = typeOfStreams;
              logger.log("RTCMC - socket start-broadcasting room", rtcmc.userid);
              createRoom({
                room: rtcmc.userid,
                force: true
              });
            } else {
              eventCallback("roomNotFound");
            }
          });
        });
      }
    } else {
      opts.meetingRules = {};
    }
    if (!opts.userObject) {
      opts.userObject = { ...opts.user };
      opts.user = JSON.stringify(opts.user);
    }
    rtcmc.extra = {
      user: {
        username: opts.userObject.username,
        uuid: opts.userObject.uuid,
        name: opts.userObject.name,
        avatar: (_a = opts.userObject.profile) == null ? void 0 : _a.avatar,
        cover: (_b = opts.userObject.profile) == null ? void 0 : _b.cover
      },
      isInitiator: false,
      isHost: opts.meeting.isHost,
      canModerate: opts.meeting.canModerate,
      canToggleAudio: opts.meetingConfigs.canToggleAudio,
      canToggleVideo: opts.meetingConfigs.canToggleVideo,
      canHaveStream: opts.meetingRules.sendAudio || opts.meetingRules.sendVideo,
      broadcastId: opts.room,
      streamsInfo: {}
    };
    eventCallback("sessionCreated");
    checkNumberOfParticipants();
    if (_.isFunction(opts.success)) {
      logger.log("RTCMC - Success callback after creating session");
      opts.success();
    }
  }
  function roomExists(opts = {}) {
    if (!rtcmc) {
      if (_.isFunction(opts.no)) {
        opts.no();
      }
      return;
    }
    logger.log("RTCMC - roomExists called", opts);
    if (rtcmc.enableScalableBroadcast) {
      getSocket().then((socket) => {
        socket.emit("check-broadcast-presence", opts.room, (isBroadcastExists) => {
          if (isBroadcastExists === true) {
            logger.log("RTCMC - broadcast room Exists yes");
            if (_.isFunction(opts.yes)) {
              opts.yes(socket);
            }
          } else {
            logger.log("RTCMC - broadcast room Exists no");
            if (_.isFunction(opts.no)) {
              opts.no(socket);
            }
          }
        });
      }).catch((error2) => {
        logger.error(error2);
        if (_.isFunction(opts.no)) {
          opts.no(error2);
        }
      });
    } else {
      rtcmc.checkPresence(opts.room, (isRoomExist, roomid) => {
        if (isRoomExist === true) {
          logger.log("RTCMC - room Exists yes");
          if (_.isFunction(opts.yes)) {
            opts.yes();
          }
        } else {
          logger.log("RTCMC - room Exists no");
          if (_.isFunction(opts.no)) {
            opts.no();
          }
        }
      });
    }
  }
  function createRoom(opts = {}) {
    logger.log("RTCMC - createRoom called", opts);
    const rtcmcOpenRoom = () => {
      if (roomJoined) {
        return;
      }
      rtcmc.extra.isInitiator = true;
      rtcmc.open(opts.room, (isRoomOpened, roomid, error2) => {
        roomJoined = false;
        if (error2) {
          eventCallback("createRoomError", error2);
        } else if (isRoomOpened === true) {
          roomJoined = true;
          eventCallback("roomCreated", roomid);
          initSocketListener();
        }
      });
    };
    if (opts.force) {
      rtcmcOpenRoom();
      return;
    }
    roomExists({
      room: opts.room,
      no(socket) {
        rtcmcOpenRoom();
      },
      yes() {
        joinRoom({ ...opts, force: true });
      }
    });
  }
  function joinRoom(opts = {}) {
    logger.log("RTCMC - joinRoom called", opts);
    const rtcmcJoinRoom = () => {
      if (roomJoined) {
        return;
      }
      rtcmc.join(opts.room, (isJoined, roomid, error2) => {
        roomJoined = false;
        if (isJoined === false || error2) {
          if (error2 === "Room full") {
            eventCallback("roomFullError", error2);
          } else {
            eventCallback("joinRoomError", error2);
          }
        } else {
          roomJoined = true;
          checkNumberOfParticipants();
          initSocketListener();
          eventCallback("roomJoined", roomid);
        }
      });
    };
    if (opts.force) {
      rtcmcJoinRoom();
      return;
    }
    roomExists({
      room: opts.room,
      no() {
        eventCallback("roomNotFound");
      },
      yes(socket) {
        rtcmcJoinRoom();
      }
    });
  }
  function updateExtraData() {
    logger.log("RTCMC - updateExtraData called", rtcmc.extra);
    rtcmc.updateExtraData();
  }
  function publishFeed(opts = {}) {
    logger.log("RTCMC - publishFeed called", opts);
    if (!opts.stream) {
      return;
    }
    const options = { ...opts };
    if (options.info) {
      rtcmc.extra.streamsInfo[options.stream.id] = options.info;
      updateExtraData();
      let streamFrom = options.info.from;
      localStreamMidMap[streamFrom] = {
        info: options.info,
        streamId: options.stream.id,
        stream: options.stream
      };
      window.setTimeout(() => {
        rtcmc.addStream(options.stream);
      }, 2e3);
      if (streamFrom === "cam") {
        const audioTracks = options.stream.getAudioTracks();
        if (audioTracks.length)
          ;
      }
    } else {
      rtcmc.addStream(options.stream);
    }
  }
  function updatePublishedFeed(opts = {}) {
    logger.log("RTCMC - updatePublishedFeed called", opts);
    const options = { ...opts };
    let streamMidObj = null;
    let streamFrom = null;
    if (options.info) {
      streamFrom = options.info.from;
      streamMidObj = localStreamMidMap[streamFrom];
      if (streamMidObj) {
        const streamId = streamMidObj.streamId;
        if (streamMidObj.stream) {
          options.existingStream = rtcmc.attachStreams.find((s) => s && s.id === streamId);
        }
        rtcmc.extra.streamsInfo[streamId].mirroredVideo = options.info.mirroredVideo;
        updateExtraData();
        localStreamMidMap[streamFrom].info.mirroredVideo = options.info.mirroredVideo;
      }
    }
    const existingStream = options.existingStream;
    if (options.stream) {
      logger.log("RTCMC - updatePublishedFeed - has new stream");
      if (existingStream) {
        logger.log("RTCMC - updatePublishedFeed - has existing stream");
        if (streamFrom === "cam" && speechEvents) {
          speechEvents.stop();
        }
        const audioTracks = options.stream.getAudioTracks();
        const videoTracks = options.stream.getVideoTracks();
        const existingStreamTracks = existingStream.getTracks();
        if (audioTracks.length || videoTracks.length) {
          if (options.action !== "blur" && options.action !== "unblur") {
            existingStreamTracks.forEach((track) => {
              track.enabled = false;
              track.stop();
            });
          }
          sendMessage({
            event: "streamPaused",
            data: {
              id: existingStream.id
            }
          });
          if (options.action !== "blur" && options.action !== "unblur") {
            existingStream.paused = true;
          }
          publishFeed(options);
          if (audioTracks.length && options.info && options.info.from === "cam")
            ;
          return;
        } else if (existingStreamTracks.length) {
          existingStreamTracks.forEach((track) => {
            track.enabled = false;
            track.stop();
          });
          sendMessage({
            event: "streamTrackRemoved",
            data: {
              id: existingStream.id
            },
            timeout: existingStream.paused ? 2e3 : 0
          });
          existingStream.paused = false;
          return;
        }
      } else {
        logger.log("RTCMC - updatePublishedFeed - no existing stream");
        publishFeed(options);
      }
    } else {
      logger.log("RTCMC - updatePublishedFeed - no new stream");
      if (streamFrom === "cam" && speechEvents) {
        speechEvents.stop();
      }
      if (existingStream) {
        logger.log("RTCMC - updatePublishedFeed - has existing stream");
        rtcmc.removeStream(existingStream.id);
        existingStream.getTracks().forEach((track) => {
          track.enabled = false;
        });
        existingStream.paused = true;
        if (options.action === "remove") {
          sendMessage({
            event: "streamTrackRemoved",
            data: {
              id: existingStream.id
            }
          });
        } else {
          sendMessage({
            event: "streamPaused",
            data: {
              id: existingStream.id
            }
          });
        }
      }
    }
  }
  function close(opts = {}) {
    logger.log("RTCMC - close called", opts);
    if (rtcmc) {
      if (opts.feeds && opts.feeds.length) {
        opts.feeds.forEach((feed) => {
          rtcmc.removeStream(feed.stream.id);
          if (typeof feed.stopFn === "function") {
            feed.stopFn(feed.stream);
          } else if (typeof feed.stream.getTracks === "function") {
            feed.stream.getTracks().forEach((track) => track.stop());
          } else if (typeof feed.stream.stop === "function") {
            feed.stream.stop();
          }
        });
      }
      rtcmc.removeStream({
        video: true,
        audio: true
      });
      rtcmc.attachStreams.forEach((localStream) => {
        rtcmc.removeStream(localStream.id);
        localStream.getTracks().forEach((track) => track.stop());
      });
      rtcmc.attachStreams = [];
    }
    window.setTimeout(() => {
      rtcmc.getAllParticipants().forEach((participant) => {
        rtcmc.disconnectWith(participant);
      });
      if (rtcmc) {
        rtcmc.leave();
        rtcmc.closeSocket();
      }
      rtcmc = null;
      roomJoined = false;
      localStreamMidMap = {};
      alreadyAcceptedParticipants = {};
      connectedWith = {};
      newParticipantsList = [];
      if (typeof opts.callback === "function") {
        opts.callback();
      }
    }, 500);
  }
  function shareFile(opts = {}) {
    if (!opts.file || !opts.sendTo) {
      return;
    }
    rtcmc.shareFile(opts.file, opts.sendTo);
  }
  function getAllStreams(opts = {}) {
    return rtcmc.streamEvents.selectAll();
  }
  function initSocketListener() {
    if (!rtcmc) {
      return;
    }
    const callbackList = {
      "streamTrackRemoved": onStreamTrackRemoved,
      "streamTrackUpdated": onStreamTrackUpdated,
      "streamPaused": onStreamPaused,
      "remoteHandToggled": onRemoteHandToggled,
      "speaking": onSpeaking,
      "stoppedSpeaking": onStoppedSpeaking,
      "snapshotTaken": onSnapshotTaken,
      "meetingUpdated": onMeetingUpdated,
      "meetingEnded": onMeetingEnded,
      "userBanned": onUserBanned,
      "participantLeft": onParticipantLeft,
      "toggleRemoteAV": onToggleRemoteAV,
      "pollPublished": onPollPublished,
      "pollResultPublished": onPollResultPublished
    };
    getSocket().then((socket) => {
      socket.on("Connect-Whisper-" + meeting.uuid, (e) => {
        logger.log("RTCMC - Got Socket Whisper!", e);
        if (!rtcmc) {
          return;
        }
        if (e && callbackList.hasOwnProperty(e.event)) {
          logger.log("RTCMC - Got Socket Whisper Event: ", e.event, e.data);
          callbackList[e.event](e.data);
        }
      });
    }).catch((error2) => {
      logger.error(error2);
    });
  }
  function checkNumberOfParticipants() {
    if (!rtcmc) {
      return;
    }
    const participants = rtcmc.getAllParticipants();
    const participantsList = [];
    participants.forEach((participantId, index) => {
      const participant = rtcmc.peers[participantId];
      if (participant) {
        participantsList.push({
          userId: participant.userid,
          ...participant.extra
        });
      }
    });
    logger.log("RTCMC - checkNumberOfParticipants - participants", participantsList);
    eventCallback("participantsCountChecked", participantsList);
    return participants.length;
  }
  function getFeedObject(feed = {}) {
    if (!feed) {
      return;
    }
    const feedExtraData = feed.extra ? feed.extra : {};
    const feedId = feed.id || feed.streamid;
    const userId = feed.userid || feed.userId;
    const userUuid = feedExtraData.user ? feedExtraData.user.uuid : null;
    const streamInfo = feedId && feedExtraData.streamsInfo ? feedExtraData.streamsInfo[feedId] : {};
    const feedObject = {
      userId,
      userUuid,
      ...feedExtraData
    };
    if (feedId) {
      feedObject.id = feedId;
      feedObject.key = userUuid;
      feedObject.isScreen = false;
      feedObject.isWhiteboard = false;
      feedObject.isTalking = false;
    }
    if (streamInfo) {
      feedObject.mirroredVideo = streamInfo.mirroredVideo || false;
      feedObject.info = streamInfo;
      if (streamInfo.from) {
        if (streamInfo.from === "screen" || streamInfo.from === "whiteboard") {
          feedObject.key = feedObject.key + "-" + streamInfo.from;
        }
        feedObject.from = streamInfo.from;
        feedObject.isScreen = streamInfo.from === "screen";
        feedObject.isWhiteboard = streamInfo.from === "whiteboard";
        feedObject.isTalking = streamInfo.from === "cam" && streamInfo.talking;
      }
    }
    if (feed.stream) {
      feedObject.stream = feed.stream;
    }
    return feedObject;
  }
  function onStreamTrackRemoved(feed) {
    logger.log("RTCMC - On onStreamTrackRemoved: ", feed);
    const feedObject = getFeedObject(feed);
    eventCallback("streamRemoved", {
      ...feedObject,
      kind: feed.kind,
      info: feed.info
    });
  }
  function onStreamTrackUpdated(feed) {
    logger.log("RTCMC - On onStreamTrackUpdated: ", feed);
    const feedObject = getFeedObject(feed);
    eventCallback("streamUpdated", {
      ...feedObject,
      kind: feed.kind,
      info: feed.info
    });
  }
  function onStreamPaused(feed) {
    logger.log("RTCMC - On onStreamPaused: ", feed);
    const feedObject = getFeedObject(feed);
    eventCallback("streamUpdated", {
      ...feedObject,
      kind: feed.kind,
      type: "paused",
      info: feed.info
    });
  }
  function onRemoteHandToggled(feed) {
    logger.log("RTCMC - On onRemoteHandToggled: ", feed);
    const feedObject = getFeedObject(feed);
    eventCallback("remoteHandToggled", {
      ...feedObject,
      isHandUp: feed.isHandUp
    });
  }
  function onSpeaking(feed) {
    const feedObject = getFeedObject(feed);
    eventCallback("streamUpdated", {
      ...feedObject,
      from: feed.from,
      type: "meta-updated",
      data: {
        key: "isTalking",
        value: true
      }
    });
  }
  function onStoppedSpeaking(feed) {
    const feedObject = getFeedObject(feed);
    eventCallback("streamUpdated", {
      ...feedObject,
      from: feed.from,
      type: "meta-updated",
      data: {
        key: "isTalking",
        value: false
      }
    });
  }
  function onSnapshotTaken(info) {
    logger.log("RTCMC - On onSnapshotTaken: ", info);
    eventCallback("snapshotTaken", info);
  }
  function onMeetingUpdated(meeting2) {
    logger.log("RTCMC - On onMeetingUpdated: ", meeting2);
    eventCallback("meetingUpdated", meeting2);
  }
  function onMeetingEnded(e) {
    logger.log("RTCMC - On onMeetingEnded: ", e);
    eventCallback("meetingEnded", e);
  }
  function onUserBanned(feed) {
    logger.log("RTCMC - On onUserBanned: ", feed);
    checkNumberOfParticipants();
    eventCallback("userBanned", feed);
  }
  function onParticipantLeft(feed) {
    logger.log("RTCMC - onParticipantLeft: ", feed);
    if (!rtcmc) {
      return;
    }
    const feedObject = getFeedObject(feed);
    if (!(feedObject.userId || feedObject.userUuid)) {
      return;
    }
    eventCallback("participantLeft", feedObject);
    window.setTimeout(checkNumberOfParticipants, 1e3);
  }
  function onToggleRemoteAV(data) {
    logger.log("RTCMC - On onToggleRemoteAV: ", data);
    if (!(!data.userId || data.userId !== rtcmc.userid)) {
      return;
    }
    eventCallback("toggleRemoteAV", data);
  }
  function onPollPublished(data) {
    logger.log("RTCMC - On onPollPublished: ", data);
    eventCallback("pollPublished", data);
  }
  function onPollResultPublished(data) {
    logger.log("RTCMC - On onPollResultPublished: ", data);
    eventCallback("pollResultPublished", data);
  }
  function rtcmOnOpen(e) {
    logger.log("RTCMC - On rtcmOnOpen: ", e);
    if (connectedWith[e.userid]) {
      return;
    }
    connectedWith[e.userid] = true;
    checkNumberOfParticipants();
    eventCallback("dataChannelOpened", e);
  }
  function rtcmOnMessage({ data, extra, userid }) {
    logger.log("RTCMC - On rtcmOnMessage: ", data, extra, userid);
    if (!data) {
      return;
    }
    if (data.type === "whiteboard") {
      eventCallback("whiteboardMessageReceived", {
        userId: userid,
        user: extra == null ? void 0 : extra.user,
        data: data.data
      });
      return;
    } else if (data.type === "file-sharing") {
      eventCallback("fileSharingMessageReceived", {
        userId: userid,
        user: extra == null ? void 0 : extra.user,
        data: data.data
      });
      return;
    }
    eventCallback("messageReceived", {
      userId: userid,
      user: extra == null ? void 0 : extra.user,
      data: data.data
    });
  }
  function rtcmOnNewParticipant(participantId, userPreferences) {
    logger.log("RTCMC - On rtcmOnNewParticipant - participantId, userPreferences: ", participantId, userPreferences);
    if (!rtcmc) {
      return;
    }
    if (checkNumberOfParticipants() >= rtcmc.maxParticipantsAllowed) {
      return;
    }
    const userId = userPreferences.connectionDescription.remoteUserId;
    rtcmc.acceptParticipationRequest(participantId, userPreferences);
    alreadyAcceptedParticipants[userId] = true;
    checkNumberOfParticipants();
    logger.log("RTCMC - On rtcmOnNewParticipant - auto accepted!");
    return;
  }
  function onNumberOfBroadcastViewersUpdated(e) {
    logger.log("RTCMC - On onNumberOfBroadcastViewersUpdated: ", e);
    if (!rtcmc.isInitiator && rtcmc.extra.isHost) {
      return;
    }
    eventCallback("numberOfBroadcastViewersUpdated", e.numberOfBroadcastViewers);
  }
  function rtcmOnStream(feed) {
    logger.log("RTCMC - On rtcmOnStream: ", feed);
    if (!rtcmc) {
      return;
    }
    const feedObject = getFeedObject(feed);
    if (!rtcmc.peers[feedObject.userId]) {
      logger.log("RTCMC - On rtcmOnStream - participant already gone!");
      eventCallback("participantLeft", feedObject);
      checkNumberOfParticipants();
      return;
    }
    let feedExtraData = { ...feed.extra };
    if (!(feedExtraData.user && feedExtraData.user.uuid)) {
      logger.log("RTCMC - On rtcmOnStream - Not enough data!");
      return;
    }
    if (meeting.type.uuid === "live_class" && !(rtcmc.isInitiator || rtcmc.extra.isHost) && !(feedExtraData.isInitiator || feedExtraData.isHost) && feed.type === "remote") {
      logger.log("RTCMC - On rtcmOnStream - Incoming stream is not from host! Dont show!");
      return;
    }
    if ((meeting.type.uuid === "webinar" || meeting.type.uuid === "podcast") && !(rtcmc.isInitiator || rtcmc.extra.isHost) && !(feedExtraData.isInitiator || feedExtraData.isHost) && feed.type === "remote") {
      if (rtcmc.enableScalableBroadcast) {
        if (feedExtraData.broadcasterExtra) {
          let broadcasterExtra = { ...feedExtraData.broadcasterExtra };
          delete feedExtraData.broadcasterExtra;
          feedExtraData = {
            ...feedExtraData,
            ...broadcasterExtra
          };
        }
      } else {
        if (!feed.extra.isInitiator && !feed.extra.isHost) {
          logger.log("RTCMC - On rtcmOnStream - Incoming stream is not from host! Dont show!");
          return;
        }
      }
    }
    if (rtcmc.enableScalableBroadcast) {
      if ((rtcmc.isInitiator || rtcmc.extra.isHost) && feed.type === "remote") {
        return;
      }
      rtcmc.isUpperUserLeft = false;
      if (feed.extra.isInitiator || feed.extra.isHost) {
        rtcmc.extra.broadcasterExtra = {
          ...feedExtraData
        };
        updateExtraData();
      }
    }
    eventCallback("streamAdded", feedObject);
    if (rtcmc.enableScalableBroadcast && !rtcmc.isInitiator && !rtcmc.isHost && feed.type === "remote") {
      rtcmc.dontCaptureUserMedia = true;
      rtcmc.attachStreams = [feed.stream];
      rtcmc.sdpConstraints.mandatory = {
        OfferToReceiveAudio: false,
        OfferToReceiveVideo: false
      };
      rtcmc.getSocket((socket) => {
        if (rtcmc.DetectRTC.browser.name === "Chrome") {
          rtcmc.getAllParticipants().forEach((p) => {
            if (p + "" != feed.userid + "") {
              let peer = rtcmc.peers[p].peer;
              peer.getLocalStreams().forEach((localStream) => {
                peer.removeStream(localStream);
              });
              feed.stream.getTracks().forEach((track) => {
                peer.addTrack(track, feed.stream);
              });
              rtcmc.dontAttachStream = true;
              rtcmc.renegotiate(p);
              rtcmc.dontAttachStream = false;
            }
          });
        }
        if (rtcmc.DetectRTC.browser.name === "Firefox") {
          rtcmc.getAllParticipants().forEach((p) => {
            if (p + "" != feed.userid + "") {
              rtcmc.replaceTrack(feed.stream, p);
            }
          });
        }
        if (rtcmc.DetectRTC.browser.name === "Chrome")
          ;
      });
    }
    checkNumberOfParticipants();
  }
  function rtcmOnStreamEnded(feed) {
    logger.log("RTCMC - On rtcmOnStreamEnded: ", feed);
    if (!rtcmc) {
      return;
    }
    const feedObject = getFeedObject(feed);
    if (!(feedObject.user && feedObject.user.uuid)) {
      logger.log("RTCMC - On rtcmOnStreamEnded - Not enough data!");
      return;
    }
    if (!rtcmc.peers[feedObject.userId]) {
      logger.log("RTCMC - On rtcmOnStream - participant already gone!");
      eventCallback("participantLeft", feedObject);
      checkNumberOfParticipants();
      return;
    }
    eventCallback("streamRemoved", feedObject);
    checkNumberOfParticipants();
  }
  function rtcmOnMediaError(error2) {
    logger.log("RTCMC - On rtcmOnMediaError: ", error2);
  }
  function rtcmOnError(event2) {
    logger.log("RTCMC - On rtcmOnError: ", event2);
    if (!rtcmc) {
      return;
    }
    const feedObject = getFeedObject(event2);
    if (!(feedObject.userId || feedObject.userUuid)) {
      return;
    }
    eventCallback("participantLeft", feedObject);
    window.setTimeout(checkNumberOfParticipants, 1e3);
  }
  function rtcmOnUserIdAlreadyTaken(useridAlreadyTaken, yourNewUserId) {
    logger.log("RTCMC - On rtcmOnUserIdAlreadyTaken: ", error);
    rtcmc.userid = yourNewUserId;
  }
  function rtcmOnExtraDataUpdated(event2) {
    logger.log("RTCMC - On rtcmOnExtraDataUpdated: ", event2);
    if (!rtcmc) {
      return;
    }
    const feedObject = getFeedObject(event2);
    if (!(feedObject.userId || feedObject.userUuid)) {
      return;
    }
    if (!rtcmc.peers[feedObject.userId]) {
      logger.log("RTCMC - On rtcmOnExtraDataUpdated - participant already gone!");
      eventCallback("participantLeft", feedObject);
      checkNumberOfParticipants();
      return;
    }
    const newParticipantIndex = newParticipantsList.findIndex((p) => p.userid === feedObject.userId);
    if (newParticipantIndex !== -1) {
      newParticipantsList.splice(newParticipantIndex, 1);
      eventCallback("participantJoined", feedObject);
    } else {
      eventCallback("userInfoUpdated", feedObject);
    }
    checkNumberOfParticipants();
  }
  function rtcmOnUserStatusChanged(event2) {
    logger.log("RTCMC - On rtcmOnUserStatusChanged - event : ", event2);
    if (!rtcmc) {
      return;
    }
    if (!event2.userid || !event2.status) {
      return;
    }
    if (!(event2.extra && event2.extra.user)) {
      newParticipantsList.push(event2);
      return;
    }
    const feedObject = getFeedObject(event2);
    if (!(feedObject.userId || feedObject.userUuid)) {
      return;
    }
    if (event2.status === "online") {
      eventCallback("participantJoined", feedObject);
    } else {
      eventCallback("participantLeft", feedObject);
    }
    window.setTimeout(checkNumberOfParticipants, 1e3);
  }
  function rtcmOnSocketDisconnect(event2) {
    logger.log("RTCMC - On rtcmOnSocketDisconnect: ", event2);
    getSocket().then((socket) => {
      logger.log("RTCMC - On rtcmOnSocketReconnect");
    }).catch((error2) => {
      logger.error(error2);
    });
  }
  function rtcmOnFileStart(file) {
    eventCallback("fileReceivingStart", {
      file
    });
  }
  function rtcmOnFileProgress(chunk) {
    eventCallback("fileReceivingProgress", {
      chunk
    });
  }
  function rtcmOnFileEnd(file) {
    eventCallback("fileReceivingEnd", {
      file
    });
  }
  return {
    init
  };
}
export {
  rtcRtcmc as default
};
//# sourceMappingURL=rtc-rtcmc.1a67a00b.js.map
