import { S as Swal, _ as __vitePreload } from "./app.9a8150b2.js";
import { b as addButton, i as filterButton, d as configButton, j as importOption, k as configOption, p as printOption, g as exportPdfOption, l as exportCsvOption, m as exportXlsOption, n as getSortOptions, a as commonKeyBindings } from "./header.a91390e7.js";
import { m as mapGetters, i as mapActions } from "./vendor/vendor-core.2a9962eb.js";
import { E as EventBus } from "./event-bus.0afcd682.js";
import { g as BTable } from "./vendor/vendor-bootstrap-vue.397f83c5.js";
const table = {
  components: {
    BTable
  },
  data() {
    return {
      uuid: null,
      entity: null,
      fields: [],
      preRequisite: {},
      preRequisiteFetchList: [],
      showFilters: false,
      isInitialized: false,
      isLoading: false,
      isFetching: false,
      noMoreData: false,
      getInitialDataCalled: false,
      gotError: false,
      selectedRows: [],
      formErrors: {},
      customFilters: {},
      filtersCastBoolean: [],
      appendToQuery: {},
      filtersOptions: {
        name: ""
      },
      sortOptions: {
        hasScroll: false
      },
      columnsOptions: {
        hasScroll: false
      },
      exportOptions: {},
      initUrl: "",
      initSubUrl: null,
      dataType: null,
      printOptions: null,
      headerButtons: null,
      headerFloaters: null,
      headerLinks: null,
      hideHeaderLinks: false,
      hideSortOptions: false,
      hideColumnOptions: false,
      hideFilterButton: false,
      feedTable: false
    };
  },
  computed: {
    ...mapGetters("common", [
      "entities",
      "feed",
      "filters",
      "columns",
      "others"
    ]),
    ...mapGetters("config", [
      "configs",
      "uiConfigs",
      "vars",
      "allowExtraInput"
    ]),
    ...mapGetters("user", [
      "hasRole",
      "hasPermission",
      "hasAnyPermission",
      "profile"
    ]),
    isFiltered() {
      const query = this.$route.query;
      return query.filtered === "true" ? true : query.filtered === "false" ? false : query.filtered;
    },
    selectAllRows: {
      get: function() {
        return this.entities && this.entities.data.every(({ uuid }) => this.selectedRows.indexOf(uuid) !== -1);
      },
      set: function(value) {
        let selected = this.selectedRows;
        if (value) {
          this.entities.data.forEach((ent) => {
            if (selected.indexOf(ent.uuid) === -1) {
              selected.push(ent.uuid);
            }
          });
        } else {
          this.entities.data.forEach((ent) => {
            const index = selected.indexOf(ent.uuid);
            if (index !== -1) {
              selected.splice(index, 1);
            }
          });
        }
        this.selectedRows = selected;
      }
    },
    showTagsForm() {
      return !!this.selectedRows.length;
    },
    tableMeta() {
      if (this.uiConfigs.hideSecureContent && this.filterFn && _.isFunction(this.filterFn)) {
        let arrayOfSecuredContent = this.entities.data.filter(this.filterFn);
        arrayOfSecuredContent = arrayOfSecuredContent.length;
        return {
          ...this.entities.meta,
          to: this.entities.meta.to - arrayOfSecuredContent,
          total: this.entities.meta.total - arrayOfSecuredContent
        };
      }
      return this.entities.meta;
    }
  },
  watch: {
    $route(val, oldVal) {
      if (this.initSubUrl && this.$route.params.uuid && val.params.uuid !== oldVal.params.uuid) {
        this.doInit();
        this.getEntityData();
      } else {
        this.updatePageMeta();
        this.applyPageHeader();
      }
    },
    columns(val, oldVal) {
      if (val.fields) {
        this.fields = val.fields;
        this.refreshTable();
      }
    }
  },
  methods: {
    ...mapActions("common", [
      "Init",
      "InitSub",
      "Get",
      "GetList",
      "GetFeed",
      "Destroy",
      "Update",
      "SetMeta",
      "SetFilters",
      "Custom",
      "GetPreRequisite",
      "ResetFilters",
      "SetPageHeader"
    ]),
    ...mapActions("config", [
      "SetUiConfig",
      "SetConfig"
    ]),
    itemsProvider(context) {
      this.isLoading = true;
      const query = {
        ...this.filters,
        currentPage: this.entities.meta.currentPage,
        perPage: this.entities.meta.perPage,
        ...this.appendToQuery,
        sortBy: this.filters.sortBy ? this.filters.sortBy.snakeCase() : this.filters.sortBy
      };
      this.gotError = false;
      return this.GetList(query).then((response) => {
        return response.data;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
        this.gotError = true;
        return [];
      });
    },
    getFeed: _.debounce(function(e, reset = false) {
      if (!this.feedTable || this.noMoreData) {
        return;
      }
      this.isFetching = true;
      const query = {
        ...this.filters,
        perPage: this.feed.meta.perPage,
        cursor: reset ? reset : this.feed.meta.cursor ? this.feed.meta.cursor : true,
        ...this.appendToQuery,
        sortBy: this.filters.sortBy ? this.filters.sortBy.snakeCase() : this.filters.sortBy
      };
      this.gotError = false;
      return this.GetFeed(query).then((response) => {
        if (response.meta && response.meta.hasMorePages && response.data && response.data.length) {
          this.noMoreData = false;
        } else {
          this.noMoreData = true;
        }
        this.isInitialized = true;
        this.isFetching = false;
        this.isLoading = false;
        return response.data;
      }).catch((error) => {
        this.noMoreData = false;
        this.isInitialized = true;
        this.isFetching = false;
        this.isLoading = false;
        formUtil.handleErrors(error);
        this.gotError = true;
        return [];
      });
    }, 100),
    updatePageMeta(initTable = true, forceRefresh = false) {
      const query = this.$route.query;
      const paginationMeta = {
        currentPage: parseInt(query.currentPage || 1),
        perPage: parseInt(query.perPage || this.configs.system.perPage),
        cursor: query.cursor || this.entities.meta.cursor || true
      };
      let filtersMeta = this.filters;
      query.objForEach((value, key) => {
        filtersMeta[key] = value;
      });
      if (this.filtersCastBoolean && this.filtersCastBoolean.length) {
        this.filtersCastBoolean.objForEach((value) => {
          filtersMeta[value] = filtersMeta[value] === "true" ? true : filtersMeta[value] === "false" ? false : filtersMeta[value];
        });
      }
      if (this.customFilters) {
        this.customFilters.objForEach((value, key) => {
          filtersMeta[key] = value;
        });
      }
      this.SetMeta(paginationMeta);
      this.SetFilters(filtersMeta);
      if (initTable) {
        if (this.isInitialized) {
          this.refreshTable();
          this.isInitialized = true;
        } else {
          this.isInitialized = true;
        }
      } else if (forceRefresh) {
        this.refreshTable();
      }
    },
    refreshTable() {
      if (this.$refs && this.$refs.hasOwnProperty("btable") && this.$refs.btable) {
        this.$refs.btable.refresh();
        console.log("Refreshing table");
        return;
      }
      console.log("Refreshing feed");
      this.getFeed(null, true);
    },
    refreshTableIfRoute(route) {
      if (this.$route.name === route) {
        this.refreshTable();
        console.log("Refreshing table");
        return;
      }
      console.log("Refreshing feed");
      this.getFeed(null, true);
    },
    toggleFilter() {
      this.showFilters = !this.showFilters;
    },
    deleteEntity(entity) {
      formUtil.confirmAction().then((result) => {
        if (result.value) {
          this.isLoading = true;
          this.Destroy(entity).then((response) => {
            this.isLoading = false;
            this.$toasted.success(response.message, this.$toastConfig);
            this.$nextTick(() => {
              this.refreshTable();
              if (typeof this.getInitialData === "function" && this.getInitialDataCalled && this.getInitialDataCalledAfterDeleting) {
                this.getInitialData();
              }
            });
          }).catch((error) => {
            this.isLoading = false;
            this.isInitialized = true;
            this.formErrors = formUtil.handleErrors(error);
          });
        } else {
          result.dismiss === Swal.DismissReason.cancel;
        }
      });
    },
    fillFilterPreRequisite() {
      if (!(this.isFiltered && this.filters && this.preRequisiteFetchList && this.preRequisiteFetchList.length)) {
        return;
      }
      this.preRequisiteFetchList.forEach((obj) => {
        if (obj.filterKey && obj.preRequisiteKey && obj.url) {
          this.Custom({
            url: obj.url + this.filters[obj.filterKey],
            method: "get"
          }).then((response) => {
            if (response) {
              this.preRequisite[obj.preRequisiteKey].push(response);
            }
          });
        }
      });
    },
    fillPreRequisite(response) {
      this.preRequisite.objForEach((value, key) => {
        this.preRequisite[key] = response.hasOwnProperty(key) ? response[key] : value;
      });
      this.isLoading = false;
    },
    async getInitialData() {
      this.isLoading = true;
      this.getInitialDataCalled = true;
      try {
        const query = this.$route.query;
        let preRequisiteQuery = {};
        if (this.isFiltered && query && this.preRequisiteFetchList && this.preRequisiteFetchList.length) {
          this.preRequisiteFetchList.forEach((obj) => {
            if (obj.filterKey && query[obj.filterKey]) {
              preRequisiteQuery[obj.filterKey] = query[obj.filterKey];
            }
          });
        }
        const response = await this.GetPreRequisite({
          ...this.customFilters,
          ...preRequisiteQuery
        });
        this.fillPreRequisite(response);
        this.updatePageMeta();
        this.fillFilterPreRequisite();
        if (typeof this.afterGetInitialData === "function") {
          this.afterGetInitialData();
        }
        return response;
      } catch (error) {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
        throw error;
      }
    },
    getEntityData(callbackFn) {
      this.isLoading = true;
      if (this.initSubUrl && this.$route.params.uuid) {
        this.uuid = this.$route.params.uuid;
        return this.Get({ uuid: this.uuid }).then((response) => {
          this.entity = response;
          if (response.name) {
            this.pageTitle = response.name;
            this.subTitle = response.name ? this.subTitle : "";
            this.applyPageHeader();
          }
          this.doInitSub();
          this.updatePageMeta();
          this.isLoading = false;
          if (this.afterGetEntityData && typeof this.afterGetEntityData === "function") {
            this.afterGetEntityData();
          }
          if (callbackFn && typeof callbackFn === "function") {
            callbackFn();
          }
        }).catch((error) => {
          this.isLoading = false;
          formUtil.handleErrors(error);
          this.$router.back();
        });
      } else {
        this.isLoading = false;
        this.$router.back();
      }
    },
    reloadEntityData(callbackFn) {
      this.isLoading = true;
      if (this.initSubUrl && this.$route.params.uuid) {
        this.uuid = this.$route.params.uuid;
        return this.Get({ uuid: this.uuid }).then((response) => {
          this.entity = response;
          if (response.name) {
            this.pageTitle = response.name;
            this.subTitle = response.name ? this.subTitle : "";
            this.applyPageHeader();
          }
          this.isLoading = false;
          if (callbackFn && typeof callbackFn === "function") {
            callbackFn();
          }
        }).catch((error) => {
          this.isLoading = false;
          formUtil.handleErrors(error);
          this.$router.back();
        });
      } else {
        this.isLoading = false;
        this.$router.back();
      }
    },
    applyTags(formData) {
      this.Custom({
        url: `/tags`,
        method: "post",
        data: {
          ...formData,
          type: (this.tagType || this.dataType).kebabCase(),
          uuids: this.selectedRows
        }
      }).then((response) => {
        this.selectedRows = [];
        this.$toasted.success(response.message, this.$toastConfig);
        if (this.refreshAfterTagsApplied) {
          this.$nextTick(() => {
            this.refreshTable();
          });
        }
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    getSortOptionsArray() {
      return this.fields.filter((f) => f.sort).map((f) => {
        return {
          label: f.label,
          sort: f.sort,
          thClass: f.thClass,
          tdClass: f.tdClass
        };
      });
    },
    getHeaderOptions() {
      let buttons = [];
      if (this.routesRequired && this.routesRequired.add) {
        if (typeof this.permissionsRequired === "object" && this.permissionsRequired !== null && this.permissionsRequired.add) {
          buttons.push(addButton(this.routesRequired.add, this.permissionsRequired.add));
        } else if (this.permissionsRequired) {
          buttons.push(addButton(this.routesRequired.add, this.permissionsRequired));
        } else {
          buttons.push(addButton(this.routesRequired.add));
        }
      }
      if (!this.hideFilterButton) {
        buttons.push(filterButton());
      }
      if (this.routesRequired && this.routesRequired.config) {
        if (typeof this.permissionsRequired === "object" && this.permissionsRequired !== null && this.permissionsRequired.config) {
          buttons.push(configButton(this.routesRequired.config, this.permissionsRequired.config));
        } else if (this.permissionsRequired) {
          buttons.push(configButton(this.routesRequired.config, this.permissionsRequired));
        } else {
          buttons.push(configButton(this.routesRequired.config));
        }
      }
      if (this.headerButtons) {
        buttons = buttons.concat(this.headerButtons);
      }
      let floaters = [];
      if (this.headerFloaters) {
        headerFloaters = headerFloaters.concat(this.headerFloaters);
      }
      let links = [];
      if (this.routesRequired && this.routesRequired.import) {
        if (typeof this.permissionsRequired === "object" && this.permissionsRequired !== null && this.permissionsRequired.import) {
          links.push(importOption(this.routesRequired.import, this.permissionsRequired.import));
        } else if (this.permissionsRequired) {
          links.push(importOption(this.routesRequired.import, this.permissionsRequired));
        }
      }
      if (this.routesRequired && this.routesRequired.config) {
        if (typeof this.permissionsRequired === "object" && this.permissionsRequired !== null && this.permissionsRequired.config) {
          links.push(configOption(this.routesRequired.config, this.permissionsRequired.config));
        } else if (this.permissionsRequired) {
          links.push(configOption(this.routesRequired.config, this.permissionsRequired));
        }
      }
      if (!this.feedTable) {
        links.push(printOption());
        links.push(exportPdfOption());
        links.push(exportCsvOption());
        links.push(exportXlsOption());
      }
      if (this.headerLinks) {
        links = links.concat(this.headerLinks);
      }
      return {
        hideLinks: this.hideHeaderLinks || false,
        buttons,
        floaters,
        sort: this.hideSortOptions ? false : getSortOptions(this.sortOptions || {}, this.getSortOptionsArray()),
        links,
        columns: this.hideColumnOptions ? false : this.columnsOptions,
        title: this.pageTitle || "",
        subTitle: this.pageTitle ? this.subTitle || "" : ""
      };
    },
    getKeyBindingOptions() {
      let opts = {
        ...commonKeyBindings
      };
      if (this.routesRequired && this.routesRequired.add) {
        opts["key_a"] = this.routesRequired.add;
      }
      return opts;
    },
    applyPageHeader() {
      let pageHeaderOptions = Object.assign({}, this.getHeaderOptions(), this.header || {});
      let keyBindings = Object.assign({}, this.getKeyBindingOptions(), this.keyBindings || {});
      this.SetPageHeader(pageHeaderOptions);
      this.SetConfig({
        keyBindings
      });
    },
    async export(options) {
      this.isLoading = true;
      const transformers = await __vitePreload(() => import("./helpers/transformers.f12abdae.js"), true ? ["assets/js/helpers/transformers.f12abdae.js","assets/js/app.9a8150b2.js","assets/js/vendor/vendor-core.2a9962eb.js","assets/js/vendor/vendor-others.d4f8aae2.js","assets/js/vendor/vendor-essential.31dae676.js","assets/js/vendor/vendor-bootstrap-vue.397f83c5.js","assets/js/vendor/vendor-vue-gtag.137cb49d.js","assets/css/app.css"] : void 0);
      const getFinalValue = (item, key) => {
        let finalVal;
        const keys = key.split(".");
        if (keys && keys.length) {
          keys.forEach((k, i) => {
            finalVal = finalVal ? finalVal[k] : i === 0 ? item[k] : null;
          });
        } else {
          finalVal = item[key];
        }
        return finalVal;
      };
      let exportUtil;
      let exportOptions = this.exportOptions || {};
      let fields = this.exportPdfFields || this.fields.filter((f) => (f.label || f.headerTitle) && !f.cantExport);
      if (this.uiConfigs.hideSecureContent) {
        const secureContentPattern = new RegExp("secure-content", "igm");
        fields = fields.filter((f) => !secureContentPattern.test(f.thClass) && !secureContentPattern.test(f.tdClass));
      }
      let content = [];
      let fileTitle = "";
      let fileName = moment().unix();
      if (this.$route.meta.title) {
        fileTitle = this.$route.meta.trans ? $t(this.$route.meta.trans, { attribute: $t(this.$route.meta.title) }) : $t(this.$route.meta.title);
        fileName = fileTitle.toLowerCase().replace(/\s+/g, "-") + "-" + fileName;
      }
      if (options.type === "xls-csv") {
        options.type = "csv";
      }
      if (options.type === "pdf" || options.type === "print") {
        exportUtil = await __vitePreload(() => import("./helpers/export/pdf.088a2296.js"), true ? ["assets/js/helpers/export/pdf.088a2296.js","assets/js/app.9a8150b2.js","assets/js/vendor/vendor-core.2a9962eb.js","assets/js/vendor/vendor-others.d4f8aae2.js","assets/js/vendor/vendor-essential.31dae676.js","assets/js/vendor/vendor-bootstrap-vue.397f83c5.js","assets/js/vendor/vendor-vue-gtag.137cb49d.js","assets/css/app.css"] : void 0);
        const columns = fields.map((f) => {
          return {
            header: f.label || f.headerTitle,
            dataKey: f.key
          };
        });
        content = this.entities.data.map((item) => {
          let row = {};
          fields.forEach((field) => {
            let ft = field.transformer;
            let value = getFinalValue(item, field.key);
            if (ft && (value || value === false)) {
              ft = _.isArray(ft) ? ft : [ft];
              ft.forEach((ftrans) => {
                const func = _.isFunction(ftrans) ? ftrans : transformers[ftrans];
                value = field.transformerOpts ? func(value, field.transformerOpts) : func(value, item);
              });
            }
            row[field.key] = value || "";
          });
          return row;
        });
        if (options.type === "pdf") {
          exportUtil.downloadPdfFile(fileName, fileTitle, columns, content, exportOptions);
        } else {
          exportUtil.printTable(fileTitle, columns, content, exportOptions);
        }
      } else {
        exportUtil = await __vitePreload(() => import("./helpers/export/csv.448e0e31.js"), true ? ["assets/js/helpers/export/csv.448e0e31.js","assets/js/vendor/vendor-export-from-json.7fa9cd33.js"] : void 0);
        content = this.entities.data.map((item) => {
          let row = {};
          fields.forEach((field) => {
            let ft = field.transformer;
            let value = getFinalValue(item, field.key);
            if (ft && (value || value === false)) {
              ft = _.isArray(ft) ? ft : [ft];
              ft.forEach((ftrans) => {
                const func = _.isFunction(ftrans) ? ftrans : transformers[ftrans];
                value = field.transformerOpts ? func(value, field.transformerOpts) : func(value, item);
              });
            }
            row[field.label] = value || "";
          });
          return row;
        });
        exportUtil.downloadFile(content, options.type, fileName);
      }
      this.isLoading = false;
    },
    doInitSub() {
      this.uuid = this.$route.params.uuid;
      if (!this.uuid) {
        this.isLoading = false;
        this.$router.back();
      }
      this.InitSub({
        url: this.uuid + "/" + this.initSubUrl,
        filters: this.filtersOptions,
        columns: this.fields
      });
    },
    doInit() {
      this.Init({
        url: this.initUrl,
        filters: this.filtersOptions,
        columns: this.fields
      });
      this.applyPageHeader();
    },
    clearFilters() {
      let filterOptionsHasDefaultValues = false;
      this.filtersOptions.objForEach((value, key) => {
        if (value !== "") {
          filterOptionsHasDefaultValues = true;
        }
      });
      if (filterOptionsHasDefaultValues) {
        this.ResetFilters();
        this.SetFilters({
          ...this.filters,
          ...this.filtersOptions
        });
      } else {
        this.ResetFilters();
      }
      if (this.$route.query && this.$route.query.filtered) {
        this.$router.push({ path: this.$route.path }).catch((err) => {
        });
      }
      if (this.afterClearFilters && _.isFunction(this.afterClearFilters)) {
        this.afterClearFilters();
      }
    },
    rowClickHandler(opts, item) {
      if (opts.action && typeof opts.action === "function") {
        opts.action(opts, item);
      } else if (opts.route) {
        this.$router.push({ name: opts.route, params: { uuid: item.uuid } });
      } else if (opts.getRoute && _.isFunction(opts.getRoute)) {
        const route = opts.getRoute(item);
        if (route) {
          this.$router.push({ name: route, params: { uuid: item.uuid } });
        }
      }
    },
    getBalanceClass(balance) {
      let classText = balance > 0 ? "text-success" : "text-danger";
      classText = balance && Number(balance) != 0 ? classText : "text-muted";
      classText = classText + " font-weight-600";
      return classText;
    },
    getPopoverContent(rowItem, type = "list", entityKey, entityProperty = "name", customContentFn) {
      if (type === "list" && entityKey && entityProperty) {
        let content = this.getDetailsList(rowItem[entityKey], entityProperty);
        content = `<ul>${content.join()}</ul>`;
        return content;
      } else if (type === "custom" && customContentFn && typeof customContentFn === "function") {
        return customContentFn(rowItem);
      }
    },
    getDetailsList(entities, key) {
      return entities.map((entity) => {
        return `<li>${entity[key]}</li>`;
      });
    },
    momentFn(date, inFormat, outFormat) {
      return moment(date, inFormat || this.vars.serverDateFormat).format(outFormat || this.vars.defaultDateFormat);
    }
  },
  mounted() {
    EventBus.$off("REFRESH_TABLE", this.refreshTableIfRoute);
    EventBus.$on("REFRESH_TABLE", this.refreshTableIfRoute);
    EventBus.$off("TOGGLE_FILTER", this.toggleFilter);
    EventBus.$on("TOGGLE_FILTER", this.toggleFilter);
    EventBus.$off("CLEAR_FILTERS", this.clearFilters);
    EventBus.$on("CLEAR_FILTERS", this.clearFilters);
    EventBus.$off("EXPORT", this.export);
    EventBus.$on("EXPORT", this.export);
    if (this.isFiltered) {
      this.showFilters = true;
    }
    this.doInit();
  },
  destroyed() {
    EventBus.$off("REFRESH_TABLE", this.refreshTableIfRoute);
    EventBus.$off("TOGGLE_FILTER", this.toggleFilter);
    EventBus.$off("CLEAR_FILTERS", this.clearFilters);
    EventBus.$off("EXPORT", this.export);
  }
};
export {
  table as t
};
//# sourceMappingURL=table.f559165b.js.map
