import { j as instance, k as instanceSilent } from "./app.9a8150b2.js";
function uploadImage(options, onUploadProgress) {
  return instance({
    url: options.url,
    method: "post",
    data: options.data,
    upload: true,
    config: { headers: { "Content-Type": "multipart/form-data" } },
    headers: { "Content-Type": "multipart/form-data; charset=utf-8; boundary=" + Math.random().toString().substr(2) },
    onUploadProgress
  });
}
function removeImage(options) {
  return instance({
    url: options.url,
    method: "delete",
    data: options.data
  });
}
function uploadFile(options, onUploadProgress, cancelToken) {
  const data = {
    url: options.url,
    method: "post",
    data: options.data,
    upload: true,
    config: { headers: { "Content-Type": "multipart/form-data" } },
    headers: { "Content-Type": "multipart/form-data; charset=utf-8; boundary=" + Math.random().toString().substr(2) },
    onUploadProgress,
    cancelToken
  };
  if (options.silent) {
    return instanceSilent(data);
  }
  return instance(data);
}
function removeFile(options) {
  return instance({
    url: options.url,
    method: "delete",
    data: options.data
  });
}
export {
  uploadImage as a,
  removeImage as b,
  removeFile as r,
  uploadFile as u
};
//# sourceMappingURL=uploader.39656730.js.map
