import { c as configs } from "../../../meeting-configs.55b97e1f.js";
import { f as form } from "../../../form.ff4ac955.js";
import { E as EventBus } from "../../../event-bus.0afcd682.js";
import { E as EditConfig } from "../../../edit-config.aa4a5abe.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../header.a91390e7.js";
import "../../../app.9a8150b2.js";
import "../../../vendor/vendor-core.2a9962eb.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../FileUploader.a3ada0d1.js";
import "../../../uploader.39656730.js";
import "../../../momentz.3304bf92.js";
const _sfc_main = {
  extends: form,
  components: {
    EditConfig
  },
  data() {
    return {
      formData: configs(),
      preRequisite: {
        rtcLibraries: [
          { uuid: "rtcmc", label: "RTCMC" }
        ]
      },
      initUrl: "meetings",
      initSubUrl: "config",
      meeting: null
    };
  },
  methods: {
    getMeeting() {
      this.isLoading = true;
      this.doInit();
      this.Get(this.subUuid).then((response) => {
        this.doInitSub();
        this.meeting = response;
        if (response.config) {
          this.formData.objForEach((value, key) => {
            this.formData[key] = response.config.hasOwnProperty(key) ? response.config[key] : this.formData[key];
          });
        }
        this.initialFormData = _.cloneDeep(this.formData);
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    },
    changeMeetingConfigsFormData(configFormData = {}) {
      Object.assign(this.formData, configFormData);
    },
    beforeSubmit() {
      return !(this.formData.autoUploadRecording && this.formData.autoUploadRecorded);
    }
  },
  mounted() {
    this.getMeeting();
  },
  beforeRouteLeave(to, from, next) {
    EventBus.$emit("ROUTE_LEAVING", next);
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor, "id": "printable" } }, [_c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_c("edit-config", { attrs: { "configs": _vm.configs, "meeting": _vm.meeting, "meeting-config": _vm.formData, "formErrors": _vm.formErrors, "preRequisite": _vm.preRequisite }, on: { "changed": _vm.changeMeetingConfigsFormData } }), _c("div", { staticClass: "form-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.$router.back();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.cancel")))])], 1), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light" }, on: { "click": _vm.reset } }, [_vm._v(_vm._s(_vm.$t("general.reset")))]), _c("base-button", { attrs: { "type": "submit", "design": "primary" } }, [_vm._v(_vm._s(_vm.$t("global.save", { attribute: _vm.$t("config.config") })))])], 1)])], 1)]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const config = __component__.exports;
export {
  config as default
};
//# sourceMappingURL=config.0e95595f.js.map
