import { m as mapGetters, i as mapActions } from "../../../vendor/vendor-core.2a9962eb.js";
import { f as form } from "../../../form.ff4ac955.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../header.a91390e7.js";
import "../../../app.9a8150b2.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../FileUploader.a3ada0d1.js";
import "../../../uploader.39656730.js";
import "../../../event-bus.0afcd682.js";
import "../../../momentz.3304bf92.js";
const _sfc_main = {
  extends: form,
  data() {
    return {
      formData: {
        identifier: ""
      },
      initUrl: "meetings"
    };
  },
  computed: {
    ...mapGetters("config", [
      "configs"
    ]),
    demoImage() {
      if (!this.configs.assets) {
        return "/images/demo-screenshot.jpg";
      }
      let demoImage = this.configs.assets.meetingDemoImage ? this.configs.assets.meetingDemoImage : "/images/demo-screenshot.jpg";
      return demoImage;
    }
  },
  methods: {
    ...mapActions("config", [
      "SetUiConfig"
    ]),
    submit() {
      if (formUtil.isUnchanged(this.initialFormData, this.formData)) {
        this.$toasted.info(this.$t("general.nothing_changed"), this.$toastConfig.info);
        return false;
      }
      this.isLoading = true;
      this.Custom({
        url: `/meetings/m/${this.formData.identifier}`,
        method: "get"
      }).then((response) => {
        if (response.uuid) {
          this.$router.push({ name: "liveMeeting", params: { uuid: response.uuid } });
        }
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    this.isLoading = false;
    this.$nextTick(() => {
      this.SetUiConfig({ pageHeaderShow: false });
    });
  },
  destroyed() {
    this.SetUiConfig({ pageHeaderShow: true });
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { staticClass: "mt-element", attrs: { "boxed": "" } }, [_vm.isLoading ? [_c("div", { staticClass: "pt-150 pb-150 text-center" }, [_c("animated-loader", { attrs: { "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor, "size": "inline", "with-overlay": false } }), _c("br"), _c("br"), _c("h5", [_vm._v(_vm._s(_vm.$t("meeting.joining_a_meeting")))])], 1)] : [_c("div", { staticClass: "row pt-15 pb-15" }, [_c("div", { staticClass: "col-12 col-md-5 pt-50 pb-50" }, [_c("h1", { staticClass: "text-left" }, [_vm._v(_vm._s(_vm.$t("meeting.join_a_meeting")))]), _c("p", { staticClass: "text-muted" }, [_vm._v(_vm._s(_vm.$t("meeting.join_a_meeting_desc")))]), _c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.$t("meeting.enter_meeting_code"), "type": "text", "error": _vm.formErrors.identifier, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "identifier", $event);
  } }, model: { value: _vm.formData.identifier, callback: function($$v) {
    _vm.$set(_vm.formData, "identifier", $$v);
  }, expression: "formData.identifier" } }), _c("div", { staticClass: "form-footer mt-5" }, [_vm.hasPermission("create-meeting") ? _c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light" }, on: { "click": function($event) {
    return _vm.$router.push({ name: "appInstantMeetingStart" });
  } } }, [_vm._v(_vm._s(_vm.$t("meeting.new_meeting")))])], 1) : _vm._e(), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "submit", "design": "primary" } }, [_vm._v(_vm._s(_vm.$t("meeting.join")))])], 1)])], 1)]), _c("div", { staticClass: "col-12 col-md-6 offset-md-1" }, [_c("img", { staticClass: "img-fluid img-thumbnail", attrs: { "src": _vm.demoImage } })])])]], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const join = __component__.exports;
export {
  join as default
};
//# sourceMappingURL=join.a127c294.js.map
