import { t as table } from "../../../table.f559165b.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../app.9a8150b2.js";
import "../../../vendor/vendor-core.2a9962eb.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../header.a91390e7.js";
import "../../../event-bus.0afcd682.js";
const _sfc_main = {
  components: {},
  extends: table,
  data() {
    return {
      fields: [
        {
          key: "name",
          label: $t("option.props.name"),
          sort: "name"
        },
        {
          key: "slug",
          label: $t("option.props.slug"),
          sort: "slug"
        },
        {
          key: "description",
          label: $t("option.props.description")
        },
        {
          key: "parent.name",
          label: $t("option.props.parent"),
          sort: "parent_id"
        },
        {
          key: "createdAt",
          label: $t("general.created_at"),
          sort: "created_at",
          transformer: "date",
          thClass: "d-none",
          tdClass: "d-none"
        },
        {
          key: "updatedAt",
          label: $t("general.updated_at"),
          sort: "updated_at",
          transformer: "date",
          thClass: "d-none",
          tdClass: "d-none"
        },
        {
          key: "actions",
          label: "",
          cantHide: true,
          tdClass: "actions-wrapper"
        }
      ],
      preRequisite: {
        options: []
      },
      filtersOptions: {
        name: ""
      },
      permissionsRequired: "access-config",
      routesRequired: {},
      initUrl: "options",
      dataType: "option",
      entityTitle: "option.option",
      entitiesTitle: "option.options",
      entityDescription: "option.module_description",
      hasSlug: false,
      hasParent: false,
      hideFilterButton: true,
      routeNamePrefix: ""
    };
  },
  mounted() {
    this.getInitialData();
  },
  beforeMount() {
    const meta = this.$route.meta;
    this.customFilters.type = meta.optionType;
    this.entityTitle = meta.entityTitle;
    this.entitiesTitle = meta.entitiesTitle;
    this.entityDescription = meta.entityDescription;
    this.permissionsRequired = meta.permissionRequired;
    this.routeNamePrefix = meta.routeNamePrefix;
    this.routesRequired.add = `${meta.routeNamePrefix}Add`;
    this.fields = this.fields.filter((f) => {
      if (f.key === "slug") {
        return meta.hasSlug;
      } else if (f.key === "parent.name") {
        return meta.hasParent;
      }
      return true;
    });
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { staticClass: "p-0 flex-grow", attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.isInitialized ? _c("table-wrapper", { attrs: { "meta": _vm.entities.meta, "filtered": _vm.isFiltered, "add-button-route": _vm.routesRequired.add, "entity-title": _vm.entityTitle, "entities-title": _vm.entitiesTitle, "entity-description": _vm.entityDescription } }, [_c("b-table", { directives: [{ name: "show", rawName: "v-show", value: _vm.entities.meta.total, expression: "entities.meta.total" }], ref: "btable", attrs: { "items": _vm.itemsProvider, "fields": _vm.fields, "busy": _vm.isLoading, "hover": "", "striped": "", "stacked": "sm", "per-page": _vm.entities.meta.perPage, "current-page": _vm.entities.meta.currentPage, "filters": null }, on: { "update:busy": function($event) {
    _vm.isLoading = $event;
  } }, scopedSlots: _vm._u([{ key: "cell(createdAt)", fn: function(row) {
    return [_c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.createdAt, "with-tz": "", "tag": "span" } })];
  } }, { key: "cell(updatedAt)", fn: function(row) {
    return [_c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.updatedAt, "with-tz": "", "tag": "span" } })];
  } }, { key: "cell(actions)", fn: function(row) {
    return [_c("div", { staticClass: "btn-group", attrs: { "role": "group", "aria-label": "Actions Buttons" } }, [_vm.hasPermission(_vm.permissionsRequired) ? _c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], attrs: { "type": "button", "size": "sm", "design": "dark", "title": _vm.$t("global.edit", { attribute: _vm.$t(_vm.entityTitle) }) }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.$router.push({ name: `${_vm.routeNamePrefix}Edit`, params: { uuid: row.item.uuid } });
    } } }, [_c("i", { staticClass: "fas fa-edit" })]) : _vm._e(), _vm.hasPermission(_vm.permissionsRequired) ? _c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], attrs: { "type": "button", "size": "sm", "design": "dark", "title": _vm.$t("global.delete", { attribute: _vm.$t(_vm.entityTitle) }) }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.deleteEntity(row.item);
    } } }, [_c("i", { staticClass: "fas fa-trash" })]) : _vm._e()], 1)];
  } }], null, false, 1308271276) })], 1) : _vm._e()], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const index = __component__.exports;
export {
  index as default
};
//# sourceMappingURL=option-index.d89536da.js.map
