import { I as ImageUploader } from "../../../../../ImageUploader.fa5c4dda.js";
import { m as mapGetters, i as mapActions } from "../../../../../vendor/vendor-core.2a9962eb.js";
import { E as handleErrors } from "../../../../../app.9a8150b2.js";
import { P as ProfileImageMaleKid, a as ProfileImageMaleTeen, b as ProfileImageFemaleKid, c as ProfileImageFemaleTeen, d as ProfileImageFemale } from "../../../../../default-profile-image-female.0dd92339.js";
import { P as ProfileImageMale } from "../../../../../default-profile-image-male.529a2fd5.js";
import { n as normalizeComponent } from "../../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../../event-bus.0afcd682.js";
import "../../../../../uploader.39656730.js";
import "../../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../../vendor/vendor-essential.31dae676.js";
import "../../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../../vendor/vendor-vue-gtag.137cb49d.js";
const _sfc_main = {
  components: {
    ImageUploader
  },
  data() {
    return {
      isLoading: false
    };
  },
  computed: {
    ...mapGetters("config", [
      "configs",
      "vars"
    ]),
    ...mapGetters("user", [
      "loggedInUser"
    ])
  },
  methods: {
    ...mapActions("common", [
      "Init",
      "Custom"
    ]),
    ...mapActions("user", [
      "GetUser"
    ]),
    handleUploadError(errorMessage) {
      this.$toasted.error(errorMessage, this.$toastConfig.error);
    },
    getUserImage(gender, age) {
      if (!gender) {
        return ProfileImageMale;
      }
      if (gender.uuid === "male") {
        if (age) {
          if (age.years < 13) {
            return ProfileImageMaleKid;
          } else if (age.years < 18) {
            return ProfileImageMaleTeen;
          }
        }
        return ProfileImageMale;
      } else {
        if (age) {
          if (age.years < 13) {
            return ProfileImageFemaleKid;
          } else if (age.years < 18) {
            return ProfileImageFemaleTeen;
          }
        }
        return ProfileImageFemale;
      }
    },
    getInitialData() {
      this.isLoading = true;
      this.GetUser().then((response) => {
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        handleErrors(error);
      });
    }
  },
  mounted() {
    this.Init({ url: "users" });
    this.getInitialData();
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.loggedInUser ? _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12" }, [_c("h4", { staticClass: "text-center mb-5" }, [_vm._v(_vm._s(_vm.$t("global.upload", { attribute: _vm.$t("user.props.image") })) + " for " + _vm._s(_vm.loggedInUser.name))]), _c("hr")]), _c("div", { staticClass: "col-12 col-md-6 d-flex justify-content-center" }, [_c("image-uploader", { attrs: { "url": `/profile/avatar`, "name-label": "user.props.image", "existing-image": _vm.loggedInUser.avatar, "placeholder": _vm.getUserImage(_vm.loggedInUser.gender, _vm.loggedInUser.age), "remove-from-server": "", "profile": "" }, on: { "uploaded": _vm.getInitialData, "removed": _vm.getInitialData } })], 1), _c("div", { staticClass: "col-12 col-md-6 d-flex justify-content-center" }, [_c("image-uploader", { attrs: { "url": `/profile/avatar?type=cover`, "name-label": "user.props.cover_image", "existing-image": _vm.loggedInUser.cover, "placeholder": _vm.getUserImage(_vm.loggedInUser.gender, _vm.loggedInUser.age), "remove-from-server": "" }, on: { "uploaded": _vm.getInitialData, "removed": _vm.getInitialData } })], 1)]) : _vm._e(), _c("div", { staticClass: "form-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.$router.back();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.back")))])], 1)])]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const view = __component__.exports;
export {
  view as default
};
//# sourceMappingURL=view.35af06d6.js.map
