import { P as ProfilePage, a as ProfilePageSidebox } from "../../../../ProfilePage.f0895252.js";
import { b as addButton, p as printOption, g as exportPdfOption, a as commonKeyBindings } from "../../../../header.a91390e7.js";
import "../../../../helpers/transformers.f12abdae.js";
import { m as mapGetters, i as mapActions } from "../../../../vendor/vendor-core.2a9962eb.js";
import { E as EventBus } from "../../../../event-bus.0afcd682.js";
import { n as normalizeComponent } from "../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../app.9a8150b2.js";
import "../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../vendor/vendor-essential.31dae676.js";
import "../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../vendor/vendor-vue-gtag.137cb49d.js";
const _sfc_main = {
  components: {
    ProfilePage,
    ProfilePageSidebox
  },
  data() {
    return {
      entity: null,
      isLoading: false,
      initUrl: "users",
      dataTitle: $t("user.user"),
      fallBackRoute: "appUserList",
      headerButtons: null,
      headerLinks: null
    };
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    ...mapGetters("user", [
      "uuid",
      "hasPermission",
      "liveUsers"
    ]),
    liveUser() {
      return this.value && this.liveUsers.find((u) => u.uuid === this.value.uuid);
    },
    isOnline() {
      return !!this.liveUser;
    }
  },
  methods: {
    ...mapActions("common", [
      "Init",
      "Get",
      "Custom",
      "SetPageHeader"
    ]),
    ...mapActions("config", [
      "SetUiConfig",
      "SetConfig"
    ]),
    changeStatus(status) {
      formUtil.confirmAction().then((result) => {
        if (result.value) {
          this.isLoading = true;
          let data = {
            status
          };
          this.Custom({
            url: `/${this.initUrl}/${this.uuid}/status`,
            method: "post",
            data
          }).then((response) => {
            this.isLoading = false;
            this.getInitialData();
          }).catch((error) => {
            this.isLoading = false;
            formUtil.handleErrors(error);
          });
        } else {
          result.dismiss === Swal.DismissReason.cancel;
        }
      });
    },
    setEntityData(response) {
      if (this.entityKey && response.hasOwnProperty(this.entityKey)) {
        this.entity = response[this.entityKey];
      } else {
        this.entity = response;
      }
    },
    async getInitialData() {
      this.isLoading = true;
      try {
        let response = await this.Get({ uuid: this.uuid });
        this.setEntityData(response);
        this.isLoading = false;
        return response;
      } catch (error) {
        this.isLoading = false;
        formUtil.handleErrors(error);
        this.$router.push({ name: this.fallBackRoute });
      }
    },
    getHeaderOptions() {
      let buttons = [];
      if (this.routesRequired && this.routesRequired.add) {
        if (typeof this.permissionsRequired === "object" && this.permissionsRequired !== null && this.permissionsRequired.add) {
          buttons.push(addButton(this.routesRequired.add, this.permissionsRequired.add));
        } else if (this.permissionsRequired) {
          buttons.push(addButton(this.routesRequired.add, this.permissionsRequired));
        }
      }
      if (this.headerButtons) {
        buttons = buttons.concat(this.headerButtons);
      }
      let links = [];
      links.push(printOption());
      links.push(exportPdfOption());
      if (this.headerLinks) {
        links = links.concat(this.headerLinks);
      }
      return {
        hideLinks: this.hideHeaderLinks || false,
        buttons,
        links,
        title: this.pageTitle || "",
        subTitle: this.pageTitle ? this.subTitle || "" : ""
      };
    },
    getKeyBindingOptions() {
      let opts = {
        ...commonKeyBindings
      };
      if (this.routesRequired && this.routesRequired.add) {
        opts["key_a"] = this.routesRequired.add;
      }
      if (this.routesRequired && this.routesRequired.edit) {
        opts["key_e"] = this.routesRequired.edit;
      }
      return opts;
    },
    applyPageHeader() {
      let pageHeaderOptions = Object.assign({}, this.getHeaderOptions(), this.header || {});
      let keyBindings = Object.assign({}, this.getKeyBindingOptions(), this.keyBindings || {});
      this.SetPageHeader(pageHeaderOptions);
      this.SetConfig({
        keyBindings
      });
    },
    async export(options) {
      this.isLoading = true;
      try {
        let printTitle = `Printing ${this.dataTitle || ""}`;
        if (this.printTitle) {
          printTitle = this.printTitle;
        }
        const printPreview = this.configs.system.printPreview;
        this.$printComponent("printable", { title: printTitle, autoPrint: !printPreview, autoCloseAfterPrint: !printPreview });
      } catch (e) {
      }
      this.isLoading = false;
    },
    doInit() {
      this.Init({ url: this.initUrl });
      this.getInitialData();
      this.applyPageHeader();
    }
  },
  mounted() {
    EventBus.$off("EXPORT", this.export);
    EventBus.$on("EXPORT", this.export);
    this.doInit();
  },
  destroyed() {
    EventBus.$off("EXPORT", this.export);
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("profile-page", { attrs: { "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor, "inner-sidebar-box-classes": "h-100" }, scopedSlots: _vm._u([{ key: "sidebarMainContent", fn: function() {
    return [_vm.entity ? _c("profile-card", { attrs: { "name": _vm.entity.profile.name, "sub-heading": _vm.entity.username || "-", "gender": _vm.entity.profile.gender, "image": _vm.entity.profile.avatar, "cover-image": _vm.entity.profile.cover, "age": _vm.entity.profile.age, "data-card-color": "whitish", "user-status": _vm.isOnline, "user": _vm.entity, "horizontal": false, "edit-image": "" } }) : _vm._e()];
  }, proxy: true }, { key: "mainContent", fn: function() {
    return [_c("base-container", { attrs: { "boxed": "", "with-loader": "", "has-footer": "", "min-height": "full", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.entity ? [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("view-single", { attrs: { "label": _vm.$t("user.props.name"), "value": _vm.entity.profile.name } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("view-single", { attrs: { "label": _vm.$t("user.props.gender"), "value": _vm.entity.profile.gender, "showIfExists": "name" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("view-single", { attrs: { "label": _vm.$t("user.props.email"), "value": _vm.entity.email } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("view-single", { attrs: { "label": _vm.$t("user.props.birth_date"), "value": _vm._f("moment")(_vm.entity.profile.birthDate, _vm.vars.defaultDateFormat) } })], 1)])] : _vm._e(), _c("div", { staticClass: "form-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
      return _vm.$router.back();
    } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.back")))])], 1), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "button", "design": "dark" }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.$router.push({ name: "appProfileViewImage", params: { uuid: _vm.entity.uuid } });
    } } }, [_c("i", { staticClass: "fas fa-image" }), _vm._v(" " + _vm._s(_vm.$t("global.edit", { attribute: _vm.$t("user.props.image") })))]), _c("base-button", { attrs: { "type": "button", "design": "primary" }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.$router.push({ name: "appProfileEdit", params: { uuid: _vm.entity.uuid } });
    } } }, [_c("i", { staticClass: "fas fa-edit" }), _vm._v(" " + _vm._s(_vm.$t("global.edit", { attribute: _vm.$t("user.user") })))])], 1)])], 2)];
  }, proxy: true }]) });
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const view = __component__.exports;
export {
  view as default
};
//# sourceMappingURL=view.516e1411.js.map
