import { t as table } from "../../../../table.f559165b.js";
import { f as filterForm } from "../../../../filter-form.416a20d1.js";
import { n as normalizeComponent } from "../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../app.9a8150b2.js";
import "../../../../vendor/vendor-core.2a9962eb.js";
import "../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../vendor/vendor-essential.31dae676.js";
import "../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../../header.a91390e7.js";
import "../../../../event-bus.0afcd682.js";
const _sfc_main$1 = {
  extends: filterForm
};
var _sfc_render$1 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("filter-wrapper", { attrs: { "boxed": _vm.boxed, "is-loading": _vm.isLoading }, on: { "close": function($event) {
    return _vm.$emit("close");
  } } }, [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.$t("general.search_keyword"), "type": "text", "disabled": _vm.isLoading }, model: { value: _vm.filters.keyword, callback: function($$v) {
    _vm.$set(_vm.filters, "keyword", $$v);
  }, expression: "filters.keyword" } })], 1), _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-select", { attrs: { "options": _vm.preRequisite.statuses, "label": _vm.$t("utility.todo.props.status"), "disabled": _vm.isLoading, "simple": true }, model: { value: _vm.filters.status, callback: function($$v) {
    _vm.$set(_vm.filters, "status", $$v);
  }, expression: "filters.status" } })], 1), _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("date-between", { attrs: { "label": _vm.$t("global.between", { attribute: _vm.$t("utility.todo.todo") }), "start": _vm.filters.startDate, "end": _vm.filters.endDate, "disabled": _vm.isLoading }, on: { "update:start": function($event) {
    return _vm.$set(_vm.filters, "startDate", $event);
  }, "update:end": function($event) {
    return _vm.$set(_vm.filters, "endDate", $event);
  } } })], 1)])]);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  null,
  null,
  null
);
const FilterForm = __component__$1.exports;
const _sfc_main = {
  components: {
    FilterForm
  },
  extends: table,
  data() {
    return {
      fields: [
        {
          key: "title",
          label: $t("utility.todo.props.title"),
          sort: "title",
          transformer: "limitWords",
          tdClass: "td-ellipsis max-width-250px"
        },
        {
          key: "date",
          label: $t("utility.todo.due_on"),
          sort: "date",
          transformer: "date"
        },
        {
          key: "status",
          label: $t("utility.todo.props.status"),
          sort: "status",
          transformer: "badgeStatusCompleted"
        },
        {
          key: "completedAt",
          label: $t("utility.todo.completed_at"),
          sort: "completed_at",
          transformer: "date"
        },
        {
          key: "actions",
          label: "",
          cantHide: true,
          tdClass: "actions-dropdown-wrapper"
        }
      ],
      filtersOptions: {
        keyword: "",
        status: "",
        startDate: "",
        endDate: ""
      },
      permissionsRequired: "access-todo",
      routesRequired: {
        add: "appUtilityTodoAdd"
      },
      initUrl: "utility/todos",
      dataType: "todo"
    };
  },
  methods: {
    toggleTodo(todo) {
      this.isLoading = true;
      this.Custom({
        url: "utility/todos/" + todo.uuid + "/status",
        method: "post"
      }).then((response) => {
        this.isLoading = false;
        this.$nextTick(() => {
          this.refreshTable();
        });
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    this.updatePageMeta();
  }
};
var _sfc_render = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "entity-list-container" }, [_c("collapse-transition", { attrs: { "group": true, "duration": 300, "tag": "div" } }, [_vm.showFilters ? _c("filter-form", { key: "filters", attrs: { "boxed": true, "pre-requisite": _vm.preRequisite, "is-loading": _vm.isLoading }, on: { "close": _vm.toggleFilter } }) : _vm._e(), _c("base-container", { key: "list", staticClass: "p-0", attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.isInitialized ? _c("table-wrapper", { attrs: { "meta": _vm.entities.meta, "filtered": _vm.isFiltered, "add-button-route": "appUtilityTodoAdd", "add-button-permissions": ["access-todo"], "entity-title": "utility.todo.todo", "entities-title": "utility.todo.todos", "entity-description": "utility.todo.module_description" } }, [_c("b-table", { directives: [{ name: "show", rawName: "v-show", value: _vm.entities.meta.total, expression: "entities.meta.total" }], ref: "btable", attrs: { "items": _vm.itemsProvider, "fields": _vm.fields, "busy": _vm.isLoading, "hover": "", "striped": "", "stacked": "sm", "per-page": _vm.entities.meta.perPage, "current-page": _vm.entities.meta.currentPage, "filters": null }, on: { "update:busy": function($event) {
    _vm.isLoading = $event;
  }, "row-dblclicked": function($event) {
    return _vm.rowClickHandler({ route: "appUtilityTodoView" }, $event);
  } }, scopedSlots: _vm._u([{ key: "cell(date)", fn: function(row) {
    return [row.item.time ? _c("view-date", { staticClass: "mb-0", attrs: { "value": `${row.item.date} ${row.item.time}`, "with-tz": "", "tag": "span" } }) : _c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.date, "tag": "span" } })];
  } }, { key: "cell(completedAt)", fn: function(row) {
    return [_c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.completedAt, "with-tz": "", "tag": "span" } })];
  } }, { key: "cell(status)", fn: function(row) {
    return [_c("div", { staticClass: "pointer", on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.toggleTodo(row.item);
    } } }, [row.item.status ? _c("badge", { attrs: { "rounded": "", "type": "primary" } }, [_c("i", { staticClass: "far fa-check-circle" }), _vm._v(" " + _vm._s(_vm.$t("utility.todo.completed")))]) : _c("badge", { attrs: { "rounded": "", "type": "dark" } }, [_c("i", { staticClass: "far fa-circle" }), _vm._v(" " + _vm._s(_vm.$t("utility.todo.incomplete")))])], 1)];
  } }, { key: "cell(actions)", fn: function(row) {
    return [_c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], class: row.item.status ? "text-success" : "text-dark", attrs: { "type": "button", "size": "sm", "design": "", "title": _vm.$t("global.toggle", { attribute: _vm.$t("utility.todo.todo") }) }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.toggleTodo(row.item);
    } } }, [row.item.status ? _c("i", { staticClass: "fas fa-check-circle" }) : _c("i", { staticClass: "fas fa-times-circle" })]), _c("table-row-actions", [_c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appUtilityTodoView", params: { uuid: row.item.uuid } } } }, [_c("i", { staticClass: "fas fa-arrow-circle-right" }), _vm._v(" " + _vm._s(_vm.$t("global.view", { attribute: _vm.$t("utility.todo.todo") })))]), _vm.hasPermission("edit-user") ? _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appUtilityTodoEdit", params: { uuid: row.item.uuid } } } }, [_c("i", { staticClass: "fas fa-edit" }), _vm._v(" " + _vm._s(_vm.$t("global.edit", { attribute: _vm.$t("utility.todo.todo") })))]) : _vm._e(), _vm.hasPermission("delete-user") ? _c("a", { staticClass: "dropdown-item", on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.deleteEntity(row.item);
    } } }, [_c("i", { staticClass: "fas fa-trash" }), _vm._v(" " + _vm._s(_vm.$t("global.delete", { attribute: _vm.$t("utility.todo.todo") })))]) : _vm._e()], 1)];
  } }], null, false, 998769854) })], 1) : _vm._e()], 1)], 1)], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const index = __component__.exports;
export {
  index as default
};
//# sourceMappingURL=todo-index.fab771d2.js.map
