import { A as AppSidebar } from "../../../AppSidebar.43e19366.js";
import { A as AppLogo } from "../../../AppLogo.c559b5f2.js";
import { m as mapGetters, j as mapState, i as mapActions } from "../../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import { k as BCollapse } from "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
const appSidebarLeft_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  components: {
    AppSidebar,
    AppLogo,
    BCollapse
  },
  data() {
    return {
      lastStyle: "",
      currentScrollPosition: {
        x: 0,
        y: 0
      },
      lastScrollPosition: {
        x: 0,
        y: 0
      },
      isCollapseOpen: false
    };
  },
  computed: {
    ...mapGetters("config", [
      "configs",
      "uiConfigs"
    ]),
    ...mapGetters("user", {
      profile: "profile"
    }),
    ...mapState("config", {
      showPin: (state) => state.ui.leftSidebarHeight === "full" && (state.ui.leftSidebarStyle === "over" || state.ui.leftSidebarStyle === "folded"),
      showUnpin: (state) => state.ui.leftSidebarHeight === "full" && state.ui.leftSidebarStyle === "push-content",
      thumbRight: (state) => state.ui.leftSidebarStyle === "folded" || state.ui.navMenuThumbOnRight
    }),
    sidebarStyle() {
      if (this.uiConfigs.leftSidebarColor === "wallpaper") {
        if (this.uiConfigs.wallpaper) {
          return {
            "--bg-image": `url(${this.uiConfigs.wallpaper.urls.regular})`
          };
        } else {
          this.$store.dispatch("config/getWallpaper");
        }
      }
      return {
        "--bg-image": ""
      };
    },
    sidebarOpen() {
      return this.uiConfigs.leftSidebarShow;
    }
  },
  watch: {
    sidebarOpen(v) {
      setTimeout(() => {
        this.isCollapseOpen = v;
      }, 150);
    }
  },
  methods: {
    ...mapActions("config", [
      "SetUiConfig"
    ]),
    pinSidebar() {
      this.lastStyle = this.uiConfigs.leftSidebarStyle;
      this.SetUiConfig({ leftSidebarStyle: "push-content" });
      this.SetUiConfig({ leftSidebarBackdrop: false });
      this.SetUiConfig({ leftSidebarShadow: false });
    },
    unpinSidebar() {
      this.SetUiConfig({ leftSidebarStyle: this.lastStyle || "folded" });
      this.SetUiConfig({ leftSidebarBackdrop: true });
      this.SetUiConfig({ leftSidebarShadow: true });
    },
    showSidebar() {
      this.SetUiConfig({ leftSidebarShow: true });
      setTimeout(() => {
        if (this.$refs.vuescrollSidebarLeft) {
          this.$refs.vuescrollSidebarLeft.scrollTo(this.lastScrollPosition, { speed: 100, easing: "easeInOutCubic" });
        }
      }, 100);
    },
    handleScroll(vertical, horizontal, nativeEvent) {
      this.currentScrollPosition.x = horizontal;
      this.currentScrollPosition.y = vertical;
    },
    hideSidebar() {
      this.SetUiConfig({ leftSidebarShow: false });
      setTimeout(() => {
        this.lastScrollPosition.x = this.currentScrollPosition.x.scrollLeft;
        this.lastScrollPosition.y = this.currentScrollPosition.y.scrollTop;
        if (this.$refs.vuescrollSidebarLeft) {
          this.$refs.vuescrollSidebarLeft.scrollTo({
            x: 0,
            y: 0
          }, { speed: 100, easing: "easeInOutCubic" });
        }
      }, 100);
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("app-sidebar", { staticClass: "left-sidebar", style: _vm.sidebarStyle, attrs: { "data-v-step": "menu-sidebar" } }, [_c("div", _vm._g({ staticClass: "wrapper" }, _vm.uiConfigs.leftSidebarStyle === "folded" ? { mouseenter: _vm.showSidebar, mouseleave: _vm.hideSidebar } : {}), [_c("div", { staticClass: "content" }, [_c("div", { staticClass: "logo-wrapper" }, [_c("app-logo", { attrs: { "place": "sidebar" } }), _c("div", { staticClass: "seperator" }), _c("div", { staticClass: "sidebar-switches" }, [_vm.showPin ? _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "unpinned", attrs: { "title": _vm.$t("config.ui.pin_sidebar") }, on: { "click": _vm.pinSidebar } }, [_c("i", { staticClass: "far fa-circle" })]) : _vm.showUnpin ? _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "pinned", attrs: { "title": _vm.$t("config.ui.pin_sidebar") }, on: { "click": _vm.unpinSidebar } }, [_c("i", { staticClass: "fas fa-dot-circle" })]) : _vm._e()])], 1), _c("vue-scroll", { ref: "vuescrollSidebarLeft", class: ["vue-scroll-sidebar-left", { "menu-after-widgets": _vm.configs.sidebar.showMenuAfterWidgets }, { "has-widgets": _vm.configs.sidebar.enableWidgets }], attrs: { "id": "vuescrollSidebarLeft" }, on: { "handle-scroll": _vm.handleScroll } }, [_vm.configs.sidebar.showMenuAfterWidgets ? [_vm._t("widgets"), _vm._t("menu")] : [_vm._t("menu"), _vm._t("widgets")]], 2), _vm.uiConfigs.leftSidebarColor === "wallpaper" && _vm.uiConfigs.wallpaper ? _c("div", { staticClass: "unsplash-credit" }, [_vm._v(" Photo by "), _c("a", { attrs: { "href": _vm.uiConfigs.wallpaper.user.links.html } }, [_vm._v(_vm._s(_vm.uiConfigs.wallpaper.user.name))]), _vm._v(" on "), _c("a", { attrs: { "href": "https://unsplash.com" } }, [_vm._v("Unsplash")])]) : _vm._e(), _vm._t("default")], 2)])]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const appSidebarLeft = __component__.exports;
export {
  appSidebarLeft as default
};
//# sourceMappingURL=app-sidebar-left.2cf48c7d.js.map
