import { m as mapGetters } from "./vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  props: {
    tag: {
      type: String,
      default: "a"
    },
    place: {
      type: String,
      default: "normal"
    },
    size: {
      type: String,
      default: "normal"
    },
    appLogo: {
      type: Boolean,
      default: false
    },
    inline: {
      type: Boolean,
      default: false
    },
    link: {
      type: String,
      default: ""
    },
    assets: {
      type: Object
    }
  },
  data() {
    return {
      appLogoText: window.kmenv.name
    };
  },
  computed: {
    ...mapGetters("config", [
      "configs",
      "uiConfigs"
    ]),
    computedUrl() {
      return this.tag === "a" ? this.link !== "" ? this.link : "/" : false;
    },
    orgLogo() {
      if (this.appLogo || !(this.configs.assets || this.assets)) {
        if (this.place === "navbar" || this.place === "sidebar" || this.place === "dark") {
          return "/images/logo-light.png";
        }
        return "/images/logo.png";
      }
      let finalLogo = this.assets && this.assets.logo ? this.assets.logo : this.configs.assets.logo ? this.configs.assets.logo : "/images/logo.png";
      if (this.assets && this.assets.logoLight || this.configs.assets.logoLight) {
        if (this.place === "navbar" && this.uiConfigs.topNavbarLogoLight || this.place === "sidebar" && this.uiConfigs.leftSidebarLogoLight || this.place === "dark") {
          finalLogo = this.assets && this.assets.logoLight ? this.assets.logoLight : this.configs.assets.logoLight;
        }
      }
      return finalLogo;
    },
    orgIcon() {
      if (!(this.configs.assets || this.assets)) {
        return "/images/icon.png";
      }
      let finalIcon = this.assets && this.assets.icon ? this.assets.icon : this.configs.assets.icon ? this.configs.assets.icon : "/images/icon.png";
      return finalIcon;
    },
    appTitle() {
      return this.configs.basic ? this.configs.basic.appName : window.kmenv.name;
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c(_vm.tag, { tag: "component", class: ["logo", `${_vm.place}-logo`, `${_vm.size}-logo`, _vm.orgLogo ? "org-logo" : "app-logo", _vm.inline ? "inline-logo" : ""], attrs: { "href": _vm.computedUrl } }, [_vm.orgLogo ? _c("img", { staticClass: "logo-icon", attrs: { "src": _vm.orgLogo, "alt": _vm.appTitle } }) : _vm._e(), _vm.orgIcon ? _c("img", { staticClass: "logo-icon-mobile", attrs: { "src": _vm.orgIcon, "alt": _vm.appTitle } }) : [_c("span", { staticClass: "logo-text", attrs: { "title": _vm.appTitle } }, [_vm._v(_vm._s(_vm.appLogoText))])]], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const AppLogo = __component__.exports;
export {
  AppLogo as A
};
//# sourceMappingURL=AppLogo.c559b5f2.js.map
