import { m as mapGetters } from "../vendor/vendor-core.2a9962eb.js";
import { P as ProfileImageMaleKid, a as ProfileImageMaleTeen, b as ProfileImageFemaleKid, c as ProfileImageFemaleTeen, d as ProfileImageFemale } from "../default-profile-image-female.0dd92339.js";
import { P as ProfileImageMale } from "../default-profile-image-male.529a2fd5.js";
import { n as normalizeComponent } from "../_plugin-vue2_normalizer.7b9a2fe2.js";
import { m as BPopover } from "../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../vendor/vendor-others.d4f8aae2.js";
const _sfc_main = {
  name: "view-user",
  components: {
    BPopover
  },
  props: {
    label: {
      type: String,
      description: "View label (text before input)"
    },
    labelClasses: {
      type: [String, Array],
      description: "View label css classes",
      default: "d-block"
    },
    dataClasses: {
      type: [String, Array],
      description: "View css classes"
    },
    value: {
      type: [String, Number, Boolean, Object],
      description: "View value"
    },
    tag: {
      type: String,
      description: "Tag value",
      default: "h6"
    },
    subtitleKey: {
      type: String,
      default: "username"
    },
    subtitleSecondaryKey: {
      type: String,
      default: "email"
    },
    subArr: {
      type: Array
    },
    showSub: {
      type: Boolean,
      default: true
    },
    showImage: {
      type: Boolean,
      default: true
    },
    size: {
      type: String,
      default: "md"
    },
    showStatus: {
      type: Boolean,
      default: true
    },
    showStatusIfOnline: {
      type: Boolean,
      default: true
    },
    showButtons: {
      type: Boolean,
      default: false
    },
    showPopoverButtons: {
      type: Boolean,
      default: true
    },
    focusable: {
      type: Boolean,
      default: false
    },
    hidePopover: {
      type: Boolean,
      default: false
    },
    inlineSub: {
      type: Boolean,
      default: false
    },
    inline: {
      type: Boolean,
      default: false
    },
    link: {
      type: Object,
      default: null
    },
    linkSecond: {
      type: Object,
      default: null
    }
  },
  data() {
    return {
      elementId: "",
      renderPopover: false,
      showPopup: false,
      timer: "",
      isInInfo: false
    };
  },
  computed: {
    ...mapGetters("user", [
      "liveUsers",
      "liveLoggedInUser"
    ]),
    isLoggedIn() {
      return this.value && this.liveLoggedInUser && this.value.uuid === this.liveLoggedInUser.uuid;
    },
    liveUser() {
      return this.value && this.liveUsers.find((u) => u.uuid === this.value.uuid);
    },
    isOnline() {
      return !!this.liveUser;
    },
    isUserBusy() {
      return this.isOnline && !!this.liveUser.busy;
    },
    computedLink() {
      return this.link ? this.link : this.profileLink ? this.profileLink : null;
    },
    computedLinkSecond() {
      return this.linkSecond ? this.linkSecond : this.ledgerLink ? this.ledgerLink : null;
    },
    profileLink() {
      return this.value ? { name: "appUserView", params: { uuid: this.value.uuid, slug: this.value.slug } } : null;
    }
  },
  methods: {
    getSubValue(keys, fromVal) {
      keys = keys.split(".");
      let val = fromVal;
      keys.forEach((k) => {
        val = val[k];
      });
      return val;
    },
    computedImage() {
      if (!(this.value.profile && this.value.profile.gender)) {
        return ProfileImageMale;
      }
      const gender = this.value.profile.gender;
      const age = this.value.profile.age;
      if (gender === "male" || gender.uuid === "male") {
        if (age) {
          if (age.years < 13) {
            return ProfileImageMaleKid;
          } else if (age.years < 18) {
            return ProfileImageMaleTeen;
          }
        }
        return ProfileImageMale;
      } else {
        if (age) {
          if (age.years < 13) {
            return ProfileImageFemaleKid;
          } else if (age.years < 18) {
            return ProfileImageFemaleTeen;
          }
        }
        return ProfileImageFemale;
      }
    },
    hover() {
      let vm = this;
      this.timer = setTimeout(() => {
        vm.showPopover();
      }, 300);
    },
    hoverOut() {
      let vm = this;
      clearTimeout(vm.timer);
      this.timer = setTimeout(() => {
        if (!vm.isInInfo) {
          vm.closePopover();
        }
      }, 200);
    },
    hoverInfo() {
      this.isInInfo = true;
    },
    hoverOutInfo() {
      this.isInInfo = false;
      this.hoverOut();
    },
    showPopover() {
      this.showPopup = true;
    },
    closePopover() {
      this.showPopup = false;
    },
    onShow() {
    },
    onShown() {
    },
    onHidden() {
    },
    focusRef(ref) {
      this.$nextTick(() => {
        this.$nextTick(() => {
          (ref.$el || ref).focus();
        });
      });
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.renderPopover = true;
    });
  },
  created() {
    this.elementId = Math.random().toString(16).slice(2);
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "base-view view-user" }, [_c("div", { staticClass: "view-group", class: [
    { "has-label": _vm.label || _vm.$slots.label },
    { "not-empty": _vm.value || _vm.value === 0 },
    { "d-inline": _vm.inline },
    `size-${_vm.size}`
  ] }, [_vm._t("label", function() {
    return [_vm.label ? _c("label", { class: _vm.labelClasses }, [_vm._v(" " + _vm._s(_vm.label) + " ")]) : _vm._e()];
  }), _vm._t("main", function() {
    return [_vm.value && _vm.elementId ? [_c("div", { class: ["popover-parent user-popover-parent", { "show-buttons": _vm.showButtons && _vm.hidePopover }], attrs: { "id": "Container" + _vm.elementId } }, [_c("router-link", { ref: "Button" + _vm.elementId, staticClass: "btn-popover-link", class: [{ "focusable": _vm.focusable }], attrs: { "to": _vm.computedLink, "disabled": !_vm.hidePopover && _vm.showPopup, "id": "Button" + _vm.elementId, "custom": "" }, scopedSlots: _vm._u([{ key: "default", fn: function({ navigate }) {
      return [_c("button", { attrs: { "role": "link" }, on: { "click": navigate, "keypress": function($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return navigate.apply(null, arguments);
      } } }, [_c("div", { staticClass: "popover-element", on: { "mouseover": _vm.hover, "mouseout": _vm.hoverOut } }, [_vm.showImage ? _c("div", { staticClass: "user-image-wrapper" }, [_vm.value.profile && _vm.value.profile.avatar ? _c("img", { staticClass: "user-image", attrs: { "src": _vm.value.profile.avatar } }) : _c("img", { staticClass: "user-image", attrs: { "src": _vm.computedImage() } })]) : _vm._e(), _c("div", { staticClass: "user-details" }, [_c(_vm.tag, { tag: "component", class: ["view-data", { "inline-sub": _vm.inlineSub }, { "user-status": !_vm.isLoggedIn && _vm.showStatus && (!_vm.showStatusIfOnline || _vm.showStatusIfOnline && _vm.isOnline) }, { "is-online": _vm.isOnline }, { "is-offline": !_vm.isOnline }, { "is-busy": _vm.isUserBusy }, _vm.dataClasses] }, [_c("span", { staticClass: "title" }, [_vm._v(_vm._s(_vm.value.profile.name))]), _vm.showSub && _vm.inlineSub ? _c("small", { staticClass: "subtitle" }, [_vm.subtitleKey ? _c("span", { staticClass: "bracketed" }, [_vm._v(_vm._s(_vm.getSubValue(_vm.subtitleKey, _vm.value)))]) : _vm._e()]) : _vm._e()]), _vm._t("sub", function() {
        return [_vm._t("submain", function() {
          return [_vm.showSub && !_vm.inlineSub ? _c("div", { staticClass: "subtitle comma-list" }, [_vm.subtitleKey ? _c("span", { staticClass: "bracketed" }, [_vm._v(_vm._s(_vm.getSubValue(_vm.subtitleKey, _vm.value)))]) : _vm._e(), _vm.subtitleSecondaryKey ? _c("span", { staticClass: "bracketed" }, [_vm._v(_vm._s(_vm.getSubValue(_vm.subtitleSecondaryKey, _vm.value)))]) : _vm._e()]) : _vm._e()];
        }), _vm._t("subextra")];
      })], 2)])])];
    } }], null, true) }), _vm.showButtons && _vm.hidePopover ? _c("profile-buttons", { attrs: { "link": _vm.link, "user": _vm.value } }) : _vm._e(), !_vm.hidePopover && _vm.renderPopover ? [_c("b-popover", { ref: "Popover" + _vm.elementId, attrs: { "target": "Button" + _vm.elementId, "show": _vm.showPopup, "placement": "auto", "container": "Container" + _vm.elementId }, on: { "update:show": function($event) {
      _vm.showPopup = $event;
    }, "show": _vm.onShow, "shown": _vm.onShown, "hidden": _vm.onHidden } }, [_c("div", { staticClass: "user-popover dark-bg", on: { "mouseover": _vm.hoverInfo, "mouseout": _vm.hoverOutInfo } }, [_c("profile-card", { attrs: { "name": _vm.value.profile.name, "sub-heading": _vm.value.username || "-", "gender": _vm.value.profile.gender, "image": _vm.value.profile.avatar, "age": _vm.value.profile.age, "data-card-color": "whitish", "to": _vm.profileLink, "show-buttons": _vm.showPopoverButtons, "user-status": _vm.isOnline, "user": _vm.value }, on: { "buttonClicked": function($event) {
      return _vm.$root.$emit("bv::hide::popover", "Button" + _vm.elementId);
    } } })], 1)])] : _vm._e()], 2)] : _c("span", [_vm._v("-")])];
  })], 2)]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ViewUser = __component__.exports;
export {
  ViewUser as default
};
//# sourceMappingURL=ViewUser.44508661.js.map
