import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const BaseButton_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "base-button",
  props: {
    tag: {
      type: String,
      default: "button",
      description: "Button tag (default -> button)"
    },
    design: {
      type: String,
      default: "default",
      description: "Button design (e,g primary, danger etc)"
    },
    size: {
      type: String,
      default: "",
      description: "Button size lg|sm"
    },
    textColor: {
      type: String,
      default: "",
      description: "Button text color (e.g primary, danger etc)"
    },
    type: {
      type: String,
      default: "button",
      description: "Button native type (e.g submit,button etc)"
    },
    icon: {
      type: String,
      default: "",
      description: "Button icon"
    },
    text: {
      type: String,
      default: "",
      description: "Button text in case not provided via default slot"
    },
    outline: {
      type: Boolean,
      default: false,
      description: "Whether button style is outline"
    },
    rounded: {
      type: Boolean,
      default: false,
      description: "Whether button style is rounded"
    },
    noShadow: {
      type: Boolean,
      default: false,
      description: "Whether button shadow should be removed"
    },
    iconOnly: {
      type: Boolean,
      default: false,
      description: "Whether button contains only an icon"
    },
    block: {
      type: Boolean,
      default: false,
      description: "Whether button is of block type"
    }
  },
  computed: {
    classes() {
      let btnClasses = [
        { "btn-block": this.block },
        { "rounded-circle": this.rounded },
        { "shadow-none": this.noShadow },
        { "btn-icon-only": this.iconOnly },
        {
          [`text-${this.textColor}`]: this.textColor
        },
        { "btn-icon": this.icon || this.$slots.icon },
        this.design && !this.outline ? `btn-${this.design}` : "",
        this.outline ? `btn-outline-${this.design}` : ""
      ];
      if (this.size) {
        btnClasses.push(`btn-${this.size}`);
      }
      return btnClasses;
    }
  },
  methods: {
    handleClick(evt) {
      this.$emit("click", evt);
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c(_vm.tag, { tag: "component", staticClass: "btn", class: _vm.classes, attrs: { "type": _vm.tag === "button" ? _vm.type : "" }, on: { "click": _vm.handleClick } }, [_vm.$slots.icon || _vm.icon && _vm.$slots.default ? _c("span", { staticClass: "btn-inner--icon" }, [_vm._t("icon", function() {
    return [_c("i", { class: _vm.icon })];
  })], 2) : _vm._e(), !_vm.$slots.default ? _c("i", { class: _vm.icon }) : _vm._e(), _vm.$slots.icon || _vm.icon && _vm.$slots.default ? _c("span", { staticClass: "btn-inner--text" }, [_vm._t("default", function() {
    return [_vm._v(" " + _vm._s(_vm.text) + " ")];
  })], 2) : _vm._e(), !_vm.$slots.icon && !_vm.icon ? _vm._t("default") : _vm._e()], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const BaseButton = __component__.exports;
export {
  BaseButton as default
};
//# sourceMappingURL=BaseButton.85f8caa9.js.map
