import { m as mapGetters } from "../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  name: "date-between",
  props: {
    start: {
      type: String
    },
    end: {
      type: String
    },
    label: {
      type: String,
      default: "Date Between"
    },
    name: {
      type: String,
      default: "betweenDates"
    },
    disabled: {
      type: Boolean,
      default: false
    },
    required: {
      type: Boolean,
      default: false
    },
    inputClasses: {
      type: String,
      default: ""
    }
  },
  data() {
    return {
      value: ""
    };
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    bdbValue: {
      get() {
        if (this.start) {
          this.value = this.start;
          if (this.end) {
            this.value = this.value + " to " + this.end;
          }
        } else {
          this.value = "";
        }
        return this.value;
      },
      set(newValue) {
        if (newValue) {
          const dates = newValue.split(" to ");
          if (dates.length > 1) {
            this.$emit("update:start", dates[0]);
            this.$emit("update:end", dates[1]);
          } else {
            this.$emit("update:start", newValue);
            this.$emit("update:end", "");
          }
        } else {
          this.value = "";
          this.$emit("update:start", "");
          this.$emit("update:end", "");
        }
      }
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-input", { attrs: { "label": _vm.label, "addon-right-icon": "far fa-calendar-alt", "type": "text", "name": _vm.name, "is-wrapper": true, "required": _vm.required }, model: { value: _vm.bdbValue, callback: function($$v) {
    _vm.bdbValue = $$v;
  }, expression: "bdbValue" } }, [_c("date-picker", { class: ["form-control datepicker", _vm.inputClasses], attrs: { "config": _vm.vars.datepickerRangeConfig, "disabled": _vm.disabled }, model: { value: _vm.bdbValue, callback: function($$v) {
    _vm.bdbValue = $$v;
  }, expression: "bdbValue" } })], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const DateBetween = __component__.exports;
export {
  DateBetween as default
};
//# sourceMappingURL=DateBetween.1f188441.js.map
