import { E as EventBus } from "../../event-bus.0afcd682.js";
import { m as mapGetters } from "../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
import { f as BPagination } from "../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../vendor/vendor-others.d4f8aae2.js";
const _sfc_main = {
  name: "table-wrapper",
  props: {
    meta: {
      type: Object,
      default() {
        return {
          total: 0,
          currentPage: 1,
          perPage: 10
        };
      }
    },
    pagination: {
      type: Object,
      default() {
        return {
          align: "align",
          size: ""
        };
      }
    },
    entityTitle: {
      type: String,
      required: true
    },
    entitiesTitle: {
      type: String,
      required: true
    },
    entityDescription: {
      type: String,
      required: true
    },
    addButtonRoute: {
      type: String
    },
    addButtonLabel: {
      type: String,
      default: "global.add"
    },
    addButtonParams: {
      type: Object,
      default() {
        return {};
      }
    },
    addButtonQuery: {
      type: Object,
      default() {
        return {};
      }
    },
    addButtonPermissions: {
      type: Array
    },
    filtered: {
      type: Boolean,
      default: false
    },
    showReset: {
      type: Boolean,
      default: true
    },
    showFooter: {
      type: Boolean,
      default: true
    },
    smallFooter: {
      type: Boolean,
      default: false
    },
    scrollTo: {
      type: String
    },
    tableWrapperId: {
      type: String,
      default: "printableTable"
    }
  },
  components: {
    BPagination
  },
  data() {
    return {};
  },
  computed: {
    ...mapGetters("config", [
      "configs"
    ]),
    ...mapGetters("user", [
      "hasAllPermissions"
    ]),
    currentPage: {
      get() {
        return this.meta.currentPage;
      },
      set(v) {
        let query = {
          ...this.$route.query,
          currentPage: v,
          perPage: this.perPage
        };
        if (this.scrollTo) {
          query.scroll = this.scrollTo;
        }
        this.$router.push({ path: this.$route.path, query });
      }
    },
    perPage: {
      get() {
        return this.meta.perPage;
      },
      set(v) {
        let query = {
          ...this.$route.query,
          currentPage: this.currentPage,
          perPage: v
        };
        if (this.scrollTo) {
          query.scroll = this.scrollTo;
        }
        this.$router.push({ path: this.$route.path, query });
      }
    },
    isEmpty() {
      return !this.meta.total;
    }
  },
  methods: {
    reset() {
      EventBus.$emit("CLEAR_FILTERS");
    },
    changePerPage(opt) {
      if (this.perPage != opt) {
        this.perPage = opt;
      }
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { class: ["table-wrapper"] }, [_c("div", { class: [_vm.isEmpty ? "" : "min-height-400px"], attrs: { "id": _vm.tableWrapperId } }, [_vm._t("default")], 2), !_vm.filtered && _vm.isEmpty ? _c("div", { staticClass: "empty-table text-muted" }, [_vm._m(0), _c("h2", { staticClass: "text-muted", domProps: { "textContent": _vm._s(_vm.$t("global.list", { attribute: _vm.$t(_vm.entitiesTitle) })) } }), _c("p", { domProps: { "textContent": _vm._s(_vm.$t(_vm.entityDescription)) } }), _c("div", { staticClass: "mt-5" }, [_vm._t("button", function() {
    return [(!_vm.addButtonPermissions || _vm.hasAllPermissions(_vm.addButtonPermissions)) && _vm.addButtonRoute && _vm.addButtonLabel ? _c("base-button", { attrs: { "type": "button", "design": "primary" }, on: { "click": function($event) {
      return _vm.$router.push({ name: _vm.addButtonRoute, params: _vm.addButtonParams, query: _vm.addButtonQuery });
    } } }, [_c("i", { staticClass: "fas fa-plus" }), _vm._v(" " + _vm._s(_vm.$t(_vm.addButtonLabel, { attribute: _vm.$t(_vm.entityTitle) })))]) : _vm._e()];
  })], 2)]) : _vm._e(), _vm.filtered && _vm.isEmpty ? _c("div", { staticClass: "empty-table text-muted" }, [_vm._m(1), _c("h2", { staticClass: "text-muted", domProps: { "textContent": _vm._s(_vm.$t("global.could_not_find", { attribute: _vm.$t(_vm.entityTitle) })) } }), _vm.showReset || (!_vm.addButtonPermissions || _vm.hasAllPermissions(_vm.addButtonPermissions)) && _vm.addButtonRoute && _vm.addButtonLabel ? _c("div", { staticClass: "mt-5" }, [_vm.showReset ? _c("base-button", { attrs: { "type": "button", "design": "light" }, on: { "click": _vm.reset } }, [_vm._v(_vm._s(_vm.$t("general.clear")))]) : _vm._e(), (!_vm.addButtonPermissions || _vm.hasAllPermissions(_vm.addButtonPermissions)) && _vm.addButtonRoute && _vm.addButtonLabel ? _c("base-button", { attrs: { "type": "button", "design": "primary" }, on: { "click": function($event) {
    return _vm.$router.push({ name: _vm.addButtonRoute, params: _vm.addButtonParams, query: _vm.addButtonQuery });
  } } }, [_c("i", { staticClass: "fas fa-plus" }), _vm._v(" " + _vm._s(_vm.$t(_vm.addButtonLabel, { attribute: _vm.$t(_vm.entityTitle) })))]) : _vm._e()], 1) : _vm._e()]) : _vm._e(), !_vm.isEmpty ? _c("div", { staticClass: "my-5" }, [_vm._t("instructions")], 2) : _vm._e(), !_vm.isEmpty && _vm.showFooter ? _c("div", { class: ["list-pagination-component", { "small-footer": _vm.smallFooter }] }, [_c("div", { staticClass: "pagination-status-component flex-grow text-muted small" }, [_c("div", [_c("p", [_vm._v(_vm._s(_vm.$t("global.total_result_found_with_record", { attribute: _vm.meta.total, from: _vm.meta.from, to: _vm.meta.to })))]), _vm.filtered ? [_c("p", [_vm._v(_vm._s(_vm.$t("general.filtered_data")) + " - "), _c("base-button", { staticClass: "ml-1 inline", attrs: { "type": "button", "design": "link", "size": "sm" }, on: { "click": _vm.reset } }, [_vm._v(_vm._s(_vm.$t("general.clear_filter")))])], 1)] : _vm._e()], 2)]), _c("base-dropdown", { staticClass: "per-page-component", attrs: { "tag": "div", "direction": "up", "menu-classes": "show-dropdown-up", "position": "right" } }, [_c("base-button", { staticClass: "mr-3", attrs: { "slot": "title", "type": "button", "size": _vm.pagination.size, "design": "primary", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_vm._v(_vm._s(_vm.meta.perPage) + " per page "), _c("i", { staticClass: "fas fa-chevron-up" })]), _vm._l(_vm.configs.system.paginations, function(option) {
    return _c("a", { key: option, staticClass: "dropdown-item", on: { "click": function($event) {
      return _vm.changePerPage(option);
    } } }, [_c("span", { staticClass: "font-weight-700" }, [_vm._v(_vm._s(option))]), _vm._v(" per page")]);
  })], 2), _c("div", { staticClass: "pagination-buttons-component" }, [_c("b-pagination", { attrs: { "align": _vm.pagination.align, "size": _vm.pagination.size, "total-rows": _vm.meta.total, "per-page": _vm.meta.perPage }, model: { value: _vm.currentPage, callback: function($$v) {
    _vm.currentPage = $$v;
  }, expression: "currentPage" } })], 1)], 1) : _vm._e()]);
};
var _sfc_staticRenderFns = [function() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "mb-5" }, [_c("i", { staticClass: "fas fa-list fa-5x" })]);
}, function() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "mb-5" }, [_c("i", { staticClass: "far fa-frown fa-5x" })]);
}];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const TableWrapper = __component__.exports;
export {
  TableWrapper as default
};
//# sourceMappingURL=TableWrapper.2749f1d0.js.map
