import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const DEFAULT_TRANSITION = "fade-transform";
const DEFAULT_TRANSITION_MODE = "out-in";
const _sfc_main = {
  name: "TransitionPage",
  props: {
    transName: {
      type: String,
      default: DEFAULT_TRANSITION
    },
    transMode: {
      type: String,
      default: DEFAULT_TRANSITION_MODE
    }
  },
  data() {
    return {
      prevHeight: 0,
      transitionName: DEFAULT_TRANSITION,
      transitionMode: DEFAULT_TRANSITION_MODE,
      transitionEnterActiveClass: ""
    };
  },
  created() {
    this.$router.beforeEach((to, from, next) => {
      let transitionName = to.meta.transitionName || from.meta.transitionName || this.transName;
      let toDepth = to.matched.length;
      let fromDepth = from.matched.length;
      if (toDepth === fromDepth) {
        toDepth = to.path.replace(/\/+$/, "").split("/").length;
        fromDepth = from.path.replace(/\/+$/, "").split("/").length;
      }
      if (transitionName === "slide") {
        transitionName = toDepth < fromDepth ? "slide-right" : "slide-left";
      } else if (transitionName === "fade-transform") {
        transitionName = toDepth < fromDepth ? "fade-transform-right" : "fade-transform-left";
      }
      this.transitionMode = this.transMode;
      this.transitionEnterActiveClass = `${transitionName}-enter-active`;
      if (to.meta.transitionName === "zoom") {
        this.transitionMode = "in-out";
        this.transitionEnterActiveClass = "zoom-enter-active";
        document.body.style.overflow = "hidden";
      }
      if (from.meta.transitionName === "zoom") {
        this.transitionMode = null;
        this.transitionEnterActiveClass = null;
        document.body.style.overflow = null;
      }
      this.transitionName = transitionName;
      next();
    });
  },
  methods: {}
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("transition", { attrs: { "appear": "", "name": _vm.transitionName, "mode": _vm.transitionMode, "enter-active-class": _vm.transitionEnterActiveClass } }, [_vm._t("default")], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const TransitionPage = __component__.exports;
export {
  TransitionPage as default
};
//# sourceMappingURL=TransitionPage.c6ad6b62.js.map
