import { m as mapGetters } from "../../vendor/vendor-core.2a9962eb.js";
import { C as formatCurrency } from "../../app.9a8150b2.js";
import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../vendor/vendor-others.d4f8aae2.js";
import "../../vendor/vendor-essential.31dae676.js";
import "../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../vendor/vendor-vue-gtag.137cb49d.js";
const _sfc_main = {
  name: "view-currency",
  props: {
    label: {
      type: String,
      description: "View label (text before input)"
    },
    labelClasses: {
      type: [String, Array],
      description: "View label css classes",
      default: "d-block"
    },
    dataClasses: {
      type: [String, Array],
      description: "View css classes"
    },
    prefixClasses: {
      type: [String, Array],
      description: "Prefix",
      default: ""
    },
    suffixClasses: {
      type: [String, Array],
      description: "Suffix",
      default: ""
    },
    prefixOuterClasses: {
      type: [String, Array],
      description: "Prefix",
      default: ""
    },
    suffixOuterClasses: {
      type: [String, Array],
      description: "Suffix",
      default: ""
    },
    value: {
      type: [String, Number, Boolean, Object],
      description: "View value"
    },
    tag: {
      type: String,
      description: "Tag value",
      default: "h6"
    },
    hideIfEmpty: {
      type: Boolean,
      default: false
    },
    hidePrefixSuffix: {
      type: Boolean,
      default: false
    },
    round: {
      type: Boolean,
      default: false
    },
    delimeter: {
      type: Boolean,
      default: false
    },
    suffix: {
      type: String,
      description: "Right text"
    },
    prefix: {
      type: String,
      description: "Left text"
    },
    currency: {
      type: Object
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    computedCurrency() {
      return this.currency ? this.currency : this.vars.defaultCurrency;
    }
  },
  methods: {
    getValue() {
      return this.computedCurrency ? formatCurrency.to(this.value, this.computedCurrency, false, this.delimeter, true, this.round) : this.value;
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return !_vm.hideIfEmpty || _vm.hideIfEmpty && _vm.value !== null && _vm.value !== "" ? _c("div", { staticClass: "base-view view-currency" }, [_c("div", { staticClass: "view-group", class: [
    { "has-label": _vm.label || _vm.$slots.label },
    { "not-empty": _vm.value || _vm.value === 0 }
  ] }, [_vm._t("label", function() {
    return [_vm.label ? _c("label", { class: _vm.labelClasses }, [_vm._v(" " + _vm._s(_vm.label) + " ")]) : _vm._e()];
  }), _vm._t("main", function() {
    return [_vm.value || _vm.value === 0 ? _c(_vm.tag, { tag: "component", class: ["view-data no-wrap", _vm.dataClasses] }, [_vm.prefix ? _c("span", { class: _vm.prefixOuterClasses }, [_vm._v(_vm._s(_vm.prefix))]) : _vm._e(), _c("span", { class: [_vm.prefixClasses] }, [_vm._v(_vm._s(_vm.hidePrefixSuffix ? "" : _vm.computedCurrency.prefix ? _vm.computedCurrency.prefix : _vm.computedCurrency.position === "prefix" ? _vm.computedCurrency.symbol : ""))]), [_vm._v(_vm._s(_vm.getValue()))], _c("span", { class: [_vm.suffixClasses] }, [_vm._v(_vm._s(_vm.hidePrefixSuffix ? "" : _vm.computedCurrency.suffix ? _vm.computedCurrency.suffix : _vm.computedCurrency.position === "suffix" ? _vm.computedCurrency.symbol : ""))]), _vm.suffix ? _c("span", { class: _vm.suffixOuterClasses }, [_vm._v(_vm._s(_vm.suffix))]) : _vm._e(), _vm._t("badge")], 2) : _c("span", { class: ["view-data no-wrap", _vm.dataClasses] }, [_vm._v("-")])];
  })], 2), _vm._t("errorBlock")], 2) : _vm._e();
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ViewCurrency = __component__.exports;
export {
  ViewCurrency as default
};
//# sourceMappingURL=ViewCurrency.fad8ef24.js.map
