import { n as normalizeComponent } from "../../_plugin-vue2_normalizer.7b9a2fe2.js";
const VueAt_vue_vue_type_style_index_0_lang = "";
function scrollIntoView(t, scrollParent) {
  if (typeof t !== "object")
    return;
  if (t.getRangeAt) {
    if (t.rangeCount == 0)
      return;
    t = t.getRangeAt(0);
  }
  if (t.cloneRange) {
    let r = t.cloneRange();
    r.collapse(true);
    t = r.startContainer;
    if (t.nodeType == 1)
      t = t.childNodes[r.startOffset];
  }
  if (!t)
    return;
  var o = t;
  while (o && o.nodeType != 1)
    o = o.previousSibling;
  t = o || t.parentNode;
  if (t)
    scrollIntoViewElement(t, scrollParent);
}
function scrollIntoViewElement(el, scrollParent) {
  if (el.scrollIntoViewIfNeeded) {
    el.scrollIntoViewIfNeeded(false);
  } else {
    scrollParent = scrollParent || el.parentElement;
    const diff = el.offsetTop - scrollParent.scrollTop;
    if (diff < 0 || diff > scrollParent.offsetHeight - el.offsetHeight) {
      scrollParent.scrollTop = el.offsetTop;
    }
  }
}
function applyRange(range) {
  const selection = window.getSelection();
  if (selection) {
    selection.removeAllRanges();
    selection.addRange(range);
  }
}
function getRange() {
  const selection = window.getSelection();
  if (selection && selection.rangeCount > 0) {
    return selection.getRangeAt(0);
  }
}
function getAtAndIndex(text, ats) {
  return ats.map((at) => {
    return { at, index: text.lastIndexOf(at) };
  }).reduce((a, b) => {
    return a.index > b.index ? a : b;
  });
}
function getOffset(element, target) {
  target = target || window;
  var offset = { top: element.offsetTop, left: element.offsetLeft }, parent = element.offsetParent;
  while (parent != null && parent != target) {
    offset.left += parent.offsetLeft;
    offset.top += parent.offsetTop;
    parent = parent.offsetParent;
  }
  return offset;
}
function closest(el, predicate) {
  do
    if (predicate(el))
      return el;
  while (el = el && el.parentNode);
}
function getPrecedingRange() {
  const r = getRange();
  if (r) {
    const range = r.cloneRange();
    range.collapse(true);
    range.setStart(range.endContainer, 0);
    return range;
  }
}
const _sfc_main = {
  name: "VueAt",
  props: {
    value: {
      type: String,
      default: null
    },
    at: {
      type: String,
      default: null
    },
    ats: {
      type: Array,
      default: () => ["@"]
    },
    suffix: {
      type: String,
      default: " "
    },
    loop: {
      type: Boolean,
      default: true
    },
    allowSpaces: {
      type: Boolean,
      default: true
    },
    tabSelect: {
      type: Boolean,
      default: false
    },
    avoidEmail: {
      type: Boolean,
      default: true
    },
    showUnique: {
      type: Boolean,
      default: true
    },
    hoverSelect: {
      type: Boolean,
      default: true
    },
    members: {
      type: Array,
      default: () => []
    },
    nameKey: {
      type: String,
      default: ""
    },
    filterMatch: {
      type: Function,
      default: (name, chunk, at) => {
        return name.toLowerCase().indexOf(chunk.toLowerCase()) > -1;
      }
    },
    deleteMatch: {
      type: Function,
      default: (name, chunk, suffix) => {
        return chunk === name + suffix;
      }
    },
    scrollRef: {
      type: String,
      default: ""
    }
  },
  data() {
    return {
      bindsValue: this.value != null,
      customsEmbedded: false,
      hasComposition: false,
      atwho: null
    };
  },
  computed: {
    atItems() {
      return this.at ? [this.at] : this.ats;
    },
    currentItem() {
      if (this.atwho) {
        return this.atwho.list[this.atwho.cur];
      }
      return "";
    },
    style() {
      if (this.atwho) {
        const { list, cur, x, y } = this.atwho;
        const { wrap } = this.$refs;
        if (wrap) {
          const offset = getOffset(wrap);
          const scrollLeft = this.scrollRef ? document.querySelector(this.scrollRef).scrollLeft : 0;
          const scrollTop = this.scrollRef ? document.querySelector(this.scrollRef).scrollTop : 0;
          const left = x + scrollLeft + window.pageXOffset - offset.left + "px";
          const top = y + scrollTop + window.pageYOffset - offset.top + "px";
          return { left, top };
        }
      }
      return null;
    }
  },
  watch: {
    "atwho.cur"(index) {
      if (index != null) {
        this.$nextTick(() => {
          this.scrollToCur();
        });
      }
    },
    members() {
      this.handleInput(true);
    },
    value(value, oldValue) {
      if (this.bindsValue) {
        this.handleValueUpdate(value);
      }
    }
  },
  mounted() {
    if (this.$scopedSlots.embeddedItem) {
      this.customsEmbedded = true;
    }
    if (this.bindsValue) {
      this.handleValueUpdate(this.value);
    }
  },
  methods: {
    itemName(v) {
      const { nameKey } = this;
      return nameKey ? v[nameKey] : v;
    },
    isCur(index) {
      return index === this.atwho.cur;
    },
    handleValueUpdate(value) {
      const el = this.$el.querySelector("[contenteditable]");
      if (value !== el.innerHTML) {
        el.innerHTML = value;
        this.dispatchInput();
      }
    },
    dispatchInput() {
      let el = this.$el.querySelector("[contenteditable]");
      let ev = new Event("input", { bubbles: true });
      el.dispatchEvent(ev);
    },
    handleItemHover(e) {
      if (this.hoverSelect) {
        this.selectByMouse(e);
      }
    },
    handleItemClick(e) {
      this.selectByMouse(e);
      this.insertItem();
    },
    handleDelete(e) {
      const range = getPrecedingRange();
      if (range) {
        if (this.customsEmbedded && range.endOffset >= 1) {
          let a = range.endContainer.childNodes[range.endOffset] || range.endContainer.childNodes[range.endOffset - 1];
          if (!a || a.nodeType === Node.TEXT_NODE && !/^\s?$/.test(a.data)) {
            return;
          } else if (a.nodeType === Node.TEXT_NODE) {
            if (a.previousSibling)
              a = a.previousSibling;
          } else {
            if (a.previousElementSibling)
              a = a.previousElementSibling;
          }
          let ch = [].slice.call(a.childNodes);
          ch = [].reverse.call(ch);
          ch.unshift(a);
          let last;
          [].some.call(ch, (c) => {
            if (c.getAttribute && c.getAttribute("data-at-embedded") != null) {
              last = c;
              return true;
            }
          });
          if (last) {
            e.preventDefault();
            e.stopPropagation();
            const r = getRange();
            if (r) {
              r.setStartBefore(last);
              r.deleteContents();
              applyRange(r);
              this.handleInput();
            }
          }
          return;
        }
        const { atItems, members, suffix, deleteMatch, itemName } = this;
        const text = range.toString();
        const { at, index } = getAtAndIndex(text, atItems);
        if (index > -1) {
          const chunk = text.slice(index + at.length);
          const has = members.some((v) => {
            const name = itemName(v);
            return deleteMatch(name, chunk, suffix);
          });
          if (has) {
            e.preventDefault();
            e.stopPropagation();
            const r = getRange();
            if (r) {
              r.setStart(r.endContainer, index);
              r.deleteContents();
              applyRange(r);
              this.handleInput();
            }
          }
        }
      }
    },
    handleKeyDown(e) {
      const { atwho } = this;
      if (atwho) {
        if (e.keyCode === 38 || e.keyCode === 40) {
          if (!(e.metaKey || e.ctrlKey)) {
            e.preventDefault();
            e.stopPropagation();
            this.selectByKeyboard(e);
          }
          return;
        }
        if (e.keyCode === 13 || this.tabSelect && e.keyCode === 9) {
          e.preventDefault();
          e.stopPropagation();
          this.insertItem();
          return;
        }
        if (e.keyCode === 27) {
          this.closePanel();
          return;
        }
      }
      const isValid = e.keyCode >= 48 && e.keyCode <= 90 || e.keyCode === 8;
      if (isValid) {
        setTimeout(() => {
          this.handleInput();
        }, 50);
      }
      if (e.keyCode === 8) {
        this.handleDelete(e);
      }
    },
    handleCompositionStart() {
      this.hasComposition = true;
    },
    handleCompositionEnd() {
      this.hasComposition = false;
      this.handleInput();
    },
    handleInput(keep) {
      if (this.hasComposition)
        return;
      const el = this.$el.querySelector("[contenteditable]");
      this.$emit("input", el.innerHTML);
      const range = getPrecedingRange();
      if (range) {
        const { atItems, avoidEmail, allowSpaces, showUnique } = this;
        let show = true;
        const text = range.toString();
        const { at, index } = getAtAndIndex(text, atItems);
        if (index < 0)
          show = false;
        const prev = text[index - 1];
        const chunk = text.slice(index + at.length, text.length);
        if (avoidEmail) {
          if (/^[a-z0-9]$/i.test(prev))
            show = false;
        }
        if (!allowSpaces && /\s/.test(chunk)) {
          show = false;
        }
        if (/^\s/.test(chunk))
          show = false;
        if (!show) {
          this.closePanel();
        } else {
          const { members, filterMatch, itemName } = this;
          if (!keep && chunk) {
            this.$emit("at", chunk);
          }
          const matched = members.filter((v) => {
            const name = itemName(v);
            return filterMatch(name, chunk, at);
          });
          show = false;
          if (matched.length) {
            show = true;
            if (!showUnique) {
              let item = matched[0];
              if (chunk === itemName(item)) {
                show = false;
              }
            }
          }
          if (show) {
            this.openPanel(matched, range, index, at);
          } else {
            this.closePanel();
          }
        }
      }
    },
    closePanel() {
      if (this.atwho) {
        this.atwho = null;
      }
    },
    openPanel(list, range, offset, at) {
      const fn = () => {
        const r = range.cloneRange();
        r.setStart(r.endContainer, offset + at.length);
        const rect = r.getClientRects()[0];
        this.atwho = {
          range,
          offset,
          list,
          x: rect.left,
          y: rect.top - 4,
          cur: 0
        };
      };
      if (this.atwho) {
        fn();
      } else {
        setTimeout(fn, 10);
      }
    },
    scrollToCur() {
      const curEl = this.$refs.cur[0];
      const scrollParent = curEl.parentElement.parentElement;
      scrollIntoView(curEl, scrollParent);
    },
    selectByMouse(e) {
      const el = closest(e.target, (d) => {
        return d.getAttribute("data-index");
      });
      const cur = +el.getAttribute("data-index");
      this.atwho = {
        ...this.atwho,
        cur
      };
    },
    selectByKeyboard(e) {
      const offset = e.keyCode === 38 ? -1 : 1;
      const { cur, list } = this.atwho;
      const nextCur = this.loop ? (cur + offset + list.length) % list.length : Math.max(0, Math.min(cur + offset, list.length - 1));
      this.atwho = {
        ...this.atwho,
        cur: nextCur
      };
    },
    insertText(text, r) {
      r.deleteContents();
      const node = r.endContainer;
      if (node.nodeType === Node.TEXT_NODE) {
        const cut = r.endOffset;
        node.data = node.data.slice(0, cut) + text + node.data.slice(cut);
        r.setEnd(node, cut + text.length);
      } else {
        const t = document.createTextNode(text);
        r.insertNode(t);
        r.setEndAfter(t);
      }
      r.collapse(false);
      applyRange(r);
      this.dispatchInput();
    },
    insertHtml(html, r) {
      r.deleteContents();
      const node = r.endContainer;
      var newElement = document.createElement("span");
      newElement.appendChild(document.createTextNode(" "));
      newElement.appendChild(this.htmlToElement(html));
      newElement.appendChild(document.createTextNode(" "));
      newElement.setAttribute("data-at-embedded", "");
      newElement.setAttribute("contenteditable", false);
      if (node.nodeType === Node.TEXT_NODE) {
        const cut = r.endOffset;
        var secondPart = node.splitText(cut);
        node.parentNode.insertBefore(newElement, secondPart);
        r.setEndBefore(secondPart);
      } else {
        const t = document.createTextNode(this.suffix);
        r.insertNode(newElement);
        r.setEndAfter(newElement);
        r.insertNode(t);
        r.setEndAfter(t);
      }
      r.collapse(false);
      applyRange(r);
    },
    insertItem() {
      const { range, offset, list, cur } = this.atwho;
      const { suffix, atItems, itemName, customsEmbedded } = this;
      const r = range.cloneRange();
      const text = range.toString();
      const { at, index } = getAtAndIndex(text, atItems);
      const start = customsEmbedded ? index : index + at.length;
      r.setStart(r.endContainer, start);
      applyRange(r);
      applyRange(r);
      const curItem = list[cur];
      if (customsEmbedded) {
        const html = this.$refs.embeddedItem.firstChild.innerHTML;
        this.insertHtml(html, r);
      } else {
        const t = itemName(curItem) + suffix;
        this.insertText(t, r);
      }
      this.$emit("insert", curItem);
      this.handleInput();
      scrollIntoView(r);
    },
    htmlToElement(html) {
      var template = document.createElement("template");
      html = html.trim();
      template.innerHTML = html;
      return template.content.firstChild;
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { ref: "wrap", staticClass: "atwho-wrap", on: { "compositionstart": _vm.handleCompositionStart, "compositionend": _vm.handleCompositionEnd, "input": function($event) {
    return _vm.handleInput();
  }, "!keydown": function($event) {
    return _vm.handleKeyDown.apply(null, arguments);
  } } }, [_vm.atwho ? _c("div", { staticClass: "atwho-panel", style: _vm.style }, [_c("div", { staticClass: "atwho-inner" }, [_c("div", { staticClass: "atwho-view" }, [_c("ul", { staticClass: "atwho-ul" }, _vm._l(_vm.atwho.list, function(item, index) {
    return _c("li", { key: index, ref: _vm.isCur(index) && "cur", refInFor: true, staticClass: "atwho-li", class: _vm.isCur(index) && "atwho-cur", attrs: { "data-index": index }, on: { "mouseenter": _vm.handleItemHover, "click": _vm.handleItemClick } }, [_vm._t("item", function() {
      return [_c("span", { domProps: { "textContent": _vm._s(_vm.itemName(item)) } })];
    }, { "item": item })], 2);
  }), 0)])])]) : _vm._e(), _c("span", { directives: [{ name: "show", rawName: "v-show", value: false, expression: "false" }], ref: "embeddedItem" }, [_vm._t("embeddedItem", null, { "current": _vm.currentItem })], 2), _vm._t("default")], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const VueAt = __component__.exports;
export {
  VueAt as default
};
//# sourceMappingURL=VueAt.3a752d48.js.map
