import { c as configs } from "./meeting-configs.55b97e1f.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  props: {
    configs: {
      type: Object,
      required: true
    },
    meeting: {
      type: Object
    },
    meetingConfig: {
      type: Object,
      required: true
    },
    formErrors: {
      type: Object
    },
    preRequisite: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      formData: configs()
    };
  },
  watch: {
    meetingConfig: {
      handler(val, oldVal) {
        if (!oldVal && val) {
          Object.assign(this.formData, this.meetingConfig);
        }
      }
    },
    formData: {
      deep: true,
      handler(val, oldVal) {
        this.$emit("changed", val);
      }
    }
  },
  methods: {
    autoUploadRecordedChanged() {
      this.meetingConfig.autoUploadRecording = this.meetingConfig.autoUploadRecorded ? false : this.meetingConfig.autoUploadRecording;
    },
    autoUploadRecordingChanged() {
      this.meetingConfig.autoUploadRecorded = this.meetingConfig.autoUploadRecording ? false : this.meetingConfig.autoUploadRecorded;
    }
  },
  created() {
    Object.assign(this.formData, this.meetingConfig);
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 mb-4" }, [_c("base-select", { attrs: { "options": _vm.preRequisite.rtcLibraries, "label": _vm.$t("meeting.config.rtc_library"), "allow-empty": false, "preselect-first": "", "simple": "", "track-by": "uuid", "show-by": "label" }, model: { value: _vm.formData.rtcLibrary, callback: function($$v) {
    _vm.$set(_vm.formData, "rtcLibrary", $$v);
  }, expression: "formData.rtcLibrary" } }), _vm.formData.rtcLibrary === "janus" ? _c("div", { staticClass: "mt-3 text-muted text-sm opacity-8" }, [_vm._v(" " + _vm._s(_vm.$t("meeting.config.rtc_library_janus_helper")) + " ")]) : _vm._e()], 1)]), _c("fieldset", { staticClass: "fieldset light p-2 p-md-3 p-lg-4 mt-element" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("meeting.config.miscellaneous")))]), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_share_files") } }, [_c("base-switch", { model: { value: _vm.formData.canShareFiles, callback: function($$v) {
    _vm.$set(_vm.formData, "canShareFiles", $$v);
  }, expression: "formData.canShareFiles" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_share_screen") } }, [_c("base-switch", { model: { value: _vm.formData.canShareScreen, callback: function($$v) {
    _vm.$set(_vm.formData, "canShareScreen", $$v);
  }, expression: "formData.canShareScreen" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_share_link") } }, [_c("base-switch", { model: { value: _vm.formData.canShareLink, callback: function($$v) {
    _vm.$set(_vm.formData, "canShareLink", $$v);
  }, expression: "formData.canShareLink" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_use_whiteboard") } }, [_c("base-switch", { model: { value: _vm.formData.canUseWhiteboard, callback: function($$v) {
    _vm.$set(_vm.formData, "canUseWhiteboard", $$v);
  }, expression: "formData.canUseWhiteboard" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_use_hand_gesture") } }, [_c("base-switch", { model: { value: _vm.formData.canUseHandGesture, callback: function($$v) {
    _vm.$set(_vm.formData, "canUseHandGesture", $$v);
  }, expression: "formData.canUseHandGesture" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_toggle_layout") } }, [_c("base-switch", { model: { value: _vm.formData.canToggleLayout, callback: function($$v) {
    _vm.$set(_vm.formData, "canToggleLayout", $$v);
  }, expression: "formData.canToggleLayout" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_toggle_info") } }, [_c("base-switch", { model: { value: _vm.formData.canToggleInfo, callback: function($$v) {
    _vm.$set(_vm.formData, "canToggleInfo", $$v);
  }, expression: "formData.canToggleInfo" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.enable_chat") } }, [_c("base-switch", { model: { value: _vm.formData.enableChat, callback: function($$v) {
    _vm.$set(_vm.formData, "enableChat", $$v);
  }, expression: "formData.enableChat" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.auto_open_chat") } }, [_c("base-switch", { model: { value: _vm.formData.autoOpenChat, callback: function($$v) {
    _vm.$set(_vm.formData, "autoOpenChat", $$v);
  }, expression: "formData.autoOpenChat" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.mute_participants_on_start") } }, [_c("base-switch", { model: { value: _vm.formData.muteParticipantsOnStart, callback: function($$v) {
    _vm.$set(_vm.formData, "muteParticipantsOnStart", $$v);
  }, expression: "formData.muteParticipantsOnStart" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.ask_host_before_joining") } }, [_c("base-switch", { model: { value: _vm.formData.askHostBeforeJoining, callback: function($$v) {
    _vm.$set(_vm.formData, "askHostBeforeJoining", $$v);
  }, expression: "formData.askHostBeforeJoining" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.speech_detection") } }, [_c("base-switch", { model: { value: _vm.formData.speechDetection, callback: function($$v) {
    _vm.$set(_vm.formData, "speechDetection", $$v);
  }, expression: "formData.speechDetection" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-4 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.enable_poll") } }, [_c("base-switch", { model: { value: _vm.formData.enablePoll, callback: function($$v) {
    _vm.$set(_vm.formData, "enablePoll", $$v);
  }, expression: "formData.enablePoll" } })], 1)], 1)])]), _vm.configs.meeting && _vm.configs.meeting.enablePam && (!_vm.meeting || _vm.meeting.isPam) ? [_c("fieldset", { staticClass: "fieldset light p-2 p-md-3 p-lg-4 mt-element" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("meeting.publicly_accessible_meetings")))]), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.pam_open_join_as_guest_page") } }, [_c("base-switch", { model: { value: _vm.formData.pamOpenJoinAsGuestPage, callback: function($$v) {
    _vm.$set(_vm.formData, "pamOpenJoinAsGuestPage", $$v);
  }, expression: "formData.pamOpenJoinAsGuestPage" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.pam_can_share_screen_for_guest") } }, [_c("base-switch", { model: { value: _vm.formData.pamCanShareScreenForGuest, callback: function($$v) {
    _vm.$set(_vm.formData, "pamCanShareScreenForGuest", $$v);
  }, expression: "formData.pamCanShareScreenForGuest" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.pam_can_share_link_for_guest") } }, [_c("base-switch", { model: { value: _vm.formData.pamCanShareLinkForGuest, callback: function($$v) {
    _vm.$set(_vm.formData, "pamCanShareLinkForGuest", $$v);
  }, expression: "formData.pamCanShareLinkForGuest" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.pam_can_use_whiteboard_for_guest") } }, [_c("base-switch", { model: { value: _vm.formData.pamCanUseWhiteboardForGuest, callback: function($$v) {
    _vm.$set(_vm.formData, "pamCanUseWhiteboardForGuest", $$v);
  }, expression: "formData.pamCanUseWhiteboardForGuest" } })], 1)], 1)])])] : _vm._e(), _c("fieldset", { staticClass: "fieldset light p-2 p-md-3 p-lg-4 mt-element" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("meeting.config.snapshot")))]), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_take_snapshot") } }, [_c("base-switch", { model: { value: _vm.formData.canTakeSnapshot, callback: function($$v) {
    _vm.$set(_vm.formData, "canTakeSnapshot", $$v);
  }, expression: "formData.canTakeSnapshot" } })], 1)], 1), _vm.formData.canTakeSnapshot ? [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.anyone_can_take_snapshot") } }, [_c("base-switch", { model: { value: _vm.formData.anyoneCanTakeSnapshot, callback: function($$v) {
    _vm.$set(_vm.formData, "anyoneCanTakeSnapshot", $$v);
  }, expression: "formData.anyoneCanTakeSnapshot" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.enable_snapshot_alert") } }, [_c("base-switch", { model: { value: _vm.formData.enableSnapshotAlert, callback: function($$v) {
    _vm.$set(_vm.formData, "enableSnapshotAlert", $$v);
  }, expression: "formData.enableSnapshotAlert" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.snapshot_alert_to_user_only") } }, [_c("base-switch", { model: { value: _vm.formData.snapshotAlertToUserOnly, callback: function($$v) {
    _vm.$set(_vm.formData, "snapshotAlertToUserOnly", $$v);
  }, expression: "formData.snapshotAlertToUserOnly" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.snapshot_alert_to_moderators") } }, [_c("base-switch", { model: { value: _vm.formData.snapshotAlertToModerators, callback: function($$v) {
    _vm.$set(_vm.formData, "snapshotAlertToModerators", $$v);
  }, expression: "formData.snapshotAlertToModerators" } })], 1)], 1)] : _vm._e()], 2)]), _c("fieldset", { staticClass: "fieldset light p-2 p-md-3 p-lg-4 mt-element" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("meeting.config.recording")))]), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_record") } }, [_c("base-switch", { model: { value: _vm.formData.canRecord, callback: function($$v) {
    _vm.$set(_vm.formData, "canRecord", $$v);
  }, expression: "formData.canRecord" } })], 1)], 1), _vm.formData.canRecord ? [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.enable_auto_recording") } }, [_c("base-switch", { model: { value: _vm.formData.enableAutoRecording, callback: function($$v) {
    _vm.$set(_vm.formData, "enableAutoRecording", $$v);
  }, expression: "formData.enableAutoRecording" } })], 1)], 1), _vm.formData.enableAutoRecording ? _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_stop_auto_recording") } }, [_c("base-switch", { model: { value: _vm.formData.canStopAutoRecording, callback: function($$v) {
    _vm.$set(_vm.formData, "canStopAutoRecording", $$v);
  }, expression: "formData.canStopAutoRecording" } })], 1)], 1) : _vm._e(), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.auto_upload_recording") } }, [_c("base-switch", { on: { "input": _vm.autoUploadRecordingChanged }, model: { value: _vm.formData.autoUploadRecording, callback: function($$v) {
    _vm.$set(_vm.formData, "autoUploadRecording", $$v);
  }, expression: "formData.autoUploadRecording" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.auto_upload_recorded") } }, [_c("base-switch", { on: { "input": _vm.autoUploadRecordedChanged }, model: { value: _vm.formData.autoUploadRecorded, callback: function($$v) {
    _vm.$set(_vm.formData, "autoUploadRecorded", $$v);
  }, expression: "formData.autoUploadRecorded" } })], 1)], 1)] : _vm._e()], 2)]), _c("fieldset", { staticClass: "fieldset light p-2 p-md-3 p-lg-4 mt-element" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("meeting.config.auto_end")))]), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.auto_end_meeting") } }, [_c("base-switch", { model: { value: _vm.formData.autoEndMeeting, callback: function($$v) {
    _vm.$set(_vm.formData, "autoEndMeeting", $$v);
  }, expression: "formData.autoEndMeeting" } })], 1)], 1), _vm.formData.autoEndMeeting ? [_c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.alert_before_auto_end") } }, [_c("base-switch", { model: { value: _vm.formData.alertBeforeAutoEnd, callback: function($$v) {
    _vm.$set(_vm.formData, "alertBeforeAutoEnd", $$v);
  }, expression: "formData.alertBeforeAutoEnd" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_snooze_auto_end") } }, [_c("base-switch", { model: { value: _vm.formData.canSnoozeAutoEnd, callback: function($$v) {
    _vm.$set(_vm.formData, "canSnoozeAutoEnd", $$v);
  }, expression: "formData.canSnoozeAutoEnd" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("meeting.config.can_cancel_auto_end") } }, [_c("base-switch", { model: { value: _vm.formData.canCancelAutoEnd, callback: function($$v) {
    _vm.$set(_vm.formData, "canCancelAutoEnd", $$v);
  }, expression: "formData.canCancelAutoEnd" } })], 1)], 1), _c("div", { staticClass: "col-12" }), _vm.formData.alertBeforeAutoEnd ? _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("base-input", { attrs: { "label": _vm.$t("meeting.config.alert_before_auto_end_time"), "type": "number", "select-on-focus": "", "min": 1, "step": 1 }, on: { "wheel": function($event) {
    $event.stopPropagation();
    $event.preventDefault();
  } }, model: { value: _vm.formData.alertBeforeAutoEndTime, callback: function($$v) {
    _vm.$set(_vm.formData, "alertBeforeAutoEndTime", $$v);
  }, expression: "formData.alertBeforeAutoEndTime" } })], 1) : _vm._e(), _c("div", { staticClass: "col-12 col-md-6 my-2" }, [_c("base-input", { attrs: { "label": _vm.$t("meeting.config.end_time_snooze_period"), "type": "number", "select-on-focus": "", "min": 1, "max": 120, "step": 1 }, on: { "wheel": function($event) {
    $event.stopPropagation();
    $event.preventDefault();
  } }, model: { value: _vm.formData.endTimeSnoozePeriod, callback: function($$v) {
    _vm.$set(_vm.formData, "endTimeSnoozePeriod", $$v);
  }, expression: "formData.endTimeSnoozePeriod" } })], 1)] : _vm._e()], 2)])], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const EditConfig = __component__.exports;
export {
  EditConfig as E
};
//# sourceMappingURL=edit-config.aa4a5abe.js.map
