import { f as form$1 } from "./form.ff4ac955.js";
import { E as EditorWrapper } from "./EditorWrapper.6dc46fdc.js";
import { f as form } from "./modal-form.fc115176.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
import { n as now } from "./momentz.3304bf92.js";
import { s as store } from "./app.9a8150b2.js";
const _sfc_main$1 = {
  extends: form,
  props: {
    meta: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      formData: {
        uuid: null,
        name: "",
        slug: "",
        description: "",
        parent: null,
        type: null
      },
      hasSlug: false,
      hasParent: false,
      preRequisite: {
        options: []
      },
      formLabels: {
        name: $t("option.props.name"),
        slug: $t("option.props.slug"),
        description: $t("option.props.description"),
        parent: $t("option.props.parent"),
        type: $t("option.props.type")
      },
      initUrl: "options",
      dataType: "option",
      dataTypeArr: "options",
      propertyToMatch: "name",
      entityTitle: "option.option"
    };
  },
  watch: {
    meta: {
      deep: true,
      handler(newValue, oldValue) {
        this.formData.type = newValue.optionType;
        this.entityTitle = newValue.entityTitle;
        this.dataType = newValue.dataType;
        this.dataTypeArr = newValue.dataTypeArr;
        this.hasSlug = newValue.hasSlug;
        this.hasParent = newValue.hasParent;
      }
    }
  },
  methods: {
    createSlug() {
      if (this.showKeepAdding && this.formData.name != this.initialFormData.name) {
        this.formData.slug = this.formData.name.kebabCase();
      } else {
        this.formData.slug = this.formData.slug ? this.formData.slug : this.formData.name.kebabCase();
      }
    },
    preSubmit() {
      this.createSlug();
      if (this.hasParent && !this.formData.parent) {
        this.$toasted.error($t("global.invalid", { attribute: $t("option.props.parent") }), this.$toastConfig.error);
        return;
      }
      this.submit();
    }
  },
  mounted() {
    this.getInitialData();
  },
  created() {
    this.formData.type = this.meta.optionType;
    this.entityTitle = this.meta.entityTitle;
    this.dataType = this.meta.dataType;
    this.dataTypeArr = this.meta.dataTypeArr;
    this.hasSlug = this.meta.hasSlug;
    this.hasParent = this.meta.hasParent;
  }
};
var _sfc_render$1 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("form", { staticClass: "has-fixed-footer", on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.preSubmit.apply(null, arguments);
  } } }, [_c("h5", { staticClass: "text-center" }, [_vm._v(_vm._s(_vm.$t("global.add", { attribute: _vm.$t("option.option") })))]), _c("hr"), _c("animated-loader", { attrs: { "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 mb-4" }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.formLabels.name, "type": "text", "error": _vm.formErrors.name, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "name", $event);
  }, "blur": _vm.createSlug }, model: { value: _vm.formData.name, callback: function($$v) {
    _vm.$set(_vm.formData, "name", $$v);
  }, expression: "formData.name" } })], 1), _vm.hasSlug ? _c("div", { staticClass: "col-12 mb-4" }, [_c("base-input", { attrs: { "label": _vm.formLabels.slug, "type": "text", "error": _vm.formErrors.slug, "format": "kebabCase", "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "slug", $event);
  }, "focus": _vm.createSlug, "blur": _vm.createSlug }, model: { value: _vm.formData.slug, callback: function($$v) {
    _vm.$set(_vm.formData, "slug", $$v);
  }, expression: "formData.slug" } })], 1) : _vm._e(), _vm.hasParent ? _c("div", { staticClass: "col-12 mb-4" }, [_c("base-select", { attrs: { "options": _vm.preRequisite.options, "label": _vm.formLabels.parent, "error": _vm.formErrors.parent, "allow-empty": true, "disabled": _vm.isLoading, "track-by": "uuid", "show-by": "nameWithParents" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "parent", $event);
  } }, model: { value: _vm.formData.parent, callback: function($$v) {
    _vm.$set(_vm.formData, "parent", $$v);
  }, expression: "formData.parent" } })], 1) : _vm._e(), _c("div", { staticClass: "col-12 mb-4" }, [_c("base-input", { attrs: { "label": _vm.formLabels.description, "type": "text", "error": _vm.formErrors.description }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "description", $event);
  } }, model: { value: _vm.formData.description, callback: function($$v) {
    _vm.$set(_vm.formData, "description", $$v);
  }, expression: "formData.description" } })], 1)]), _c("div", { staticClass: "form-footer fixed-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.close();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.cancel")))])], 1), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "submit", "design": "primary" } }, [_c("i", { staticClass: "fas fa-save" }), _vm._v(" " + _vm._s(_vm.$t("global.save", { attribute: _vm.$t("option.option") })))])], 1)])], 1);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  null,
  null,
  null
);
const OptionForm = __component__$1.exports;
const vars = store.getters["config/vars"];
const _sfc_main = {
  extends: form$1,
  components: {
    EditorWrapper,
    OptionForm
  },
  data() {
    return {
      formData: {
        uuid: null,
        title: "",
        agenda: "",
        description: "",
        startDateTime: now(vars.serverDateTimeFormat),
        period: 60,
        type: null,
        category: null,
        identifier: "",
        maxParticipantCount: 1e3,
        accessibleViaLink: false,
        hasEvent: false,
        accessibleToMembers: false,
        isPam: false,
        isPaid: false,
        fee: 0
      },
      preRequisite: {
        types: [],
        segments: [],
        categories: []
      },
      formLabels: {
        title: $t("meeting.props.title"),
        agenda: $t("meeting.props.agenda"),
        identifier: $t("meeting.enter_meeting_code"),
        maxParticipantCount: $t("meeting.config.max_participant_count"),
        description: $t("meeting.props.description"),
        startDateTime: $t("meeting.props.start_date_time"),
        period: $t("meeting.props.estimated_period"),
        type: $t("meeting.props.type"),
        category: $t("meeting.meeting_category.category"),
        accessibleViaLink: $t("meeting.props.accessible_via_link"),
        hasEvent: $t("meeting.props.has_event"),
        accessibleToMembers: $t("meeting.props.only_accessible_to_members"),
        isPam: $t("meeting.props.is_pam"),
        isPaid: $t("meeting.props.is_paid"),
        fee: $t("meeting.props.fee")
      },
      initUrl: "meetings",
      dateTimeFields: ["startDateTime"]
    };
  },
  computed: {
    maxParticipantAllowed() {
      return this.configs.meeting.maxParticipantCount ? this.configs.meeting.maxParticipantCount : 999999;
    }
  },
  methods: {
    afterEditData() {
      if (this.duplicate) {
        this.formData.identifier = "";
        this.formData.startDateTime = moment().format(vars.serverDateTimeFormat);
      }
    },
    isPamChanged() {
      if (this.formData.isPam) {
        this.formData.accessibleToMembers = false;
        this.formData.isPaid = false;
        this.formData.fee = 0;
      }
    },
    accessibleToMembersChanged() {
      if (this.formData.accessibleToMembers) {
        this.formData.isPam = false;
        this.formData.isPaid = false;
        this.formData.fee = 0;
      }
    },
    isPaidChanged() {
      if (this.formData.isPaid) {
        this.formData.isPam = false;
        this.formData.accessibleToMembers = false;
      }
    }
  },
  mounted() {
    this.getInitialData();
  }
};
var _sfc_render = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_c("animated-loader", { attrs: { "is-loading": _vm.isLoading || _vm.isFetching, "loader-color": _vm.vars.loaderColor } }), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-5" }, [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 mb-3" }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.formLabels.title, "type": "text", "error": _vm.formErrors.title, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "title", $event);
  } }, model: { value: _vm.formData.title, callback: function($$v) {
    _vm.$set(_vm.formData, "title", $$v);
  }, expression: "formData.title" } })], 1), _c("div", { staticClass: "col-12 mb-3" }, [_c("base-textarea", { attrs: { "rows": "8", "label": _vm.formLabels.agenda, "error": _vm.formErrors.agenda, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "agenda", $event);
  } }, model: { value: _vm.formData.agenda, callback: function($$v) {
    _vm.$set(_vm.formData, "agenda", $$v);
  }, expression: "formData.agenda" } })], 1)])]), _c("div", { staticClass: "col-12 col-md-7" }, [_c("fieldset", { staticClass: "fieldset primary" }, [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-select", { attrs: { "options": _vm.preRequisite.types, "label": _vm.formLabels.type, "error": _vm.formErrors.type, "required": "", "allow-empty": false, "preselect-first": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "type", $event);
  } }, model: { value: _vm.formData.type, callback: function($$v) {
    _vm.$set(_vm.formData, "type", $$v);
  }, expression: "formData.type" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-select", { attrs: { "options": _vm.preRequisite.categories, "label": _vm.formLabels.category, "error": _vm.formErrors.category, "required": "", "allow-empty": false, "preselect-first": "", "add-new-modal": true, "needed-permission": "access-meeting-config" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "category", $event);
  } }, scopedSlots: _vm._u([{ key: "addNewModal", fn: function() {
    return [_c("option-form", { attrs: { "meta": { optionType: "meeting_category", dataType: "category", dataTypeArr: "categories", entityTitle: "meeting.meeting_category.category" } }, on: { "close": _vm.newModalClose } })];
  }, proxy: true }]), model: { value: _vm.formData.category, callback: function($$v) {
    _vm.$set(_vm.formData, "category", $$v);
  }, expression: "formData.category" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-input", { staticClass: "mb-3", attrs: { "label": _vm.formLabels.startDateTime, "addon-right-icon": "far fa-calendar-alt", "type": "text", "error": _vm.formErrors.startDateTime, "is-wrapper": true, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "startDateTime", $event);
  } }, model: { value: _vm.formData.startDateTime, callback: function($$v) {
    _vm.$set(_vm.formData, "startDateTime", $$v);
  }, expression: "formData.startDateTime" } }, [_c("date-picker", { staticClass: "form-control datepicker", attrs: { "config": _vm.vars.datetimepickerConfig }, model: { value: _vm.formData.startDateTime, callback: function($$v) {
    _vm.$set(_vm.formData, "startDateTime", $$v);
  }, expression: "formData.startDateTime" } })], 1)], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-input", { staticClass: "mb-3", attrs: { "label": _vm.formLabels.period, "type": "number", "error": _vm.formErrors.period, "required": "", "select-on-focus": "", "addon-right-text": _vm.$t("list.general.durations.minutes") }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "period", $event);
  }, "wheel": function($event) {
    $event.stopPropagation();
    $event.preventDefault();
  } }, model: { value: _vm.formData.period, callback: function($$v) {
    _vm.$set(_vm.formData, "period", $$v);
  }, expression: "formData.period" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-input", { attrs: { "label": _vm.formLabels.identifier, "type": "text", "error": _vm.formErrors.identifier }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "identifier", $event);
  } }, model: { value: _vm.formData.identifier, callback: function($$v) {
    _vm.$set(_vm.formData, "identifier", $$v);
  }, expression: "formData.identifier" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("base-input", { attrs: { "label": _vm.formLabels.maxParticipantCount, "type": "number", "error": _vm.formErrors.maxParticipantCount, "min": 2, "max": _vm.maxParticipantAllowed, "step": 1 }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "maxParticipantCount", $event);
  } }, model: { value: _vm.formData.maxParticipantCount, callback: function($$v) {
    _vm.$set(_vm.formData, "maxParticipantCount", $$v);
  }, expression: "formData.maxParticipantCount" } })], 1)])])])]), _c("div", { staticClass: "mt-element" }, [_c("fieldset", { staticClass: "fieldset light" }, [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-checkbox", { staticClass: "ml-3 mt-2", model: { value: _vm.formData.accessibleViaLink, callback: function($$v) {
    _vm.$set(_vm.formData, "accessibleViaLink", $$v);
  }, expression: "formData.accessibleViaLink" } }, [_vm._v(" " + _vm._s(_vm.formLabels.accessibleViaLink) + " ")])], 1), _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-checkbox", { staticClass: "ml-3 mt-2", model: { value: _vm.formData.hasEvent, callback: function($$v) {
    _vm.$set(_vm.formData, "hasEvent", $$v);
  }, expression: "formData.hasEvent" } }, [_vm._v(" " + _vm._s(_vm.formLabels.hasEvent) + " ")])], 1), _vm.configs.meeting && _vm.configs.meeting.enablePam && !_vm.formData.accessibleToMembers && !_vm.formData.isPaid ? _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-checkbox", { staticClass: "ml-3 mt-2", on: { "change": _vm.isPamChanged }, model: { value: _vm.formData.isPam, callback: function($$v) {
    _vm.$set(_vm.formData, "isPam", $$v);
  }, expression: "formData.isPam" } }, [_vm._v(" " + _vm._s(_vm.formLabels.isPam) + " ")])], 1) : _vm._e()]), _vm.allowExtraInput && !_vm.formData.isPam ? [!_vm.formData.isPaid ? _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-checkbox", { staticClass: "ml-3 mt-2", on: { "change": _vm.accessibleToMembersChanged }, model: { value: _vm.formData.accessibleToMembers, callback: function($$v) {
    _vm.$set(_vm.formData, "accessibleToMembers", $$v);
  }, expression: "formData.accessibleToMembers" } }, [_vm._v(" " + _vm._s(_vm.formLabels.accessibleToMembers) + " ")])], 1)]) : _vm._e(), _vm.configs.meeting.enablePaidMeeting && !_vm.formData.accessibleToMembers ? _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 mb-3" }, [_c("base-checkbox", { staticClass: "ml-3 mt-2", on: { "change": _vm.isPaidChanged }, model: { value: _vm.formData.isPaid, callback: function($$v) {
    _vm.$set(_vm.formData, "isPaid", $$v);
  }, expression: "formData.isPaid" } }, [_vm._v(" " + _vm._s(_vm.formLabels.isPaid) + " ")])], 1), _vm.formData.isPaid ? _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-input", { attrs: { "label": _vm.formLabels.fee, "type": "number", "error": _vm.formErrors.fee, "min": 0.01, "step": 0.01, "format": "currency" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "fee", $event);
  } }, model: { value: _vm.formData.fee, callback: function($$v) {
    _vm.$set(_vm.formData, "fee", $$v);
  }, expression: "formData.fee" } })], 1) : _vm._e()]) : _vm._e()] : _vm._e()], 2)]), _c("div", { staticClass: "mt-element" }, [_c("editor-wrapper", { attrs: { "label": _vm.formLabels.description, "error": _vm.formErrors.description }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "description", $event);
  } }, model: { value: _vm.formData.description, callback: function($$v) {
    _vm.$set(_vm.formData, "description", $$v);
  }, expression: "formData.description" } })], 1), _vm.formHasErrors ? _c("div", { staticClass: "alert alert-danger", attrs: { "role": "alert" } }, [_c("h6", { staticClass: "m-0" }, [_vm._v(_vm._s(_vm.$t("general.form_has_errors")))])]) : _vm._e(), _c("div", { staticClass: "form-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.$router.back();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.cancel")))]), _vm.showKeepAdding ? _c("base-checkbox", { staticClass: "ml-3 mt-2", model: { value: _vm.keepAdding, callback: function($$v) {
    _vm.keepAdding = $$v;
  }, expression: "keepAdding" } }, [_vm._v(" " + _vm._s(_vm.$t("general.keep_adding")) + " ")]) : _vm._e()], 1), _c("div", { staticClass: "right-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light" }, on: { "click": _vm.reset } }, [_vm._v(_vm._s(_vm.$t("general.reset")))]), _c("base-button", { attrs: { "type": "submit", "design": "primary" } }, [_vm._v(_vm._s(_vm.$t("global.save", { attribute: _vm.$t("meeting.meeting") })))])], 1)]), _vm.showKeepAdding && _vm.keepAdding ? [_c("keep-adding-form", { attrs: { "keep-adding-fields": _vm.keepAddingFields, "keep-adding-option": _vm.keepAddingOption, "keep-adding-selected-fields": _vm.keepAddingSelectedFields, "is-loading": _vm.isLoading }, on: { "optionUpdated": function($event) {
    _vm.keepAddingOption = $event;
  }, "fieldsUpdated": function($event) {
    _vm.keepAddingSelectedFields = $event;
  } } })] : _vm._e()], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const CommonForm = __component__.exports;
export {
  CommonForm as C
};
//# sourceMappingURL=form.48bafbfe.js.map
