import { m as mapGetters, i as mapActions } from "./vendor/vendor-core.2a9962eb.js";
import { F as FileUploader } from "./FileUploader.a3ada0d1.js";
import { E as EmojiPicker } from "./vendor/vendor-vue-emoji-picker.359f6e78.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
import { f as form } from "./config-form.7cab216a.js";
import { n as now } from "./momentz.3304bf92.js";
import { b as playOutgoingCall } from "./media.10b7361f.js";
import { c as callAlert, S as Swal, e as fileIcons, h as fileMimeTypes, i as enterPressed, f as formatKeysToCamelCase } from "./app.9a8150b2.js";
import { E as EventBus } from "./event-bus.0afcd682.js";
const _sfc_main$6 = {
  props: {
    activeContainer: {
      type: String,
      default: "home",
      required: true
    },
    configs: {
      type: Object,
      required: true
    },
    fullPage: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    computedTitle() {
      return this.activeContainer === "settings" ? $t("config.chat.chat_config") : this.activeContainer === "chatgroup" ? $t("chat.chat_group") : $t("chat.live_chat");
    }
  }
};
var _sfc_render$6 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "chat-box-header" }, [_c("h6", { staticClass: "cb-header-title" }, [_vm._v(_vm._s(_vm.computedTitle))]), _c("div", { staticClass: "cb-header-buttons action-buttons" }, [_vm.activeContainer === "chatgroup" ? [_c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("goBack");
  } } }, [_c("i", { class: ["fas", { "fa-chevron-left": _vm.activeContainer === "chatgroup" }] })]), _c("button", { staticClass: "auto-width", attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("showAddMemberScreen");
  } } }, [_c("i", { staticClass: "fas fa-plus" }), _vm._v(" "), _c("span", { staticClass: "px-2" }, [_vm._v(_vm._s(_vm.$t("chat.add")))])])] : [_vm.activeContainer !== "home" ? _c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("goHome");
  } } }, [_c("i", { class: ["fas", { "fa-chevron-left": _vm.activeContainer === "conversation" }, { "fa-chevron-right": _vm.activeContainer === "settings" }] })]) : _vm._e(), _vm.activeContainer !== "settings" ? [_c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("toggleSearch");
  } } }, [_c("i", { staticClass: "fas fa-search" })]), _c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("goToSettings");
  } } }, [_c("i", { staticClass: "fas fa-cog" })])] : _vm._e(), _vm.activeContainer === "home" && !_vm.fullPage && _vm.configs.chat.seaparateWindow ? _c("router-link", { staticClass: "button", attrs: { "to": { name: "appChat" } } }, [_c("i", { staticClass: "fas fa-external-link-alt" })]) : _vm._e()], !_vm.fullPage ? _c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
    return _vm.$emit("hideChatBox");
  } } }, [_c("i", { staticClass: "fas fa-times" })]) : _vm._e()], 2)]);
};
var _sfc_staticRenderFns$6 = [];
var __component__$6 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$6,
  _sfc_render$6,
  _sfc_staticRenderFns$6,
  false,
  null,
  null,
  null,
  null
);
const ChatBoxHeader = __component__$6.exports;
const settings_vue_vue_type_style_index_0_lang = "";
const _sfc_main$5 = {
  extends: form,
  props: {
    activeContainer: {
      type: String,
      default: "home",
      required: true
    }
  },
  watch: {
    activeContainer(newVal, oldVal) {
      if (newVal === "settings" && newVal !== oldVal) {
        this.formData = Object.assign({}, this.formData, _.cloneDeep(this.initialFormData));
      }
    }
  },
  data() {
    return {
      now: now({ moment: true }),
      formData: {
        chat: {
          enableAutoOpen: false,
          enterToSubmit: false,
          muteSoundNotification: false
        },
        override: true
      },
      useUserPreference: true
    };
  },
  methods: {
    afterSubmitSuccess() {
      this.$emit("goHome");
    }
  }
};
var _sfc_render$5 = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "cb-inner-window settings-container" }, [_vm.activeContainer === "settings" ? _c("div", { staticClass: "settings-wrapper" }, [_c("div", { staticClass: "settings" }, [_c("vue-scroll", { ref: "vue-scroll-settings", attrs: { "id": "vue-scroll-settings" } }, [_c("div", { staticClass: "settings-list" }, [_c("switch-wrapper", { staticClass: "text-light", attrs: { "label": _vm.$t("config.chat.enable_auto_open") } }, [_c("base-switch", { attrs: { "design": "success" }, model: { value: _vm.formData.chat.enableAutoOpen, callback: function($$v) {
    _vm.$set(_vm.formData.chat, "enableAutoOpen", $$v);
  }, expression: "formData.chat.enableAutoOpen" } })], 1), _c("switch-wrapper", { staticClass: "text-light", attrs: { "label": _vm.$t("config.chat.enter_to_submit") } }, [_c("base-switch", { attrs: { "design": "success" }, model: { value: _vm.formData.chat.enterToSubmit, callback: function($$v) {
    _vm.$set(_vm.formData.chat, "enterToSubmit", $$v);
  }, expression: "formData.chat.enterToSubmit" } })], 1), _c("switch-wrapper", { staticClass: "text-light", attrs: { "label": _vm.$t("config.chat.mute_sound_notification") } }, [_c("base-switch", { attrs: { "design": "success" }, model: { value: _vm.formData.chat.muteSoundNotification, callback: function($$v) {
    _vm.$set(_vm.formData.chat, "muteSoundNotification", $$v);
  }, expression: "formData.chat.muteSoundNotification" } })], 1)], 1)])], 1), _c("div", { staticClass: "settings-footer" }, [_c("base-button", { attrs: { "type": "button", "design": "primary", "size": "block" }, on: { "click": _vm.submit } }, [_vm._v(_vm._s(_vm.$t("general.save")))])], 1)]) : _vm._e()]);
};
var _sfc_staticRenderFns$5 = [];
var __component__$5 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$5,
  _sfc_render$5,
  _sfc_staticRenderFns$5,
  false,
  null,
  null,
  null,
  null
);
const ChatBoxSettings = __component__$5.exports;
const group_vue_vue_type_style_index_0_lang = "";
const _sfc_main$4 = {
  props: {
    activeContainer: {
      type: String,
      default: "home",
      required: true
    },
    activeGroup: {
      type: [Object, null],
      default() {
        return null;
      }
    },
    membersToAdd: {
      type: Array,
      default() {
        return [];
      }
    },
    membersToRemove: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  data() {
    return {
      formData: {
        uuid: null,
        name: "",
        isPublicGroup: false,
        members: []
      },
      showEditNameForm: false,
      isLoading: false
    };
  },
  watch: {
    activeContainer(newVal, oldVal) {
      if (newVal === "chatgroup" && newVal !== oldVal) {
        if (!this.activeGroup) {
          this.formData.uuid = null;
          this.formData.name = "";
          this.formData.isPublicGroup = false;
          this.formData.members = [];
        }
      }
    },
    activeGroup(newValue, oldValue) {
      if (oldValue !== newValue) {
        if (newValue) {
          this.formData.uuid = newValue.uuid;
          this.formData.name = newValue.name;
          this.formData.members = newValue.members;
          this.getMembers();
        } else {
          this.formData.uuid = null;
          this.formData.name = "";
          this.formData.isPublicGroup = false;
          this.formData.members = [];
        }
      }
    },
    membersToAdd: {
      handler(newValue) {
        if (!(newValue && newValue.length)) {
          return;
        }
        newValue.forEach((m) => {
          const foundIndex = this.formData.members.findIndex((u) => u.user.uuid === m.user.uuid);
          if (foundIndex === -1) {
            this.formData.members.push({ ...m });
          }
        });
      },
      deep: true
    },
    membersToRemove: {
      handler(newValue) {
        if (!(newValue && newValue.length)) {
          return;
        }
        newValue.forEach((m) => {
          const foundIndex = this.formData.members.findIndex((u) => u.user.uuid === m.user.uuid);
          if (foundIndex !== -1) {
            this.formData.members.splice(foundIndex, 1);
          }
        });
      },
      deep: true
    }
  },
  computed: {
    ...mapGetters("user", [
      "hasRole"
    ]),
    ...mapGetters("config", [
      "configs"
    ])
  },
  methods: {
    ...mapActions("chat", [
      "CreateRoom",
      "UpdateRoom",
      "GetRoomMembers"
    ]),
    goBack() {
      this.formData.uuid = null;
      this.formData.name = "";
      this.formData.isPublicGroup = false;
      this.formData.members = [];
      this.$emit("goBack");
    },
    editName() {
      this.showEditNameForm = true;
    },
    updateName() {
      this.isLoading = true;
      this.UpdateRoom({
        uuid: this.formData.uuid,
        name: this.formData.name
      }).then((response) => {
        this.isLoading = false;
        this.showEditNameForm = false;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    },
    createGroup() {
      this.isLoading = true;
      this.CreateRoom({
        name: this.formData.name,
        isPublicGroup: this.formData.isPublicGroup,
        members: this.formData.members.map((m) => m.user)
      }).then((response) => {
        this.isLoading = false;
        this.$emit("goToConversation", {
          room: response,
          user: null
        });
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    },
    getMembers() {
      if (!this.activeGroup) {
        return;
      }
      this.isLoading = true;
      this.GetRoomMembers({
        uuid: this.activeGroup.uuid
      }).then((response) => {
        this.isLoading = false;
        this.formData.members = response;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    if (this.activeGroup) {
      this.getMembers();
    }
  }
};
var _sfc_render$4 = function render3() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "cb-inner-window chatgroup-container" }, [_vm.activeContainer === "chatgroup" ? _c("div", { staticClass: "chatgroup-wrapper" }, [_c("div", { staticClass: "chatgroup" }, [_c("vue-scroll", { ref: "vue-scroll-chatgroup", attrs: { "id": "vue-scroll-chatgroup" } }, [_c("div", { staticClass: "chatgroup-form" }, [_vm.activeGroup ? [!_vm.showEditNameForm ? _c("div", { staticClass: "chatgroup-name mt-2" }, [_c("h6", [_vm._v(_vm._s(_vm.formData.name))]), _vm.activeGroup.canModerate ? _c("div", { staticClass: "chatgroup-actions" }, [_c("button", { attrs: { "type": "button" }, on: { "click": _vm.editName } }, [_c("i", { staticClass: "fas fa-pencil-alt" })])]) : _vm._e()]) : _vm.activeGroup.canModerate ? _c("div", { staticClass: "chatgroup-name mt-2" }, [_c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.formData.name, expression: "formData.name" }], ref: "groupName", staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.$t("chat.chat_group_name") }, domProps: { "value": _vm.formData.name }, on: { "input": function($event) {
    if ($event.target.composing)
      return;
    _vm.$set(_vm.formData, "name", $event.target.value);
  } } }), _c("div", { staticClass: "chatgroup-actions" }, [_c("button", { attrs: { "type": "button" }, on: { "click": _vm.updateName } }, [_c("i", { staticClass: "fas fa-check" })])])]) : _vm._e()] : [_c("div", { staticClass: "chatgroup-name" }, [_c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.formData.name, expression: "formData.name" }], ref: "groupName", staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.$t("chat.chat_group_name") }, domProps: { "value": _vm.formData.name }, on: { "input": function($event) {
    if ($event.target.composing)
      return;
    _vm.$set(_vm.formData, "name", $event.target.value);
  } } })]), _vm.configs.chat.allowPublicGroupChat ? [_vm.hasRole("admin") ? _c("base-checkbox", { staticClass: "ml-3 mt-4", model: { value: _vm.formData.isPublicGroup, callback: function($$v) {
    _vm.$set(_vm.formData, "isPublicGroup", $$v);
  }, expression: "formData.isPublicGroup" } }, [_c("span", { staticClass: "text-light" }, [_vm._v(_vm._s(_vm.$t("chat.is_public_group")) + "?")])]) : _vm._e(), _c("p", { staticClass: "ml-3 mt-1 text-muted text-sm" }, [_vm._v(_vm._s(_vm.$t("chat.public_chat_group_helper_info")))])] : _vm._e()], _c("div", { staticClass: "chatgroup-members-header pt-3" }), _c("div", { staticClass: "chatgroup-members" }, [_vm._t("members", null, { "members": _vm.formData.members })], 2)], 2)])], 1), !_vm.activeGroup ? _c("div", { staticClass: "chatgroup-footer" }, [_c("base-button", { attrs: { "type": "button", "design": "dark-primary" }, on: { "click": _vm.goBack } }, [_vm._v(_vm._s(_vm.$t("general.cancel")))]), _c("base-button", { attrs: { "type": "button", "design": "primary" }, on: { "click": _vm.createGroup } }, [_vm._v(_vm._s(_vm.$t("general.save")))])], 1) : _vm._e()]) : _vm._e()]);
};
var _sfc_staticRenderFns$4 = [];
var __component__$4 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$4,
  _sfc_render$4,
  _sfc_staticRenderFns$4,
  false,
  null,
  null,
  null,
  null
);
const ChatBoxGroup = __component__$4.exports;
const _sfc_main$3 = {
  props: {
    room: {
      type: Object,
      required: true
    },
    roomName: {
      type: String,
      required: true
    },
    showLastMessage: {
      type: Boolean,
      default: true
    },
    clickAction: {
      type: String,
      default: "goToConversation"
    },
    showCustomAction: {
      type: Boolean,
      default: false
    },
    clickActionOnCustom: {
      type: String,
      default: "removeMember"
    },
    customActionIcon: {
      type: String,
      default: "fas fa-times"
    },
    vars: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  computed: {
    ...mapGetters("user", {
      "userUuid": "uuid"
    }),
    computedAvatar() {
      return this.room.isGroup || !this.room.member ? this.room : this.room.member;
    }
  },
  methods: {
    removeHtmlTags(content) {
      if (!content) {
        return content;
      }
      content = content.replace(/<(?!\/?>)[^>]+>/gmi, " ").replace(/\s+/gmi, " ");
      let tmp = document.createElement("DIV");
      tmp.innerHTML = content;
      return tmp.textContent || tmp.innerText || "";
    },
    onClickRoomItem() {
      if (this.computedAvatar.uuid === this.userUuid) {
        return;
      }
      if (this.clickAction === "addToGroup") {
        this.$emit(this.clickAction, {
          room: null,
          user: this.room.member ? this.room.member : this.room
        });
      } else {
        if (this.room.isGroup || this.room.member) {
          this.$emit(this.clickAction, {
            room: this.room,
            user: null
          });
        } else {
          this.$emit(this.clickAction, {
            room: null,
            user: this.room
          });
        }
      }
    },
    doCustomAction() {
      this.$emit(this.clickActionOnCustom, {
        room: this.room,
        user: this.room.member ? this.room.member : this.room
      });
    }
  }
};
var _sfc_render$3 = function render4() {
  var _vm = this, _c = _vm._self._c;
  return _c("li", { class: ["room-item"], on: { "click": _vm.onClickRoomItem } }, [_c("div", { staticClass: "item-thumb" }, [_c("user-avatar", { attrs: { "user": _vm.computedAvatar, "size": 40 } })], 1), _c("div", { staticClass: "item-details" }, [_c("div", { staticClass: "title-row" }, [_c("h6", { staticClass: "item-title" }, [_vm._v(_vm._s(_vm.roomName))]), _vm.showLastMessage && _vm.room.lastConversationAt ? _c("small", { staticClass: "item-meta" }, [_vm._v(_vm._s(_vm._f("momentCalendarTz")(_vm.room.lastConversationAt)))]) : _vm._e()]), _vm.showLastMessage && _vm.room.lastConversationAt ? [_vm.room.message ? _c("div", { staticClass: "meta-row text-ellipsis" }, [_vm.room.message === "%%chat_attachment_%%" ? _c("span", [_vm._v(_vm._s(_vm.$t("upload.attachment")))]) : _c("span", [_vm._v(_vm._s(_vm.removeHtmlTags(_vm.room.message)))])]) : _vm.room.isGroup ? _c("div", { staticClass: "meta-row text-ellipsis" }, [_c("span", [_vm._v(_vm._s(_vm.room.memberCount) + " " + _vm._s(_vm.$t("chat.members")))])]) : _vm._e()] : _vm._e(), _vm.room.unreadMessages ? _c("div", { staticClass: "unread-messages" }, [_c("span", { staticClass: "badge badge-sm badge-pill badge-light" }, [_vm._v(_vm._s(_vm.room.unreadMessages))])]) : _vm._e()], 2), _vm._t("actions", function() {
    return [_vm.showCustomAction ? _c("div", { staticClass: "item-actions action-buttons floating-action-buttons" }, [_c("button", { attrs: { "type": "button" }, on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.doCustomAction.apply(null, arguments);
    } } }, [_c("i", { class: _vm.customActionIcon })])]) : _vm._e()];
  })], 2);
};
var _sfc_staticRenderFns$3 = [];
var __component__$3 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$3,
  _sfc_render$3,
  _sfc_staticRenderFns$3,
  false,
  null,
  null,
  null,
  null
);
const ChatRoomItem = __component__$3.exports;
const _sfc_main$2 = {
  props: {
    room: {
      type: Object,
      required: true
    },
    roomName: {
      type: String,
      required: true
    },
    vars: {
      type: Object,
      required: true
    },
    configs: {
      type: Object,
      required: true
    },
    typingUser: {
      type: String
    },
    canModerate: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      subscriptions: {},
      callId: null
    };
  },
  computed: {
    ...mapGetters("user", [
      "loggedInUser",
      "loggedInUserBusy",
      "liveUsers",
      "hasPermission"
    ]),
    computedUser() {
      return this.room.isGroup || !this.room.member ? this.room : this.room.member;
    },
    liveUser() {
      return this.computedUser && this.liveUsers.find((u) => u.uuid === this.computedUser.uuid);
    },
    isOnline() {
      return !!this.liveUser;
    },
    isUserBusy() {
      return this.isOnline && !!this.liveUser.busy;
    },
    callUuid() {
      return this.callId ? this.callId : this.callId = uuid();
    },
    toUser() {
      return {
        uuid: this.computedUser.uuid,
        username: this.computedUser.username,
        profile: this.computedUser.profile
      };
    },
    fromUser() {
      return {
        uuid: this.loggedInUser.uuid,
        username: this.loggedInUser.username,
        profile: this.loggedInUser.profile
      };
    },
    roomMembers() {
      if (this.room.memberCount <= 1) {
        return this.$t("chat.only_you_are_member");
      }
      if (this.room.members && this.room.members.length > 1) {
        return this.room.members[1].user.profile.name + this.$t("chat.and_n_other_members", { attribute: this.room.memberCount - 1 });
      }
      return "";
    },
    canSeeInfo() {
      return this.room.isGroup && !this.room.hasLeft && this.configs && this.configs.chat.groupChat;
    },
    canCall() {
      return !this.room.isGroup && this.isOnline && !this.isUserBusy && !this.loggedInUserBusy && this.hasPermission("create-meeting");
    }
  },
  methods: {
    ...mapActions("user", [
      "UpdateLiveUser"
    ]),
    goToGroup() {
      this.$emit("goToGroup", this.room);
    },
    setUserStatus(status = false, timerToFalse = null) {
      this.UpdateLiveUser({
        ...this.fromUser,
        busy: status,
        timerToFalse
      });
      this.subscriptions.users.whisper("SetUserStatus", {
        ...this.fromUser,
        busy: status
      });
    },
    showCallingNotification(to) {
      window.callPlaying = playOutgoingCall();
      const alertContent = {
        title: $t("chat.calling", { attribute: to.profile.name }),
        cancelButtonText: $t("chat.cancel"),
        showConfirmButton: false,
        showCancelButton: true,
        position: this.$toastConfig && this.$toastConfig.position ? this.$toastConfig.position.replace("-center", "").replace("start", "left").replace("end", "right") : "bottom-end"
      };
      this.$toasted.clear();
      this.setUserStatus("CALLING");
      window.callTo = to;
      callAlert.fire(alertContent).then((result) => {
        window.callPlaying.pause();
        window.callTo = null;
        if (result.value) {
          this.setUserStatus("ON_CALL");
        } else {
          if (result.dismiss === Swal.DismissReason.cancel) {
            this.setUserStatus(false);
            this.subscriptions.users.whisper("CallCancelled", {
              to: this.toUser,
              from: this.fromUser,
              id: this.callUuid
            });
            this.$toasted.info($t("chat.call_cancelled"), this.$toastConfig.info);
          } else if (result.dismiss === Swal.DismissReason.timer) {
            this.setUserStatus(false);
            this.$toasted.info($t("chat.call_not_answered", { attribute: to.profile.name }), this.$toastConfig.info);
          }
        }
      });
    },
    startCalling() {
      this.$gaEvent("engagement", "startCalling", "ProfileButtons");
      this.$emit("buttonClicked");
      this.showCallingNotification(this.toUser);
      this.callId = uuid();
      window.callUuid = this.callUuid;
      this.subscriptions.users.whisper("IncomingCall", {
        to: this.toUser,
        from: this.fromUser,
        id: this.callUuid
      });
    },
    endCall() {
      this.subscriptions.users.whisper("EndCalling", {
        to: this.toUser,
        from: this.fromUser,
        id: this.callUuid
      });
      this.setUserStatus(false);
      window.callUuid = null;
    },
    clearRoom() {
      this.$emit("clearRoom", this.room);
    }
  },
  created() {
    if (window.Echo && window.EchoOpts) {
      this.subscriptions = {
        users: window.EchoOpts.subscriptions.users
      };
    }
  }
};
var _sfc_render$2 = function render5() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "conversation-header" }, [_c("div", { staticClass: "room-thumb" }, [_c("user-avatar", { attrs: { "user": _vm.computedUser, "size": 40 } })], 1), _c("div", { staticClass: "room-details" }, [_c("div", { staticClass: "title-row" }, [_c("h6", { staticClass: "room-title" }, [_vm._v(_vm._s(_vm.roomName))])]), _c("div", { staticClass: "meta-row" }, [!_vm.room.isGroup && !_vm.typingUser ? [_vm.isOnline ? _c("span", [_vm._v(_vm._s(_vm.$t("general.online")))]) : _c("span", [_vm._v(_vm._s(_vm.$t("general.offline")))])] : _vm.room.isGroup ? [_vm.typingUser ? [_c("span", { staticClass: "typing-indicator" }, [_vm._v(_vm._s(_vm.typingUser) + " " + _vm._s(_vm.$t("general.is_typing")))]), _vm._v(" "), _c("span", [_vm._v(" \xA0")])] : _vm.roomMembers ? _c("span", [_vm._v(_vm._s(_vm.roomMembers))]) : _c("span", [_vm._v(_vm._s(_vm.room.memberCount) + " " + _vm._s(_vm.$t("chat.members")))])] : [_c("span", { directives: [{ name: "show", rawName: "v-show", value: _vm.typingUser, expression: "typingUser" }], staticClass: "typing-indicator" }, [_vm._v(_vm._s(_vm.$t("general.is_typing")))]), _vm._v(" "), _c("span", [_vm._v(" \xA0")])]], 2)]), _c("div", { staticClass: "room-btns action-buttons" }, [_vm.canSeeInfo || _vm.canCall || _vm.canModerate ? _c("base-dropdown", { attrs: { "tag": "div", "direction": "down", "menu-classes": "show-dropdown-down", "position": "right" } }, [_c("button", { attrs: { "slot": "title", "type": "button", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_c("i", { staticClass: "fas fa-ellipsis-vertical" })]), _vm.canSeeInfo ? _c("a", { staticClass: "dropdown-item", on: { "click": _vm.goToGroup } }, [_c("i", { staticClass: "fas fa-info-circle" }), _vm._v(" " + _vm._s(_vm.$t("chat.more_info")) + " ")]) : _vm._e(), _vm.canCall ? _c("a", { staticClass: "dropdown-item", on: { "click": _vm.startCalling } }, [_c("i", { staticClass: "fas fa-phone-alt" }), _vm._v(" " + _vm._s(_vm.$t("chat.start_calling")) + " ")]) : _vm._e(), _vm.canModerate ? _c("a", { staticClass: "dropdown-item", on: { "click": _vm.clearRoom } }, [_c("i", { staticClass: "fas fa-trash-can" }), _vm._v(" " + _vm._s(_vm.$t("chat.clear_chat")) + " ")]) : _vm._e()]) : _vm._e()], 1)]);
};
var _sfc_staticRenderFns$2 = [];
var __component__$2 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$2,
  _sfc_render$2,
  _sfc_staticRenderFns$2,
  false,
  null,
  null,
  null,
  null
);
const ConversationHeader = __component__$2.exports;
const _sfc_main$1 = {
  props: {
    message: {
      type: Object,
      required: true
    },
    fileIcons: {
      type: Object,
      required: true
    },
    fileMimeTypes: {
      type: Object,
      required: true
    },
    vars: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  data() {
    return {
      messageStatusIcons: {
        "sending": "far fa-clock",
        "sent": "fas fa-check",
        "delivered": "fas fa-check-double",
        "read": "fas fa-check-double",
        "error": "fas fa-exclamation-triangle"
      }
    };
  },
  computed: {
    hasAttachment() {
      return (!this.message.message || this.message.message === "%%chat_attachment_%%") && this.message.attachments && this.message.attachments.length;
    }
  },
  methods: {
    removeHtmlTags(content) {
      if (!content) {
        return content;
      }
      content = content.replace(/<[^>]+/gmi, (match) => match.replace(/ on\w+="[^"]*"/gmi, "")).replace(/<(?!\/?>)[^>]+>/gmi, " ").replace(/\s+/gmi, " ");
      let tmp = document.createElement("DIV");
      tmp.innerHTML = content;
      return tmp.textContent || tmp.innerText || "";
    }
  }
};
var _sfc_render$1 = function render6() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "message-item-wrapper" }, [_c("div", { class: ["message-item", { "has-attachments": _vm.hasAttachment }] }, [_c("span", { staticClass: "tail-in" }, [_c("svg", { attrs: { "xmlns": "http://www.w3.org/2000/svg", "viewBox": "0 0 8 13", "width": "8", "height": "13" } }, [_c("path", { attrs: { "opacity": ".13", "fill": "#0000000", "d": "M1.533 3.568L8 12.193V1H2.812C1.042 1 .474 2.156 1.533 3.568z" } }), _c("path", { attrs: { "fill": "currentColor", "d": "M1.533 2.568L8 11.193V0H2.812C1.042 0 .474 1.156 1.533 2.568z" } })])]), _c("div", { staticClass: "message-header" }, [_c("h6", { staticClass: "message-user" }, [_vm._v(_vm._s(_vm.message.user.profile.name))])]), _vm.hasAttachment ? _c("div", { staticClass: "message-content" }, [_vm._l(_vm.message.attachments, function(attachment) {
    return [_c("div", { key: attachment.uuid, class: ["attachment", { "non-image-attachment": attachment.mime !== "image/png" && attachment.mime !== "image/jpeg" }] }, [attachment.mime === "image/png" || attachment.mime === "image/jpeg" ? [_c("a", { staticClass: "attachment-link", attrs: { "href": attachment.fullUrl, "target": "_blank" } }, [_c("img", { staticClass: "img-fluid", attrs: { "src": attachment.fullUrl, "alt": attachment.filename } })]), _c("div", { staticClass: "attachment-shadow" }), _c("div", { staticClass: "message-footer small" }, [_vm.message.sentAt ? _c("span", { staticClass: "message-created-at" }, [_vm._v(_vm._s(_vm._f("momentCalendarTz")(_vm.message.sentAt)))]) : _vm._e(), _c("span", { class: ["message-status", _vm.message.status] }, [_c("i", { class: _vm.messageStatusIcons[_vm.message.status] })])])] : [_c("a", { staticClass: "attachment-link", attrs: { "href": attachment.fullUrl, "target": "_blank" } }, [_c("div", { staticClass: "attachment-details" }, [_c("div", { staticClass: "attachment-icon" }, [_c("i", { class: ["fas", _vm.fileIcons[attachment.mime]] })]), _c("div", { staticClass: "attachment-name" }, [_c("h6", [_vm._v(_vm._s(attachment.filename))])]), _vm._m(0, true)])]), _c("div", { staticClass: "message-footer small" }, [_c("div", { staticClass: "left-side" }, [_c("span", { staticClass: "attachment-type" }, [_vm._v(_vm._s(_vm.fileMimeTypes[attachment.mime]))]), _c("span", { staticClass: "attachment-size" }, [_vm._v(_vm._s(attachment.humanReadableSize))])]), _c("div", { staticClass: "right-side" }, [_vm.message.sentAt ? _c("span", { staticClass: "message-created-at" }, [_vm._v(_vm._s(_vm._f("momentCalendarTz")(_vm.message.sentAt)))]) : _vm._e(), _c("span", { class: ["message-status", _vm.message.status] }, [_c("i", { class: _vm.messageStatusIcons[_vm.message.status] })])])])]], 2)];
  })], 2) : _c("div", { staticClass: "message-content" }, [_c("div", { staticClass: "message-body" }, [_vm.message.status === "sent" ? _c("div", { staticClass: "message", domProps: { "innerHTML": _vm._s(_vm.message.message) } }) : _c("div", { staticClass: "message" }, [_vm._v(_vm._s(_vm.removeHtmlTags(_vm.message.message)))]), _c("div", { staticClass: "footer-space" })]), _c("div", { staticClass: "message-footer small" }, [_vm.message.sentAt ? _c("span", { staticClass: "message-created-at" }, [_vm._v(_vm._s(_vm._f("momentCalendarTz")(_vm.message.sentAt)))]) : _vm._e(), _c("span", { class: ["message-status", _vm.message.status] }, [_c("i", { class: _vm.messageStatusIcons[_vm.message.status] })])])])])]);
};
var _sfc_staticRenderFns$1 = [function() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "download-icon" }, [_c("i", { staticClass: "far fa-arrow-alt-circle-down" })]);
}];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  null,
  null,
  null
);
const MessageItem = __component__$1.exports;
const index_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  name: "ChatBox",
  components: {
    FileUploader,
    EmojiPicker,
    ChatBoxHeader,
    ChatBoxSettings,
    ChatBoxGroup,
    ChatRoomItem,
    ConversationHeader,
    MessageItem
  },
  props: {
    channel: {
      default: null
    },
    boxVisibility: {
      type: Boolean,
      default: false
    },
    fullPage: {
      type: Boolean,
      default: false
    },
    meeting: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  data() {
    return {
      isBoxShown: false,
      isSearchShown: false,
      showChatOptions: false,
      largeChatBox: false,
      searched: false,
      newChatScreen: false,
      newGroupScreen: false,
      cbHeaderTitle: $t("chat.live_chat"),
      searchTerm: "",
      searchTermEmoji: "",
      activeContainer: "home",
      members: [],
      newMessage: {
        message: "",
        attachments: [],
        updated: false
      },
      newMessageRequestUUID: uuid(),
      activeConversation: null,
      activeGroup: null,
      activeGroupMembersToAdd: [],
      activeGroupMembersToRemove: [],
      uploadURL: "",
      formErrors: {},
      preRequisite: {
        uploaderConfig: {
          module: "",
          token: "",
          allowedExtensions: "",
          allowedMaxFileSize: null,
          maxNoOfFiles: 1,
          uuid: uuid()
        }
      },
      goingToConversation: false,
      isFetching: false,
      noMoreMessages: false,
      newUnreadMessageOnFeed: false,
      showScrollToLatestBtn: false,
      chatRoomChannel: null,
      typingUser: null,
      typingUserTimeout: null,
      initialNewMessage: null,
      firstFetch: true,
      fileIcons,
      fileMimeTypes
    };
  },
  watch: {
    boxVisibility(newVal, oldVal) {
      this.isBoxShown = newVal;
      if (this.isBoxShown) {
        document.body.classList.add("chat-box-shown");
      }
    },
    activeChatUser(newVal, oldVal) {
      if (newVal !== null && (!oldVal || oldVal !== null && newVal.uuid !== oldVal.uuid)) {
        this.goToConversation({ user: newVal });
      }
    },
    activeChatRoom(newVal, oldVal) {
      if (this.goingToConversation === false && newVal !== null && (!oldVal || oldVal !== null && newVal.uuid !== oldVal.uuid)) {
        this.goToConversation({ room: newVal });
      }
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars",
      "configs",
      "uiConfigs"
    ]),
    ...mapGetters("user", {
      "userUuid": "uuid"
    }),
    ...mapGetters("user", [
      "profile",
      "username"
    ]),
    ...mapGetters("chat", [
      "rooms",
      "roomsPageMeta",
      "roomsSearch",
      "messages",
      "messagesPageMeta",
      "messagesSearch",
      "activeChatRoom",
      "activeChatUser"
    ]),
    user() {
      return {
        uuid: this.userUuid,
        username: this.username,
        name: this.profile.name,
        profile: this.profile
      };
    },
    hasMessages() {
      return this.activeConversation && this.messages.data;
    },
    computedParticipants() {
      if (this.activeConversation) {
        return this.activeConversation.members;
      }
      return [];
    },
    enterToSubmit() {
      return this.configs.chat && this.configs.chat.enterToSubmit;
    }
  },
  methods: {
    ...mapActions("chat", [
      "GetRooms",
      "GetRoom",
      "AddMemberToRoom",
      "RemoveMemberFromRoom",
      "SearchRooms",
      "SearchMessages",
      "GetMessages",
      "SendMessage",
      "PutMessageToFeed",
      "PatchMessageInFeed",
      "ResetMessage",
      "SetMessage",
      "ClearRoom",
      "ResetTotalUnreadCount",
      "SetActiveChatRoom",
      "SetActiveChatUser",
      "ResetActiveChatRoomAndUser",
      "SearchRoomMembers"
    ]),
    hideChatBox() {
      this.isBoxShown = false;
      this.ResetActiveChatRoomAndUser();
      setTimeout(() => {
        this.$emit("boxHidden");
      }, 200);
    },
    showChatBox() {
      this.isBoxShown = true;
      this.$emit("boxShown");
    },
    hideSearch() {
      this.searchTerm = "";
      this.searched = false;
      this.isSearchShown = false;
      this.showChatOptions = true;
      this.newChatScreen = false;
      this.newGroupScreen = false;
      if (this.activeContainer === "home") {
        this.fetchRooms(true);
        this.scrollTo("vue-scroll-rooms", 0);
      } else if (this.activeContainer === "conversation") {
        this.fetchMessages(true);
      }
    },
    toggleSearch(startNewChat = false, startNewGroup = false) {
      this.searchTerm = "";
      this.searched = false;
      this.isSearchShown = !this.isSearchShown;
      if (this.isSearchShown) {
        this.newChatScreen = startNewChat;
        this.newGroupScreen = startNewGroup;
        this.showChatOptions = !(startNewChat || startNewGroup);
        this.$nextTick(() => {
          this.$refs[`searchTerm`].focus();
        });
      } else {
        this.newChatScreen = false;
        this.newGroupScreen = false;
        this.showChatOptions = true;
        if (this.activeContainer === "home") {
          this.fetchRooms(true);
          this.scrollTo("vue-scroll-rooms", 0);
        } else if (this.activeContainer === "conversation") {
          this.fetchMessages(true);
        }
      }
    },
    startNewChat() {
      this.toggleSearch(true);
    },
    goHome() {
      this.lastActiveContainer = this.activeContainer;
      this.activeContainer = "home";
      this.ResetActiveChatRoomAndUser();
      if (this.lastActiveContainer === "conversation") {
        this.leaveChatRoomChannel(this.activeConversation.chatRoom);
        this.hideSearch();
        if (this.searchRoomObj && this.searchRoomObj.searched) {
          this.searchTerm = this.searchRoomObj.searchTerm;
          this.searched = this.searchRoomObj.searched;
          this.isSearchShown = true;
          this.showChatOptions = false;
        } else {
          this.fetchRooms();
        }
      } else {
        this.fetchRooms();
      }
      this.scrollTo("vue-scroll-rooms", 0);
      setTimeout(() => {
        this.activeConversation = null;
      }, 100);
    },
    goToConversation({ room, user }, fetchRoomForUser = false) {
      this.goingToConversation = true;
      const swtichToConversationTab = () => {
        setTimeout(() => {
          this.activeContainer = "conversation";
          if (this.isSearchShown) {
            this.searchRoomObj = {
              searchTerm: this.searchTerm,
              searched: this.searched
            };
            this.hideSearch();
          } else {
            this.searchRoomObj = {
              searchTerm: null,
              searched: null
            };
          }
          this.goingToConversation = false;
          window.setTimeout(() => {
            this.scrollToLatestMessages();
            this.focusNewMessage();
            this.showScrollToLatestBtn = false;
            this.newUnreadMessageOnFeed = false;
          }, 300);
        }, 100);
      };
      this.activeConversation = {
        chatRoom: room || null,
        user: room && room.isGroup ? null : user || null,
        members: room && room.isGroup ? room.members : user ? [user] : []
      };
      this.ResetMessage();
      if (room) {
        if (!room.hasLeft) {
          this.joinChatRoomChannel(room);
        }
        this.GetRoom({
          uuid: room.uuid
        }).then((response) => {
          const newChatRoomInfo = response.chatRoom;
          const newChats = response.chats;
          this.activeConversation.chatRoom = newChatRoomInfo;
          if (room.hasLeft && !newChatRoomInfo.hasLeft) {
            this.joinChatRoomChannel(newChatRoomInfo);
          }
          if (newChatRoomInfo.hasLeft) {
            this.leaveChatRoomChannel(newChatRoomInfo);
          }
          this.SetMessage({
            data: [...newChats],
            meta: {
              ...this.messages.meta,
              total: newChats.length,
              lastItemUuid: newChats.length ? newChats[newChats.length - 1].uuid : null
            }
          });
          if (this.activeConversation.chatRoom && this.activeConversation.chatRoom.hasOwnProperty("chats")) {
            delete this.activeConversation.chatRoom.chats;
          }
          this.noMoreMessages = false;
          this.SetActiveChatRoom(this.activeConversation.chatRoom);
          swtichToConversationTab();
        }).catch((error) => {
          this.goingToConversation = false;
          formUtil.handleErrors(error);
        });
      } else {
        this.SetActiveChatUser(this.activeConversation.user);
        this.fetchMessages(true);
        swtichToConversationTab();
      }
    },
    goToSettings() {
      this.lastActiveContainer = this.activeContainer;
      this.activeContainer = "settings";
      this.scrollTo("vue-scroll-rooms", 0);
      setTimeout(() => {
        if (this.lastActiveContainer === "conversation") {
          this.ResetActiveChatRoomAndUser();
          this.leaveChatRoomChannel(this.activeConversation.chatRoom);
        }
        if (this.isSearchShown) {
          this.hideSearch();
        }
        this.activeConversation = null;
      }, 100);
    },
    goToCreateGroup() {
      this.activeGroup = null;
      this.goToGroup();
    },
    goToGroup(activeGroup = null) {
      this.activeGroupMembersToAdd = [];
      this.activeGroupMembersToRemove = [];
      this.lastActiveContainer = this.activeContainer;
      this.activeContainer = "chatgroup";
      this.activeGroup = activeGroup;
      this.scrollTo("vue-scroll-rooms", 0);
      if (this.isSearchShown) {
        this.hideSearch();
      }
      if (!activeGroup) {
        this.$nextTick(() => {
          window.setTimeout(() => {
            this.$refs[`chatBoxGroup`].$refs[`groupName`].focus();
          }, 300);
        });
      }
    },
    showAddMemberScreen() {
      this.activeGroupMembersToAdd = [];
      this.activeGroupMembersToRemove = [];
      this.toggleSearch(false, true);
    },
    addToGroup(data) {
      if (data && data.user) {
        if (this.activeGroup) {
          this.isLoading = true;
          this.AddMemberToRoom({
            uuid: this.activeGroup.uuid,
            members: [data.user]
          }).then((response) => {
            this.isLoading = false;
            this.activeGroup = response;
            this.activeConversation.chatRoom = response;
            this.activeConversation.chatRoom.members = response.members;
          }).catch((error) => {
            this.isLoading = false;
            formUtil.handleErrors(error);
          });
        } else {
          this.activeGroupMembersToAdd.push(data);
        }
      }
      this.toggleSearch();
    },
    removeMemberFromGroup(data) {
      this.activeGroupMembersToAdd = [];
      this.activeGroupMembersToRemove = [];
      if (data && data.user) {
        if (this.activeGroup) {
          this.isLoading = true;
          this.RemoveMemberFromRoom({
            uuid: this.activeGroup.uuid,
            members: [data.user]
          }).then((response) => {
            this.isLoading = false;
            this.activeGroup = response;
            this.activeConversation.chatRoom = response;
          }).catch((error) => {
            this.isLoading = false;
            formUtil.handleErrors(error);
          });
        } else {
          this.activeGroupMembersToRemove.push(data);
        }
      }
    },
    goBack() {
      if (this.lastActiveContainer) {
        this.activeContainer = this.lastActiveContainer;
      } else {
        this.goHome();
      }
    },
    searchTermChanged: _.debounce(function() {
      if (!this.searchTerm || this.searchTerm.length < 2) {
        return;
      }
      if (this.activeContainer === "home" || this.activeContainer === "chatgroup") {
        this.searchRooms();
        this.scrollTo("vue-scroll-rooms", 0);
      } else if (this.activeContainer === "conversation") {
        this.searchMessages();
      }
    }, 500),
    handleAt(chunk) {
      if (!chunk || chunk.length < 2) {
        if (this.activeConversation) {
          this.activeConversation.members = [];
        }
        return;
      }
      if (!this.activeConversation.chatRoom) {
        this.activeConversation.members = [];
        return;
      }
      this.SearchRoomMembers({ uuid: this.activeConversation.chatRoom.uuid, term: chunk }).then((response) => {
        this.activeConversation.members = response;
      }).catch((error) => {
        formUtil.handleErrors(error);
        if (this.activeConversation) {
          this.activeConversation.members = [];
        }
        return;
      });
    },
    fetchRooms(reset = true) {
      this.isFetching = true;
      const query = {
        ...this.roomsPageMeta,
        lastItemUuid: reset ? null : this.rooms.meta.lastItemUuid,
        perPage: this.rooms.meta.perPage
      };
      this.GetRooms(query).then((response) => {
        this.isFetching = false;
      }).catch((error) => {
        this.isFetching = false;
        formUtil.handleErrors(error);
      });
    },
    searchRooms() {
      this.isFetching = true;
      this.SearchRooms(this.searchTerm).then((response) => {
        this.searched = true;
        this.showChatOptions = false;
        this.isFetching = false;
      }).catch((error) => {
        this.isFetching = false;
        formUtil.handleErrors(error);
      });
    },
    searchMessages() {
      if (!this.activeConversation.chatRoom) {
        return;
      }
      this.isFetching = true;
      this.SearchMessages({
        q: this.searchTerm,
        chatRoom: this.activeConversation.chatRoom.uuid
      }).then((response) => {
        this.searched = true;
        this.isFetching = false;
        window.setTimeout(() => {
          this.scrollToLatestMessages();
          this.showScrollToLatestBtn = false;
          this.newUnreadMessageOnFeed = false;
        }, 300);
      }).catch((error) => {
        this.isFetching = false;
        formUtil.handleErrors(error);
      });
    },
    fetchMessages(reset = false) {
      if (!this.activeConversation.chatRoom && !this.activeConversation.user) {
        return;
      }
      this.isFetching = true;
      this.noMoreMessages = false;
      this.newUnreadMessageOnFeed = false;
      const query = {
        ...this.messagesPageMeta,
        lastItemUuid: reset ? null : this.messages.meta.lastItemUuid,
        perPage: this.messages.meta.perPage,
        chatRoom: this.activeConversation.chatRoom ? this.activeConversation.chatRoom.uuid : null,
        user: this.activeConversation.user ? this.activeConversation.user.uuid : null
      };
      this.GetMessages(query).then((response) => {
        this.isFetching = false;
        if (!response.data.length) {
          this.noMoreMessages = true;
        }
        if (reset) {
          window.setTimeout(() => {
            this.scrollToLatestMessages();
            this.showScrollToLatestBtn = false;
            this.newUnreadMessageOnFeed = false;
          }, 300);
        }
        if (!this.searched) {
          this.focusNewMessage();
        }
      }).catch((error) => {
        this.isFetching = false;
        formUtil.handleErrors(error);
      });
    },
    chatRoomUpdated() {
      this.GetRoom({
        uuid: this.activeConversation.chatRoom.uuid
      }).then((response) => {
        const newChatRoomInfo = response.chatRoom;
        this.activeConversation.chatRoom = newChatRoomInfo;
        if (response.hasLeft) {
          this.leaveChatRoomChannel(newChatRoomInfo);
        }
      }).catch((error) => {
        formUtil.handleErrors(error);
      });
    },
    postMessage() {
      if (!this.newMessage.message) {
        return;
      }
      this.newMessage.message = this.removeHtmlTags(this.newMessage.message.trim());
      const messageObj = {
        uuid: this.newMessageRequestUUID,
        message: this.newMessage.message,
        user: this.user,
        sentAt: now(this.vars.serverDateTimeFormat),
        status: "sending"
      };
      this.newMessageRequestUUID = uuid();
      this.newMessage = _.cloneDeep(this.initialNewMessage);
      this.noMoreMessages = false;
      this.putMessageToFeed(messageObj);
      window.setTimeout(() => {
        this.scrollTo("vue-scroll-messages", 100);
        this.focusNewMessage();
      }, 300);
      this.SendMessage({
        message: messageObj.message,
        chatRoom: this.activeConversation.chatRoom,
        user: this.activeConversation.user
      }).then((response) => {
        this.messageSentSuccess(messageObj, response);
      }).catch((error) => {
        this.messageSendingFailed(messageObj, error);
      });
    },
    attachmentUploadStarted(count) {
      if (!this.newMessage.attachments || this.newMessage.attachments.length) {
        return;
      }
      const messageObj = {
        uuid: this.newMessageRequestUUID,
        message: null,
        user: this.user,
        sentAt: moment.utc().format(this.vars.serverDateTimeFormat),
        status: "sending"
      };
      this.newMessageRequestUUID = uuid();
      this.newMessage = _.cloneDeep(this.initialNewMessage);
      this.putMessageToFeed(messageObj);
      window.setTimeout(() => {
        this.scrollTo("vue-scroll-messages", 100);
        this.focusNewMessage();
      }, 300);
    },
    attachmentUploaded(response) {
      if (!(response && response.meta && response.meta.requestUuid)) {
        this.$toasted.error($t("misc.error_unknown"), this.$toastConfig.error);
        return;
      }
      EventBus.$emit("RESET_UPLOAD");
      this.messageSentSuccess({
        uuid: response.meta.requestUuid
      }, response);
    },
    attachmentUploadError(error) {
      if (!(error && error.meta && error.meta.requestUuid)) {
        this.$toasted.error($t("misc.error_unknown"), this.$toastConfig.error);
        return;
      }
      EventBus.$emit("RESET_UPLOAD");
      if (error) {
        this.messageSendingFailed({
          uuid: error.meta.requestUuid
        }, error);
      }
    },
    messageSentSuccess(oldMessage, newMessageResponse) {
      const newMessage = newMessageResponse.data;
      this.PatchMessageInFeed({
        old: oldMessage,
        new: {
          ...newMessage,
          newUuid: newMessage.uuid,
          uuid: oldMessage.uuid
        }
      });
      if (!this.activeConversation.chatRoom) {
        this.joinChatRoomChannel(newMessage.chatRoom);
        this.GetRoom({
          uuid: newMessage.chatRoom.uuid
        }).then((response) => {
          this.activeConversation.chatRoom = response.chatRoom;
          if (this.activeConversation.chatRoom && this.activeConversation.chatRoom.hasOwnProperty("chats")) {
            delete this.activeConversation.chatRoom.chats;
          }
        }).catch((error) => {
          formUtil.handleErrors(error);
        });
      }
    },
    messageSendingFailed(oldMessage, error) {
      this.PatchMessageInFeed({
        old: oldMessage,
        new: {
          ...oldMessage,
          status: "error",
          error: formUtil.getError(error)
        }
      });
    },
    noNeedCallback() {
      this.afterUploadComplete();
    },
    joinChatRoomChannel(chatRoom) {
      window.EchoOpts.subscriptions.chatRoom = window.Echo.join(`ChatRoom.${chatRoom.uuid}`);
      this.chatRoomChannel = window.EchoOpts.subscriptions.chatRoom;
      this.chatRoomChannel.listen("ChatMessageSentToRoom", this.newMessageReceived);
      this.chatRoomChannel.listen("ChatRoomUpdated", this.chatRoomUpdated);
      this.chatRoomChannel.listenForWhisper("typing", this.anotherUserTyping);
    },
    leaveChatRoomChannel(chatRoom) {
      if (this.chatRoomChannel) {
        this.chatRoomChannel.stopListening("ChatMessageSentToRoom");
        this.chatRoomChannel = null;
      }
      if (chatRoom) {
        window.Echo.leave(`ChatRoom.${chatRoom.uuid}`);
      }
      if (window.EchoOpts && window.EchoOpts.subscriptions) {
        window.EchoOpts.subscriptions.chatRoom = null;
      }
    },
    clearRoom(room) {
      if (room) {
        this.isLoading = true;
        this.ClearRoom(room).then((response) => {
          this.goHome();
          this.isLoading = false;
        }).catch((error) => {
          this.isLoading = false;
          formUtil.handleErrors(error);
        });
      }
    },
    enterPressedEvt(fnCallback, event) {
      if (this.enterToSubmit) {
        return enterPressed(fnCallback, event);
      }
      return false;
    },
    putMessageToFeed(message) {
      if (this.messages.data.findIndex((c) => c.uuid === message.uuid) !== -1) {
        return;
      }
      this.PutMessageToFeed(message);
    },
    focusNewMessage() {
      if (this.$refs["newMessageInput"]) {
        this.$refs["newMessageInput"].focus();
      }
    },
    scrollTo(refId, pos) {
      if (this.$refs[refId]) {
        this.$refs[refId].scrollTo(
          {
            y: `${pos}%`
          },
          300
        );
      }
    },
    scrollToLatestMessages() {
      this.scrollTo("vue-scroll-messages", 100);
    },
    handleMessageScroll: _.debounce(function(vertical, horizontal) {
      if (vertical.process > 0.95) {
        this.showScrollToLatestBtn = false;
        this.newUnreadMessageOnFeed = false;
      } else {
        if (!this.searched || this.searched && vertical.process !== 0) {
          this.showScrollToLatestBtn = true;
        }
      }
      if (vertical.process < 0.5 && !this.isFetching && !this.noMoreMessages) {
        this.fetchMessages();
      }
    }, 500),
    handleRoomsScroll: _.debounce(function(vertical, horizontal) {
      if (vertical.process > 0.5 && !this.isFetching) {
        this.fetchRooms();
      }
    }, 500),
    isTyping: _.throttle(function() {
      if (this.chatRoomChannel) {
        this.chatRoomChannel.whisper("typing", {
          user: this.user
        });
      }
    }, 500, {
      "leading": true,
      "trailing": false
    }),
    anotherUserTyping({ user }) {
      this.typingUser = user.name;
      if (this.typingUserTimeout) {
        clearTimeout(this.typingUserTimeout);
      }
      this.typingUserTimeout = setTimeout(() => {
        this.typingUser = null;
      }, 1500);
    },
    newMessageReceived(message) {
      if (!message) {
        return;
      }
      message = formatKeysToCamelCase(message);
      if (message && message.user && message.user.uuid !== this.userUuid) {
        this.putMessageToFeed(message);
        window.setTimeout(() => {
          const { v, h } = this.$refs["vue-scroll-messages"].getScrollProcess();
          if (v > 0.5) {
            this.scrollToLatestMessages();
          } else {
            this.showScrollToLatestBtn = true;
            this.newUnreadMessageOnFeed = true;
          }
        }, 300);
      }
    },
    appendEmoji(emoji) {
      this.newMessage.message += emoji;
    },
    removeHtmlTags(content) {
      content = content ? content.replace(/<[^>]+/gmi, (match) => match.replace(/ on\w+="[^"]*"/gmi, "")).replace(/<(?!\/?b>|\/?p>|\/?strong>|\/?div>|\/?br>|\/?span>|\/?em>|\/?i>)[^>]+>/gmi, "") : content;
      return content;
    },
    doInit() {
      this.initialNewMessage = _.cloneDeep(this.newMessage);
      if (this.activeChatRoom) {
        this.goToConversation({ room: this.activeChatRoom });
      } else if (this.activeChatUser) {
        this.goToConversation({ user: this.activeChatUser });
      } else {
        this.fetchRooms();
      }
      if (this.isBoxShown) {
        document.body.classList.add("chat-box-shown");
      }
      setTimeout(() => {
        this.showChatOptions = this.boxVisibility;
      }, 1e3);
    }
  },
  directives: {
    focus: {
      inserted(el) {
        el.focus();
      }
    }
  },
  mounted() {
    setTimeout(() => {
      this.isBoxShown = this.boxVisibility;
    }, 100);
    setTimeout(() => {
      this.doInit();
    }, 200);
  },
  created() {
    if (this.configs.system && this.configs.system.allowedFileExtensions) {
      this.preRequisite.uploaderConfig.allowedExtensions = this.configs.system.allowedFileExtensions;
    }
    if (this.configs.system && this.configs.system.postMaxSize) {
      this.preRequisite.uploaderConfig.allowedMaxFileSize = this.configs.system.postMaxSize;
    }
  },
  beforeDestroy() {
    document.body.classList.remove("chat-box-shown");
    if (window.Echo && window.EchoOpts) {
      if (window.EchoOpts.subscriptions && window.EchoOpts.subscriptions.chatRoom) {
        window.EchoOpts.subscriptions.chatRoom.stopListening("ChatMessageSentToRoom");
        window.EchoOpts.subscriptions.chatRoom = null;
      }
    }
  }
};
var _sfc_render = function render7() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { class: ["chat-box-wrapper", { "shown": _vm.isBoxShown }, { "search-shown": _vm.isSearchShown }, { "chat-box-lg": _vm.largeChatBox }, { "show-chat-options": _vm.showChatOptions }] }, [_c("chat-box-header", { attrs: { "active-container": _vm.activeContainer, "configs": _vm.configs, "full-page": _vm.fullPage }, on: { "goHome": _vm.goHome, "toggleSearch": _vm.toggleSearch, "goToSettings": _vm.goToSettings, "goBack": _vm.goBack, "hideChatBox": _vm.hideChatBox, "showAddMemberScreen": _vm.showAddMemberScreen } }), _c("div", { staticClass: "search" }, [_c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.searchTerm, expression: "searchTerm" }], ref: "searchTerm", staticClass: "form-control", attrs: { "type": "text", "placeholder": _vm.$t("general.search_helper_default_text") }, domProps: { "value": _vm.searchTerm }, on: { "keydown": function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "esc", 27, $event.key, ["Esc", "Escape"]))
      return null;
    return _vm.toggleSearch.apply(null, arguments);
  }, "input": [function($event) {
    if ($event.target.composing)
      return;
    _vm.searchTerm = $event.target.value;
  }, _vm.searchTermChanged] } }), _vm.searchTerm ? _c("button", { staticClass: "clear-btn", attrs: { "type": "button" }, on: { "click": _vm.hideSearch } }, [_vm._v(_vm._s(_vm.$t("general.clear")))]) : _vm._e()]), _c("div", { class: ["chat-box", { "showing-settings": _vm.activeContainer === "settings" }, { "showing-chats": _vm.activeContainer === "conversation" }, { "showing-chatgroup": _vm.activeContainer === "chatgroup" }] }, [_vm.configs.chat.groupChat ? _c("chat-box-group", { ref: "chatBoxGroup", attrs: { "active-container": _vm.activeContainer, "active-group": _vm.activeGroup, "members-to-add": _vm.activeGroupMembersToAdd, "members-to-remove": _vm.activeGroupMembersToRemove }, on: { "goToConversation": _vm.goToConversation, "goBack": _vm.goBack, "goHome": _vm.goHome }, scopedSlots: _vm._u([{ key: "members", fn: function({ members }) {
    return [_c("div", { staticClass: "rooms-wrapper" }, [_vm.searchTerm && _vm.searched ? [_vm.roomsSearch.rooms.length || _vm.roomsSearch.users.length ? _c("ul", { staticClass: "rooms" }, [_vm._l(_vm.roomsSearch.rooms, function(room) {
      return [!room.isGroup ? _c("chat-room-item", { key: room.uuid, attrs: { "room": room, "room-name": room.name, "click-action": "addToGroup", "vars": _vm.vars, "show-last-message": false }, on: { "addToGroup": _vm.addToGroup } }) : _vm._e()];
    }), _vm._l(_vm.roomsSearch.users, function(user) {
      return _c("chat-room-item", { key: user.uuid, attrs: { "room": user, "room-name": user.profile.name, "click-action": "addToGroup", "vars": _vm.vars }, on: { "addToGroup": _vm.addToGroup } });
    })], 2) : _c("div", { staticClass: "no-data" }, [_c("h5", [_vm._v(_vm._s(_vm.$t("chat.no_result_found")))])])] : [_c("ul", { staticClass: "rooms" }, _vm._l(members, function(member) {
      return _c("chat-room-item", { key: member.user.uuid, attrs: { "room": member.user, "room-name": member.user.profile.name, "click-action": "goToConversation", "show-custom-action": _vm.activeGroup && _vm.activeGroup.canModerate, "click-action-on-custom": "removeMember", "vars": _vm.vars }, on: { "goToConversation": _vm.goToConversation, "removeMember": _vm.removeMemberFromGroup } });
    }), 1)]], 2)];
  } }], null, false, 3462095424) }) : _vm._e(), _c("chat-box-settings", { attrs: { "active-container": _vm.activeContainer }, on: { "goHome": _vm.goHome } }), _c("div", { staticClass: "cb-inner-window rooms-container" }, [_c("vue-scroll", { ref: "vue-scroll-rooms", attrs: { "id": "vue-scroll-rooms" }, on: { "handle-scroll": _vm.handleRoomsScroll } }, [_c("div", { staticClass: "rooms-wrapper" }, [_vm.searchTerm && _vm.searched || _vm.newChatScreen || _vm.newGroupScreen ? [_vm.roomsSearch.rooms.length || _vm.roomsSearch.users.length ? _c("ul", { staticClass: "rooms" }, [!_vm.newChatScreen || !_vm.newGroupScreen ? [_vm._l(_vm.roomsSearch.rooms, function(room) {
    return _c("chat-room-item", { key: room.uuid, attrs: { "room": room, "room-name": room.name, "vars": _vm.vars }, on: { "goToConversation": _vm.goToConversation } });
  }), _vm.roomsSearch.users.length ? _c("li", { staticClass: "my-2 pl-3 font-weight-500" }, [_vm._v(_vm._s(_vm.$t("user.users")))]) : _vm._e()] : _vm._e(), _vm._l(_vm.roomsSearch.users, function(user) {
    return _c("chat-room-item", { key: user.uuid, attrs: { "room": user, "room-name": user.profile.name, "click-action": "goToConversation", "vars": _vm.vars }, on: { "goToConversation": _vm.goToConversation } });
  })], 2) : _c("div", { staticClass: "no-data" }, [_c("h5", [_vm._v(_vm._s(_vm.$t("chat.no_result_found")))])])] : [_vm.rooms.data && _vm.rooms.data.length ? _c("ul", { staticClass: "rooms" }, _vm._l(_vm.rooms.data, function(room) {
    return _c("chat-room-item", { key: room.uuid, attrs: { "room": room, "room-name": room.name, "vars": _vm.vars }, on: { "goToConversation": _vm.goToConversation } });
  }), 1) : _c("div", { staticClass: "no-data" }, [_c("h5", [_vm._v(_vm._s(_vm.$t("chat.no_chats_yet")))])])]], 2)]), _c("div", { staticClass: "chat-option-buttons" }, [_vm.configs.chat.groupChat ? _c("button", { attrs: { "type": "button" }, on: { "click": _vm.goToCreateGroup } }, [_c("i", { staticClass: "fas fa-users" })]) : _vm._e(), _c("button", { attrs: { "type": "button" }, on: { "click": _vm.startNewChat } }, [_c("i", { staticClass: "fas fa-user" })]), _vm._m(0)])], 1), _c("div", { staticClass: "cb-inner-window conversation-container" }, [_vm.activeConversation ? _c("div", { staticClass: "conversation-wrapper" }, [_vm.activeConversation.chatRoom ? _c("conversation-header", { attrs: { "room": _vm.activeConversation.chatRoom, "room-name": _vm.activeConversation.chatRoom.name, "vars": _vm.vars, "configs": _vm.configs, "typingUser": _vm.typingUser, "can-moderate": _vm.activeConversation.chatRoom.canModerate }, on: { "goToGroup": _vm.goToGroup, "clearRoom": _vm.clearRoom } }) : _vm.activeConversation.user ? _c("conversation-header", { attrs: { "room": _vm.activeConversation.user, "room-name": _vm.activeConversation.user.profile.name, "vars": _vm.vars, "configs": _vm.configs, "typingUser": _vm.typingUser, "can-moderate": _vm.activeConversation.chatRoom.canModerate }, on: { "clearRoom": _vm.clearRoom } }) : _vm._e(), _c("div", { class: ["conversation", { "no-messages": !_vm.hasMessages }, { "got-new-messages": _vm.newUnreadMessageOnFeed }, { "show-scroll-btn": _vm.showScrollToLatestBtn }] }, [_vm.hasMessages ? _c("div", { staticClass: "messages-list-container" }, [_c("vue-scroll", { ref: "vue-scroll-messages", attrs: { "id": "vue-scroll-messages" }, on: { "handle-scroll": _vm.handleMessageScroll } }, [_c("div", { class: ["messages-list-wrapper", { "show-name": _vm.activeConversation.chatRoom && _vm.activeConversation.chatRoom.isGroup }] }, [_vm.searchTerm && _vm.searched ? [_vm.messagesSearch.length ? _vm._l(_vm.messagesSearch, function(message, mIndex) {
    return _c("message-item", { key: message.uuid, class: [{ "own-message": message.user.uuid === _vm.userUuid }, { "prev-diff-own": !_vm.messages.data[mIndex + 1] || _vm.messages.data[mIndex + 1].user.uuid !== message.user.uuid }, { "next-diff-own": !_vm.messages.data[mIndex - 1] || _vm.messages.data[mIndex - 1].user.uuid !== message.user.uuid }], attrs: { "message": message, "vars": _vm.vars, "file-icons": _vm.fileIcons, "file-mime-types": _vm.fileMimeTypes } });
  }) : _c("div", { staticClass: "no-data" }, [_c("h5", [_vm._v(_vm._s(_vm.$t("chat.no_result_found")))])])] : [_vm._l(_vm.messages.data, function(message, mIndex) {
    return _c("message-item", { key: message.uuid, class: [{ "own-message": message.user.uuid === _vm.userUuid }, { "prev-diff-own": !_vm.messages.data[mIndex + 1] || _vm.messages.data[mIndex + 1].user.uuid !== message.user.uuid }, { "next-diff-own": !_vm.messages.data[mIndex - 1] || _vm.messages.data[mIndex - 1].user.uuid !== message.user.uuid }], attrs: { "message": message, "vars": _vm.vars, "file-icons": _vm.fileIcons, "file-mime-types": _vm.fileMimeTypes } });
  }), _vm.isFetching ? _c("div", { staticClass: "d-flex justify-content-center my-2" }, [_c("animated-loader", { attrs: { "is-loading": _vm.isFetching, "loader-color": _vm.vars.colors.light, "overlay-color": "transparent", "size": "inline", "loader-size": "20px", "loader-stroke": "3px" } })], 1) : _vm._e(), _vm.noMoreMessages ? _c("div", { staticClass: "message-item my-4 d-flex justify-content-center align-items-center" }, [_c("h5", { staticClass: "text-muted" }, [_vm._v(" " + _vm._s(_vm.$t("chat.no_more_messages")) + " ")])]) : _vm._e()]], 2)])], 1) : _c("div", { staticClass: "d-flex justify-content-center align-items-center min-height-300px" }, [_c("h5", { staticClass: "text-muted" }, [_vm._v(" " + _vm._s(_vm.$t("chat.no_messages_yet")) + " ")])]), _c("div", { staticClass: "scroll-latest-btn", on: { "click": _vm.scrollToLatestMessages } }, [_vm._m(1)])]), _vm.activeConversation.chatRoom && !_vm.activeConversation.chatRoom.isGroup || !_vm.activeConversation.chatRoom && _vm.activeConversation.user || _vm.activeConversation.chatRoom && _vm.activeConversation.chatRoom.isGroup && !_vm.activeConversation.chatRoom.hasLeft ? _c("div", { staticClass: "conversation-footer" }, [_c("div", { staticClass: "new-message" }, [_c("vue-at", { attrs: { "members": _vm.computedParticipants, "name-key": "name" }, on: { "at": _vm.handleAt }, scopedSlots: _vm._u([{ key: "item", fn: function(s) {
    return [_c("span", { staticClass: "mentioned" }, [_vm._v(_vm._s(s.item.name) + " "), _c("span", { staticClass: "bracketed text-muted-md" }, [_vm._v(_vm._s(s.item.username))])])];
  } }, { key: "embeddedItem", fn: function(s) {
    return [_c("span", [_c("span", { staticClass: "tag mentioned bg-white text-primary mx-1 px-2 py-1 rounded", attrs: { "data-uuid": s.current && s.current.user ? s.current.user.uuid : "" } }, [_vm._v(_vm._s(s.current.name))]), _vm._v(" "), _c("span")])];
  } }], null, false, 1168386567), model: { value: _vm.newMessage.message, callback: function($$v) {
    _vm.$set(_vm.newMessage, "message", $$v);
  }, expression: "newMessage.message" } }, [_c("div", { ref: "newMessageInput", staticClass: "new-message-input form-control", attrs: { "contenteditable": "", "data-placeholder": _vm.$t("chat.type_a_message"), "placeholder": _vm.$t("chat.type_a_message") }, on: { "keydown": [_vm.isTyping, function($event) {
    if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
      return null;
    return _vm.enterPressedEvt(_vm.postMessage, $event);
  }] } }, [_c("div")])]), _c("emoji-picker", { staticClass: "emoji-picker-wrapper", attrs: { "search": _vm.searchTermEmoji }, on: { "emoji": _vm.appendEmoji }, scopedSlots: _vm._u([{ key: "emoji-invoker", fn: function({ events: { click: clickEvent } }) {
    return _c("button", { staticClass: "btn-custom emoji-button", attrs: { "type": "button" }, on: { "click": function($event) {
      $event.stopPropagation();
      return clickEvent.apply(null, arguments);
    } } }, [_c("i", { staticClass: "far fa-grin" })]);
  } }, { key: "emoji-picker", fn: function({ emojis, insert }) {
    return _c("div", { staticClass: "emoji-picker-container" }, [_c("div", { staticClass: "emoji-picker" }, [_c("div", { staticClass: "emoji-picker__search" }, [_c("input", { directives: [{ name: "model", rawName: "v-model", value: _vm.searchTermEmoji, expression: "searchTermEmoji" }, { name: "focus", rawName: "v-focus" }], attrs: { "type": "text" }, domProps: { "value": _vm.searchTermEmoji }, on: { "input": function($event) {
      if ($event.target.composing)
        return;
      _vm.searchTermEmoji = $event.target.value;
    } } })]), _c("div", _vm._l(emojis, function(emojiGroup, category) {
      return _c("div", { key: category, staticClass: "mt-2" }, [_c("h5", [_vm._v(_vm._s(category))]), _c("div", { staticClass: "emojis" }, _vm._l(emojiGroup, function(emoji, emojiName) {
        return _c("span", { key: emojiName, attrs: { "title": emojiName }, on: { "click": function($event) {
          return insert(emoji);
        } } }, [_vm._v(_vm._s(emoji))]);
      }), 0)]);
    }), 0)])]);
  } }], null, false, 1808624436) }), !_vm.newMessage.message && _vm.configs.chat.fileSharing ? _c("file-uploader", { attrs: { "url": "/chat/messages", "name-label": "upload.attachment", "names-label": "upload.attachments", "button-icon": "fas fa-paperclip", "button-classes": "btn-sm", "button-design": "custom", "hide-button-label": "", "hide-file-list": "", "options": _vm.preRequisite.uploaderConfig, "data": _vm.newMessage.attachments, "additional-form-data": _vm.activeConversation, "request-identifier": _vm.newMessageRequestUUID }, on: { "uploading": _vm.attachmentUploadStarted, "updated": _vm.attachmentUploaded, "error": _vm.attachmentUploadError, "noNeed": _vm.noNeedCallback } }) : _vm._e(), _c("button", { staticClass: "btn-custom post-message-button", attrs: { "type": "button", "title": _vm.$t("general.submit") }, on: { "click": _vm.postMessage } }, [_c("i", { staticClass: "far fa-paper-plane" })])], 1)]) : _vm._e()], 1) : _vm._e()])], 1)], 1);
};
var _sfc_staticRenderFns = [function() {
  var _vm = this, _c = _vm._self._c;
  return _c("button", { attrs: { "type": "button" } }, [_c("i", { staticClass: "fas fa-comment-dots fa-flip-horizontal" })]);
}, function() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "scroll-btn-wrapper" }, [_c("i", { staticClass: "fas fa-angle-double-down" })]);
}];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ChatBox = __component__.exports;
export {
  ChatBox as C
};
//# sourceMappingURL=index.facdc432.js.map
