import { m as mapGetters } from "./vendor/vendor-core.2a9962eb.js";
import { f as formatKeysToCamelCase } from "./app.9a8150b2.js";
import { n as normalizeComponent } from "./_plugin-vue2_normalizer.7b9a2fe2.js";
const _sfc_main = {
  props: {
    index: {
      type: Number,
      required: true
    },
    formData: {
      type: Object,
      required: true
    },
    formErrors: {
      type: [String, Object],
      default: null
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    formErrorsComputed() {
      return formatKeysToCamelCase(JSON.parse(this.formErrors) || {});
    }
  },
  watch: {
    formData: {
      deep: true,
      handler(v) {
        this.$emit("updated");
      }
    }
  },
  methods: {},
  mounted() {
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("fieldset", { staticClass: "fieldset primary server-row" }, [_c("legend", [_vm._v(_vm._s(_vm.$t("config.ice_server.server")))]), _c("close-button", { style: { top: "25px", right: "5px" }, attrs: { "title": _vm.$t("general.remove") }, on: { "click": function($event) {
    return _vm.$emit("remove");
  } } }), _c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 mb-4" }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.$t("config.ice_server.urls"), "type": "text", "error": _vm.formErrorsComputed.urls, "required": "" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "urls", $event);
  } }, model: { value: _vm.formData.urls, callback: function($$v) {
    _vm.$set(_vm.formData, "urls", $$v);
  }, expression: "formData.urls" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("config.ice_server.requires_credential") } }, [_c("base-switch", { model: { value: _vm.formData.requiresCredential, callback: function($$v) {
    _vm.$set(_vm.formData, "requiresCredential", $$v);
  }, expression: "formData.requiresCredential" } })], 1)], 1), _vm.formData.requiresCredential ? _c("div", { staticClass: "col-12 col-md-6 mb-3" }, [_c("switch-wrapper", { attrs: { "label": _vm.$t("config.ice_server.expirable_credential") } }, [_c("base-switch", { model: { value: _vm.formData.expirableCredentials, callback: function($$v) {
    _vm.$set(_vm.formData, "expirableCredentials", $$v);
  }, expression: "formData.expirableCredentials" } })], 1)], 1) : _vm._e(), _vm.formData.requiresCredential ? [_vm.formData.expirableCredentials ? [_c("div", { staticClass: "col-12 mb-4" }, [_c("base-input", { attrs: { "label": _vm.$t("config.ice_server.secret"), "type": "text", "error": _vm.formErrorsComputed.secret }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "secret", $event);
  } }, model: { value: _vm.formData.secret, callback: function($$v) {
    _vm.$set(_vm.formData, "secret", $$v);
  }, expression: "formData.secret" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-4" }, [_c("base-input", { attrs: { "label": _vm.$t("config.ice_server.expires_in"), "type": "number", "error": _vm.formErrorsComputed.expiresIn }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "expiresIn", $event);
  } }, model: { value: _vm.formData.expiresIn, callback: function($$v) {
    _vm.$set(_vm.formData, "expiresIn", $$v);
  }, expression: "formData.expiresIn" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-4" }, [_c("base-input", { attrs: { "label": _vm.$t("config.ice_server.time_difference"), "type": "number", "error": _vm.formErrorsComputed.timeDifference }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "timeDifference", $event);
  } }, model: { value: _vm.formData.timeDifference, callback: function($$v) {
    _vm.$set(_vm.formData, "timeDifference", $$v);
  }, expression: "formData.timeDifference" } })], 1)] : [_c("div", { staticClass: "col-12 col-md-6 mb-4" }, [_c("base-input", { attrs: { "label": _vm.$t("config.ice_server.username"), "type": "text", "error": _vm.formErrorsComputed.username }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "username", $event);
  } }, model: { value: _vm.formData.username, callback: function($$v) {
    _vm.$set(_vm.formData, "username", $$v);
  }, expression: "formData.username" } })], 1), _c("div", { staticClass: "col-12 col-md-6 mb-4" }, [_c("base-input", { attrs: { "label": _vm.$t("config.ice_server.credential"), "type": "text", "error": _vm.formErrorsComputed.credential }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrorsComputed, "credential", $event);
  } }, model: { value: _vm.formData.credential, callback: function($$v) {
    _vm.$set(_vm.formData, "credential", $$v);
  }, expression: "formData.credential" } })], 1)]] : _vm._e()], 2)], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const ItemRow = __component__.exports;
export {
  ItemRow as I
};
//# sourceMappingURL=item-row.c542e836.js.map
