import { j as instance } from "../../../../app.9a8150b2.js";
import { m as mapGetters } from "../../../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../vendor/vendor-essential.31dae676.js";
import "../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../vendor/vendor-vue-gtag.137cb49d.js";
const apiUrl = "/config/permissions";
function getPreRequisite(module) {
  return instance({
    url: apiUrl + "/pre-requisite",
    method: "get",
    params: {
      module
    }
  });
}
function assign(data) {
  return instance({
    url: apiUrl + "/assign",
    method: "post",
    data
  });
}
const index_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  data() {
    return {
      activeModule: "config",
      formData: {
        roles: []
      },
      preRequisite: {
        roles: [],
        permissions: [],
        modules: [],
        assignedPermissions: []
      },
      formErrors: {},
      initialFormData: null,
      isLoading: false
    };
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ])
  },
  methods: {
    submit() {
      this.isLoading = true;
      assign({ ...this.formData, module: this.activeModule }).then((response) => {
        this.isLoading = false;
        this.$toasted.success(response.message, this.$toastConfig.success);
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    getInitialData() {
      this.isLoading = true;
      if (this.$route.query && this.$route.query.module) {
        this.activeModule = this.$route.query.module;
      }
      getPreRequisite(this.activeModule).then((response) => {
        this.preRequisite = _.cloneDeep(response);
        this.formData.roles = [];
        this.preRequisite.roles.forEach((role) => {
          let permissions = this.preRequisite.assignedPermissions.find((o) => o.role.toUpperCase() === role.name.toUpperCase());
          this.formData.roles.push({
            name: role.name,
            permissions: permissions != "undefined" ? permissions.permissions : []
          });
        });
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    humanize(word) {
      return _.startCase(word);
    },
    updateRouteQuery(param) {
      const newQuery = Object.assign({}, this.$route.query, param);
      this.$router.push({ path: this.$route.path, query: newQuery });
    }
  },
  mounted() {
    this.getInitialData();
  },
  watch: {
    $route() {
      this.getInitialData();
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { staticClass: "p-0 flex-grow", attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_c("div", { staticClass: "text-right p-4" }, [_c("base-dropdown", { attrs: { "tag": "div", "direction": "down", "menu-classes": "show-dropdown-up", "position": "right" } }, [_c("base-button", { attrs: { "slot": "title", "type": "button", "data-toggle": "dropdown", "role": "button", "design": "info", "size": "md" }, slot: "title" }, [_c("i", { staticClass: "fas fa-boxes" }), _vm._v(" " + _vm._s(_vm.$t(_vm.activeModule + "." + _vm.activeModule)) + " "), _c("i", { staticClass: "fas fa-chevron-down" })]), _vm._l(_vm.preRequisite.modules, function(mod) {
    return _c("a", { staticClass: "dropdown-item", on: { "click": function($event) {
      return _vm.updateRouteQuery({ module: mod });
    } } }, [_vm._v(" " + _vm._s(_vm.$t(mod + "." + mod)) + " "), mod == _vm.activeModule ? _c("i", { staticClass: "fas fa-check pull-right" }) : _vm._e()]);
  })], 2)], 1), _c("div", { staticClass: "table-responsive table-wrapper" }, [_c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_c("table", { staticClass: "table b-table table-striped table-hover b-table-stacked-sm" }, [_c("thead", [_c("tr", [_c("th", [_vm._v(_vm._s(_vm.$t("config.permission.permissions")))]), _vm._l(_vm.formData.roles, function(rolePermission) {
    return _c("th", [_vm._v(_vm._s(_vm.humanize(rolePermission.name)))]);
  })], 2)]), _c("tbody", _vm._l(_vm.preRequisite.permissions, function(permission) {
    return _c("tr", [_c("td", [_vm._v(_vm._s(_vm.humanize(permission)))]), _vm._l(_vm.formData.roles, function(rolePermission) {
      return _c("td", [_c("base-checkbox", { staticClass: "ml-3", attrs: { "value": permission, "disabled": rolePermission.name === "admin" }, model: { value: rolePermission.permissions, callback: function($$v) {
        _vm.$set(rolePermission, "permissions", $$v);
      }, expression: "rolePermission.permissions" } })], 1);
    })], 2);
  }), 0)]), _c("div", { staticClass: "text-right mt-5 px-4 mb-4" }, [_c("base-button", { attrs: { "type": "submit", "design": "primary" } }, [_vm._v(_vm._s(_vm.$t("global.save", { attribute: _vm.$t("config.permission.permissions") })))])], 1)])])]);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const index = __component__.exports;
export {
  index as default
};
//# sourceMappingURL=permission-index.18a5b03b.js.map
