import { v as view } from "../../../../view.65eb82b1.js";
import { i as mapActions } from "../../../../vendor/vendor-core.2a9962eb.js";
import { h as headerEventButton } from "../../../../header.a91390e7.js";
import { P as PrintHeaderSimple } from "../../../../simple.b5b2d5e0.js";
import { n as normalizeComponent } from "../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../helpers/transformers.f12abdae.js";
import "../../../../app.9a8150b2.js";
import "../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../vendor/vendor-essential.31dae676.js";
import "../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../../event-bus.0afcd682.js";
import "../../../../AppLogo.c559b5f2.js";
const receipt_vue_vue_type_style_index_0_scoped_b9706e64_lang = "";
const _sfc_main = {
  extends: view,
  components: {
    PrintHeaderSimple
  },
  data() {
    return {
      receipt: null,
      showPrintHeader: true,
      headerMargin: 150,
      initUrl: "meetings",
      dataTitle: $t("meeting.meeting"),
      fallBackRoute: "appMeetingList",
      headerButtons: [
        headerEventButton($t("general.print"), "fas fa-print", { event: "EXPORT", options: { type: "print" } })
      ],
      providerConfigs: null
    };
  },
  computed: {
    computedBasic() {
      return this.receipt && this.receipt.billingAddress ? this.receipt.billingAddress : {};
    },
    address() {
      let address = this.computedBasic.addressLine1;
      address = this.computedBasic.addressLine2 ? address ? `${address}, ${this.computedBasic.addressLine2}` : this.computedBasic.addressLine2 : address;
      return address;
    },
    region() {
      let region = this.computedBasic.city;
      region = region ? this.computedBasic.zipcode ? `${region} - ${this.computedBasic.zipcode}` : region : "";
      region = this.computedBasic.state ? region ? `${region}, ${this.computedBasic.state}` : this.computedBasic.state : region;
      region = this.computedBasic.country ? region ? `${region}, ${this.computedBasic.country}` : this.computedBasic.country : region;
      return region;
    }
  },
  methods: {
    ...mapActions("common", [
      "ResetEntity",
      "SetEntity"
    ]),
    getProviderConfig() {
      this.isLoading = true;
      this.Custom({
        url: "config?provider=true",
        method: "get"
      }).then((response) => {
        if (response && response.assets && response.domain && response.domain.app) {
          response.assets.objForEach((value, key) => {
            response.assets[key] = response.domain.app + value;
          });
        }
        this.providerConfigs = response;
        this.autoPrint();
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    },
    autoPrint() {
      window.setTimeout(() => {
        this.export();
      }, 1e3);
    },
    afterGetInitialData(res) {
      if (!(res && res.isPaid && res.hasPaid)) {
        this.$router.push({ name: "appMeetingView", params: { uuid: res.uuid } });
      }
      this.SetEntity(res);
      this.getReceipt();
    },
    getReceipt() {
      this.isLoading = true;
      this.Custom({
        url: `/${this.initUrl}/${this.entity.uuid}/payment/receipt`,
        method: "get"
      }).then((response) => {
        this.receipt = response;
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    this.getInitialData().then((res) => {
      this.getProviderConfig();
    });
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { staticClass: "print-black-color", attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor, "id": "printable" } }, [_vm.showPrintHeader ? _c("print-header-simple", { attrs: { "custom-configs": _vm.providerConfigs } }) : _c("div", { staticClass: "header-margin", style: { height: _vm.headerMargin + "px" } }), _vm.entity && _vm.receipt ? [_c("div", { staticClass: "row" }, [_vm.receipt.billingAddress ? _c("div", { staticClass: "col-5 pt-1" }, [_vm.receipt.billingAddress.userName ? _c("h5", { staticClass: "font-weight-700 mb-1" }, [_vm._v(_vm._s(_vm.receipt.billingAddress.userName))]) : _vm._e(), _vm.address ? _c("p", { staticClass: "mb-0" }, [_vm._v(_vm._s(_vm.address))]) : _vm._e(), _vm.region ? _c("p", { staticClass: "mb-0" }, [_vm._v(_vm._s(_vm.region))]) : _vm._e()]) : _vm._e(), _c("div", { staticClass: "col-7" }, [_c("h1", { staticClass: "text-uppercase text-right fs-3 font-weight-800 mt-0" }, [_vm._v(_vm._s(_vm.$t("meeting.paid_meeting")))])])]), _c("div", { staticClass: "row mt-5" }, [_c("div", { staticClass: "col-4" }, [_c("view-single", { attrs: { "label": _vm.$t("meeting.payment.invoice_number"), "value": _vm.receipt.number, "data-classes": "font-weight-600" } })], 1), _c("div", { staticClass: "col-4" }, [_c("view-date", { staticClass: "text-center", attrs: { "label": _vm.$t("meeting.payment.date"), "value": _vm.receipt.date, "view-group-classes": "border-left border-right", "data-classes": "font-weight-600" } })], 1), _c("div", { staticClass: "col-4" }, [_c("view-single", { staticClass: "text-right", attrs: { "label": _vm.$t("meeting.payment.method"), "value": _vm.receipt.paymentGateway.source, "data-classes": "font-weight-600" } })], 1)]), _c("table", { staticClass: "table table-bordered table-sm mt-4 mb-4" }, [_c("thead", { staticClass: "thead-light" }, [_c("tr", [_c("th", { staticClass: "min-width-40px" }, [_vm._v("#")]), _c("th", { staticClass: "text-left min-width-100px" }, [_vm._v(_vm._s(_vm.$t("meeting.props.title")))]), _c("th", { staticClass: "text-left min-width-100px" }, [_vm._v(_vm._s(_vm.$t("meeting.props.identifier")))]), _c("th", { staticClass: "text-left min-width-100px" }, [_vm._v(_vm._s(_vm.$t("meeting.props.date_time")))]), _c("th", { staticClass: "text-left min-width-100px" }, [_vm._v(_vm._s(_vm.$t("meeting.payment.transaction_id")))]), _c("th", { staticClass: "text-right min-width-100px" }, [_vm._v(_vm._s(_vm.$t("meeting.payment.amount")))])])]), _c("tbody", [_c("tr", [_c("td", {}, [_vm._v("1")]), _c("td", {}, [_vm._v(_vm._s(_vm.entity.title))]), _c("td", {}, [_vm._v(_vm._s(_vm.entity.identifier))]), _c("td", { staticClass: "text-left" }, [_c("view-date", { staticClass: "mb-0 text-left", attrs: { "value": _vm.entity.startDateTime } })], 1), _c("td", {}, [_c("p", { staticClass: "text-wrap-pre-line" }, [_vm._v(_vm._s(_vm.receipt.paymentGateway.referenceNumber))])]), _c("td", { staticClass: "text-right" }, [_c("view-currency", { staticClass: "mb-0", attrs: { "value": _vm.receipt.amount, "currency": _vm.receipt.currency, "data-classes": "font-weight-600" } })], 1)])]), _c("tfoot", [_c("tr", [_c("td", { staticClass: "text-right fs-2 font-weight-600", attrs: { "colspan": "5" } }, [_vm._v(_vm._s(_vm.$t("general.total")))]), _c("td", { staticClass: "text-right" }, [_c("view-currency", { staticClass: "mb-0", attrs: { "value": _vm.receipt.amount, "currency": _vm.receipt.currency, "data-classes": "font-weight-600 text-success fs-2" } })], 1)])])])] : _vm._e(), _c("div", { staticClass: "form-footer mt-5" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.$router.back();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.back")))])], 1)])], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  "b9706e64",
  null,
  null
);
const receipt = __component__.exports;
export {
  receipt as default
};
//# sourceMappingURL=receipt.f751d364.js.map
