import { v as view } from "../../../view.65eb82b1.js";
import { m as mapGetters, i as mapActions } from "../../../vendor/vendor-core.2a9962eb.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../header.a91390e7.js";
import "../../../app.9a8150b2.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../helpers/transformers.f12abdae.js";
import "../../../event-bus.0afcd682.js";
const _sfc_main = {
  extends: view,
  data() {
    return {
      initUrl: "meetings",
      snapshots: [],
      fallBackRoute: "appMeetingList"
    };
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ])
  },
  methods: {
    ...mapActions("common", [
      "Custom"
    ]),
    getData() {
      this.isLoading = true;
      this.Custom({
        url: `/${this.initUrl}/${this.uuid}/snapshots`,
        method: "get"
      }).then((response) => {
        this.snapshots = response;
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    },
    deleteSnapshot(snapshot) {
      formUtil.confirmAction().then((result) => {
        if (result.value) {
          this.isLoading = true;
          this.Custom({
            url: `/${this.initUrl}/${this.uuid}/snapshots/${snapshot.uuid}`,
            method: "delete"
          }).then((response) => {
            this.isLoading = false;
            this.$toasted.success(response.message, this.$toastConfig);
            this.getData();
          }).catch((error) => {
            this.isLoading = false;
            formUtil.handleErrors(error);
          });
        } else {
          result.dismiss === Swal.DismissReason.cancel;
        }
      });
    }
  },
  mounted() {
    this.getData();
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("base-container", { attrs: { "boxed": "", "with-loader": "", "min-height": "full", "has-footer": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor, "id": "printable" } }, [_vm.entity ? [_vm.snapshots && _vm.snapshots.length ? _c("div", { staticClass: "row" }, _vm._l(_vm.snapshots, function(snapshot) {
    return _c("div", { key: snapshot.uuid, staticClass: "col-12 col-md-4 col-lg-3 mb-3 text-center" }, [_c("a", { staticClass: "d-block mb-2", attrs: { "href": snapshot.fullUrl, "target": "_blank" } }, [_c("img", { staticClass: "img-thumbnail img-responsive", attrs: { "src": snapshot.fullUrl, "alt": snapshot.name, "title": snapshot.name } })]), _c("base-button", { attrs: { "type": "button", "design": "light", "size": "sm" }, on: { "click": function($event) {
      return _vm.deleteSnapshot(snapshot);
    } } }, [_c("i", { staticClass: "fas fa-trash" }), _vm._v(" " + _vm._s(_vm.$t("general.delete")))])], 1);
  }), 0) : _c("div", { staticClass: "text-center my-5" }, [_c("h3", { staticClass: "text-muted mb-3" }, [_vm._v(_vm._s(_vm.$t("global.could_not_find_any", { attribute: _vm.$t("meeting.snapshots") })))])])] : _vm._e(), _c("div", { staticClass: "form-footer mt-3" }, [_c("div", { staticClass: "left-side" }, [_c("base-button", { attrs: { "type": "button", "design": "light", "tabindex": "-1" }, on: { "click": function($event) {
    return _vm.$router.back();
  } } }, [_c("i", { staticClass: "fas fa-chevron-left" }), _vm._v(" " + _vm._s(_vm.$t("general.back")))])], 1)])], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const snapshots = __component__.exports;
export {
  snapshots as default
};
//# sourceMappingURL=snapshots.d468f120.js.map
