import { t as table } from "../../../../table.f559165b.js";
import { f as filterForm } from "../../../../filter-form.416a20d1.js";
import { n as normalizeComponent } from "../../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../../app.9a8150b2.js";
import "../../../../vendor/vendor-core.2a9962eb.js";
import "../../../../vendor/vendor-others.d4f8aae2.js";
import "../../../../vendor/vendor-essential.31dae676.js";
import "../../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../../header.a91390e7.js";
import "../../../../event-bus.0afcd682.js";
const _sfc_main$1 = {
  extends: filterForm
};
var _sfc_render$1 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("filter-wrapper", { attrs: { "boxed": _vm.boxed, "is-loading": _vm.isLoading }, on: { "close": function($event) {
    return _vm.$emit("close");
  } } }, [_c("div", { staticClass: "row" }, [_c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-input", { attrs: { "auto-focus": "", "label": _vm.$t("general.keyword"), "type": "text", "disabled": _vm.isLoading }, model: { value: _vm.filters.keyword, callback: function($$v) {
    _vm.$set(_vm.filters, "keyword", $$v);
  }, expression: "filters.keyword" } })], 1), _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-input", { attrs: { "label": _vm.$t("site.query.props.email"), "type": "text", "disabled": _vm.isLoading }, model: { value: _vm.filters.email, callback: function($$v) {
    _vm.$set(_vm.filters, "email", $$v);
  }, expression: "filters.email" } })], 1), _c("div", { staticClass: "col-12 col-md-4 mb-3" }, [_c("base-input", { attrs: { "label": _vm.$t("site.query.props.contact_number"), "type": "text", "disabled": _vm.isLoading }, model: { value: _vm.filters.contactNumber, callback: function($$v) {
    _vm.$set(_vm.filters, "contactNumber", $$v);
  }, expression: "filters.contactNumber" } })], 1)])]);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  null,
  null,
  null
);
const FilterForm = __component__$1.exports;
const _sfc_main = {
  components: {
    FilterForm
  },
  extends: table,
  data() {
    return {
      fields: [
        {
          key: "name",
          label: $t("site.query.props.name"),
          sort: "name"
        },
        {
          key: "email",
          label: $t("site.query.props.email")
        },
        {
          key: "contactNumber",
          label: $t("site.query.props.contact_number")
        },
        {
          key: "subject",
          label: $t("site.query.props.subject"),
          tdClass: "td-ellipsis max-width-100",
          transformer: "limitWords"
        },
        {
          key: "createdAt",
          label: $t("general.submitted_at"),
          sort: "created_at",
          transformer: "date"
        },
        {
          key: "updatedAt",
          label: $t("general.updated_at"),
          sort: "updated_at",
          transformer: "date",
          thClass: "d-none",
          tdClass: "d-none"
        },
        {
          key: "actions",
          label: "",
          cantHide: true,
          tdClass: "actions-dropdown-wrapper"
        }
      ],
      filtersOptions: {
        keyword: "",
        email: "",
        contactNumber: ""
      },
      sortOptions: {
        hasScroll: true
      },
      columnsOptions: {
        hasScroll: true
      },
      initUrl: "site/queries",
      dataType: "query"
    };
  },
  mounted() {
    this.updatePageMeta();
  }
};
var _sfc_render = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "entity-list-container" }, [_c("collapse-transition", { attrs: { "group": true, "duration": 300, "tag": "div" } }, [_vm.showFilters ? _c("filter-form", { key: "filters", attrs: { "boxed": true, "pre-requisite": _vm.preRequisite, "is-loading": _vm.isLoading }, on: { "close": _vm.toggleFilter } }) : _vm._e(), _c("base-container", { key: "list", staticClass: "p-0", attrs: { "boxed": "", "with-loader": "", "is-loading": _vm.isLoading, "loader-color": _vm.vars.loaderColor } }, [_vm.isInitialized ? _c("table-wrapper", { attrs: { "meta": _vm.entities.meta, "filtered": _vm.isFiltered, "entity-title": "site.query.query", "entities-title": "site.query.queries", "entity-description": "site.query.module_description" } }, [_c("b-table", { directives: [{ name: "show", rawName: "v-show", value: _vm.entities.meta.total, expression: "entities.meta.total" }], ref: "btable", attrs: { "items": _vm.itemsProvider, "fields": _vm.fields, "busy": _vm.isLoading, "hover": "", "striped": "", "stacked": "sm", "per-page": _vm.entities.meta.perPage, "current-page": _vm.entities.meta.currentPage, "filters": null }, on: { "update:busy": function($event) {
    _vm.isLoading = $event;
  }, "row-dblclicked": function($event) {
    return _vm.rowClickHandler({ route: "appSiteQueryView" }, $event);
  } }, scopedSlots: _vm._u([{ key: "cell(name)", fn: function(row) {
    return [_c("router-link", { staticClass: "row-link", attrs: { "to": { name: "appSiteQueryView", params: { uuid: row.item.uuid } } } }, [_vm._v(" " + _vm._s(row.item.name) + " ")])];
  } }, { key: "cell(createdAt)", fn: function(row) {
    return [_c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.createdAt, "with-tz": "", "tag": "span" } })];
  } }, { key: "cell(updatedAt)", fn: function(row) {
    return [_c("view-date", { staticClass: "mb-0", attrs: { "value": row.item.updatedAt, "with-tz": "", "tag": "span" } })];
  } }, { key: "cell(actions)", fn: function(row) {
    return [_c("table-row-actions", [_c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appSiteQueryView", params: { uuid: row.item.uuid } } } }, [_c("i", { staticClass: "fas fa-arrow-circle-right" }), _vm._v(" " + _vm._s(_vm.$t("global.view", { attribute: _vm.$t("site.query.query") })))]), _vm.hasPermission("delete-query") ? _c("a", { staticClass: "dropdown-item", on: { "click": function($event) {
      $event.stopPropagation();
      return _vm.deleteEntity(row.item);
    } } }, [_c("i", { staticClass: "fas fa-trash" }), _vm._v(" " + _vm._s(_vm.$t("global.delete", { attribute: _vm.$t("site.query.query") })))]) : _vm._e()], 1)];
  } }], null, false, 3817577782) })], 1) : _vm._e()], 1)], 1)], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const index = __component__.exports;
export {
  index as default
};
//# sourceMappingURL=query-index.41193ef6.js.map
