import { A as AppLogo } from "../../../AppLogo.c559b5f2.js";
import { i as mapActions } from "../../../vendor/vendor-core.2a9962eb.js";
import { s as screenfull } from "../../../vendor/vendor-screenfull.9a79c0ca.js";
import { u as user } from "../../../user-dropdown.094e4969.js";
import { l as updateUserPref } from "../../../app.9a8150b2.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import "../../../vendor/vendor-vue-avatar.9d39aec0.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
const appNavbarRestricted_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  extends: user,
  components: {
    AppLogo
  },
  data() {
    return {
      userDropddownOpen: false
    };
  },
  computed: {
    selectedLocale() {
      return this.configs.system.locales.find((l) => l.locale === this.configs.system.locale);
    }
  },
  methods: {
    ...mapActions("config", [
      "SetUiConfig"
    ]),
    ...mapActions("common", [
      "Custom"
    ]),
    ...mapActions("navigation", [
      "Generate"
    ]),
    ...mapActions("user", [
      "GetUser"
    ]),
    toggleFullScreen(to) {
      if (screenfull.isEnabled) {
        if (to) {
          screenfull.request();
        } else {
          screenfull.exit();
        }
      }
    },
    setLocaleUserPreference(locale) {
      this.isLoading = true;
      updateUserPref({
        system: {
          locale: locale ? locale.locale : "en"
        }
      }).then((response) => {
        this.GetUser().then(() => {
          location.reload();
          this.isLoading = false;
        }).catch((error) => {
          this.isLoading = false;
          formUtil.handleErrors(error);
        });
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    if (screenfull.isEnabled) {
      screenfull.on("change", () => {
        this.SetUiConfig({ fullScreen: screenfull.isFullscreen });
      });
      screenfull.on("error", (event) => {
        console.error("Failed to enable fullscreen", event);
      });
      this.SetUiConfig({ fullScreen: false });
    }
  },
  destroyed() {
    if (screenfull.isEnabled) {
      screenfull.off("change");
      screenfull.off("error");
    }
  }
};
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("nav", { staticClass: "navbar navbar-design-basic navbar-expand-sm d-flex justify-content-around align-items-center flex-nowrap" }, [_c("app-logo", { attrs: { "place": "navbar" } }), _c("ul", { staticClass: "nav nav-inline d-none d-lg-flex mr-2" }, [_c("li", { staticClass: "nav-item" }, [_vm.uiConfigs.fullScreen ? _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link toggle-full-screen", attrs: { "title": _vm.$t("config.ui.toggle_fullscreen") }, on: { "click": function($event) {
    return _vm.toggleFullScreen(false);
  } } }, [_c("i", { staticClass: "fas fa-compress" })]) : _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link toggle-full-screen", attrs: { "title": _vm.$t("config.ui.toggle_fullscreen") }, on: { "click": function($event) {
    return _vm.toggleFullScreen(true);
  } } }, [_c("i", { staticClass: "fas fa-expand" })])])]), _c("ul", { staticClass: "nav nav-inline d-none d-md-flex mr-3" }, [_vm.configs.system && _vm.configs.system.maintenanceMode ? _c("li", { staticClass: "nav-item" }, [_c("span", { staticClass: "warning-label badge badge-warning" }, [_vm._v(_vm._s(_vm.$t("config.system.under_maintenance")))])]) : _vm._e(), _vm.configs.system && !_vm.configs.system.mode ? _c("li", { staticClass: "nav-item" }, [_c("span", { staticClass: "warning-label badge badge-warning" }, [_vm._v(_vm._s(_vm.$t("config.system.test_mode")))])]) : _vm._e(), !_vm.isOnline ? _c("li", { staticClass: "nav-item ml-2" }, [_c("span", { staticClass: "warning-label badge badge-error" }, [_c("i", { staticClass: "fas fa-exclamation-triangle" }), _vm._v(" " + _vm._s(_vm.$t("general.offline")))])]) : _vm._e()]), _c("div", { staticClass: "separator" }), _c("ul", { staticClass: "navbar-nav" }, [_vm.configs.system.locales && _vm.configs.system.locales.length > 1 ? _c("base-dropdown", { staticClass: "nav-item d-none d-sm-flex", attrs: { "tag": "div", "position": "right" } }, [_c("a", { staticClass: "nav-link", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_c("span", { staticClass: "mr-1" }, [_vm._v(_vm._s(_vm.selectedLocale.name) + " (" + _vm._s(_vm.selectedLocale.locale) + ")")]), _vm._v(" "), _c("i", { staticClass: "fas fa-angle-down" })]), _vm._l(_vm.configs.system.locales, function(locale) {
    return _c("li", { key: locale.locale, staticClass: "dropdown-item", on: { "click": function($event) {
      return _vm.setLocaleUserPreference(locale);
    } } }, [_vm._v(" " + _vm._s(locale.name) + " (" + _vm._s(locale.locale) + ") "), locale.locale == _vm.configs.system.locale ? _c("span", { staticClass: "pull-right" }, [_c("i", { staticClass: "fas fa-check" })]) : _vm._e()]);
  })], 2) : _vm._e(), _c("base-dropdown", { staticClass: "nav-item d-flex", attrs: { "tag": "li", "data-v-step": "user-dropdown", "position": "right", "open": _vm.userDropddownOpen }, on: { "update:open": function($event) {
    _vm.userDropddownOpen = $event;
  } } }, [_c("a", { staticClass: "nav-link nav-link-icon nav-user-avatar p-0", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_vm.loggedInUser ? _c("user-avatar", { attrs: { "user": _vm.loggedInUser, "size": 40, "foreground-color": _vm.uiConfigs.hideSecureContent ? _vm.vars.colors["danger"] : _vm.vars.colors["primary"] } }) : _vm._e()], 1), _c("h6", { staticClass: "dropdown-header" }, [_vm._v(_vm._s(_vm.$t("general.greeting") + ", " + _vm.loggedInUser.name))]), _c("div", { staticClass: "dropdown-divider", attrs: { "role": "separator" } }), _c("a", { staticClass: "dropdown-item", attrs: { "href": "#" }, on: { "click": function($event) {
    $event.preventDefault();
    return _vm.logout.apply(null, arguments);
  } } }, [_c("i", { staticClass: "fas fa-power-off" }), _vm._v(" " + _vm._s(_vm.$t("auth.logout")))])])], 1)], 1);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const appNavbarRestricted = __component__.exports;
export {
  appNavbarRestricted as default
};
//# sourceMappingURL=app-navbar-restricted.fdb8b058.js.map
