import { A as AppLogo } from "../../../AppLogo.c559b5f2.js";
import { E as EventBus } from "../../../event-bus.0afcd682.js";
import { m as mapGetters, i as mapActions } from "../../../vendor/vendor-core.2a9962eb.js";
import { n as now } from "../../../momentz.3304bf92.js";
import { s as store, l as updateUserPref } from "../../../app.9a8150b2.js";
import { n as normalizeComponent } from "../../../_plugin-vue2_normalizer.7b9a2fe2.js";
import { s as screenfull } from "../../../vendor/vendor-screenfull.9a79c0ca.js";
import { u as user } from "../../../user-dropdown.094e4969.js";
import "../../../vendor/vendor-others.d4f8aae2.js";
import "../../../vendor/vendor-essential.31dae676.js";
import "../../../vendor/vendor-bootstrap-vue.397f83c5.js";
import "../../../vendor/vendor-vue-gtag.137cb49d.js";
import "../../../vendor/vendor-vue-avatar.9d39aec0.js";
const Todo_vue_vue_type_style_index_0_scoped_770b9727_lang = "";
const vars = store.getters["config/vars"];
const _sfc_main$2 = {
  name: "todo-widget",
  props: {
    reload: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      todos: [],
      formData: {
        title: "",
        date: now(vars.serverDateFormat)
      },
      formErrors: {},
      isLoading: false
    };
  },
  watch: {
    reload(newValue, oldValue) {
      if (newValue && newValue !== oldValue) {
        this.getInitialData();
      }
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    ...mapGetters("common", [
      "others"
    ]),
    incompletedTasksCount() {
      return this.others ? this.others.todos.filter((t) => !t.status).length : 0;
    },
    date() {
      return moment(this.formData.date, this.vars.serverDateFormat).format("dddd, Do");
    },
    month() {
      return moment(this.formData.date, this.vars.serverDateFormat).format("MMMM");
    }
  },
  methods: {
    ...mapActions("common", [
      "Custom",
      "SetOthers"
    ]),
    submit() {
      if (!this.formData.title) {
        this.$toasted.info(this.$t("general.nothing_changed"), this.$toastConfig.info);
        return false;
      }
      this.isLoading = true;
      this.Custom({
        url: "utility/todos",
        method: "post",
        data: this.formData
      }).then((response) => {
        let todos = this.others.todos;
        todos.unshift(response.todo);
        this.SetOthers({
          todos
        });
        this.resetVueScroll();
        this.$toasted.success(response.message, this.$toastConfig);
        this.formData.title = "";
        this.isLoading = false;
        EventBus.$emit("REFRESH_TABLE", "appUtilityTodoList");
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    toggleTodo(todo) {
      this.isLoading = true;
      this.Custom({
        url: "utility/todos/" + todo.uuid + "/status",
        method: "post"
      }).then((response) => {
        todo.status = !todo.status;
        let todos = this.others.todos;
        this.SetOthers({
          todos
        });
        this.$toasted.success(response.message, this.$toastConfig);
        this.isLoading = false;
        EventBus.$emit("REFRESH_TABLE", "appUtilityTodoList");
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    getInitialData() {
      this.isLoading = true;
      this.Custom({
        url: "utility/todos?type=list&sort_by=due_date,status&order=desc,asc&date=" + this.formData.date,
        method: "get"
      }).then((response) => {
        this.SetOthers({
          todos: response
        });
        this.resetVueScroll();
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    getNextTodo() {
      this.formData.date = moment(this.formData.date, this.vars.serverDateFormat).add(1, "days").format(this.vars.serverDateFormat);
      this.getInitialData();
    },
    getPreviousTodo() {
      this.formData.date = moment(this.formData.date, this.vars.serverDateFormat).subtract(1, "days").format(this.vars.serverDateFormat);
      this.getInitialData();
    },
    resetVueScroll() {
      setTimeout(() => {
        if (this.$refs["vuescrollTodo"]) {
          this.$refs["vuescrollTodo"].scrollTo({
            x: 0,
            y: 0
          }, true);
        }
      }, 100);
    }
  },
  mounted() {
    this.getInitialData();
  }
};
var _sfc_render$2 = function render() {
  var _vm = this, _c = _vm._self._c;
  return _c("card", { staticClass: "todo-widget", attrs: { "shadow": "", "body-classes": "p-0" } }, [_c("div", { staticClass: "widget-wrapper" }, [_c("div", { staticClass: "widget-header" }, [_c("div", { staticClass: "todo-date" }, [_c("h4", [_vm._v(_vm._s(_vm.date))]), _c("h6", [_vm._v(_vm._s(_vm.month))])]), _c("div", { staticClass: "todo-meta" }, [_c("div", { staticClass: "todo-nav" }, [_c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], attrs: { "type": "button", "design": "link", "title": _vm.$t("general.previous_day") }, on: { "click": _vm.getPreviousTodo } }, [_c("i", { staticClass: "fas fa-arrow-left" })]), _c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], attrs: { "type": "button", "design": "link", "title": _vm.$t("general.next_day") }, on: { "click": _vm.getNextTodo } }, [_c("i", { staticClass: "fas fa-arrow-right" })])], 1), _vm.others.todos ? _c("span", [_vm._v(_vm._s(_vm.incompletedTasksCount) + " " + _vm._s(_vm.$t("utility.todo.tasks")))]) : _vm._e()])]), _c("div", { staticClass: "widget-body" }, [_c("div", { staticClass: "todo-form mt-2" }, [_c("form", { on: { "submit": function($event) {
    $event.preventDefault();
    return _vm.submit.apply(null, arguments);
  } } }, [_c("div", { staticClass: "d-flex" }, [_c("base-input", { staticClass: "flex-grow", attrs: { "placeholder": _vm.$t("utility.todo.type_task"), "type": "text", "name": "title", "error": _vm.formErrors.title, "format": "sentence", "wrapper-classes": "pt-0" }, on: { "update:error": function($event) {
    return _vm.$set(_vm.formErrors, "title", $event);
  } }, model: { value: _vm.formData.title, callback: function($$v) {
    _vm.$set(_vm.formData, "title", $$v);
  }, expression: "formData.title" } })], 1), _c("button", { staticClass: "d-none", attrs: { "type": "submit" } })])]), _c("div", { staticClass: "todo-list-wrapper", class: { "fixed-height": _vm.others.todos && _vm.others.todos.length > 5 } }, [_c("vue-scroll", { ref: "vuescrollTodo", attrs: { "id": "vuescrollTodo" } }, [_vm.others.todos && _vm.others.todos.length ? _c("ul", { staticClass: "todo-list" }, _vm._l(_vm.others.todos, function(todo) {
    return _c("li", { key: todo.uuid, class: ["todo-item", { "completed": todo.status }] }, [_c("div", { staticClass: "todo-details", on: { "click": function($event) {
      return _vm.$router.push({ name: "appUtilityTodoView", params: { uuid: todo.uuid } });
    } } }, [_c("h6", { staticClass: "title" }, [_vm._v(_vm._s(todo.title))])]), todo.time ? _c("div", { staticClass: "todo-date" }, [_vm._v(" " + _vm._s(_vm._f("moment")([`${todo.date} ${todo.time}`, _vm.vars.serverDateTimeFormat], "from")) + " ")]) : _c("div", { staticClass: "todo-date" }, [_vm._v(" " + _vm._s(_vm._f("moment")([todo.date, _vm.vars.serverDateFormat], "from")) + " ")]), _c("div", { staticClass: "todo-status", on: { "click": function($event) {
      return _vm.toggleTodo(todo);
    } } }, [todo.status ? _c("i", { staticClass: "fas fa-check-circle text-primary" }) : _c("i", { staticClass: "far fa-circle" })])]);
  }), 0) : _c("div", { staticClass: "d-flex min-height-100px justify-content-center align-items-center" }, [_c("h5", { staticClass: "text-muted" }, [_vm._v(_vm._s(_vm.$t("utility.todo.all_caught_up")))])])])], 1)]), _c("div", { staticClass: "widget-footer" })])]);
};
var _sfc_staticRenderFns$2 = [];
var __component__$2 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$2,
  _sfc_render$2,
  _sfc_staticRenderFns$2,
  false,
  null,
  "770b9727",
  null,
  null
);
const TodoWidget = __component__$2.exports;
const Notification_vue_vue_type_style_index_0_scoped_9c419b51_lang = "";
const _sfc_main$1 = {
  name: "notification-widget",
  props: {
    reload: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      isLoading: false
    };
  },
  watch: {
    reload(newValue, oldValue) {
      if (newValue && newValue !== oldValue) {
        this.getInitialData();
      }
    }
  },
  computed: {
    ...mapGetters("config", [
      "vars"
    ]),
    ...mapGetters("user", [
      "notifications"
    ])
  },
  methods: {
    ...mapActions("user", [
      "GetNotifications"
    ]),
    notificationClick(notification) {
      debugger;
    },
    toggleNotification(notification) {
      this.isLoading = true;
      this.Custom({
        url: "utility/notifications/" + notification.uuid + "/status",
        method: "post"
      }).then((response) => {
        notification.status = !notification.status;
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    getInitialData() {
      this.isLoading = true;
      this.GetNotifications().then((response) => {
        this.resetVueScroll();
        this.isLoading = false;
      }).catch((error) => {
        this.isLoading = false;
        this.formErrors = formUtil.handleErrors(error);
      });
    },
    resetVueScroll() {
      setTimeout(() => {
        if (this.$refs["vuescrollNotification"]) {
          this.$refs["vuescrollNotification"].scrollTo({
            x: 0,
            y: 0
          }, true);
        }
      }, 100);
    }
  },
  mounted() {
    this.getInitialData();
  }
};
var _sfc_render$1 = function render2() {
  var _vm = this, _c = _vm._self._c;
  return _c("card", { staticClass: "notification-widget", attrs: { "shadow": "", "body-classes": "p-0" } }, [_c("div", { staticClass: "widget-wrapper" }, [_c("div", { staticClass: "widget-header text-muted" }, [_c("div", { staticClass: "text-muted" }, [_c("i", { staticClass: "far fa-bell" })]), _c("div", { staticClass: "flex-grow-1 text-center" }, [_vm._v(_vm._s(_vm.$t("user.notification.notifications")))]), _c("div", {}, [_c("base-button", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover.d500", modifiers: { "hover": true, "d500": true } }], attrs: { "type": "button", "design": "link", "title": _vm.$t("config.notification.setting") } }, [_c("i", { staticClass: "fas fa-cog" })])], 1)]), _c("div", { staticClass: "widget-body" }, [_c("div", { staticClass: "notification-list-wrapper", class: { "fixed-height": _vm.notifications && _vm.notifications.length > 5 } }, [_c("vue-scroll", { ref: "vuescrollNotification", attrs: { "id": "vuescrollNotification" } }, [_vm.notifications && _vm.notifications.meta.total ? _c("ul", { staticClass: "notification-list" }, _vm._l(_vm.notifications.data, function(notification) {
    return _c("li", { key: notification.uuid, staticClass: "notification-item" }, [_c("div", { staticClass: "notification-details", class: { "completed": notification.status }, on: { "click": function($event) {
      return _vm.notificationClick(notification);
    } } }, [_c("h6", { staticClass: "title" }, [_vm._v(_vm._s(notification.data.title))])]), _c("div", { staticClass: "notification-date" }, [_vm._v(" " + _vm._s(_vm._f("moment")(notification.createdAt, "calendar", null, { sameElse: _vm.vars.defaultDateTimeFormat })) + " ")]), _c("div", { staticClass: "notification-status", on: { "click": function($event) {
      return _vm.toggleNotification(notification);
    } } }, [notification.status ? _c("i", { staticClass: "fas fa-check-circle text-primary" }) : _c("i", { staticClass: "far fa-circle" })])]);
  }), 0) : _c("div", { staticClass: "d-flex min-height-100px justify-content-center align-items-center" }, [_c("h5", { staticClass: "text-muted" }, [_vm._v(_vm._s(_vm.$t("user.notification.all_caught_up")))])])])], 1)]), _vm.notifications && _vm.notifications.length ? _c("div", { staticClass: "widget-footer text-center" }, [_c("base-button", { staticClass: "text-center btn-block p-2", attrs: { "type": "button", "design": "link", "size": "sm" } }, [_vm._v(_vm._s(_vm.$t("user.notification.see_all")))])], 1) : _vm._e()])]);
};
var _sfc_staticRenderFns$1 = [];
var __component__$1 = /* @__PURE__ */ normalizeComponent(
  _sfc_main$1,
  _sfc_render$1,
  _sfc_staticRenderFns$1,
  false,
  null,
  "9c419b51",
  null,
  null
);
const NotificationWidget = __component__$1.exports;
const appNavbar_vue_vue_type_style_index_0_lang = "";
const _sfc_main = {
  extends: user,
  components: {
    AppLogo,
    TodoWidget,
    NotificationWidget
  },
  data() {
    return {
      userDropddownOpen: false
    };
  },
  computed: {
    selectedLocale() {
      return this.configs.system.locales.find((l) => l.locale === this.configs.system.locale);
    }
  },
  methods: {
    ...mapActions("config", [
      "SetUiConfig"
    ]),
    ...mapActions("common", [
      "Custom"
    ]),
    ...mapActions("navigation", [
      "Generate"
    ]),
    ...mapActions("user", [
      "GetUser"
    ]),
    toggleSearchScreen() {
      this.$gaEvent("engagement", "toggleSearchScreen", this.uiConfigs.searchScreenShow ? "hide" : "show");
      this.SetUiConfig({ searchScreenShow: !this.uiConfigs.searchScreenShow });
    },
    toggleLeftSidebar() {
      this.SetUiConfig({ leftSidebarShow: !this.uiConfigs.leftSidebarShow });
    },
    toggleRightSidebar() {
      this.SetUiConfig({ rightSidebarShow: !this.uiConfigs.rightSidebarShow });
    },
    toggleConfigSidebar() {
      this.SetUiConfig({ configSidebarShow: !this.uiConfigs.configSidebarShow });
    },
    toggleFullScreen(to) {
      if (screenfull.isEnabled) {
        if (to) {
          screenfull.request();
        } else {
          screenfull.exit();
        }
      }
    },
    takeScreenshot() {
      this.userDropddownOpen = !this.userDropddownOpen;
      Vue.nextTick().then(() => {
        if (!html2canvas) {
          return;
        }
        html2canvas(document.querySelector(".__view"), { logging: false }).then((canvas) => {
          document.querySelector("#screenshot").innerHTML = "";
          document.querySelector("#screenshot").appendChild(canvas);
          document.querySelector("#screenshotWrapper").classList.add("show");
        });
      });
    },
    setLocaleUserPreference(locale) {
      this.isLoading = true;
      updateUserPref({
        system: {
          locale: locale ? locale.locale : "en"
        }
      }).then((response) => {
        this.GetUser().then(() => {
          location.reload();
          this.isLoading = false;
        }).catch((error) => {
          this.isLoading = false;
          formUtil.handleErrors(error);
        });
      }).catch((error) => {
        this.isLoading = false;
        formUtil.handleErrors(error);
      });
    }
  },
  mounted() {
    if (screenfull.isEnabled) {
      screenfull.on("change", () => {
        this.SetUiConfig({ fullScreen: screenfull.isFullscreen });
      });
      screenfull.on("error", (event) => {
        console.error("Failed to enable fullscreen", event);
      });
      this.SetUiConfig({ fullScreen: false });
    }
  },
  destroyed() {
    if (screenfull.isEnabled) {
      screenfull.off("change");
      screenfull.off("error");
    }
  }
};
var _sfc_render = function render3() {
  var _vm = this, _c = _vm._self._c;
  return _c("nav", { staticClass: "navbar navbar-design-basic navbar-expand-sm d-flex justify-content-around align-items-center flex-nowrap" }, [_vm.sidebarEnabled ? _c("a", { staticClass: "nav-link toggle-left-sidebar d-lg-none pr-4", on: { "click": _vm.toggleLeftSidebar } }, [_c("i", { staticClass: "fas fa-bars" })]) : _vm._e(), _c("app-logo", { attrs: { "place": "navbar" } }), _c("ul", { staticClass: "nav nav-inline d-none d-lg-flex mr-2" }, [_vm.sidebarEnabled ? _c("li", { staticClass: "nav-item" }, [_c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link toggle-left-sidebar", attrs: { "title": _vm.$t("config.ui.toggle_sidebar") }, on: { "click": _vm.toggleLeftSidebar } }, [_c("i", { staticClass: "fas fa-bars" })])]) : _vm._e(), _c("li", { staticClass: "nav-item" }, [_vm.uiConfigs.fullScreen ? _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link toggle-full-screen", attrs: { "title": _vm.$t("config.ui.toggle_fullscreen") }, on: { "click": function($event) {
    return _vm.toggleFullScreen(false);
  } } }, [_c("i", { staticClass: "fas fa-compress" })]) : _c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link toggle-full-screen", attrs: { "title": _vm.$t("config.ui.toggle_fullscreen") }, on: { "click": function($event) {
    return _vm.toggleFullScreen(true);
  } } }, [_c("i", { staticClass: "fas fa-expand" })])])]), _c("ul", { staticClass: "nav nav-inline d-none d-md-flex mr-3" }, [_vm.configs.system && _vm.configs.system.maintenanceMode ? _c("li", { staticClass: "nav-item" }, [_c("span", { staticClass: "warning-label badge badge-warning" }, [_vm._v(_vm._s(_vm.$t("config.system.under_maintenance")))])]) : _vm._e(), _vm.configs.system && !_vm.configs.system.mode ? _c("li", { staticClass: "nav-item" }, [_c("span", { staticClass: "warning-label badge badge-warning" }, [_vm._v(_vm._s(_vm.$t("config.system.test_mode")))])]) : _vm._e(), !_vm.isOnline ? _c("li", { staticClass: "nav-item ml-2" }, [_c("span", { staticClass: "warning-label badge badge-error" }, [_c("i", { staticClass: "fas fa-exclamation-triangle" }), _vm._v(" " + _vm._s(_vm.$t("general.offline")))])]) : _vm._e()]), _c("div", { staticClass: "navbar-search-form search-button-wrapper d-none d-lg-block", attrs: { "data-v-step": "search" }, on: { "click": _vm.toggleSearchScreen } }, [_vm._m(0)]), _c("div", { staticClass: "separator" }), _c("ul", { staticClass: "navbar-nav" }, [_vm.hasPermission("create-meeting") ? _c("li", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-item align-items-center d-md-flex" }, [_c("router-link", { staticClass: "nav-link cta", attrs: { "to": { name: "appInstantMeetingStart" } } }, [_c("i", { staticClass: "fas fa-business-time mr-md-2" }), _vm._v(" "), _c("span", { staticClass: "d-none d-md-flex" }, [_vm._v(_vm._s(_vm.$t("meeting.start_a_meeting")))])])], 1) : _vm._e(), _vm.configs.system.enableMultilingual && _vm.configs.system.locales && _vm.configs.system.locales.length > 1 ? _c("base-dropdown", { staticClass: "nav-item d-none d-sm-flex", attrs: { "tag": "div", "position": "right" } }, [_c("a", { staticClass: "nav-link", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_c("span", { staticClass: "mr-1" }, [_vm._v(_vm._s(_vm.selectedLocale.name) + " (" + _vm._s(_vm.selectedLocale.locale) + ")")]), _vm._v(" "), _c("i", { staticClass: "fas fa-angle-down" })]), _vm._l(_vm.configs.system.locales, function(locale) {
    return _c("li", { key: locale.locale, staticClass: "dropdown-item", on: { "click": function($event) {
      return _vm.setLocaleUserPreference(locale);
    } } }, [_vm._v(" " + _vm._s(locale.name) + " (" + _vm._s(locale.locale) + ") "), locale.locale == _vm.configs.system.locale ? _c("span", { staticClass: "pull-right" }, [_c("i", { staticClass: "fas fa-check" })]) : _vm._e()]);
  })], 2) : _vm._e(), _vm.configs.system && _vm.configs.system.notifications && _vm.hasPermission("access-notifications") ? _c("base-dropdown", { staticClass: "nav-item d-none d-sm-flex", attrs: { "tag": "li", "dropdown-menu-tag": "div", "size": "lg", "toggle-on-click": false, "menu-classes": "p-0", "position": "right" }, scopedSlots: _vm._u([{ key: "withScope", fn: function({ isOpen }) {
    return [_c("notification-widget", { attrs: { "reload": isOpen } })];
  } }], null, false, 1999882075) }, [_c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button", "title": _vm.$t("user.notifications") }, slot: "title" }, [_c("span", [_c("i", { staticClass: "far fa-bell" })])])]) : _vm._e(), _vm.configs.system && _vm.configs.system.todo && _vm.hasPermission("access-todo") ? _c("base-dropdown", { staticClass: "nav-item d-none d-sm-flex", attrs: { "tag": "li", "dropdown-menu-tag": "div", "size": "lg", "toggle-on-click": false, "menu-classes": "p-0", "position": "right" }, scopedSlots: _vm._u([{ key: "withScope", fn: function({ isOpen }) {
    return [_c("todo-widget", { attrs: { "reload": isOpen } })];
  } }], null, false, 3480721670) }, [_c("a", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-link", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button", "title": _vm.$t("utility.todo.todo") }, slot: "title" }, [_c("span", [_c("i", { staticClass: "far fa-check-circle" })])])]) : _vm._e(), _vm.hasPermission("access-config") ? _c("li", { directives: [{ name: "b-tooltip", rawName: "v-b-tooltip.hover", modifiers: { "hover": true } }], staticClass: "nav-item d-none d-md-flex", attrs: { "data-v-step": "config-link", "title": _vm.$t("config.config") } }, [_c("router-link", { staticClass: "nav-link", attrs: { "to": { name: "appConfig" } } }, [_c("i", { staticClass: "fas fa-cogs" })])], 1) : _vm._e(), _c("base-dropdown", { staticClass: "nav-item d-flex", attrs: { "tag": "li", "data-v-step": "user-dropdown", "position": "right", "open": _vm.userDropddownOpen, "menu-classes": "fullwidth-on-mobile" }, on: { "update:open": function($event) {
    _vm.userDropddownOpen = $event;
  } } }, [_c("a", { staticClass: "nav-link nav-link-icon nav-user-avatar p-0", attrs: { "slot": "title", "data-toggle": "dropdown", "role": "button" }, slot: "title" }, [_vm.loggedInUser ? _c("user-avatar", { attrs: { "user": _vm.loggedInUser, "size": 40, "background-color": _vm.vars.colors["white"], "foreground-color": _vm.vars.colors["primary"], "classes": _vm.uiConfigs.hideSecureContent ? "border-white" : "border-success" } }) : _vm._e()], 1), _c("h6", { staticClass: "dropdown-header" }, [_vm._v(_vm._s(_vm.$t("general.greeting") + ", " + _vm.loggedInUser.name))]), _vm.loggedInUser ? _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appProfileView" } } }, [_c("i", { staticClass: "fas fa-user" }), _vm._v(" " + _vm._s(_vm.$t("user.your_profile")) + " ")]) : _vm._e(), _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appUserPreference" } } }, [_c("i", { staticClass: "fas fa-user-cog" }), _vm._v(" " + _vm._s(_vm.$t("user.user_preference")) + " ")]), _vm.configs.auth.lockScreen ? _c("a", { staticClass: "dropdown-item", attrs: { "href": "#" }, on: { "click": function($event) {
    $event.preventDefault();
    return _vm.lock.apply(null, arguments);
  } } }, [_c("i", { staticClass: "fas fa-lock" }), _vm._v(" " + _vm._s(_vm.$t("auth.lock.lock")))]) : _vm._e(), _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appUserChangePassword" } } }, [_c("i", { staticClass: "fas fa-key" }), _vm._v(" " + _vm._s(_vm.$t("auth.password.change_password")) + " ")]), _vm.hasRole("admin") ? [_c("div", { staticClass: "dropdown-divider", attrs: { "role": "separator" } }), _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appProductUpdate" } } }, [_c("i", { staticClass: "fas fa-download" }), _vm._v(" " + _vm._s(_vm.$t("product.update.product_update")) + " ")])] : _vm._e(), _vm.allowExtraInput && _vm.configs.membership.enabled ? [_c("div", { staticClass: "dropdown-divider", attrs: { "role": "separator" } }), _c("router-link", { staticClass: "dropdown-item", attrs: { "to": { name: "appMembershipList" } } }, [_c("i", { staticClass: "far fa-id-badge" }), _vm._v(" " + _vm._s(_vm.hasRole("admin") ? _vm.$t("membership.memberships") : _vm.$t("membership.your_membership")) + " ")])] : _vm._e(), _c("div", { staticClass: "dropdown-divider", attrs: { "role": "separator" } }), _c("a", { staticClass: "dropdown-item", attrs: { "href": "#" }, on: { "click": function($event) {
    $event.preventDefault();
    return _vm.logout.apply(null, arguments);
  } } }, [_c("i", { staticClass: "fas fa-power-off" }), _vm._v(" " + _vm._s(_vm.$t("auth.logout")))])], 2)], 1)], 1);
};
var _sfc_staticRenderFns = [function() {
  var _vm = this, _c = _vm._self._c;
  return _c("div", { staticClass: "search-button" }, [_c("i", { staticClass: "fas fa-search" }), _vm._v(" Type anywhere to "), _c("span", { staticClass: "font-weight-700" }, [_vm._v("search")]), _vm._v("... ")]);
}];
var __component__ = /* @__PURE__ */ normalizeComponent(
  _sfc_main,
  _sfc_render,
  _sfc_staticRenderFns,
  false,
  null,
  null,
  null,
  null
);
const appNavbar = __component__.exports;
export {
  appNavbar as default
};
//# sourceMappingURL=app-navbar.08eb17e6.js.map
